      SUBROUTINE OUTCTBTO(daynumCTBTO,NOUT,IDATE00,IDATE1)
C
CCC
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 23/02/2006
C
C   Type       : Point source release model version
C   Purpose    : Write specific output file for CTBTO run 
C   Called by  : MAIN
C
CCC
C
C  Original : B. Josse(04/2007)
C
C  Last Modified :
C
CCC
C
      USE PARADI_MOD
      USE MOCF_MOD
      USE SRC_MOD
      USE SRCFLX_MOD
      USE MRAT_MOD
      USE CSTES_MOD
      USE FORMT_MOD
      USE GRIDS_MOD
      USE CTBTO_MOD

C
C INPUT
C
      INTEGER NOUT
      REAL daynumCTBTO      
      INTEGER, DIMENSION(5) :: idate00,idate1
C
C LOCAL
C      
       INTEGER, DIMENSION(5) :: IDATETEMPO1,IDATETEMPO2
       INTEGER, DIMENSION(NSRC) :: NBSECDEB,IECH
       CHARACTER*4 CDATEMI1(NSRC,5),CDATEMI2(NSRC,5)
       INTEGER J,ISRC,NBSECEMIS,NBHOUREMIS,N,NBSECSIMUL,NBHOURSIMUL
       INTEGER NBSEC
       INTEGER ILON,ILAT,ILON2DG,ILON2DGP1,ILAT2DG,ILAT2DGP1
       CHARACTER*1 C1
       CHARACTER*2 C2
       CHARACTER*3 C3
       CHARACTER*4 C4
       CHARACTER*50 NAMEFIC
       REAL QTY(NSRC),RESGRID,DEMIVIE,SEUIL
       INTEGER IFUNIT(NSRC)
       REAL CST1(NSRC)
       REAL (KIND=8), DIMENSION(LONM1,LATM1)   :: QQM2DG

       LOGICAL :: FIRSTTIME
       DATA FIRSTTIME/.TRUE./
       SAVE FIRSTTIME



C
C
C Sortie sur la grille 1 degre
C On calcule les poids uniquement au cours de la premiere echeance       
C Uniquement si on est partis d'une grille moins bien resolue, 
C sinon on va moyenner      
C     
C On calcule une seule fois, au debut, les poids
C
      IF (FIRSTTIME) THEN
       FIRSTTIME=.FALSE.
       RLON1DGMIN=-179.5/CONV
       DRLON1DG=1./CONV
       DO ILON=1,LON1DG
        RLON1DG(ILON)=RLON1DGMIN+DRLON1DG*REAL(ILON-1)
       ENDDO
       RLAT1DGMIN=-89.5/CONV
       DRLAT1DG=1./CONV
       DO ILAT=1,LAT1DG
        RLAT1DG(ILAT)=RLAT1DGMIN+DRLAT1DG*REAL(ILAT-1)
       ENDDO
C 
C On teste si la resolution de la grille
C 1 est meilleure que 1 degre. Si non (resolution +
C basse = maille + grande ), on va interpoler
      
       IF (DRLONM1.GT.DRLON1DG) THEN
        
        CALL POIDREG(RLON1DG,RLONM1(1)-DRLONM1,DRLONM1
     +              ,INDX1DGTEMP,ALFX1DGTEMP,ALFX2DGTEMP
     +              ,ALFX3DGTEMP,ALFX4DGTEMP,LON1DG)
        CALL POIDREG(RLAT1DG,RLATM1(1)-DRLATM1,DRLATM1
     +              ,INDY1DGTEMP,ALFY1DGTEMP,ALFY2DGTEMP
     +              ,ALFY3DGTEMP,ALFY4DGTEMP,LAT1DG)

        DO ILAT=1,LAT1DG
         DO ILON=1,LON1DG
          INDX1DG(ILON+LON1DG*(ILAT-1))=INDX1DGTEMP(ILON)
          ALFX1DG(ILON+LON1DG*(ILAT-1))=ALFX1DGTEMP(ILON)
          ALFX2DG(ILON+LON1DG*(ILAT-1))=ALFX2DGTEMP(ILON)
          ALFX3DG(ILON+LON1DG*(ILAT-1))=ALFX3DGTEMP(ILON)
          ALFX4DG(ILON+LON1DG*(ILAT-1))=ALFX4DGTEMP(ILON)

          INDY1DG(ILON+LON1DG*(ILAT-1))=INDY1DGTEMP(ILAT)
          ALFY1DG(ILON+LON1DG*(ILAT-1))=ALFY1DGTEMP(ILAT)
          ALFY2DG(ILON+LON1DG*(ILAT-1))=ALFY2DGTEMP(ILAT)
          ALFY3DG(ILON+LON1DG*(ILAT-1))=ALFY3DGTEMP(ILAT)
         ALFY4DG(ILON+LON1DG*(ILAT-1))=ALFY4DGTEMP(ILAT)

          ENDDO
         ENDDO 
       
       ENDIF
C Fin de la boucle 'premier passage dans la routine'       
      ENDIF

      SEUIL=1.E-7


      DO ISRC=1,NSRC ! boucle sur les sources

       PRINT*,'ISRC=',ISRC
       IDATETEMPO1(:)=IDATEMI1(isrc,:)
       IDATETEMPO2(:)=IDATEMI2(isrc,:)

       DO J=1,4
       PRINT*,'IDATETEMPO1(',J,')=',IDATETEMPO1(J)
       PRINT*,'IDATETEMPO2(',J,')=',IDATETEMPO2(J)
       ENDDO

       CALL TIMESEC(IDATETEMPO1,IDATE00,NBSEC)
       NBSECDEB(ISRC)=NBSEC
       PRINT*,'NBSEC=',NBSEC
       PRINT*,'daynumCTBTO=',daynumCTBTO
       PRINT*,'MOD=',MOD(INT(daynumCTBTO)-NBSEC,NOUT)

       IF (MOD(INT(daynumCTBTO)-NBSEC,NOUT).EQ.0) THEN ! Test echeance
                                                  ! d'impression

        IECH(ISRC)=(INT(daynumCTBTO)-NBSEC)/NOUT
        PRINT*,'IECH(',ISRC,')=',IECH(ISRC)

        IFUNIT(ISRC)=2100+ISRC    
C
C Conversions 
C 
        DEMIVIE=HALFLIFE(ISRC)
        CST1(ISRC)=XAVOG/DEMIVIE*LOG(2.)
 
C
C HYPOTHESE ACTUELLE POUR CTBTO : SORTIES SUR DOMAINE 1
C ON commence par la ligne d'entete
C 
        IF (IECH(ISRC).EQ.1) THEN ! test IECH=1

         IF (ISRC.LE.9) THEN
           WRITE(C1,fmt='(I1)') ISRC
           C3='00'//C1
         ELSEIF(ISRC.LE.99) THEN
           WRITE(C2,fmt='(I2)') ISRC
           C3='0'//C1
         ELSEIF(ISRC.LE.999) THEN
           WRITE(C3,fmt='(I3)') ISRC
         ENDIF

         WRITE(CDATEMI1(ISRC,1),fmt='(I4)')  IDATEMI1(isrc,1)
         WRITE(CDATEMI2(ISRC,1),fmt='(I4)')  IDATEMI2(isrc,1)

         DO J=2,4
          IF (IDATEMI1(ISRC,J) .LE.9) THEN
           WRITE(C1,fmt='(I1)') IDATEMI1(ISRC,J)
           CDATEMI1(ISRC,J)='0'//C1
          ELSE
           WRITE(CDATEMI1(ISRC,J),fmt='(I2)') IDATEMI1(ISRC,J)
          ENDIF
          IF (IDATEMI2(ISRC,J) .LE.9) THEN
           WRITE(C1,fmt='(I1)') IDATEMI2(ISRC,J)
           CDATEMI2(ISRC,J)='0'//C1
          ELSE
           WRITE(CDATEMI2(ISRC,J),fmt='(I2)') IDATEMI2(ISRC,J)
          ENDIF

         ENDDO

         NAMEFIC=trim(IDENTSTAT(isrc))//'.'//CDATEMI1(ISRC,1)
     +          //trim( CDATEMI1(ISRC,2))//trim(CDATEMI1(ISRC,3))
     +          //trim(CDATEMI1(ISRC,4))
     +          //'.MEFR.txt'

         OPEN(UNIT=IFUNIT(ISRC),file=NAMEFIC
     +                         ,form='formatted')


         CALL TIMESEC(IDATETEMPO2,IDATETEMPO1,NBSECEMIS)
         NBHOUREMIS=NBSECEMIS/3600
         QTY(ISRC)=PSOURCE(ISRC,3)*REAL(NBHOUREMIS)

         CALL TIMESEC(IDATE1,IDATETEMPO1,NBSECSIMUL)
         NBHOURSIMUL=NBSECSIMUL/3600

         RESGRID=1.
    
         WRITE(IFUNIT(ISRC),1001) PSOURCE(isrc,1),PSOURCE(ISRC,2)
     +        ,CDATEMI2(isrc,1),CDATEMI2(isrc,2),CDATEMI2(isrc,3)
     +        ,CDATEMI2(isrc,4),CDATEMI1(isrc,1),CDATEMI1(isrc,2)
     +        ,CDATEMI1(isrc,3),CDATEMI1(isrc,4),QTY(ISRC),NBHOURSIMUL
     +        ,NOUT/3600,NOUT/3600
     +        ,RESGRID,RESGRID,trim(IDENTSTAT(ISRC))
       
1001     FORMAT(2F9.2,A5,2(A2),X,A2,A5,2(A2),X,A2,E10.2,I5,2I2,2F5.2,A6)

        ENDIF ! Fin test IECH=1

C
C Puis sorties sur l'ensemble des echeances
C 
C
C On interpole sur la grille 1 degre a partir de la moins
C bien resolue
C      
        IF (DRLONM1.GT.DRLON1DG) THEN !test sur la resolution

C
C On impose la conversion en Bq/m3
C
         QQM2DG(:,:) = QQQM1(:,:,NIVM1,ISRC) *CST1(ISRC)
     +               * XPAM1(:,:,NIVM1)/(RD*MAIR*TGRIM1(:,:,NIVM1))

         CALL INTER2D(QQM2DG,LONM1,LATM1,INDX1DG,INDY1DG
     +                ,ALFX1DG,ALFX2DG,ALFX3DG,ALFX4DG
     +                ,ALFY1DG,ALFY2DG,ALFY3DG,ALFY4DG
     +                ,QQMTEMP,LON1DG*LAT1DG,+1,.FALSE.,1)
         DO ILAT=1,LAT1DG
          DO ILON=1,LON1DG
           QQM1DG(ILON,ILAT)=QQMTEMP(ILON+LON1DG*(ILAT-1))
          ENDDO
         ENDDO
C
C Si la resolution est meilleure, on moyenne
C Pour l'instant, on prevoit un grille de depart de 0,5 degre
C        
        ELSE
C
C On impose la conversion en Bq/m3
C
         QQM2DG(:,:) = QQQM1(:,:,NIVM1,ISRC) *CST1(ISRC)
     +               * XPAM1(:,:,NIVM1)/(RD*MAIR*TGRIM1(:,:,NIVM1))
       
         DO ILAT=1,LAT1DG
          ILAT2DG=(ILAT-1)*2+1
          ILAT2DGP1=ILAT*2
          DO ILON=1,LON1DG
           ILON2DG=(ILON-1)*2+1
           ILON2DGP1=ILON*2
           QQM1DG(ILON,ILAT)=  QQM2DG(ILON2DG  ,ILAT2DG  )
     +                      +  QQM2DG(ILON2DGP1,ILAT2DG  )
     +                      +  QQM2DG(ILON2DG  ,ILAT2DGP1)
     +                      +  QQM2DG(ILON2DGP1,ILAT2DGP1)
          ENDDO
         ENDDO

         QQM1DG=QQM1DG/4.

        ENDIF ! Fin test sur la resolution
C
C Il faut imprimer le coin en bas a gauche de la maille : on enleve 0.5
C       
        DO ILAT=1,LAT1DG
         DO ILON=1,LON1DG
          IF (QQM1DG(ILON,ILAT).GT.SEUIL) THEN
           WRITE(IFUNIT(ISRC),1002) RLAT1DG(ILAT)*CONV-0.5,
     +                              RLON1DG(ILON)*CONV-0.5,
     +                              IECH(ISRC),QQM1DG(ILON,ILAT)
          ENDIF
         ENDDO
        ENDDO
        
       ENDIF ! Fin test echeance d'impressions
       
      ENDDO ! Fin boucle sur les sources
      

1002  FORMAT(2(F9.2),I4,E15.8)      
      END

