      SUBROUTINE OUTSOURCE(daynum,idate0)
C
CCC
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 23/02/2006
C
C   Type       : Point source release model version
C   Purpose    : Write specific output file for point 
C                source release
C   Called by  : MAIN
C
CCC
C
C  Original : V.-H. Peuch, D. Lacroix (02/2006)
C
C  Last Modified :
C
CCC
C
      USE PARADI_MOD
      USE MOCF_MOD
      USE SRC_MOD
      USE SRCFLX_MOD
      USE MRAT_MOD
      USE CSTES_MOD
      USE FORMT_MOD
      USE GRIDS_MOD

C
C INPUT
C
      REAL DAYNUM
      INTEGER, DIMENSION(5) :: idate0
      REAL SOMDRYDEP,SOMWETDEP,CSTSURF,VALSURF
      INTEGER I,J
      
C
C LOCAL VARIABLES
C
      INTEGER IDIAG
C
C FLAG FOR OUTPUT MODE
C
C IDIAG = 0 DETAILED OUTPUT
C IDIAG = 1 SUMMARIZED OUTPUT
C IDIAG = 2 SORTIES AU FORMAT MEDIA 
C
      IDIAG=2
C
C 1. WRITE CURRENT DATE IN FILE
C
      IF (IDIAG.NE.2) THEN
       PRINT*,'TIME=',TIME
       IF (IFLAG1) WRITE(IFSORACC1) TIME
       IF (IFLAG2) WRITE(IFSORACC2) TIME
       IF (IFLAG3) WRITE(IFSORACC3) TIME
       IF (IFLAG4) WRITE(IFSORACC4) TIME
      ENDIF
C
C 2. WRITE IN FILES DEPENDING UPON OUTPUT MODE
C
      IF (IDIAG.EQ.0) THEN
C
C VHP : NOUVEAUX OUTPUTS COMPLETS -> ADAPTER LES OUTILS AVAL
C
C DOMAIN 1 : GLOBE
C
        IF (IFLAG1) THEN
           CALL SOUDIAGTOT(IFSORACC1,NAMDOM1,LONM1,LATM1,NIVM1,NTRA1,
     +                     QQQM1,DFDRYCUMUL1,DFBCVCUMUL1,
     +                     DFICVCUMUL1,DFSTRCUMUL1,
     +                     PCVRCUMUL1,PCVSCUMUL1,
     +                     PSTRCUMUL1,TGRIM1,XPAM1)

       ENDIF
C
C DOMAIN 2
C
        IF (IFLAG2) THEN
            CALL SOUDIAGTOT(IFSORACC2,NAMDOM2,LONM2,LATM2,NIVM2,NTRA2,
     +                      QQQM2,DFDRYCUMUL2,DFBCVCUMUL2,
     +                      DFICVCUMUL2,DFSTRCUMUL2,
     +                      PCVRCUMUL2,PCVSCUMUL2,
     +                      PSTRCUMUL2,TGRIM2,XPAM2)

        ENDIF

C
C DOMAIN 3
C
        IF (IFLAG3) THEN
            CALL SOUDIAGTOT(IFSORACC3,NAMDOM3,LONM3,LATM3,NIVM3,NTRA3,
     +                      QQQM3,DFDRYCUMUL3,DFBCVCUMUL3,
     +                      DFICVCUMUL3,DFSTRCUMUL3,
     +                      PCVRCUMUL3,PCVSCUMUL3,
     +                      PSTRCUMUL3,TGRIM3,XPAM3)
        ENDIF
C
C DOMAIN 4
C
        IF (IFLAG4) THEN
            CALL SOUDIAGTOT(IFSORACC4,NAMDOM4,LONM4,LATM4,NIVM4,NTRA4,
     +                      QQQM4,DFDRYCUMUL4,DFBCVCUMUL4,
     +                      DFICVCUMUL4,DFSTRCUMUL4,
     +                      PCVRCUMUL4,PCVSCUMUL4,
     +                      PSTRCUMUL4,TGRIM4,XPAM4)
        ENDIF       
C
      ELSEIF (IDIAG.EQ.1) THEN
C
C VHP : ANCIENS DIAGNOSTICS
C
C DOMAIN 1 : GLOBE
C
         IF (IFLAG1) THEN 
           CALL SOUDIAGSOM(IFSORACC1,NAMDOM1,LONM1,LATM1,NIVM1,NTRA1,
     +                     QQQM1,DFDRYCUMUL1,DFBCVCUMUL1,
     +                     DFICVCUMUL1,DFSTRCUMUL1,
     +                     PCVRCUMUL1,PCVSCUMUL1,
     +                     PSTRCUMUL1,TGRIM1,XPAM1)
       SOMDRYDEP=0.
       SOMWETDEP=0.
       CSTSURF=RTER*RTER*DRLONM1*DRLATM1/MAIR/GG
       DO J=1,LATM1
        VALSURF=CSTSURF*CLAT1(J)
        DO I=1,LONM1
         SOMDRYDEP=SOMDRYDEP+DFDRYCUMUL1(I,J,1)*VALSURF
         SOMWETDEP=SOMWETDEP+( DFBCVCUMUL1(I,J,1)
     +            +            DFICVCUMUL1(I,J,1)
     +            +            DFSTRCUMUL1(I,J,1) ) *VALSURF
        ENDDO
       ENDDO
       PRINT*,'SOMDRYDEP1=',SOMDRYDEP
       PRINT*,'SOMWETDEP1=',SOMWETDEP

       ENDIF

           
C
C DOMAIN 2
C
        IF (IFLAG2) THEN
            CALL SOUDIAGSOM(IFSORACC2,NAMDOM2,LONM2,LATM2,NIVM2,NTRA2,
     +                      QQQM2,DFDRYCUMUL2,DFBCVCUMUL2,
     +                      DFICVCUMUL2,DFSTRCUMUL2,
     +                      PCVRCUMUL2,PCVSCUMUL2,
     +                      PSTRCUMUL2,TGRIM2,XPAM2)
       SOMDRYDEP=0.
       SOMWETDEP=0.

       CSTSURF=RTER*RTER*DRLONM2*DRLATM2/MAIR/GG
       DO J=1,LATM2
        VALSURF=CSTSURF*CLAT2(J)
        DO I=1,LONM2
         SOMDRYDEP=SOMDRYDEP+  DFDRYCUMUL2(I,J,1)*VALSURF
         SOMWETDEP=SOMWETDEP+( DFBCVCUMUL2(I,J,1)
     +            +            DFICVCUMUL2(I,J,1)
     +            +            DFSTRCUMUL2(I,J,1) ) *VALSURF
        ENDDO
       ENDDO
       PRINT*,'SOMDRYDEP2=',SOMDRYDEP
       PRINT*,'SOMWETDEP2=',SOMWETDEP

       ENDIF


C
C DOMAIN 3
C
        IF (IFLAG3) THEN
            CALL SOUDIAGSOM(IFSORACC3,NAMDOM3,LONM3,LATM3,NIVM3,NTRA3,
     +                      QQQM3,DFDRYCUMUL3,DFBCVCUMUL3,
     +                      DFICVCUMUL3,DFSTRCUMUL3,
     +                      PCVRCUMUL3,PCVSCUMUL3,
     +                      PSTRCUMUL3,TGRIM3,XPAM3)


        ENDIF
C
C DOMAIN 4
C
        IF (IFLAG4) THEN
            CALL SOUDIAGSOM(IFSORACC4,NAMDOM4,LONM4,LATM4,NIVM4,NTRA4,
     +                      QQQM4,DFDRYCUMUL4,DFBCVCUMUL4,
     +                      DFICVCUMUL4,DFSTRCUMUL4,
     +                      PCVRCUMUL4,PCVSCUMUL4,
     +                      PSTRCUMUL4,TGRIM4,XPAM4)
        ENDIF   
       
       ELSEIF (IDIAG.EQ.2) THEN    


         IF (IFLAG1) THEN 
          CALL SOUDIAGMEDIA(IFSORACCP1,IFSORACCZ1,NAMDOM1,
     +                      LONM1,LATM1,NIVM1,NTRA1,
     +                      RLONM1,RLATM1,DRLONM1,DRLATM1,
     +                      QQQM1,DFDRYCUMUL1,DFBCVCUMUL1,
     +                      DFICVCUMUL1,DFSTRCUMUL1,
     +                      PCVRCUMUL1,PCVSCUMUL1,
     +                      PSTRCUMUL1,TGRIM1,XPAM1,XPHFM1,
     +                      daynum,idate0)
       SOMDRYDEP=0.
       SOMWETDEP=0.
       CSTSURF=RTER*RTER*DRLONM1*DRLATM1/MAIR/GG
       DO J=1,LATM1
        VALSURF=CSTSURF*CLAT1(J)
        DO I=1,LONM1
         SOMDRYDEP=SOMDRYDEP+DFDRYCUMUL1(I,J,1)*VALSURF
         SOMWETDEP=SOMWETDEP+( DFBCVCUMUL1(I,J,1)
     +            +            DFICVCUMUL1(I,J,1)
     +            +            DFSTRCUMUL1(I,J,1) ) *VALSURF
        ENDDO
       ENDDO
       PRINT*,'SOMDRYDEP1=',SOMDRYDEP
       PRINT*,'SOMWETDEP1=',SOMWETDEP

       ENDIF

           
C
C DOMAIN 2
C
        IF (IFLAG2) THEN
            CALL SOUDIAGMEDIA(IFSORACCP2,ISORACCZ2,NAMDOM2,
     +                      LONM2,LATM2,NIVM2,NTRA2,
     +                      RLONM2,RLATM2,DRLONM2,DRLATM2,
     +                      QQQM2,DFDRYCUMUL2,DFBCVCUMUL2,
     +                      DFICVCUMUL2,DFSTRCUMUL2,
     +                      PCVRCUMUL2,PCVSCUMUL2,
     +                      PSTRCUMUL2,TGRIM2,XPAM2,XPHFM2,
     +                      daynum,idate0)
       SOMDRYDEP=0.
       SOMWETDEP=0.

       CSTSURF=RTER*RTER*DRLONM2*DRLATM2/MAIR/GG
       DO J=1,LATM2
        VALSURF=CSTSURF*CLAT2(J)
        DO I=1,LONM2
         SOMDRYDEP=SOMDRYDEP+  DFDRYCUMUL2(I,J,1)*VALSURF
         SOMWETDEP=SOMWETDEP+( DFBCVCUMUL2(I,J,1)
     +            +            DFICVCUMUL2(I,J,1)
     +            +            DFSTRCUMUL2(I,J,1) ) *VALSURF
        ENDDO
       ENDDO
       PRINT*,'SOMDRYDEP2=',SOMDRYDEP
       PRINT*,'SOMWETDEP2=',SOMWETDEP

       ENDIF


C
C DOMAIN 3
C
        IF (IFLAG3) THEN
                CALL SOUDIAGMEDIA(IFSORACCP3,IFSORACCZ3,NAMDOM3,
     +                      LONM3,LATM3,NIVM3,NTRA3,
     +                      RLONM3,RLATM3,DRLONM3,DRLATM3,
     +                      QQQM3,DFDRYCUMUL3,DFBCVCUMUL3,
     +                      DFICVCUMUL3,DFSTRCUMUL3,
     +                      PCVRCUMUL3,PCVSCUMUL3,
     +                      PSTRCUMUL3,TGRIM3,XPAM3,XPHFM3,
     +                      daynum,idate0)


        ENDIF
C
C DOMAIN 4
C
        IF (IFLAG4) THEN
                CALL SOUDIAGMEDIA(IFSORACCP4,IFSORACCZ4,NAMDOM4,
     +                      LONM4,LATM4,NIVM4,NTRA4,
     +                      RLONM4,RLATM4,DRLONM4,DRLATM4,
     +                      QQQM4,DFDRYCUMUL4,DFBCVCUMUL4,
     +                      DFICVCUMUL4,DFSTRCUMUL4,
     +                      PCVRCUMUL4,PCVSCUMUL4,
     +                      PSTRCUMUL4,TGRIM4,XPAM4,XPHFM4,
     +                      daynum,idate0)
        ENDIF   


       ENDIF

CCCCCC          
C
      RETURN
      END
C
CCC
C
