      SUBROUTINE SOUDIAGMEDIA(IFSORACCP,IFSORACCZ,NAMDOM,
     +                        LON,LAT,NIV,NTRA,
     +                        RLON,RLAT,DRLON,DRLAT,
     +                        QQQM,DFDRYCUMUL,DFBCVCUMUL,
     +                        DFICVCUMUL,DFSTRCUMUL,
     +                        PCVRCUMUL,PCVSCUMUL,
     +                        PSTRCUMUL,TGRIM,XPAM,XPHFM,
     +                        daynum,idate0)

       USE CSTES_MOD
       USE SRC_MOD
       USE EXPE_MOD

       IMPLICIT NONE
C
C Diagnostic au format identique a celui de 
C MEDIA pour le mode accident
C
       INTEGER NIVINTERP,NIVINTERZ
       PARAMETER(NIVINTERP=15)
       PARAMETER(NIVINTERZ=10)


       INTEGER  IFSORACCP,IFSORACCZ
C      numero d'unite des fichiers de sortie     
       CHARACTER  (LEN=6) :: NAMDOM
C      nom du domaine 
       INTEGER LON,LAT,NIV,NTRA
C      Geometrie et nombre de polluants
       REAL (KIND=8) ::RLON(LON),RLAT(LAT),DRLON,DRLAT
C      Longitude, Latitude des points de grille et pas
       REAL (KIND=8) ::QQQM(LON,LAT,NIV,NTRA)
C      Rapport de melange de polluants
       REAL (KIND=8) ::DFDRYCUMUL(LON,LAT,NTRA)
C      Depots secs       
       REAL (KIND=8) ::DFBCVCUMUL(LON,LAT,NTRA)
       REAL (KIND=8) ::DFICVCUMUL(LON,LAT,NTRA)
       REAL (KIND=8) ::DFSTRCUMUL(LON,LAT,NTRA)
C      Depots au sol du au lessivage sous/dans le nuage cv et
C      stratiforme
       REAL (KIND=8) ::PCVRCUMUL(LON,LAT,NIV)
       REAL (KIND=8) ::PCVSCUMUL(LON,LAT,NIV)
       REAL (KIND=8) ::PSTRCUMUL(LON,LAT,NIV)
C      Cumuls 3D de pluie cv, neige cv et precip strati
       REAL (KIND=8) ::TGRIM(LON,LAT,NIV)
       REAL (KIND=8) ::XPAM (LON,LAT,NIV)
        REAL (KIND=8) ::XPHFM (LON,LAT,NIV)
	REAL (KIND=8) :: daynum
      INTEGER , DIMENSION(5) :: idate0


C      Temperature et pression

       INTEGER I,J,K,L,ISRC,INIV,LP1
       REAL (KIND=8) ::T2DOUT(LON,LAT)
       REAL (KIND=8) ::T3DOUT(LON,LAT,NIV)
       REAL (KIND=8) ::T3DOUTMEDIAP(LON,LAT,NIVINTERP)
       REAL (KIND=8) ::T3DOUTMEDIAZ(LON,LAT,NIVINTERZ)
      


       REAL (KIND=8) ::CONV3D(LON,LAT,NIV)
       REAL (KIND=8) ::CONV2D(LON,LAT)
       REAL (KIND=8) ::SOMTES(LON,LAT)
       LOGICAL CALCUL(LON,LAT)
       REAL (KIND=8) ::DEMIVIE,EPSILON,SEUILTES

       LOGICAL FIRSTTIME

       REAL (KIND=8) ::CST1

       REAL (KIND=8) :: PINTERP(NIVINTERP)
       INTEGER LINFP(LON,LAT,NIVINTERP)
       INTEGER LSUPP(LON,LAT,NIVINTERP)
       REAL (KIND=8) :: PRESINF(LON,LAT,NIVINTERP)
       REAL (KIND=8) :: PRESSUP(LON,LAT,NIVINTERP)

       REAL (KIND=8) :: ZINTERP(NIVINTERZ)
       INTEGER LINFZ(LON,LAT,NIVINTERZ)
       INTEGER LSUPZ(LON,LAT,NIVINTERZ)
       REAL (KIND=8) :: ALTIINF(LON,LAT,NIVINTERZ)
       REAL (KIND=8) :: ALTISUP(LON,LAT,NIVINTERZ)
       
       REAL (KIND=8) :: ALTI(LON,LAT,NIV)

       

       REAL (KIND=8) ::PINF,PFIN,DELTAP,COEFINF,COEFSUP
       REAL (KIND=8) ::ZINF,ZFIN,DELTAZ

       REAL (KIND=4) :: TAB3DP(LON,LAT,NIVINTERP)
       REAL (KIND=4) :: TAB3DZ(LON,LAT,NIVINTERZ)

       REAL (KIND=4) :: TAB2D(LON,LAT)
       REAL (KIND=4) :: WORK(LON,LAT,NIV)
       REAL (KIND=4) :: RWORK1,RWORK2,RWORK3,RWORK4,RWORK5,RWORK6,RWORK7
       CHARACTER(LEN=1) :: C1H
       CHARACTER(LEN=2) :: C2A,C2M,C2J,C2H
       CHARACTER(LEN=4) :: C4A
       CHARACTER(LEN=6) :: C6
       CHARACTER(LEN=11) :: C11

       INTEGER :: NBHOUR,NBDAY
       INTEGER, DIMENSION(12) :: NBJOUR
       INTEGER , DIMENSION(5) :: idate1






       DATA FIRSTTIME/.TRUE./
       SAVE FIRSTTIME
       DATA PINTERP/100000.,95000.,90000.,85000.,80000.,70000.,60000.,
     +              50000. ,40000.,30000.,25000.,20000.,15000.,10000.,
     +               7000./
       DATA ZINTERP/10.,20.,50.,100.,250.,500.,750.,
     +               1000. ,1250.,1500./
       DATA NBJOUR/31,28,31,30,31,30,31,31,30,31,30,31/

C
C Initialisations et calcul des facteurs de conversions
C 
       T2DOUT(:,:)=0.
       T3DOUT(:,:,:)=0.

      IF (EMIUNIT(1).EQ.'MOLPRS') THEN
              
C 3D en mol/mol              
        DO K=1,NIV
         DO J=1,LAT
          DO I=1,LON
           CONV3D(I,J,K)=1.
          ENDDO
         ENDDO
        ENDDO
C
C 2D en mol/m2
        
        DO J=1,LAT
         DO I=1,LON
          CONV2D(I,J)=1./MAIR/GG
         ENDDO
        ENDDO
        
       ELSEIF (EMIUNIT(1).EQ.'BQPERH') THEN
C 3D en Bq/m3
        DEMIVIE=HALFLIFE(1)
        CST1=XAVOG/DEMIVIE*LOG(2.)
        DO K=1,NIV
         DO J=1,LAT
          DO I=1,LON
           CONV3D(I,J,K)=CST1*XPAM(I,J,K)/RD/TGRIM(I,J,K)*MAIR
          ENDDO
         ENDDO
        ENDDO
C
C 2D en Bq/m2
        
        DO J=1,LAT
         DO I=1,LON
          CONV2D(I,J)=CST1/MAIR/GG
         ENDDO
        ENDDO
        
       ELSEIF (EMIUNIT(1).EQ.'GRPERS') THEN
       
C 3D en g/m3       
        DO K=1,NIV
         DO J=1,LAT
          DO I=1,LON
           CONV3D(I,J,K)=MOLWEIGHT(1)*XPAM(I,J,K)/RD/TGRIM(I,J,K)
          ENDDO
         ENDDO
        ENDDO
        
C 2d en g/m2        
        DO J=1,LAT
         DO I=1,LON
          CONV2D(I,J)=1./(MOLWEIGHT(1)*MAIR*GG)
         ENDDO
        ENDDO

      ENDIF
C
C Calcul de la date courante
C 
        NBDAY=int(daynum/86400.)
        NBHOUR=int((daynum-real(NBDAY)*86400.)/3600.)


        IF (.NOT.TRANSINV) THEN
        idate1(5)=0
        idate1(4)=idate0(4)+NBHOUR
        idate1(3)=idate0(3)+NBDAY
        idate1(2)=idate0(2)
        idate1(1)=idate0(1)
        IF (idate1(4).GE.24) THEN
          idate1(4)=idate1(4)-24
          idate1(3)=idate1(3)+1
        ENDIF
        IF (mod(idate0(1),4).EQ.0) THEN
          nbjour(2)=29
        ENDIF
        IF (idate1(3).GT.nbjour(idate1(2))) THEN
          idate1(3)=idate1(3)-nbjour(idate1(2))
          idate1(2)=idate1(2)+1
        ENDIF
        IF (idate1(2).GT.12) THEN
          idate1(1)=idate1(1)+1
          idate1(2)=1
        ENDIF
      ELSE
        idate1(5)=0
        idate1(4)=idate0(4)-NBHOUR
        idate1(3)=idate0(3)-NBDAY
        idate1(2)=idate0(2)
        idate1(1)=idate0(1)
        IF (idate1(4).LT.0) THEN
          idate1(4)=idate1(4)+24
          idate1(3)=idate1(3)-1
        ENDIF
        IF (idate1(4).GE.24) THEN
          idate1(4)=idate1(4)-24
          idate1(3)=idate1(3)+1
        ENDIF
        IF (mod(idate0(1),4).EQ.0) THEN
          nbjour(2)=29
        ENDIF
        IF (idate1(3).GT.nbjour(idate1(2))) THEN
          idate1(3)=idate1(3)-nbjour(idate1(2))
          idate1(2)=idate1(2)+1
        ENDIF
        IF (idate1(3).LE.0) THEN
          idate1(2)=idate1(2)-1
        ENDIF
        IF (idate1(2).LE.0) THEN
          idate1(1)=idate1(1)-1
          idate1(2)=12
        ENDIF
        IF (idate1(2).GT.12) THEN
          idate1(1)=idate1(1)+1
          idate1(2)=1
        ENDIF
        IF (idate1(3).LE.0) THEN
          idate1(3)=idate1(3)+nbjour(idate1(2))
        ENDIF
      ENDIF

      WRITE(C4A,1004) IDATE1(1)
      C2A=C4A(3:4)
      
      WRITE(C2M,1002) IDATE1(2)
      WRITE(C2J,1002) IDATE1(3)
      
      C6=C2A//C2M//C2J

      IF (IDATE1(4).LE.9) THEN
        WRITE(C1H,1001) IDATE1(4)
        C2H='0'//C1H
      ELSE
       WRITE(C2H,1002) IDATE1(4)
      ENDIF

      C11='_'//C4A//C2M//C2J//C2H

1001  FORMAT(I1)
1002  FORMAT(I2) 
1004  FORMAT(I4)  
      

C
C Ouverture et ecriture de l'entete du fichier
C 
       OPEN(IFSORACCP,file='CONPRE_'//NAMDOM//C11,form='UNFORMATTED')
       OPEN(IFSORACCZ,file='CONSIG_'//NAMDOM//C11,form='UNFORMATTED')
    
       RWORK1=REAL(LAT)
       RWORK2=REAL(LON)
       RWORK3=REAL(NIVINTERP-1)
       RWORK4=REAL(RLAT(LAT))
       RWORK5=REAL(RLON(1))
       RWORK6=REAL(DRLAT)
       RWORK7=REAL(DRLON)

       

       WRITE(IFSORACCP) RWORK1,RWORK2,RWORK3,RWORK4,
     +                  RWORK5,RWORK6,RWORK7
       
       RWORK3=REAL(NIVINTERZ-1)
       WRITE(IFSORACCZ)  RWORK1,RWORK2,RWORK3,RWORK4,
     +                   RWORK5,RWORK6,RWORK7


      RWORK1=REAL(IDATE1(4))*3600.

      WRITE(IFSORACCP)  C6,RWORK1
      WRITE(IFSORACCZ)  C6,RWORK1

C
C Calcul des champs a ecrire dans le fichier
C

C
C ATMOSPHERIC MIXING RATIOS
C
C 
       DO ISRC=1,NTRA
        DO K=1,NIV
         DO J=1,LAT
          DO I=1,LON
           T3DOUT(I,J,K)=T3DOUT(I,J,K)
     +                  +MAX(QQQM(I,J,K,ISRC),1.E-30)*CONV3D(I,J,K)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
       
C
C On calcule les coefficients d'interpolation pour passer
C en niveaux pressions
C
!      DO ISRC=1,NTRA
!      DO L=1,NIV
!        DO K=1,LAT
!         DO I=1,LON
!         SOMTES(I,K)=SOMTES(I,K)+QQQM(I,K,L,ISRC)
!         ENDDO
!        ENDDO
!       ENDDO
!      ENDDO

!      EPSILON=1.E-28
!      SEUILTES=1.E-30*REAL(NIV)*REAL(NTRA)+EPSILON
!      DO K=1,LAT
!       DO I=1,LON
!        IF (SOMTES(I,K).LE.SEUILTES) THEN
!         CALCUL(I,K)=.FALSE.
!        ENDIF
!       ENDDO
!      ENDDO
        
     

      LINFP(:,:,:)=0
      LSUPP(:,:,:)=0
      
      DO INIV=1,NIVINTERP
       PFIN=PINTERP(INIV)
       
       DO L=1,NIV
        DO K=1,LAT
         DO I=1,LON
          IF (XPAM(I,K,L).LE.PFIN) LSUPP(I,K,INIV)=L
         ENDDO
        ENDDO
       ENDDO

       DO K=1,LAT
        DO I=1,LON
         LINFP(I,K,INIV)=MIN(LSUPP(I,K,INIV)+1,NIV)
        ENDDO
       ENDDO
       LSUPP(:,:,:)=MAX(1,MIN(LSUPP(:,:,:),NIV))
       
       DO K=1,LAT
        DO I=1,LON
    
         PRESINF(I,K,INIV)=XPAM(I,K,LINFP(I,K,INIV))
         PRESSUP(I,K,INIV)=XPAM(I,K,LSUPP(I,K,INIV))

        ENDDO
       ENDDO

       ENDDO
       T3DOUTMEDIAP(:,:,:)=0.
       DO INIV=1,NIVINTERP
       PINF=PINTERP(INIV)
        DO K=1,LAT
         DO I=1,LON
          DELTAP=PRESSUP(I,K,INIV)-PRESINF(I,K,INIV)
          IF (DELTAP.EQ.0.) THEN ! cad LINF=LSUP
           COEFINF=1
           COEFSUP=0.
          ELSE
           COEFINF=(PRESSUP(I,K,INIV)-PINF             )/DELTAP
           COEFSUP=(PINF             -PRESINF(I,K,INIV))/DELTAP
          ENDIF
          T3DOUTMEDIAP(I,K,INIV)=COEFINF*T3DOUT(I,K,LINFP(I,K,INIV)) 
     +                          +COEFSUP*T3DOUT(I,K,LSUPP(I,K,INIV)) 

         ENDDO
        ENDDO
       ENDDO

       TAB3DP(:,:,:)=REAL(T3DOUTMEDIAP(:,:,:))
       

       DO INIV=1,NIVINTERP
        WRITE(IFSORACCP)
     +          ((TAB3DP(I,J,INIV),I=1,LON),J=LAT,1,-1)
       ENDDO
C
C Calculs des altitudes
C 
      DO K=1,LAT
       DO I=1,LON
        ALTI(I,K,NIV)=RA*TGRIM(I,K,NIV)/GG*
     +            MAX(0.,LOG(XPHFM(I,K,NIV)/XPAM(I,K,NIV)))
       ENDDO
      ENDDO
      DO L=NIV-1,1,-1
       LP1=L+1
        DO K=1,LAT
         DO I=1,LON
          ALTI(I,K,L)=ALTI(I,K,LP1)+ RA/GG *TGRIM(I,K,L)
     +               *LOG(XPAM(I,K,LP1)/XPAM(I,K,L))
         ENDDO
        ENDDO
       ENDDO
  
      LINFZ(:,:,:)=0
      LSUPZ(:,:,:)=0
      
      DO INIV=1,NIVINTERZ

       ZFIN=ZINTERP(INIV)
       
       DO L=1,NIV
        DO K=1,LAT
         DO I=1,LON
          IF (ALTI(I,K,L).GE.ZFIN)  LSUPZ(I,K,INIV)=L
         ENDDO
        ENDDO
       ENDDO

       DO K=1,LAT
        DO I=1,LON
         LINFZ(I,K,INIV)=MIN(LSUPZ(I,K,INIV)+1,NIV)
        ENDDO
       ENDDO

       LSUPZ(:,:,:)=MAX(1,MIN(LSUPZ(:,:,:),NIV))
       

       DO K=1,LAT
        DO I=1,LON
         ALTIINF(I,K,INIV)=ALTI(I,K,LINFZ(I,K,INIV))
         ALTISUP(I,K,INIV)=ALTI(I,K,LSUPZ(I,K,INIV))

        ENDDO
       ENDDO
      ENDDO

       T3DOUTMEDIAZ(:,:,:)=0.
       
       DO INIV=1,NIVINTERZ
       ZINF=ZINTERP(INIV)
        DO K=1,LAT
         DO I=1,LON
          DELTAZ=ALTISUP(I,K,INIV)-ALTIINF(I,K,INIV)
          IF (DELTAZ.EQ.0.) THEN ! cad LINF=LSUP
           COEFINF=1.
           COEFSUP=0.
          ELSE
           COEFINF=(ALTISUP(I,K,INIV)-ZINF             )/DELTAZ
           COEFSUP=(ZINF             -ALTIINF(I,K,INIV))/DELTAZ
          ENDIF

          T3DOUTMEDIAZ(I,K,INIV)=COEFINF*T3DOUT(I,K,LINFZ(I,K,INIV)) 
     +                          +COEFSUP*T3DOUT(I,K,LSUPZ(I,K,INIV)) 

         ENDDO
        ENDDO
       ENDDO

       TAB3DZ(:,:,:)=REAL(T3DOUTMEDIAZ(:,:,:))

       DO INIV=1,NIVINTERZ
        WRITE(IFSORACCZ)
     +          ((TAB3DZ(I,J,INIV),I=1,LON),J=LAT,1,-1)
       ENDDO
C
C TOTAL WET DEPOSITION
C
      T2DOUT(:,:)=0.
      DO ISRC=1,NTRA
       DO J=1,LAT
        DO I=1,LON
         T2DOUT(I,J)=T2DOUT(I,J)+DFBCVCUMUL(I,J,ISRC)
     +                          +DFICVCUMUL(I,J,ISRC)
     +                          +DFSTRCUMUL(I,J,ISRC)
         T2DOUT(I,J)=T2DOUT(I,J)*CONV2D(I,J)
         ENDDO
        ENDDO
       ENDDO

      TAB2D(:,:)=REAL(T2DOUT(:,:))
      WRITE(IFSORACCZ) 
     +      ((TAB2D(I,J),I=1,LON),J=LAT,1,-1)

       
C
C DRY DEPOSITION
C
       DO ISRC=1,NTRA
        DO J=1,LAT
         DO I=1,LON
          T2DOUT(I,J)=T2DOUT(I,J)+DFDRYCUMUL(I,J,ISRC)*CONV2D(I,J)
         ENDDO
        ENDDO
       ENDDO

       TAB2D(:,:)=REAL(T2DOUT(:,:))
       WRITE(IFSORACCZ)
     +        ((TAB2D(I,J),I=1,LON),J=LAT,1,-1)

       CLOSE(IFSORACCP)
       CLOSE(IFSORACCZ)

       RETURN 
       END
      

