        SUBROUTINE SOUDIAGSOM(IFSORACC,NAMDOM,LON,LAT,NIV,NTRA,
     +                        QQQM,DFDRYCUMUL,DFBCVCUMUL,
     +                        DFICVCUMUL,DFSTRCUMUL,
     +                        PCVRCUMUL,PCVSCUMUL,
     +                        PSTRCUMUL,TGRIM,XPAM)
C
C Diagnostic somms pour le mode accident
C
       USE CSTES_MOD
       USE SRC_MOD

       IMPLICIT NONE
      
       INTEGER  IFSORACC
C      numero d'unite du fichier de sortie      
       CHARACTER*6 NAMDOM
c      nom du domaine
       INTEGER LON,LAT,NIV,NTRA
C      Geometrie et nombre de polluants
       REAL QQQM(LON,LAT,NIV,NTRA)
C      Rapport de melange de polluants
       REAL DFDRYCUMUL(LON,LAT,NSRC)
C      Depots secs       
       REAL DFBCVCUMUL(LON,LAT,NSRC)
       REAL DFICVCUMUL(LON,LAT,NSRC)
       REAL DFSTRCUMUL(LON,LAT,NSRC)
C      Depots au sol du au lessivage sous/dans le nuage cv et
C      stratiforme
       REAL PCVRCUMUL(LON,LAT,NIV)
       REAL PCVSCUMUL(LON,LAT,NIV)
       REAL PSTRCUMUL(LON,LAT,NIV)
C      Cumuls 3D de pluie cv, neige cv et precip strati
       REAL TGRIM(LON,LAT,NIV)
       REAL XPAM (LON,LAT,NIV)
C      Temperature et pression

       INTEGER I,J,K,ISRC
       REAL T2DOUT(LON,LAT)
       REAL T3DOUT(LON,LAT,NIV)

       REAL CONV3D(LON,LAT,NIV)
       REAL CONV2D(LON,LAT)
       REAL DEMIVIE

       LOGICAL FIRSTTIME

       REAL CST1

       DATA FIRSTTIME/.TRUE./
       SAVE FIRSTTIME

      IF (FIRSTTIME) THEN
       OPEN(IFSORACC,file='RESACC'//NAMDOM,form='UNFORMATTED')
       WRITE(IFSORACC) NSRC
       FIRSTTIME=.FALSE.
      ENDIF

       T2DOUT(:,:)=0.
       T3DOUT(:,:,:)=0.

      IF (EMIUNIT(1).EQ.'MOLPRS') THEN
              
C 3D en mol/mol              
        DO K=1,NIV
         DO J=1,LAT
          DO I=1,LON
           CONV3D(I,J,K)=1.
          ENDDO
         ENDDO
        ENDDO
C
C 2D en mol/m2
        
        DO J=1,LAT
         DO I=1,LON
          CONV2D(I,J)=1./MAIR/GG
         ENDDO
        ENDDO
        
       ELSEIF (EMIUNIT(1).EQ.'BQPERH') THEN
C 3D en Bq/m3
        DEMIVIE=HALFLIFE(1)
        CST1=XAVOG/DEMIVIE*LOG(2.)
        DO K=1,NIV
         DO J=1,LAT
          DO I=1,LON
           CONV3D(I,J,K)=CST1*XPAM(I,J,K)/RD/TGRIM(I,J,K)*MAIR
          ENDDO
         ENDDO
        ENDDO
C
C 2D en Bq/m2
        
        DO J=1,LAT
         DO I=1,LON
          CONV2D(I,J)=CST1/MAIR/GG
         ENDDO
        ENDDO
        
       ELSEIF (EMIUNIT(1).EQ.'GRPERS') THEN
       
C 3D en g/m3       
        DO K=1,NIV
         DO J=1,LAT
          DO I=1,LON
           CONV3D(I,J,K)=MOLWEIGHT(1)*XPAM(I,J,K)/RD/TGRIM(I,J,K)
          ENDDO
         ENDDO
        ENDDO
        
C 2d en g/m2        
        DO J=1,LAT
         DO I=1,LON
          CONV2D(I,J)=1./(MOLWEIGHT(1)*MAIR*GG)
         ENDDO
        ENDDO

      ENDIF

C
C ATMOSPHERIC MIXING RATIOS
C
       DO ISRC=1,NSRC
        DO K=1,NIV
         DO J=1,LAT
          DO I=1,LON
           T3DOUT(I,J,K)=T3DOUT(I,J,K)+QQQM(I,J,K,ISRC)*CONV3D(I,J,K)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
                 
        WRITE(IFSORACC) T3DOUT
C
C DRY DEPOSITION
C
       DO ISRC=1,NSRC
        DO J=1,LAT
         DO I=1,LON
          T2DOUT(I,J)=T2DOUT(I,J)+DFDRYCUMUL(I,J,ISRC)*CONV2D(I,J)
         ENDDO
        ENDDO
       ENDDO

         WRITE(IFSORACC) T2DOUT

C
C TOTAL WET DEPOSITION
C
      T2DOUT(:,:)=0.
      DO ISRC=1,NSRC
       DO J=1,LAT
        DO I=1,LON
         T2DOUT(I,J)=T2DOUT(I,J)+DFBCVCUMUL(I,J,ISRC)
     +                          +DFICVCUMUL(I,J,ISRC)
     +                          +DFSTRCUMUL(I,J,ISRC)
         T2DOUT(I,J)=T2DOUT(I,J)*CONV2D(I,J)
         ENDDO
        ENDDO
       ENDDO

       WRITE(IFSORACC) T2DOUT

     
C
C TOTAL PRECIPITATION FLUXES
C
       DO k=1,NIV
        DO j=1,LAT
         DO i=1,LON
          T3DOUT(i,j,k)= PCVRCUMUL(i,j,k)
     +                 + PCVSCUMUL(i,j,k)
     +                 + PSTRCUMUL(i,j,k)
         ENDDO
        ENDDO
       ENDDO

c       WRITE(IFSORACC) T3DOUT

C  TEMPERATURE FOR LATER CONVERSIONS (3D)
C 
c       WRITE(IFSORACC) TGRIM
C
C  PRESSURE ON MODEL LEVELS FOR LATER CONVERSIONS (3D)
C
c       WRITE(IFSORACC) XPAM


       RETURN 
       END
      

