        SUBROUTINE SOUDIAGTOT(IFSORACC,NAMDOM,LON,LAT,NIV,NTRA,
     +                        QQQM,DFDRYCUMUL,DFBCVCUMUL,
     +                        DFICVCUMUL,DFSTRCUMUL,
     +                        PCVRCUMUL,PCVSCUMUL,
     +                        PSTRCUMUL,TGRIM,XPAM)

C
C Diagnostics complets pour le mode accident
C
       USE CSTES_MOD
       USE SRC_MOD

       IMPLICIT NONE
       INTEGER  IFSORACC
C      numero d'unite du fichier de sortie       
       CHARACTER*6 NAMDOM
c      nom du domaine
       INTEGER LON,LAT,NIV,NTRA
C      Geometrie et nombre de polluants
       REAL QQQM(LON,LAT,NIV,NTRA)
C      Rapport de melange de polluants
       REAL DFDRYCUMUL(LON,LAT,NSRC)
C      Depots secs       
       REAL DFBCVCUMUL(LON,LAT,NSRC)
       REAL DFICVCUMUL(LON,LAT,NSRC)
       REAL DFSTRCUMUL(LON,LAT,NSRC)
C      Depots au sol du au lessivage sous/dans le nuage cv et
C      stratiforme
       REAL PCVRCUMUL(LON,LAT,NIV)
       REAL PCVSCUMUL(LON,LAT,NIV)
       REAL PSTRCUMUL(LON,LAT,NIV)
C      Cumuls 3D de pluie cv, neige cv et precip strati
       REAL TGRIM(LON,LAT,NIV)
       REAL XPAM (LON,LAT,NIV)
C      Temperature et pression

       

       INTEGER I,J,K,ISRC
       REAL T2DOUT(LON,LAT)
       REAL T3DOUT(LON,LAT,NIV)
       REAL CONV3D(LON,LAT,NIV,NSRC)
       REAL CONV2D(LON,LAT,NSRC)

       LOGICAL FIRSTTIME
       DATA FIRSTTIME/.TRUE./
       SAVE FIRSTTIME

      IF (FIRSTTIME) THEN
       OPEN(IFSORACC,file='RESACC'//NAMDOM,form='UNFORMATTED')
       WRITE(IFSORACC) NSRC
       FIRSTTIME=.FALSE.
      ENDIF

      


       T2DOUT(:,:)=0.
       T3DOUT(:,:,:)=0.
       DO ISRC=1,NSRC
       
       IF ((EMIUNIT(ISRC).EQ.'BQPERH').OR.
     +     (EMIUNIT(ISRC).EQ.'MOLPRS') ) THEN
C 3D en mol/mol              
        DO K=1,NIV
         DO J=1,LAT
          DO I=1,LON
           CONV3D(I,J,K,ISRC)=1.
          ENDDO
         ENDDO
        ENDDO
C
C 2D en mol/m2
        
        DO J=1,LAT
         DO I=1,LON
          CONV2D(I,J,ISRC)=1./MAIR/GG
         ENDDO
        ENDDO
        
       ELSEIF (EMIUNIT(1).EQ.'GRPERS') THEN
       
C 3D en g/m3       
        DO K=1,NIV
         DO J=1,LAT
          DO I=1,LON
           CONV3D(I,J,K,ISRC)=MOLWEIGHT(ISRC)*XPAM(I,J,K)
     +                       /RD/TGRIM(I,J,K)
          ENDDO
         ENDDO
        ENDDO
        
C 2d en g/m2        
        DO J=1,LAT
         DO I=1,LON
          CONV2D(I,J,ISRC)=1./(MOLWEIGHT(ISRC)*MAIR*GG)
         ENDDO
        ENDDO

      ENDIF

      ENDDO
      
   

C
C a. ATMOSPHERIC MIXING RATIOS (3D)
C
       DO isrc=1,NSRC
        DO k=1,NIV
         DO j=1,LAT
          DO i=1,LON
            T3DOUT(i,j,k)=QQQM(i,j,k,isrc)*CONV3D(I,J,K,ISRC)
          ENDDO
         ENDDO
        ENDDO
        WRITE(IFSORACC) T3DOUT
       ENDDO
C
C b. DRY DEPOSITION (2D)
C
       DO isrc=1,NSRC
         DO j=1,LAT
          DO i=1,LON
            T2DOUT(i,j)=DFDRYCUMUL(i,j,isrc)*CONV2D(I,J,ISRC)
          ENDDO
         ENDDO
         WRITE(IFSORACC) T2DOUT
       ENDDO
C
C c. WET SCAVENGING, BELOW CV CLOUDS (2D)
C
       DO isrc=1,NSRC
         DO j=1,LAT
          DO i=1,LON
           T2DOUT(i,j)=DFBCVCUMUL(i,j,isrc)
          ENDDO
         ENDDO
         WRITE(IFSORACC) T2DOUT
        ENDDO
C
C d. WET SCAVENGING, IN CV CLOUDS (2D)
C
       DO isrc=1,NSRC
        DO j=1,LAT
         DO i=1,LON
           T2DOUT(i,j)=DFICVCUMUL(i,j,isrc)
         ENDDO
        ENDDO
        WRITE(IFSORACC) T2DOUT
       ENDDO
C
C e. WET SCAVENGING, STRATIFORM (2D)
C
       DO isrc=1,NSRC
        DO j=1,LAT
         DO i=1,LON
           T2DOUT(i,j)=DFSTRCUMUL(i,j,isrc)
         ENDDO
        ENDDO
        WRITE(IFSORACC) T2DOUT
       ENDDO
C
C f. CONVECTIVE RAIN FLUXES (3D)
C
       WRITE(IFSORACC) PCVRCUMUL
C
C g. CONVECTIVE SNOW FLUXES (3D)
C
       WRITE(IFSORACC) PCVSCUMUL
C
C h. STRATIFORM RAIN+SNOW FLUXES (3D)
C
       WRITE(IFSORACC) PSTRCUMUL
C
C i. TEMPERATURE FOR LATER CONVERSIONS (3D)
C 
       WRITE(IFSORACC) TGRIM
C
C j. PRESSURE ON MODEL LEVELS FOR LATER CONVERSIONS (3D)
C
       WRITE(IFSORACC) XPAM

       RETURN
       END
   
