	MODULE CARIOP_MOD
C
C------------------------------------------------------------------------
C 	CARIOLLE CHEMISTRY COEFFICIENTS
C
C	AUTHOR	: HERVE LE BERRE	- CERFACS -
C	DATE		: 03/08/2005
C	VERSION	: 1_0_0
C------------------------------------------------------------------------
C
	IMPLICIT NONE
C
C	
#ifdef LINO_3
	REAL (KIND=8) , ALLOCATABLE , SAVE :: CARO3PARM1(:,:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: CARO3PARM2(:,:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: CARO3PARM3(:,:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: CARO3PARM4(:,:,:,:)
#endif
#ifdef LINCO
	REAL (KIND=8) , ALLOCATABLE , SAVE :: CARCOPARM1(:,:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: CARCOPARM2(:,:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: CARCOPARM3(:,:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: CARCOPARM4(:,:,:,:)
#endif
#ifdef LINHNO_3
	REAL (KIND=8) , ALLOCATABLE , SAVE :: CARHNO3PARM1(:,:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: CARHNO3PARM2(:,:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: CARHNO3PARM3(:,:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: CARHNO3PARM4(:,:,:,:)
#endif
C
	CONTAINS
C
	SUBROUTINE ALLOC_CARIOP
C
	USE PARADI_MOD
C
#ifdef LINO_3
	ALLOCATE (CARO3PARM1(LONM1,LATM1,NIVM1,NCARIO3))
	ALLOCATE (CARO3PARM2(LONM2,LATM2,NIVM2,NCARIO3))
	ALLOCATE (CARO3PARM3(LONM3,LATM3,NIVM3,NCARIO3))
	ALLOCATE (CARO3PARM4(LONM4,LATM4,NIVM4,NCARIO3))
#endif
#ifdef LINCO
	ALLOCATE (CARCOPARM1(LONM1,LATM1,NIVM1,NCARIOCO))
	ALLOCATE (CARCOPARM2(LONM2,LATM2,NIVM2,NCARIOCO))
	ALLOCATE (CARCOPARM3(LONM3,LATM3,NIVM3,NCARIOCO))
	ALLOCATE (CARCOPARM4(LONM4,LATM4,NIVM4,NCARIOCO))
#endif
#ifdef LINHNO_3
	ALLOCATE (CARHNO3PARM1(LONM1,LATM1,NIVM1,NCARIOHNO3))
	ALLOCATE (CARHNO3PARM2(LONM2,LATM2,NIVM2,NCARIOHNO3))
	ALLOCATE (CARHNO3PARM3(LONM3,LATM3,NIVM3,NCARIOHNO3))
	ALLOCATE (CARHNO3PARM4(LONM4,LATM4,NIVM4,NCARIOHNO3))
#endif
C
	END SUBROUTINE ALLOC_CARIOP
C
	SUBROUTINE DEALLOC_CARIOP
C
#ifdef LINO_3
	DEALLOCATE (CARO3PARM1)
	DEALLOCATE (CARO3PARM2)
	DEALLOCATE (CARO3PARM3)
	DEALLOCATE (CARO3PARM4)
#endif
#ifdef LINCO
	DEALLOCATE (CARCOPARM1)
	DEALLOCATE (CARCOPARM2)
	DEALLOCATE (CARCOPARM3)
	DEALLOCATE (CARCOPARM4)
#endif
#ifdef LINHNO_3
	DEALLOCATE (CARHNO3PARM1)
	DEALLOCATE (CARHNO3PARM2)
	DEALLOCATE (CARHNO3PARM3)
	DEALLOCATE (CARHNO3PARM4)
#endif
C
	END SUBROUTINE DEALLOC_CARIOP
C
	END MODULE CARIOP_MOD
