      SUBROUTINE CARIORELAX(NLON,NLAT,NIV,NTRA,DT,
     +                      XPAM,QQQM,TRANAM)
C
CCCCC
C
C   Relaxation towards climatological profiles
C   within the troposphere for REPROBUS
C
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
CCCCC
C
C  Original :  H. Teyssedre, 02/2004
C
CCCCC
C
	IMPLICIT NONE
C	
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
C
      INTEGER :: NLON,NLAT,NIV,NTRA
      REAL (KIND=8) :: DT
      REAL (KIND=8) , DIMENSION(NLON,NLAT,NIV,NTRA) :: QQQM
      REAL (KIND=8) , DIMENSION(NLON,NLAT,NIV) :: XPAM 
      CHARACTER(LEN=15) , DIMENSION (NTRA):: TRANAM
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C
      INTEGER :: NIVBAS
      INTEGER :: NOK,iO3
      INTEGER :: ITRA,INIV,ILON
	PARAMETER (NIVBAS=50)
      REAL (KIND=8) :: DTT,XLIM
C
CCC
C
C DETERMINE USEFUL INDEXES
C
#ifdef NIV_60
#define CPP_ESP 'O_3'
#else
#define CPP_ESP 'O_x'
#endif
      NOK=0
C
      DO itra = 1,NTRA
C O_3
        IF (TRANAM(itra).EQ.CPP_ESP) THEN
          NOK=NOK+1
          iO3=itra
        ENDIF
      ENDDO
C
      IF (NOK.NE.1) THEN
        WRITE(*,*)
     +  '>> CONSTITUENT(S) MISSING FOR RELAXATION : ABORT!'
        STOP
      ENDIF
C
      DTT=DT/86400.
C
      DO iniv=NIVBAS,NIV
        DO ilon=1,NLON*NLAT
          IF (XPAM(ilon,1,iniv).GT.37000.) THEN
            XLIM = -2.3825E-08*ALOG(XPAM(ilon,1,iniv)/100.)
     +           + 1.9457E-07
          ELSE
            XLIM = QQQM(ilon,1,iniv,iO3)
          ENDIF
          QQQM(ilon,1,iniv,iO3) = MAX(0. , XLIM +
     +             (QQQM(ilon,1,iniv,iO3) - XLIM)*EXP(-DTT) )
        ENDDO
      ENDDO
C
      RETURN
      END
C
