      SUBROUTINE INICARIO3 (idate0)
C
CCCC
C
C   Purpose : initialize coefficients for linearised 
C             ozone chemistry
C
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C
C   Centre National de Recherches Meteorologiques
C   Groupe de Modelisation de Grande Echelle et du Climat
C   Equipe de Recherches sur l'Atmosphere Moyenne
C
CCC
C
C  Original : H. Teyssedre, 11/2003
C
C  Modified :
C
C
	USE PARADI_MOD
	USE MOCF_MOD
	USE CARIOP_MOD
C
	IMPLICIT NONE	
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
C
	INTEGER , DIMENSION(5) :: idate0
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C	
      INTEGER :: IMOIS,ILAT,INIV,ICOEFF,ILON
      REAL (KIND=8) :: XXLAT,XXPRE,RCLY
#ifdef LINO_3
      REAL (KIND=8) , ALLOCATABLE :: CLY(:)
      REAL (KIND=8) , ALLOCATABLE :: CARIO3PM1(:,:,:,:)
      REAL (KIND=8) , ALLOCATABLE :: CARIO3PM2(:,:,:,:)
      REAL (KIND=8) , ALLOCATABLE :: CARIO3PM3(:,:,:,:)
      REAL (KIND=8) , ALLOCATABLE :: CARIO3PM4(:,:,:,:)
#endif
#ifdef LINCO
      REAL (KIND=8) , ALLOCATABLE :: CARIOCOPM1(:,:,:,:)
      REAL (KIND=8) , ALLOCATABLE :: CARIOCOPM2(:,:,:,:)
      REAL (KIND=8) , ALLOCATABLE :: CARIOCOPM3(:,:,:,:)
      REAL (KIND=8) , ALLOCATABLE :: CARIOCOPM4(:,:,:,:)
#endif
#ifdef LINHNO_3
      REAL (KIND=8) , ALLOCATABLE :: CARIOHNO3PM1(:,:,:,:)
      REAL (KIND=8) , ALLOCATABLE :: CARIOHNO3PM2(:,:,:,:)
      REAL (KIND=8) , ALLOCATABLE :: CARIOHNO3PM3(:,:,:,:)
      REAL (KIND=8) , ALLOCATABLE :: CARIOHNO3PM4(:,:,:,:)
#endif
C
      CHARACTER (LEN=80) :: CHEADER
C
#ifdef LINO_3
C     TAUX D'EVOLUTION DU CHLORE STRATOSPHERIQUE TOTAL (EN PPBV)
C     ENTRE LES ANNEES 1970 ET 2050 D'APRES LE SCENARIO A3 DE L'IPCC
C
      ALLOCATE (CLY(1970:2050))
C
      CLY=(/
     + 1.241,1.336,1.435,1.535,1.649,1.780,1.899,2.018,2.142,2.261,
     + 2.375,2.487,2.582,2.675,2.768,2.863,2.968,3.080,3.193,3.307,
     + 3.419,3.502,3.565,3.612,3.618,3.605,3.593,3.568,3.552,3.544,
     + 3.540,3.540,3.544,3.551,3.559,3.567,3.571,3.572,3.570,3.566,
     + 3.560,3.548,3.526,3.499,3.468,3.435,3.387,3.338,3.289,3.240,
     + 3.192,3.145,3.099,3.053,3.009,2.966,2.924,2.884,2.845,2.806,
     + 2.769,2.733,2.699,2.664,2.631,2.599,2.568,2.537,2.507,2.478,
     + 2.449,2.421,2.391,2.361,2.332,2.303,2.274,2.246,2.219,2.192,
     + 2.166/)
C
C
      IF (IFLAG1) THEN
	ALLOCATE (CARIO3PM1(LATM1,NIVM1,NCARIO3,12))
        OPEN(79,FILE='CARIOZO',FORM='FORMATTED',STATUS='OLD')
        READ(79,'(A)') CHEADER
        PRINT*, CHEADER
        DO imois=1,12
          READ(79,*)
          READ(79,*)
          DO ilat=1,LATM1
          DO iniv=1,NIVM1
            READ(79,*) XXLAT,XXPRE,
     +          (CARIO3PM1(ilat,iniv,icoeff,imois),icoeff=1,NCARIO3)
          ENDDO
          ENDDO
        ENDDO
        CLOSE(79)
        DO ilat=1,LATM1*NIVM1*NCARIO3
          CARO3PARM1(1,ilat,1,1)=CARIO3PM1(ilat,1,1,idate0(2))
        ENDDO
        IF ( (idate0(1).LT.1970).OR.
     +       (idate0(1).GT.2050) ) THEN
          PRINT*,"ABORT : UNKNOWN Cly"
          STOP
        ELSE
          PRINT*,"TOTAL STRATOSPHERIC CHLORINE : ",
     +           CLY(idate0(1))," ppbv"
        ENDIF
        RCLY =(CLY(idate0(1))/CLY(2000))**2.0
        DO ilat=1,LATM1*NIVM1
          CARO3PARM1(1,ilat,1,8)=CARO3PARM1(1,ilat,1,8)*RCLY
        ENDDO
        DO ilon=2,LONM1
          DO ilat=1,LATM1*NIVM1*NCARIO3
            CARO3PARM1(ilon,ilat,1,1)=CARO3PARM1(1,ilat,1,1)
          ENDDO
        ENDDO
	DEALLOCATE (CARIO3PM1)
      ENDIF
C
      DEALLOCATE (CLY)  
C
#endif
#ifdef LINCO
C
      IF (IFLAG1) THEN
	ALLOCATE (CARIOCOPM1(LATM1,NIVM1,NCARIOCO,12))
        OPEN(78,FILE='CARIOCO',FORM='FORMATTED',STATUS='OLD')
        READ(78,'(A)') CHEADER
        PRINT*, CHEADER
        DO imois=1,12
          READ(78,*)
          READ(78,*)
          DO ilat=1,LATM1
          DO iniv=1,NIVM1
            READ(78,*) XXLAT,XXPRE,
     +          (CARIOCOPM1(ilat,iniv,icoeff,imois),icoeff=1,NCARIOCO)
          ENDDO
          ENDDO
        ENDDO
        CLOSE(78)
        DO ilat=1,LATM1*NIVM1*NCARIOCO
          CARCOPARM1(1,ilat,1,1)=CARIOCOPM1(ilat,1,1,idate0(2))
        ENDDO
        DO ilon=2,LONM1
          DO ilat=1,LATM1*NIVM1*NCARIOCO
            CARCOPARM1(ilon,ilat,1,1)=CARCOPARM1(1,ilat,1,1)
          ENDDO
        ENDDO
	DEALLOCATE (CARIOCOPM1)
      ENDIF
C
#endif
#ifdef LINHNO_3
C
      IF (IFLAG1) THEN
	ALLOCATE (CARIOHNO3PM1(LATM1,NIVM1,NCARIOHNO3,12))
        OPEN(77,FILE='CARIOHNO3',FORM='FORMATTED',STATUS='OLD')
        READ(77,'(A)') CHEADER
        PRINT*, CHEADER
        DO imois=1,12
          READ(77,*)
          READ(77,*)
          DO ilat=1,LATM1
          DO iniv=1,NIVM1
            READ(77,*) XXLAT,XXPRE,
     +   (CARIOHNO3PM1(ilat,iniv,icoeff,imois),icoeff=1,NCARIOHNO3)
          ENDDO
          ENDDO
        ENDDO
        CLOSE(77)
        DO ilat=1,LATM1*NIVM1*NCARIOHNO3
          CARHNO3PARM1(1,ilat,1,1)=CARIOHNO3PM1(ilat,1,1,idate0(2))
        ENDDO
        DO ilon=2,LONM1
          DO ilat=1,LATM1*NIVM1*NCARIOHNO3
            CARHNO3PARM1(ilon,ilat,1,1)=CARHNO3PARM1(1,ilat,1,1)
          ENDDO
        ENDDO
	DEALLOCATE (CARIOHNO3PM1)
      ENDIF
C
#endif
C
      RETURN
      END
