	MODULE ALLOC_MOD
C
C------------------------------------------------------------------------
C 	DYNAMIC ARRAY ALLOCATION AND DEALLOCATION
C
C	AUTHOR	: HERVE LE BERRE	- CERFACS -
C	DATE		: 03/08/2005
C	VERSION	: 1_0_0
C------------------------------------------------------------------------
C
C
	USE PARADI_MOD
	USE CSTES_MOD
	USE EXPE_MOD
	USE MRAT_MOD
#ifdef CARIOLLE
	USE CARIOP_MOD 
#endif	
	USE UNDCOLMT_MOD
	USE GRIDS_MOD
	USE MOCF_MOD
	USE FORC_MOD
	USE FORM_MOD
	USE FORMT_MOD
	USE FORFT_MOD
	USE FORS_MOD
	USE TOPCH_MOD
	USE DATOBS_MOD
	USE PHOTO_MOD
	USE OUTNETCDF_MOD
	USE POSI_MOD
	USE SRC_MOD
	USE SVPHOT_MOD
	USE HENRY_MOD
	USE CLOUDRAIN_MOD
#ifdef GAUSS
        USE GAUSS_MOD
#endif
#ifdef ACCIDENT
        USE SRCFLX_MOD
#endif

C	
C
	IMPLICIT NONE
C
	CONTAINS
C
	SUBROUTINE ALLOC_GLOBAL
C
C------------------------------------------------------------------------
C 	DYNAMIC ARRAY ALLOCATION AND GLOBAL PARAMETERS SETTINGS
C
C	AUTHOR	: HERVE LE BERRE	- CERFACS -
C	DATE		: 03/08/2005
C	VERSION	: 1_0_0
C------------------------------------------------------------------------
C
C
C
	CALL ALLOC_CSTES
	CALL ALLOC_MRAT
	CALL ALLOC_FORMT
	CALL ALLOC_GRIDS
	CALL ALLOC_PHOTO
	CALL ALLOC_SVPHOT
C
#ifdef CARIOLLE
	CALL ALLOC_CARIOP
#endif
	IF (L1D) CALL ALLOC_UNDCOLMT
	IF (SRC) CALL ALLOC_SRC
	CALL ALLOC_FORM
	CALL ALLOC_FORC
	CALL ALLOC_POSI
	CALL ALLOC_FORFT
	CALL ALLOC_HENRY
	CALL ALLOC_TOPCH
	IF (OBS) CALL ALLOC_DATOBS
	IF ( (CLOUD).OR.(PRMTRSP.EQ.'KFB').OR.(PRMTRSP.EQ.'TDK') )
     &    CALL ALLOC_CLOUDRAIN
	IF (SURF) CALL ALLOC_FORS
#ifdef GAUSS
	CALL ALLOC_GAUSS
#endif
#ifdef ACCIDENT
          CALL ALLOC_SRCFLX
#endif
C
	END SUBROUTINE ALLOC_GLOBAL
C
	SUBROUTINE DEALLOC_GLOBAL
C
C------------------------------------------------------------------------
C 	DYNAMIC ARRAY DEALLOCATION
C
C	AUTHOR	: HERVE LE BERRE	- CERFACS -
C	DATE		: 03/08/2005
C	VERSION	: 1_0_0
C------------------------------------------------------------------------
C
C
	CALL DEALLOC_CSTES
	CALL DEALLOC_MRAT
	CALL DEALLOC_FORMT
	CALL DEALLOC_GRIDS
	CALL DEALLOC_PHOTO
	CALL DEALLOC_SVPHOT
C
#ifdef CARIOLLE
	CALL DEALLOC_CARIOP
#endif
#ifdef GAUSS
	CALL DEALLOC_GAUSS
#endif
	IF (L1D) CALL DEALLOC_UNDCOLMT
	IF (SRC) CALL DEALLOC_SRC
	CALL DEALLOC_FORM
	CALL DEALLOC_FORC
	CALL DEALLOC_POSI
	CALL DEALLOC_FORFT
	CALL DEALLOC_HENRY
	CALL DEALLOC_TOPCH
	IF (OBS) CALL DEALLOC_DATOBS
	IF ( (CLOUD) .OR.(PRMTRSP.EQ.'KFB').OR.(PRMTRSP.EQ.'TDK') )
     &    CALL DEALLOC_CLOUDRAIN
	IF (SURF) CALL DEALLOC_FORS
C
#ifdef ACCIDENT
          CALL DEALLOC_SRCFLX
#endif
	END SUBROUTINE DEALLOC_GLOBAL
C
	END MODULE ALLOC_MOD

