subroutine assim_mopitt(nlon,nlat,nlev              &
                       ,idate                       &
                       ,lon,lat                     &
                       ,ps,p_i,p_m                  &
                       ,co,co_err)

!
!!!
!   __  __   _____   _____   _____   _____   _____
!  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
!  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
!  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
!
!   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
!   VERSION_RELEASE_BUGFIX : 0_1_1 
!
!!! DATE : 09/06/2005
!
!   Type      : Dummy
!   Purpose   : Avoid unresolved for mopitt kalman assimilation
!   Called by : 
!
!!!
!
!  Original : A. Piacentini 06/2005
!
!!!
!
  implicit none
!
! arguments

  integer, intent(in) :: nlon                                   ! number of points in longitude
  integer, intent(in) :: nlat                                   ! number of points in latitude
  integer, intent(in) :: nlev                                   ! number of points in the vertical
  integer       , dimension(5)             , intent(in)    :: idate  ! actual date
  real (kind=8) , dimension(nlon)          , intent(in)    :: lon    ! model grid longitudes
  real (kind=8) , dimension(nlat)          , intent(in)    :: lat    ! model grid latitudes
  real (kind=8) , dimension(nlon,nlat)     , intent(in)    :: ps     ! surface pressure
  real (kind=8) , dimension(nlon,nlat,nlev), intent(in)    :: p_i    ! pressure at interfaces
  real (kind=8) , dimension(nlon,nlat,nlev), intent(in)    :: p_m    ! pressure in layers
  real (kind=8) , dimension(nlon,nlat,nlev), intent(inout) :: co     ! co model distribution (in volume mixing ratio)
  real (kind=8) , dimension(nlon,nlat,nlev), intent(inout) :: co_err ! co error model distribution (in volume mixing ratio)
  return
end subroutine assim_mopitt

