C
      SUBROUTINE BACKTRA                                                
C
CCC
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type       : 3D semi-lagrangian transport scheme
C   Purpose    : Comptute back-trajectories
C   Called by  : ADVECSL
C
CCC
C
C  Original : P. Simon, 03/1999
C
C  Modified : V.-H. Peuch              (inclusion dans MOCAGE), 04/1999
C             P. Simon (modif dans la formulation multigrille), 08/1999
C
CCC
C
      USE PARADI_MOD
      USE EXPE_MOD
      USE MOCF_MOD
      USE GRIDS_MOD
      USE FORC_MOD
      USE FORM_MOD
      USE FORFT_MOD
      USE FORMT_MOD
      USE POSI_MOD
      USE CSTES_MOD
      USE GAUSS_MOD
C
      IMPLICIT NONE	
C
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C
      INTEGER :: L,K,J,N,ITER,NDOM,IDOM,NPTR,NPTR1,NPTR2,NPTR3,NPTR4,IT
      INTEGER :: NDEB1,NDEB2,NDEB3,NDEB4,I
      REAL (KIND=8) :: CINTA,CINTB,SYOR,CYOR,CXOR,COEFH,COEFV
      REAL (KIND=8) :: SYMR,CYMR,SYM,CYM,CXM
      REAL (KIND=8) :: PL1,RAP
C
      REAL (KIND=8) , ALLOCATABLE, TARGET :: XM(:),YM(:),ZM(:),PM(:)
      INTEGER , ALLOCATABLE :: IND(:)
      REAL (KIND=8) , POINTER :: XO(:),YO(:),ZO(:),PO(:)
C
      REAL (KIND=8) , ALLOCATABLE :: XMR(:),YMR(:)

      REAL (KIND=8) , ALLOCATABLE :: XOR(:),YOR(:)
C
C  vitesse interpolee sur les points medians
C
      REAL (KIND=8) , ALLOCATABLE :: USM(:),VSM(:),WSM(:)
      REAL (KIND=8) , ALLOCATABLE :: URM(:),VRM(:)
C
C  tableaux de travail
C
      REAL (KIND=8) , POINTER :: XR(:),YR(:),ZR(:),PR(:)
C
      INTEGER , ALLOCATABLE :: INDX(:),INDY(:),INDZ(:),IGRI(:)
      REAL (KIND=8) , ALLOCATABLE :: ALFX1(:),ALFX2(:)
      REAL (KIND=8) , ALLOCATABLE :: ALFX3(:),ALFX4(:)
      REAL (KIND=8) , ALLOCATABLE :: ALFY1(:),ALFY2(:)
      REAL (KIND=8) , ALLOCATABLE :: ALFY3(:),ALFY4(:)
      REAL (KIND=8) , ALLOCATABLE :: ALFZ1(:),ALFZ2(:)
      REAL (KIND=8) , ALLOCATABLE :: ALFZ3(:),ALFZ4(:) 
C
      REAL (KIND=8) , ALLOCATABLE :: WWORK1(:,:),WWORK2(:,:)
      REAL (KIND=8) , ALLOCATABLE :: WWORK3(:,:),WWORK4(:,:)

      ALLOCATE (XM(NPTS))	 ;  !XM(:) = 0.0
      ALLOCATE (YM(NPTS))	 ;  !YM(:) = 0.0
      ALLOCATE (ZM(NPTS))	 ;  !ZM(:) = 0.0
      ALLOCATE (PM(NPTS))	 ;  !PM(:) = 0.0
C	
      ALLOCATE (IND(NPTS))	 ;  !IND(:) = 0
C	
      ALLOCATE (XMR(NPTS))	 ;  !XMR(:) = 0.0
      ALLOCATE (YMR(NPTS))	 ;  !YMR(:) = 0.0
      ALLOCATE (XOR(NPTS))	 ;  !XOR(:) = 0.0
      ALLOCATE (YOR(NPTS))	 ;  !YOR(:) = 0.0
C	
      ALLOCATE (USM(NPTS))	 ;  !USM(:) = 0.0
      ALLOCATE (VSM(NPTS))	 ;  !VSM(:) = 0.0
      ALLOCATE (WSM(NPTS))	 ;  !WSM(:) = 0.0
      ALLOCATE (URM(NPTS))	 ;  !URM(:) = 0.0
      ALLOCATE (VRM(NPTS))	 ;  !VRM(:) = 0.0
C	
      ALLOCATE (INDX(NPTS))	 ;  !INDX(:) = 0
      ALLOCATE (INDY(NPTS))	 ;  !INDY(:) = 0
      ALLOCATE (INDZ(NPTS))	 ;  !INDZ(:) = 0
      ALLOCATE (IGRI(NPTS))	 ;  !IGRI(:) = 0
C		
      ALLOCATE (ALFX1(NPTS))	 ;  !ALFX1(:) = 0.0
      ALLOCATE (ALFX2(NPTS))	 ;  !ALFX2(:) = 0.0
      ALLOCATE (ALFX3(NPTS))	 ;  !ALFX3(:) = 0.0
      ALLOCATE (ALFX4(NPTS))	 ;  !ALFX4(:) = 0.0
C		
      ALLOCATE (ALFY1(NPTS))	 ;  !ALFY1(:) = 0.0
      ALLOCATE (ALFY2(NPTS))	 ;  !ALFY2(:) = 0.0
      ALLOCATE (ALFY3(NPTS))	 ;  !ALFY3(:) = 0.0
      ALLOCATE (ALFY4(NPTS))	 ;  !ALFY4(:) = 0.0
C		
      ALLOCATE (ALFZ1(NPTS))	 ;  !ALFZ1(:) = 0.0
      ALLOCATE (ALFZ2(NPTS))	 ;  !ALFZ2(:) = 0.0
      ALLOCATE (ALFZ3(NPTS))	 ;  !ALFZ3(:) = 0.0
      ALLOCATE (ALFZ4(NPTS))	 ;  !ALFZ4(:) = 0.0
	
      ALLOCATE(WWORK1(LONF1,LATF1))	 ;  !WWORK1(:,:) = 0.0
      ALLOCATE(WWORK2(LONF2,LATF2))	 ;  !WWORK2(:,:) = 0.0
      ALLOCATE(WWORK3(LONF3,LATF3))	 ;  !WWORK3(:,:) = 0.0
      ALLOCATE(WWORK4(LONF3,LATF4))	 ;  !WWORK4(:,:) = 0.0

C	
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C       Selectionne les domaines actifs
C
      IF(IFLAG1) NDOM=1
      IF(IFLAG2) NDOM=2
      IF(IFLAG3) NDOM=3
      IF(IFLAG4) NDOM=4
C
      IF (NDOM .ge. 2) THEN
C
          ALLOCATE (XO(NPTS)) ; !XO(:) = 0.0
          ALLOCATE (YO(NPTS)) ; !YO(:) = 0.0
          ALLOCATE (ZO(NPTS)) ; !ZO(:) = 0.0
          ALLOCATE (PO(NPTS)) ; !PO(:) = 0.0
C
          ALLOCATE (XR(NPTS)) ; !XR(:) = 0.0
          ALLOCATE (YR(NPTS)) ; !YR(:) = 0.0
          ALLOCATE (ZR(NPTS)) ; !ZR(:) = 0.0
          ALLOCATE (PR(NPTS)) ; !PR(:) = 0.0
C
      ENDIF
C
C  0. Interpolation temporelle en fin de pas de temps NITER
C
      IF (.NOT.TRANSINV) THEN
          CINTB=REAL(NITER)/REAL(NITERT)
          CINTA=1.-CINTB
      ELSE
          CINTA=REAL(NITER)/REAL(NITERT)
          CINTB=1.-CINTA
      ENDIF
C
C  0.1. Grille globale
C
      IF(IFLAG1) THEN
          PSOLM1 = CINTA*PSOLM1A + CINTB*PSOLM1B
          XPAM1  = CINTA*XPAM1A  + CINTB*XPAM1B 
          XPHFM1 = CINTA*XPHFM1A + CINTB*XPHFM1B
          UGRIM1 = CINTA*UGRIM1A + CINTB*UGRIM1B
          VGRIM1 = CINTA*VGRIM1A + CINTB*VGRIM1B
          WGRIM1 = CINTA*WGRIM1A + CINTB*WGRIM1B
          TGRIM1 = CINTA*TGRIM1A + CINTB*TGRIM1B
          QGRIM1 = CINTA*QGRIM1A + CINTB*QGRIM1B
          PVGRIM1= CINTA*PVGRIM1A+ CINTB*PVGRIM1B
          DIVQM1 = CINTA*DIVQM1A + CINTB*DIVQM1B
          DIVUM1 = CINTA*DIVUM1A + CINTB*DIVUM1B
      ENDIF
C
C  0.2. Grille continentale
C
      IF(IFLAG2) THEN
	  PSOLM2 = CINTA*PSOLM2A + CINTB*PSOLM2B
          XPAM2  = CINTA*XPAM2A  + CINTB*XPAM2B 
          XPHFM2 = CINTA*XPHFM2A + CINTB*XPHFM2B
          UGRIM2 = CINTA*UGRIM2A + CINTB*UGRIM2B
          VGRIM2 = CINTA*VGRIM2A + CINTB*VGRIM2B
          WGRIM2 = CINTA*WGRIM2A + CINTB*WGRIM2B
          TGRIM2 = CINTA*TGRIM2A + CINTB*TGRIM2B
          QGRIM2 = CINTA*QGRIM2A + CINTB*QGRIM2B
          PVGRIM2= CINTA*PVGRIM2A+ CINTB*PVGRIM2B
          DIVQM2 = CINTA*DIVQM2A + CINTB*DIVQM2B
          DIVUM2 = CINTA*DIVUM2A + CINTB*DIVUM2B
      ENDIF
C
C  0.3. Grille regionale
C
      IF(IFLAG3) THEN
	  PSOLM3 = CINTA*PSOLM3A + CINTB*PSOLM3B
          XPAM3  = CINTA*XPAM3A  + CINTB*XPAM3B 
          XPHFM3 = CINTA*XPHFM3A + CINTB*XPHFM3B
          UGRIM3 = CINTA*UGRIM3A + CINTB*UGRIM3B
          VGRIM3 = CINTA*VGRIM3A + CINTB*VGRIM3B
          WGRIM3 = CINTA*WGRIM3A + CINTB*WGRIM3B
          TGRIM3 = CINTA*TGRIM3A + CINTB*TGRIM3B
          QGRIM3 = CINTA*QGRIM3A + CINTB*QGRIM3B
          PVGRIM3= CINTA*PVGRIM3A+ CINTB*PVGRIM3B
          DIVQM3 = CINTA*DIVQM3A + CINTB*DIVQM3B
          DIVUM3 = CINTA*DIVUM3A + CINTB*DIVUM3B
      ENDIF
C
C  0.4. Grille zoom
C
      IF(IFLAG4) THEN
	  PSOLM4 = CINTA*PSOLM4A + CINTB*PSOLM4B
          XPAM4  = CINTA*XPAM4A  + CINTB*XPAM4B 
          XPHFM4 = CINTA*XPHFM4A + CINTB*XPHFM4B
          UGRIM4 = CINTA*UGRIM4A + CINTB*UGRIM4B
          VGRIM4 = CINTA*VGRIM4A + CINTB*VGRIM4B
          WGRIM4 = CINTA*WGRIM4A + CINTB*WGRIM4B
          TGRIM4 = CINTA*TGRIM4A + CINTB*TGRIM4B
          QGRIM4 = CINTA*QGRIM4A + CINTB*QGRIM4B
          PVGRIM4= CINTA*PVGRIM4A+ CINTB*PVGRIM4B
          DIVQM4 = CINTA*DIVQM4A + CINTB*DIVQM4B
          DIVUM4 = CINTA*DIVUM4A + CINTB*DIVUM4B
      ENDIF
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  1. Initialisation des positions
C
C  1.1. Grille globale
C
      IF(IFLAG1) THEN
C
!$omp parallel do default(shared) private(J,K,L,N)
          DO 11 L=1,NIVM1
          DO 11 K=1,LATM1
          DO 11 J=1,LONM1
             N=J+(K-1)*LONM1+(L-1)*LOLAM1
             X1O(N)=RLONM1(J)
             Y1O(N)=RLATM1(K)
             Z1O(N)=XPAM1(J,K,L)
             P1O(N)=PSOLM1(J,K)
 11       CONTINUE
!$omp end parallel do
C
      ENDIF
C
C  1.2. Grille continentale
C
      IF(IFLAG2) THEN
C
!$omp parallel do default(shared) private(J,K,L,N)
        DO 12 L=1,NIVM2
        DO 12 K=1,LATM2
        DO 12 J=1,LONM2
           N=J+(K-1)*LONM2+(L-1)*LOLAM2
           X2O(N)=RLONM2(J)
           Y2O(N)=RLATM2(K)
           Z2O(N)=XPAM2(J,K,L)
           P2O(N)=PSOLM2(J,K)
 12     CONTINUE
!$omp end parallel do
C
      ENDIF
C
C  1.3. Grille regionale
C
      IF(IFLAG3) THEN
C
!$omp parallel do default(shared) private(J,K,L,N)
        DO 13 L=1,NIVM3
        DO 13 K=1,LATM3
        DO 13 J=1,LONM3
           N=J+(K-1)*LONM3+(L-1)*LOLAM3
           X3O(N)=RLONM3(J)
           Y3O(N)=RLATM3(K)
           Z3O(N)=XPAM3(J,K,L)
           P3O(N)=PSOLM3(J,K)
 13     CONTINUE
!$omp end parallel do
C
      ENDIF
C
C  1.4. Grille zoom
C
      IF(IFLAG4) THEN
C
!$omp parallel do default(shared) private(J,K,L,N)
        DO 14 L=1,NIVM4
        DO 14 K=1,LATM4
        DO 14 J=1,LONM4
           N=J+(K-1)*LONM4+(L-1)*LOLAM4
           X4O(N)=RLONM4(J)
           Y4O(N)=RLATM4(K)
           Z4O(N)=XPAM4(J,K,L)
           P4O(N)=PSOLM4(J,K)
 14     CONTINUE
!$omp end parallel do
C
      ENDIF
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C-
C  2. Le pas de temps DT0 est partage en NITRA intervalles de temps
C     de DTN=DT0/NITRA pour le calcul des trajectoires arriere
C
      DO 2 ITER=1,NITRA
C
C  Interpolation temporelle (milieu d'intervalle ITER)
C
        IF (.NOT.TRANSINV) THEN
            CINTB=( REAL(NITER) - (REAL(ITER)-.5)/REAL(NITRA) )
     +          /REAL(NITERT)
            CINTA=1.-CINTB
        ELSE
            CINTA=( REAL(NITER) - (REAL(ITER)-.5)/REAL(NITRA) )
     +          /REAL(NITERT)
            CINTB=1.-CINTA
        ENDIF
C
C  Grille globale
C
         IF(IFLAG1) THEN
             PSOLF1 = CINTA*PSOLF1A+CINTB*PSOLF1B
             UGRIF1 = CINTA*UGRIF1A+CINTB*UGRIF1B
             VGRIF1 = CINTA*VGRIF1A+CINTB*VGRIF1B
             WGRIF1 = CINTA*WGRIF1A+CINTB*WGRIF1B
         ENDIF
C
C  Grille continentale
C
         IF(IFLAG2) THEN
             PSOLF2 = CINTA*PSOLF2A+CINTB*PSOLF2B
             UGRIF2 = CINTA*UGRIF2A+CINTB*UGRIF2B
             VGRIF2 = CINTA*VGRIF2A+CINTB*VGRIF2B
             WGRIF2 = CINTA*WGRIF2A+CINTB*WGRIF2B
         ENDIF
C
C  Grille regionale
C
         IF(IFLAG3) THEN
             PSOLF3 = CINTA*PSOLF3A+CINTB*PSOLF3B
             UGRIF3 = CINTA*UGRIF3A+CINTB*UGRIF3B
             VGRIF3 = CINTA*VGRIF3A+CINTB*VGRIF3B
             WGRIF3 = CINTA*WGRIF3A+CINTB*WGRIF3B
         ENDIF
C
C  Grille zoom
C
         IF(IFLAG4) THEN
             PSOLF4 = CINTA*PSOLF4A+CINTB*PSOLF4B
             UGRIF4 = CINTA*UGRIF4A+CINTB*UGRIF4B
             VGRIF4 = CINTA*VGRIF4A+CINTB*VGRIF4B
             WGRIF4 = CINTA*WGRIF4A+CINTB*WGRIF4B
         ENDIF
C
C  Pour eviter les singularites aux poles, on utilise un repere
C  auxiliaire dont l'equateur passe par les poles geographiques
C  (rotation de 90 degres de l'axe des poles du repere standard)
C
         CALL INIVIT
C
C  Boucle sur les domaines actives
C
         DO 20 IDOM=1,NDOM
C
C  Initialisations pour le domaine IDOM
C
         IF(IDOM.EQ.1) THEN
C
             NPTR=NPTS1
             IF (NDOM .ge. 2) THEN
                 XO(1:NPTR) = X1O(1:NPTR)
                 YO(1:NPTR) = Y1O(1:NPTR)
                 ZO(1:NPTR) = Z1O(1:NPTR)
                 PO(1:NPTR) = P1O(1:NPTR)
             ELSE
                 XO => X1O
                 YO => Y1O
                 ZO => Z1O
                 PO => P1O
             ENDIF
C
         ELSEIF(IDOM.EQ.2) THEN
C
             NPTR=NPTS2
             XO(1:NPTR) = X2O(1:NPTR)
             YO(1:NPTR) = Y2O(1:NPTR)
             ZO(1:NPTR) = Z2O(1:NPTR)
             PO(1:NPTR) = P2O(1:NPTR)
C
         ELSEIF(IDOM.EQ.3) THEN
C
             NPTR=NPTS3
             XO(1:NPTR) = X3O(1:NPTR)
             YO(1:NPTR) = Y3O(1:NPTR)
             ZO(1:NPTR) = Z3O(1:NPTR)
             PO(1:NPTR) = P3O(1:NPTR)
C
         ELSEIF(IDOM.EQ.4) THEN
C
             NPTR=NPTS4
             XO(1:NPTR) = X4O(1:NPTR)
             YO(1:NPTR) = Y4O(1:NPTR)
             ZO(1:NPTR) = Z4O(1:NPTR)
             PO(1:NPTR) = P4O(1:NPTR)
C
         ENDIF
C
C  first-guess du point median
C
         DO 201 N=1,NPTR
           XM(N)=XO(N)
           YM(N)=YO(N)
           ZM(N)=ZO(N)
           PM(N)=PO(N)
           IND(N)=0
           IF(ABS(YM(N)).GE.RLATLIM) IND(N)=1
 201     CONTINUE
C
         DO 202 N=1,NPTR
           IF(IND(N).NE.0) THEN
               SYOR=-COS(XO(N))*COS(YO(N))
               YOR(N)=ASIN(SYOR)
               CYOR=SQRT(1.-SYOR*SYOR)
C
C FUJITSU
C
C              CXOR=CVMGZ(0.,AMAX1(-1.,
C     +                       AMIN1(1.,SIN(YO(N))/CYOR)),CYOR)
               IF (CYOR.EQ.0.) THEN
                   CXOR=0.
               ELSE
                   CXOR=MAX(-1.,MIN(1.,SIN(YO(N))/CYOR))
               ENDIF
C
               XOR(N)=SIGN(ACOS(CXOR),SIN(XO(N)))
           ENDIF
 202     CONTINUE
C
C  NITAP approximations successives du point median (XM,YM,ZM)
C
         DO 203 IT=1,NITAP
C
C  calcul du point origine pour la derniere iteration
C
           IF(IT.EQ.NITAP) THEN
               IF (.NOT.TRANSINV) THEN
                   COEFH=DTN/RTER
                   COEFV=DTN
               ELSE
                   COEFH=-DTN/RTER
                   COEFV=-DTN
               ENDIF 
           ELSE
               IF (.NOT.TRANSINV) THEN
                   COEFH=.5*DTN/RTER
                   COEFV=.5*DTN
               ELSE
                   COEFH=-.5*DTN/RTER
                   COEFV=-.5*DTN
               ENDIF
           ENDIF
C
C  interpolation du champ de vitesse
C
C  positionnement par rapport aux differents domaines
C
           IF (NDOM .ge. 2) THEN
               XR(1:NPTR) = XM(1:NPTR)
               YR(1:NPTR) = YM(1:NPTR)
               ZR(1:NPTR) = ZM(1:NPTR)
               PR(1:NPTR) = PM(1:NPTR)
           ELSE
               XR => XM
               YR => YM
               ZR => ZM
               PR => PM
           ENDIF
C
           CALL POSIREG(XR,YR,IDOM
     +               ,RLONF2(1),RLONF2(LONF2),RLATF2(1),RLATF2(LATF2)
     +               ,RLONF3(1),RLONF3(LONF3),RLATF3(1),RLATF3(LATF3)
     +               ,RLONF4(1),RLONF4(LONF4),RLATF4(1),RLATF4(LATF4)
     +               ,IGRI,NPTR)
C
C  reordonnancement des points selon IGRI
C
           IF (NDOM .EQ. 1) THEN
               NPTR1 = NPTR
               NPTR2 = 0
               NPTR3 = 0
               NPTR4 = 0
           ELSE
               CALL REORPOS(XR,YR,ZR,PR,IGRI,IDOM
     +             ,NPTR,NPTR1,NPTR2,NPTR3,NPTR4)
           ENDIF
C
C 1.0 Calcul de la vitesse verticale etendue au niveau 0
C (de telle sorte que le champ de vent reste conservatif)           
C
#ifdef MIDATM
        IF (IFLAG1) THEN
          DO I=1,LOLAF1
            WWORK1(I,1)=WGRIF1(I,1,1)
          ENDDO
        ENDIF        
        IF (IFLAG2) THEN
          DO I=1,LOLAF2
            WWORK2(I,1)=WGRIF2(I,1,1)
          ENDDO
        ENDIF        
        IF (IFLAG3) THEN
          DO I=1,LOLAF3
            WWORK3(I,1)=WGRIF3(I,1,1)
          ENDDO
        ENDIF        
        IF (IFLAG4) THEN
          DO I=1,LOLAF4
            WWORK4(I,1)=WGRIF4(I,1,1)
          ENDDO
        ENDIF        
#else
        PLSUP=400.
        PL1=ALF1(1)
        RAP=PLSUP/PL1

        IF (IFLAG1) THEN
          DO I=1,LOLAF1
            WWORK1(I,1)=WGRIF1(I,1,1)*RAP
          ENDDO
        ENDIF        
        IF (IFLAG2) THEN
          DO I=1,LOLAF2
            WWORK2(I,1)=WGRIF2(I,1,1)*RAP
          ENDDO
        ENDIF        
        IF (IFLAG3) THEN
          DO I=1,LOLAF3
            WWORK3(I,1)=WGRIF3(I,1,1)*RAP
          ENDDO
        ENDIF        
        IF (IFLAG4) THEN
          DO I=1,LOLAF4
            WWORK4(I,1)=WGRIF4(I,1,1)*RAP
          ENDDO
        ENDIF        
#endif            
C
C  1. traitement des NPTR1 points appartenant au domaine 1
C
           IF(NPTR1.NE.0) THEN
C
               NDEB1=1
C
C  calcul des poids pour l'interpolation
C
               CALL POIDREG(XR(NDEB1),RLONF1(1)-DRLONF1,DRLONF1
     +               ,INDX,ALFX1,ALFX2,ALFX3,ALFX4,NPTR1)
#ifndef GAUSS
               CALL POIDREG(YR(NDEB1),RLATF1(1)-DRLATF1,DRLATF1
     +               ,INDY,ALFY1,ALFY2,ALFY3,ALFY4,NPTR1)
#else
               CALL POIDGAU(YR(NDEB1),XLAT,YCOEF,LATF1
     +                 ,INDY,ALFY1,ALFY2,ALFY3,ALFY4,NPTR1)
#endif
               CALL POIDZ  (ZR(NDEB1),PR(NDEB1),ALF1,BLF1,NIVF1
     +               ,INDZ,ALFZ1,ALFZ2,ALFZ3,ALFZ4,NPTR1)
C
C  interpolation composante par composante
C	   
               CALL INTER3D(UGRIF1,UGRIF1(1,1,1),
     +                LONF1,LATF1,NIVF1,
     +                INDX,INDY,INDZ,
     +                ALFX1,ALFX2,ALFX3,ALFX4,
     +                ALFY1,ALFY2,ALFY3,ALFY4,
     +                ALFZ1,ALFZ2,ALFZ3,ALFZ4,
     +                USM,NPTR1,-1.,.FALSE.,1,.TRUE.)
               CALL INTER3D(VGRIF1,VGRIF1(1,1,1),
     +                LONF1,LATF1,NIVF1,
     +                INDX,INDY,INDZ,
     +                ALFX1,ALFX2,ALFX3,ALFX4,
     +                ALFY1,ALFY2,ALFY3,ALFY4,
     +                ALFZ1,ALFZ2,ALFZ3,ALFZ4,
     +                VSM,NPTR1,-1.,.FALSE.,1,.TRUE.)
               CALL INTER3D(WGRIF1,WWORK1,
     +                LONF1,LATF1,NIVF1,
     +                INDX,INDY,INDZ,
     +                ALFX1,ALFX2,ALFX3,ALFX4,
     +                ALFY1,ALFY2,ALFY3,ALFY4,
     +                ALFZ1,ALFZ2,ALFZ3,ALFZ4,
     +                WSM,NPTR1,+1.,.FALSE.,1,.FALSE.)
               CALL INTER3D(UMODF1,UMODF1(1,1,1),
     +                LONF1,LATF1,NIVF1,
     +                INDX,INDY,INDZ,
     +                ALFX1,ALFX2,ALFX3,ALFX4,
     +                ALFY1,ALFY2,ALFY3,ALFY4,
     +                ALFZ1,ALFZ2,ALFZ3,ALFZ4,
     +                URM,NPTR1,+1.,.FALSE.,1,.TRUE.)
               CALL INTER3D(VMODF1,VMODF1(1,1,1),
     +                LONF1,LATF1,NIVF1,
     +                INDX,INDY,INDZ,
     +                ALFX1,ALFX2,ALFX3,ALFX4,
     +                ALFY1,ALFY2,ALFY3,ALFY4,
     +                ALFZ1,ALFZ2,ALFZ3,ALFZ4,
     +                VRM,NPTR1,+1.,.FALSE.,1,.TRUE.)        
C
           ENDIF
C
C  2. traitement des NPTR2 points appartenant au domaine 2
C
           IF(NPTR2.NE.0) THEN
C
               NDEB2=NPTR1+1
C
C  calcul des poids pour l'interpolation
C
               CALL POIDREG(XR(NDEB2),RLONF2(1)-DRLONF2,DRLONF2
     +               ,INDX,ALFX1,ALFX2,ALFX3,ALFX4,NPTR2)
               CALL POIDREG(YR(NDEB2),RLATF2(1)-DRLATF2,DRLATF2
     +               ,INDY,ALFY1,ALFY2,ALFY3,ALFY4,NPTR2)
               CALL POIDZ  (ZR(NDEB2),PR(NDEB2),ALF2,BLF2,NIVF2
     +               ,INDZ,ALFZ1,ALFZ2,ALFZ3,ALFZ4,NPTR2)
C
C  interpolation composante par composante
C
               CALL INTER3D(UGRIF2,UGRIF2(1,1,1),
     +                LONF2,LATF2,NIVF2,
     +                INDX,INDY,INDZ,
     +                ALFX1,ALFX2,ALFX3,ALFX4,
     +                ALFY1,ALFY2,ALFY3,ALFY4,
     +                ALFZ1,ALFZ2,ALFZ3,ALFZ4,
     +                USM(NDEB2),NPTR2,-1.,.FALSE.,2,.TRUE.)
               CALL INTER3D(VGRIF2,VGRIF2(1,1,1),
     +                LONF2,LATF2,NIVF2,
     +                INDX,INDY,INDZ,
     +                ALFX1,ALFX2,ALFX3,ALFX4,
     +                ALFY1,ALFY2,ALFY3,ALFY4,
     +                ALFZ1,ALFZ2,ALFZ3,ALFZ4,
     +                VSM(NDEB2),NPTR2,-1.,.FALSE.,2,.TRUE.)
               CALL INTER3D(WGRIF2,WWORK2,
     +                LONF2,LATF2,NIVF2,
     +                INDX,INDY,INDZ,
     +                ALFX1,ALFX2,ALFX3,ALFX4,
     +                ALFY1,ALFY2,ALFY3,ALFY4,
     +                ALFZ1,ALFZ2,ALFZ3,ALFZ4,
     +                WSM(NDEB2),NPTR2,+1.,.FALSE.,2,.FALSE.)
               CALL INTER3D(UMODF2,UMODF2(1,1,1),
     +                LONF2,LATF2,NIVF2,
     +                INDX,INDY,INDZ,
     +                ALFX1,ALFX2,ALFX3,ALFX4,
     +                ALFY1,ALFY2,ALFY3,ALFY4,
     +                ALFZ1,ALFZ2,ALFZ3,ALFZ4,
     +                URM(NDEB2),NPTR2,+1.,.FALSE.,2,.TRUE.)
               CALL INTER3D(VMODF2,VMODF2(1,1,1),
     +                LONF2,LATF2,NIVF2,
     +                INDX,INDY,INDZ,
     +                ALFX1,ALFX2,ALFX3,ALFX4,
     +                ALFY1,ALFY2,ALFY3,ALFY4,
     +                ALFZ1,ALFZ2,ALFZ3,ALFZ4,
     +                VRM(NDEB2),NPTR2,+1.,.FALSE.,2,.TRUE.)
C
           ENDIF
C
C  3. traitement des NPTR3 points appartenant au domaine 3
C
           IF(NPTR3.NE.0) THEN
C
               NDEB3=NPTR1+NPTR2+1
C
C  calcul des poids pour l'interpolation
C
               CALL POIDREG(XR(NDEB3),RLONF3(1)-DRLONF3,DRLONF3
     +               ,INDX,ALFX1,ALFX2,ALFX3,ALFX4,NPTR3)
               CALL POIDREG(YR(NDEB3),RLATF3(1)-DRLATF3,DRLATF3
     +               ,INDY,ALFY1,ALFY2,ALFY3,ALFY4,NPTR3)
               CALL POIDZ  (ZR(NDEB3),PR(NDEB3),ALF3,BLF3,NIVF3
     +               ,INDZ,ALFZ1,ALFZ2,ALFZ3,ALFZ4,NPTR3)
C
C  interpolation composante par composante
C
               CALL INTER3D(UGRIF3,UGRIF3(1,1,1),
     +                LONF3,LATF3,NIVF3,
     +                INDX,INDY,INDZ,
     +                ALFX1,ALFX2,ALFX3,ALFX4,
     +                ALFY1,ALFY2,ALFY3,ALFY4,
     +                ALFZ1,ALFZ2,ALFZ3,ALFZ4,
     +                USM(NDEB3),NPTR3,-1.,.FALSE.,3,.TRUE.)
               CALL INTER3D(VGRIF3,VGRIF3(1,1,1),
     +                LONF3,LATF3,NIVF3,
     +                INDX,INDY,INDZ,
     +                ALFX1,ALFX2,ALFX3,ALFX4,
     +                ALFY1,ALFY2,ALFY3,ALFY4,
     +                ALFZ1,ALFZ2,ALFZ3,ALFZ4,
     +                VSM(NDEB3),NPTR3,-1.,.FALSE.,3,.TRUE.)
               CALL INTER3D(WGRIF3,WWORK3,
     +                LONF3,LATF3,NIVF3,
     +                INDX,INDY,INDZ,
     +                ALFX1,ALFX2,ALFX3,ALFX4,
     +                ALFY1,ALFY2,ALFY3,ALFY4,
     +                ALFZ1,ALFZ2,ALFZ3,ALFZ4,
     +                WSM(NDEB3),NPTR3,+1.,.FALSE.,3,.FALSE.)
               CALL INTER3D(UMODF3,UMODF3(1,1,1),
     +                LONF3,LATF3,NIVF3,
     +                INDX,INDY,INDZ,
     +                ALFX1,ALFX2,ALFX3,ALFX4,
     +                ALFY1,ALFY2,ALFY3,ALFY4,
     +                ALFZ1,ALFZ2,ALFZ3,ALFZ4,
     +                URM(NDEB3),NPTR3,+1.,.FALSE.,3,.TRUE.)
               CALL INTER3D(VMODF3,VMODF3(1,1,1),
     +                LONF3,LATF3,NIVF3,
     +                INDX,INDY,INDZ,
     +                ALFX1,ALFX2,ALFX3,ALFX4,
     +                ALFY1,ALFY2,ALFY3,ALFY4,
     +                ALFZ1,ALFZ2,ALFZ3,ALFZ4,
     +                VRM(NDEB3),NPTR3,+1.,.FALSE.,3,.TRUE.)	     
C
	   ENDIF
C
	   
C
C  4. traitement des NPTR4 points appartenant au domaine 4
C
           IF(NPTR4.NE.0) THEN
C
               NDEB4=NPTR1+NPTR2+NPTR3+1
C
C  calcul des poids pour l'interpolation
C
               CALL POIDREG(XR(NDEB4),RLONF4(1)-DRLONF4,DRLONF4
     +               ,INDX,ALFX1,ALFX2,ALFX3,ALFX4,NPTR4)
               CALL POIDREG(YR(NDEB4),RLATF4(1)-DRLATF4,DRLATF4
     +               ,INDY,ALFY1,ALFY2,ALFY3,ALFY4,NPTR4)
               CALL POIDZ  (ZR(NDEB4),PR(NDEB4),ALF4,BLF4,NIVF4
     +               ,INDZ,ALFZ1,ALFZ2,ALFZ3,ALFZ4,NPTR4)
C
C  interpolation composante par composante
C
               CALL INTER3D(UGRIF4,UGRIF4(1,1,1),
     +                LONF4,LATF4,NIVF4,
     +                INDX,INDY,INDZ,
     +                ALFX1,ALFX2,ALFX3,ALFX4,
     +                ALFY1,ALFY2,ALFY3,ALFY4,
     +                ALFZ1,ALFZ2,ALFZ3,ALFZ4,
     +                USM(NDEB4),NPTR4,-1.,.FALSE.,4,.TRUE.)
               CALL INTER3D(VGRIF4,VGRIF4(1,1,1),
     +                LONF4,LATF4,NIVF4,
     +                INDX,INDY,INDZ,
     +                ALFX1,ALFX2,ALFX3,ALFX4,
     +                ALFY1,ALFY2,ALFY3,ALFY4,
     +                ALFZ1,ALFZ2,ALFZ3,ALFZ4,
     +                VSM(NDEB4),NPTR4,-1.,.FALSE.,4,.TRUE.)
               CALL INTER3D(WGRIF4,WWORK4,
     +                LONF4,LATF4,NIVF4,
     +                INDX,INDY,INDZ,
     +                ALFX1,ALFX2,ALFX3,ALFX4,
     +                ALFY1,ALFY2,ALFY3,ALFY4,
     +                ALFZ1,ALFZ2,ALFZ3,ALFZ4,
     +                WSM(NDEB4),NPTR4,+1.,.FALSE.,4,.FALSE.)
               CALL INTER3D(UMODF4,UMODF4(1,1,1),
     +                LONF4,LATF4,NIVF4,
     +                INDX,INDY,INDZ,
     +                ALFX1,ALFX2,ALFX3,ALFX4,
     +                ALFY1,ALFY2,ALFY3,ALFY4,
     +                ALFZ1,ALFZ2,ALFZ3,ALFZ4,
     +                URM(NDEB4),NPTR4,+1.,.FALSE.,4,.TRUE.)
               CALL INTER3D(VMODF4,VMODF4(1,1,1),
     +                LONF4,LATF4,NIVF4,
     +                INDX,INDY,INDZ,
     +                ALFX1,ALFX2,ALFX3,ALFX4,
     +                ALFY1,ALFY2,ALFY3,ALFY4,
     +                ALFZ1,ALFZ2,ALFZ3,ALFZ4,
     +                VRM(NDEB4),NPTR4,+1.,.FALSE.,4,.TRUE.)
C
           ENDIF
C
C  reordonnancement des composantes de la vitesse
C
           IF (NDOM .GE. 2) THEN
               CALL REORCHA(USM,IGRI,IDOM
     +             ,NPTR,NPTR1,NPTR2,NPTR3,NPTR4)
               CALL REORCHA(VSM,IGRI,IDOM
     +             ,NPTR,NPTR1,NPTR2,NPTR3,NPTR4)
               CALL REORCHA(WSM,IGRI,IDOM
     +             ,NPTR,NPTR1,NPTR2,NPTR3,NPTR4)
               CALL REORCHA(URM,IGRI,IDOM
     +             ,NPTR,NPTR1,NPTR2,NPTR3,NPTR4)
               CALL REORCHA(VRM,IGRI,IDOM
     +             ,NPTR,NPTR1,NPTR2,NPTR3,NPTR4)
           ENDIF
C
C  calcul du point median
C
           DO 2034 N=1,NPTR
             IF(IND(N).EQ.0) THEN
                 XM(N)=XO(N)-COEFH*USM(N)/COS(YM(N))
                 YM(N)=YO(N)-COEFH*VSM(N)
             ELSE
                 SYMR=-COS(XM(N))*COS(YM(N))
                 CYMR=SQRT(1.-SYMR*SYMR)
C
                 XMR(N)=XOR(N)-COEFH*URM(N)/CYMR
                 YMR(N)=YOR(N)-COEFH*VRM(N)
C
                 SYM=COS(XMR(N))*COS(YMR(N))
                 YM(N)=ASIN(SYM)
                 CYM=SQRT(1.-SYM*SYM)
C
C FUJITSU
C                 CXM=CVMGM(0.,AMAX1(-1.,
C     +                        AMIN1(1.,-SIN(YMR(N))/CYM)),CYM)
C
                 IF(CYM.LT.0.) THEN
                     CXM=0.
                 ELSE
                     CXM=MAX(-1.,MIN(1.,-SIN(YMR(N))/CYM))
                 ENDIF
C
                 XM(N)=SIGN(ACOS(CXM),SIN(XMR(N)))
             ENDIF
             ZM(N)=ZO(N)-COEFV*WSM(N)
 2034      CONTINUE
C
           CALL CORLAT(XM,YM,RLONF1MIN,RLONF1MAX,NPTR)
C
           IF(IT.NE.NITAP) THEN
C
C  interpolation de la pression sol
C
C  positionnement par rapport aux differents domaines
C
               IF (NDOM .ge. 2) THEN
                   XR(1:NPTR) = XM(1:NPTR)
                   YR(1:NPTR) = YM(1:NPTR)
                   ZR(1:NPTR) = 0.d0
                   PR(1:NPTR) = 0.d0
               ELSE
                   XR => XM
                   YR => YM
                   NULLIFY(ZR)
                   NULLIFY(PR)
               ENDIF
C
               CALL POSIREG(XR,YR,IDOM
     +               ,RLONF2(1),RLONF2(LONF2),RLATF2(1),RLATF2(LATF2)
     +               ,RLONF3(1),RLONF3(LONF3),RLATF3(1),RLATF3(LATF3)
     +               ,RLONF4(1),RLONF4(LONF4),RLATF4(1),RLATF4(LATF4)
     +               ,IGRI,NPTR)
C
C  reordonnancement des points selon IGRI
C
               IF (NDOM .EQ. 1) THEN
                   NPTR1 = NPTR
                   NPTR2 = 0
                   NPTR3 = 0
                   NPTR4 = 0
               ELSE
                   CALL REORPOS(XR,YR,ZR,PR,IGRI,IDOM
     +                 ,NPTR,NPTR1,NPTR2,NPTR3,NPTR4)
               ENDIF
C
C  1. traitement des NPTR1 points appartenant au domaine 1
C
               IF(NPTR1.NE.0) THEN
C
                   NDEB1=1
C
C  calcul des poids pour l'interpolation
C
                   CALL POIDREG(XR(NDEB1),RLONF1(1)-DRLONF1,DRLONF1
     +                 ,INDX,ALFX1,ALFX2,ALFX3,ALFX4,NPTR1)
#ifndef GAUSS        
                   CALL POIDREG(YR(NDEB1),RLATF1(1)-DRLATF1,DRLATF1
     +                 ,INDY,ALFY1,ALFY2,ALFY3,ALFY4,NPTR1)
#else
                   CALL POIDGAU(YR(NDEB1),XLAT,YCOEF,LATF1
     +                   ,INDY,ALFY1,ALFY2,ALFY3,ALFY4,NPTR1)
#endif
C
C  calcul de la pression sol PM a la verticale du point (XM,YM)
C
                   CALL INTER2D(PSOLF1,LONF1,LATF1,
     +                 INDX,INDY,
     +                 ALFX1,ALFX2,ALFX3,ALFX4,
     +                 ALFY1,ALFY2,ALFY3,ALFY4,
     +                 PM,NPTR1,+1.,.FALSE.,1)
               ENDIF
C
C  2. traitement des NPTR2 points appartenant au domaine 2
C
               IF(NPTR2.NE.0) THEN
C
                   NDEB2=NPTR1+1
C
C  calcul des poids pour l'interpolation
C
                   CALL POIDREG(XR(NDEB2),RLONF2(1)-DRLONF2,DRLONF2
     +                 ,INDX,ALFX1,ALFX2,ALFX3,ALFX4,NPTR2)
                   CALL POIDREG(YR(NDEB2),RLATF2(1)-DRLATF2,DRLATF2
     +                 ,INDY,ALFY1,ALFY2,ALFY3,ALFY4,NPTR2)
C
C  calcul de la pression sol PM a la verticale du point (XM,YM)
C	     
                   CALL INTER2D(PSOLF2,LONF2,LATF2,
     +                 INDX,INDY,
     +                 ALFX1,ALFX2,ALFX3,ALFX4,
     +                 ALFY1,ALFY2,ALFY3,ALFY4,
     +                 PM(NDEB2),NPTR2,+1.,.FALSE.,2)
               ENDIF
C
C  3. traitement des NPTR3 points appartenant au domaine 3
C
               IF(NPTR3.NE.0) THEN
C
                   NDEB3=NPTR1+NPTR2+1
C
C  calcul des poids pour l'interpolation
C	     
                   CALL POIDREG(XR(NDEB3),RLONF3(1)-DRLONF3,DRLONF3
     +                 ,INDX,ALFX1,ALFX2,ALFX3,ALFX4,NPTR3)
                   CALL POIDREG(YR(NDEB3),RLATF3(1)-DRLATF3,DRLATF3
     +                 ,INDY,ALFY1,ALFY2,ALFY3,ALFY4,NPTR3)
C
C  calcul de la pression sol PM a la verticale du point (XM,YM)
C
                   CALL INTER2D(PSOLF3,LONF3,LATF3,
     +                 INDX,INDY,
     +                 ALFX1,ALFX2,ALFX3,ALFX4,
     +                 ALFY1,ALFY2,ALFY3,ALFY4,
     +                 PM(NDEB3),NPTR3,+1.,.FALSE.,3)
C
               ENDIF
C
C  4. traitement des NPTR4 points appartenant au domaine 4
C
               IF(NPTR4.NE.0) THEN
C
                   NDEB4=NPTR1+NPTR2+NPTR3+1
C
C  calcul des poids pour l'interpolation
C

                   CALL POIDREG(XR(NDEB4),RLONF4(1)-DRLONF4,DRLONF4
     +                 ,INDX,ALFX1,ALFX2,ALFX3,ALFX4,NPTR4)
                   CALL POIDREG(YR(NDEB4),RLATF4(1)-DRLATF4,DRLATF4
     +                 ,INDY,ALFY1,ALFY2,ALFY3,ALFY4,NPTR4)
C
C  calcul de la pression sol PM a la verticale du point (XM,YM)
C
                   CALL INTER2D(PSOLF4,LONF4,LATF4,
     +                 INDX,INDY,
     +                 ALFX1,ALFX2,ALFX3,ALFX4,
     +                 ALFY1,ALFY2,ALFY3,ALFY4,
     +                 PM(NDEB4),NPTR4,+1.,.FALSE.,4)
C
               ENDIF
C
               IF (NDOM .GE. 2)
     +             CALL REORCHA(PM,IGRI,IDOM
     +             ,NPTR,NPTR1,NPTR2,NPTR3,NPTR4)
C
C  limitation du ZM (entre PLT(NIV)=PM et PLT(0))
C
               CALL CORNIV(ZM,PM,NPTR)
C
           ENDIF
C
 203     CONTINUE
C
         DO 2041 N=1,NPTR
           XO(N)=XM(N)
           YO(N)=YM(N)
           ZO(N)=ZM(N)
           PO(N)=PM(N)
 2041    CONTINUE
C
C  interpolation temporelle (debut d'iteration ITER)
C
         CINTB=( REAL(NITER) - (REAL(ITER)-1.)/REAL(NITRA) )
     +       /REAL(NITERT)
         CINTA=1.-CINTB
C
         IF(IFLAG1) PSOLF1=CINTA*PSOLF1A+CINTB*PSOLF1B
         IF(IFLAG2) PSOLF2=CINTA*PSOLF2A+CINTB*PSOLF2B
         IF(IFLAG3) PSOLF3=CINTA*PSOLF3A+CINTB*PSOLF3B
         IF(IFLAG4) PSOLF4=CINTA*PSOLF4A+CINTB*PSOLF4B
C
C  interpolation de la pression sol
C
C  positionnement par rapport aux differents domaines
C
         IF(NDOM .ge. 2) THEN
             XR(1:NPTR) = XO(1:NPTR)
             YR(1:NPTR) = YO(1:NPTR)
             ZR(1:NPTR) = 0.d0
             PR(1:NPTR) = 0.d0
         ELSE
             XR => XO
             YR => YO
             NULLIFY(ZR)
             NULLIFY(PR)
         ENDIF
             
C
         CALL POSIREG(XR,YR,IDOM
     +               ,RLONF2(1),RLONF2(LONF2),RLATF2(1),RLATF2(LATF2)
     +               ,RLONF3(1),RLONF3(LONF3),RLATF3(1),RLATF3(LATF3)
     +               ,RLONF4(1),RLONF4(LONF4),RLATF4(1),RLATF4(LATF4)
     +               ,IGRI,NPTR)
C
C  reordonnancement des points selon IGRI
C
         IF (NDOM .EQ. 1) THEN
             NPTR1 = NPTR
             NPTR2 = 0
             NPTR3 = 0
             NPTR4 = 0
         ELSE
             CALL REORPOS(XR,YR,ZR,PR,IGRI,IDOM
     +           ,NPTR,NPTR1,NPTR2,NPTR3,NPTR4)
         ENDIF
C
C  1. traitement des NPTR1 points appartenant au domaine 1
C
         IF(NPTR1.NE.0) THEN
C
             NDEB1=1
C
C  calcul des poids pour l'interpolation
C
             CALL POIDREG(XR(NDEB1),RLONF1(1)-DRLONF1,DRLONF1
     +           ,INDX,ALFX1,ALFX2,ALFX3,ALFX4,NPTR1)
#ifndef GAUSS
             CALL POIDREG(YR(NDEB1),RLATF1(1)-DRLATF1,DRLATF1
     +                 ,INDY,ALFY1,ALFY2,ALFY3,ALFY4,NPTR1)
#else
              CALL POIDGAU(YR(NDEB1),XLAT,YCOEF,LATF1
     +                   ,INDY,ALFY1,ALFY2,ALFY3,ALFY4,NPTR1)
#endif
C
C  calcul de la pression sol PO a la verticale du point (XO,YO)
C           
	     CALL INTER2D(PSOLF1,LONF1,LATF1,
     +                  INDX,INDY,
     +                  ALFX1,ALFX2,ALFX3,ALFX4,
     +                  ALFY1,ALFY2,ALFY3,ALFY4,
     +                  PO,NPTR1,+1.,.FALSE.,1)
C
         ENDIF
C
C  2. traitement des NPTR2 points appartenant au domaine 2
C
         IF(NPTR2.NE.0) THEN
C
             NDEB2=NPTR1+1
C
C  calcul des poids pour l'interpolation
C
             CALL POIDREG(XR(NDEB2),RLONF2(1)-DRLONF2,DRLONF2
     +                 ,INDX,ALFX1,ALFX2,ALFX3,ALFX4,NPTR2)
             CALL POIDREG(YR(NDEB2),RLATF2(1)-DRLATF2,DRLATF2
     +                 ,INDY,ALFY1,ALFY2,ALFY3,ALFY4,NPTR2)
C
C  calcul de la pression sol PO a la verticale du point (XO,YO)
C
             CALL INTER2D(PSOLF2,LONF2,LATF2,
     +                  INDX,INDY,
     +                  ALFX1,ALFX2,ALFX3,ALFX4,
     +                  ALFY1,ALFY2,ALFY3,ALFY4,
     +                  PO(NDEB2),NPTR2,+1.,.FALSE.,2)
C
         ENDIF
C
C  3. traitement des NPTR3 points appartenant au domaine 3
C
         IF(NPTR3.NE.0) THEN
C
             NDEB3=NPTR1+NPTR2+1
C
C  calcul des poids pour l'interpolation
C
             CALL POIDREG(XR(NDEB3),RLONF3(1)-DRLONF3,DRLONF3
     +                 ,INDX,ALFX1,ALFX2,ALFX3,ALFX4,NPTR3)
             CALL POIDREG(YR(NDEB3),RLATF3(1)-DRLATF3,DRLATF3
     +                 ,INDY,ALFY1,ALFY2,ALFY3,ALFY4,NPTR3)
C
C  calcul de la pression sol PO a la verticale du point (XO,YO)
C
	     CALL INTER2D(PSOLF3,LONF3,LATF3,
     +                  INDX,INDY,
     +                  ALFX1,ALFX2,ALFX3,ALFX4,
     +                  ALFY1,ALFY2,ALFY3,ALFY4,
     +                  PO(NDEB3),NPTR3,+1.,.FALSE.,3)
C
         ENDIF
C
C  4. traitement des NPTR4 points appartenant au domaine 4
C
         IF(NPTR4.NE.0) THEN
C
           NDEB4=NPTR1+NPTR2+NPTR3+1
C
C  calcul des poids pour l'interpolation
C
           CALL POIDREG(XR(NDEB4),RLONF4(1)-DRLONF4,DRLONF4
     +                 ,INDX,ALFX1,ALFX2,ALFX3,ALFX4,NPTR4)
           CALL POIDREG(YR(NDEB4),RLATF4(1)-DRLATF4,DRLATF4
     +                 ,INDY,ALFY1,ALFY2,ALFY3,ALFY4,NPTR4)
C
C  calcul de la pression sol PO a la verticale du point (XO,YO)
C
           CALL INTER2D(PSOLF4,LONF4,LATF4,
     +                  INDX,INDY,
     +                  ALFX1,ALFX2,ALFX3,ALFX4,
     +                  ALFY1,ALFY2,ALFY3,ALFY4,
     +                  PO(NDEB4),NPTR4,+1.,.FALSE.,4)
C
       ENDIF
C
       IF (NDOM .GE. 2)
     +     CALL REORCHA(PO,IGRI,IDOM
     +     ,NPTR,NPTR1,NPTR2,NPTR3,NPTR4)
C
C  limitation du ZO (entre PLT(NIV)=PO et PLT(0))
C
       CALL CORNIV(ZO,PO,NPTR)
C       
       IF (NDOM .GE. 2) THEN
C
           IF(IDOM.EQ.1) THEN
C
               DO 2051 N=1,NPTR
                 X1O(N)=XO(N)
                 Y1O(N)=YO(N)
                 Z1O(N)=ZO(N)
                 P1O(N)=PO(N)
 2051          CONTINUE
C
           ELSEIF(IDOM.EQ.2) THEN
C
               DO 2052 N=1,NPTR
                 X2O(N)=XO(N)
                 Y2O(N)=YO(N)
                 Z2O(N)=ZO(N)
                 P2O(N)=PO(N)
 2052          CONTINUE
C
           ELSEIF(IDOM.EQ.3) THEN
C
               DO 2053 N=1,NPTR
                 X3O(N)=XO(N)
                 Y3O(N)=YO(N)
                 Z3O(N)=ZO(N)
                 P3O(N)=PO(N)
 2053          CONTINUE
C
           ELSEIF(IDOM.EQ.4) THEN
C
               DO 2054 N=1,NPTR
                 X4O(N)=XO(N)
                 Y4O(N)=YO(N)
                 Z4O(N)=ZO(N)
                 P4O(N)=PO(N)
 2054          CONTINUE
C
           ENDIF
C
       ENDIF
C
C  fin de la boucle sur les domaines
C
 20   CONTINUE
C
C  fin de la boucle des iterations
C
 2    CONTINUE
C
C
      DEALLOCATE (XM)
      DEALLOCATE (YM)
      DEALLOCATE (ZM)
      DEALLOCATE (PM)
      DEALLOCATE (IND)
      IF (NDOM .ge. 2) THEN
          DEALLOCATE (XO)
          DEALLOCATE (YO)
          DEALLOCATE (ZO)
          DEALLOCATE (PO)
      ELSE
          NULLIFY(XO)
          NULLIFY(YO)
          NULLIFY(ZO)
          NULLIFY(PO)
      ENDIF
C
      DEALLOCATE (XMR)
      DEALLOCATE (YMR)
      DEALLOCATE (XOR)
      DEALLOCATE (YOR)
      DEALLOCATE (USM)
      DEALLOCATE (VSM)
      DEALLOCATE (WSM)
      DEALLOCATE (URM)
      DEALLOCATE (VRM)
C
      IF (NDOM .ge. 2) THEN
          DEALLOCATE (XR)
          DEALLOCATE (YR)
          DEALLOCATE (ZR)
          DEALLOCATE (PR)
      ELSE
          NULLIFY(XR)
          NULLIFY(YR)
          NULLIFY(ZR)
          NULLIFY(PR)
      ENDIF
C	
      DEALLOCATE (INDX)
      DEALLOCATE (INDY)
      DEALLOCATE (INDZ)
      DEALLOCATE (IGRI)
C	
      DEALLOCATE (ALFX1)
      DEALLOCATE (ALFX2)
      DEALLOCATE (ALFX3)
      DEALLOCATE (ALFX4)
C	
      DEALLOCATE (ALFY1)
      DEALLOCATE (ALFY2)
      DEALLOCATE (ALFY3)
      DEALLOCATE (ALFY4)
C	
      DEALLOCATE (ALFZ1)
      DEALLOCATE (ALFZ2)
      DEALLOCATE (ALFZ3)
      DEALLOCATE (ALFZ4)
C	
      DEALLOCATE(WWORK1)
      DEALLOCATE(WWORK2)
      DEALLOCATE(WWORK3)
      DEALLOCATE(WWORK4)
C      
C
      RETURN
      END
