      subroutine conserv(QQQM,HHHM,
     $                   nlon,nlat,niv,ntra,nsls)
C
CCC
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type      : REPROBUS
C   Purpose   : Correction for mass conservation
C   Called by : 
C
CCC
C
C  Original : F. Lefevre (REPROBUS, LIB37)
C
C  Modified : V.-H.Peuch (inclusion dans MOCAGE), 08/1999
C
CCC
C
	IMPLICIT NONE
C	
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
C 
	INTEGER :: NLON,NLAT,NIV,NTRA,NSLS
	REAL (KIND=8) , DIMENSION (nlon,nlat,niv,ntra) :: QQQM,HHHM
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C
	INTEGER :: NIVBAS,ILON,LOLANIBA,LOLANITRA
	REAL (KIND=8) :: BRX,rapclx, rapbrx, rapnox, totmas
      PARAMETER (nivbas = 29)
C            
C
      lolaniba=nlon*nlat*nivbas
C
      do ilon = 1,lolaniba
C
C chlorine  
C
         totmas =   QQQM(ilon,1,1,23)
     $            + QQQM(ilon,1,1,10) + 2.*QQQM(ilon,1,1,25)
     $            + QQQM(ilon,1,1,13) + QQQM(ilon,1,1,14)
     $            + QQQM(ilon,1,1,15) + 2.*QQQM(ilon,1,1,16)
     $            + QQQM(ilon,1,1,18)
         rapclx = (QQQM(ilon,1,1,7)-QQQM(ilon,1,1,27))/ totmas
         HHHM(ilon,1,1,3)  = HHHM(ilon,1,1,3)*rapclx
         HHHM(ilon,1,1,11) = HHHM(ilon,1,1,11)*rapclx
         QQQM(ilon,1,1,10)=QQQM(ilon,1,1,10)*rapclx
         QQQM(ilon,1,1,13)=QQQM(ilon,1,1,13)*rapclx
         QQQM(ilon,1,1,14)=QQQM(ilon,1,1,14)*rapclx
         QQQM(ilon,1,1,15)=QQQM(ilon,1,1,15)*rapclx
         QQQM(ilon,1,1,16)=QQQM(ilon,1,1,16)*rapclx
         QQQM(ilon,1,1,18)=QQQM(ilon,1,1,18)*rapclx
         QQQM(ilon,1,1,23)=QQQM(ilon,1,1,23)*rapclx
         QQQM(ilon,1,1,25)=QQQM(ilon,1,1,25)*rapclx
C
C nitrogen 
C
         totmas = QQQM(ilon,1,1,21) + QQQM(ilon,1,1,5)
     $          + 2.*QQQM(ilon,1,1,6) + QQQM(ilon,1,1,22)
         rapnox = max((QQQM(ilon,1,1,4) - QQQM(ilon,1,1,14)
     $           - QQQM(ilon,1,1,18) - QQQM(ilon,1,1,20)), 0.)
     $           / totmas
         HHHM(ilon,1,1,7)  = HHHM(ilon,1,1,7)*rapnox
         HHHM(ilon,1,1,8)  = HHHM(ilon,1,1,8)*rapnox
         HHHM(ilon,1,1,10) = HHHM(ilon,1,1,10)*rapnox
         HHHM(ilon,1,1,13) = HHHM(ilon,1,1,13)*rapnox
         QQQM(ilon,1,1,5) = QQQM(ilon,1,1,5)*rapnox
         QQQM(ilon,1,1,6) = QQQM(ilon,1,1,6)*rapnox
         QQQM(ilon,1,1,21)= QQQM(ilon,1,1,21)*rapnox
         QQQM(ilon,1,1,22)= QQQM(ilon,1,1,22)*rapnox
C
C bromine  
C
         totmas = QQQM(ilon,1,1,24)
     $          + QQQM(ilon,1,1,26)
     $          + QQQM(ilon,1,1,19)
     $          + QQQM(ilon,1,1,20)
     $          + QQQM(ilon,1,1,27)
      brx = (20. - (4.36e-2*QQQM(ilon,1,1,31)*1.e12)
     $      - 1.1e-4*(QQQM(ilon,1,1,31)*1.e12)**2)*1.e-12
      rapbrx = brx/totmas
         HHHM(ilon,1,1,  9)= HHHM(ilon,1,1, 9)*rapbrx
         HHHM(ilon,1,1, 12)= HHHM(ilon,1,1,12)*rapbrx
         QQQM(ilon,1,1,19)=QQQM(ilon,1,1,19)*rapbrx
         QQQM(ilon,1,1,20)=QQQM(ilon,1,1,20)*rapbrx
         QQQM(ilon,1,1,24)=QQQM(ilon,1,1,24)*rapbrx
         QQQM(ilon,1,1,26)=QQQM(ilon,1,1,26)*rapbrx
         QQQM(ilon,1,1,27)=QQQM(ilon,1,1,27)*rapbrx
C
      end do
C
C Temporary!
C     lolanitra=nlon*nlat*niv*ntra
C
      lolanitra=nlon*nlat*niv*41
C
      do ilon=1,lolanitra
        QQQM(ilon,1,1,1)=MAX(QQQM(ilon,1,1,1),1.e-30)
      enddo
C
      return
      end
C
