      SUBROUTINE CORLAT(X,Y,XMIN,XMAX,NDIM)
C
CCC
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type      : 3D semi-lagrangian transport scheme
C   Purpose   : Correction of latitudes
C   Called by : 
C
CCC
C
C  Original : P. Simon, 03/1999
C
C  Modified : V.-H. Peuch            (inclusion dans MOCAGE), 04/1999
C             P. Simon (passage de XMIN et XMAX en argument), 08/1999
C
CCC
C
	USE CSTES_MOD
C
	IMPLICIT NONE	
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
C
	INTEGER :: NDIM
      REAL (KIND=8) :: XMIN,XMAX
	REAL (KIND=8) , DIMENSION (NDIM) :: X,Y
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C
	INTEGER :: N
	REAL (KIND=8) :: TEMP0,TEMP1,TEMP2
C
C
      DO 1 N=1,NDIM                                                     
         X(N)=X(N)-XPI2*INT(X(N)/XPI2)                                 
C
C FUJITSU
C         X(N)=CVMGM(X(N)+XPI2,X(N),X(N))                                
C
         IF (X(N).LT.0.) THEN
           X(N)=X(N)+XPI2
         ENDIF
C
         Y(N)=Y(N)-XPI2*INT(Y(N)/XPI2)                                 
 1    CONTINUE                                                          
C                                                                       
C  In TEMP1 longitudinal angles less than pi get translated by pi,      
C                        angles greater than pi get translated by -pi   
C  ie. TEMP1 is rotated about the pole by pi.                           
C                                                                       
C  TEMP2 reflects the latitudinal angle about the pole                  
C           (eg. 91 to 89 degrees).                                     
C                                                                       
      DO 2 N=1,NDIM                                                     
         TEMP0=XPIH-ABS(Y(N))                                           
C
C FUJITSU
C         TEMP1=CVMGM(X(N)+XPI,X(N)-XPI,X(N)-XPI)                        
C
         IF ((X(N)-XPI).LT.0.) THEN
           TEMP1=X(N)+XPI
         ELSE
           TEMP1=X(N)-XPI
         ENDIF
C
         TEMP2=SIGN(XPI,Y(N))-Y(N)                                      
C                                                                       
C FUJITSU
C         X(N)=CVMGM(TEMP1,X(N),TEMP0)                                   
C         Y(N)=CVMGM(TEMP2,Y(N),TEMP0)                                   
C
         IF (TEMP0.LT.0.) THEN
           X(N)=TEMP1
           Y(N)=TEMP2
         ENDIF
C
      IF (X(N).GT.XMAX) X(N)=X(N)-XPI2
      IF (X(N).LT.XMIN) X(N)=X(N)+XPI2
C
 2    CONTINUE
C
      RETURN                                                            
      END 
C
