      SUBROUTINE CORNIV(Z,P,NDIM)                                       
C
CCC
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type      : 3D semi-lagrangian transport scheme
C   Purpose   : Pressure correction (z between p=0 and p=psurf)
C   Called by : 
C
CCC
C
C  Original : P. Simon, 03/1999
C
C  Modified : V.-H. Peuch (inclusion dans MOCAGE), 04/1999
C
CCC
C
	IMPLICIT NONE
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
C
	INTEGER :: NDIM
	REAL (KIND=8) , DIMENSION (NDIM) :: Z,P
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C
	INTEGER :: N
C                                                                       
      DO 1 N=1,NDIM                                                     
         Z(N)=MIN(P(N),MAX(0.,Z(N)))                                
 1    CONTINUE                                                          
C                                                                       
      RETURN                                                            
      END                                                               
