      SUBROUTINE DATEFORCING( daynum, NSCY, idate0,
     $                        TRANSINV,
     $                        NAMDOM1,NAMDOM2,NAMDOM3,NAMDOM4,
     $                        nbjour,
     $                        clf1,clf2,clf3,clf4,
     $                        idate1)

C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type       : I/O
C   Purpose    : Defines the date of the forcing  and the name of the
C                forcing files
C   Called by  : FORCAGE
C
CCC
C
C  Original : P. Moinat, 21/10/2005
C
C  Last Modified : H. Le Berre 10/2006  Integration in CVS
C
C
      IMPLICIT NONE
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
      REAL (KIND=8) :: daynum
      INTEGER :: NSCY
      INTEGER , DIMENSION(5) :: idate0,idate1
      LOGICAL :: TRANSINV
      CHARACTER (LEN=6) :: NAMDOM1,NAMDOM2,NAMDOM3,NAMDOM4
      INTEGER , DIMENSION(12) :: nbjour
      CHARACTER (LEN=19) :: clf1,clf2,clf3,clf4
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~      
      INTEGER :: NBDAY,NBHOUR
C
C
          NBDAY=int((daynum+real(NSCY))/86400.)
          NBHOUR=int((daynum+real(NSCY)-real(NBDAY)*86400.)/3600.)
c
      IF (.NOT.TRANSINV) THEN     ! NOT TRANSINV
          idate1(5)=0
          idate1(4)=idate0(4)+NBHOUR
          idate1(3)=idate0(3)+NBDAY
          idate1(2)=idate0(2)
          idate1(1)=idate0(1)
c
          if (idate1(4).GE.24) then
            idate1(4)=idate1(4)-24
            idate1(3)=idate1(3)+1
          endif
c
          if (mod(idate0(1),4).EQ.0) then
            nbjour(2)=29      ! 29 days in february
          endif

          if (idate1(3).GT.nbjour(idate1(2))) then
            idate1(3)=idate1(3)-nbjour(idate1(2))
            idate1(2)=idate1(2)+1
          endif
c
          if (idate1(2).GT.12) then
            idate1(1)=idate1(1)+1
            idate1(2)=1
          endif

      ELSE                   
           idate1(5)=0
           idate1(4)=idate0(4)-NBHOUR
           idate1(3)=idate0(3)-NBDAY
           idate1(2)=idate0(2)
           idate1(1)=idate0(1)
C
          if (idate1(4).LT.0) then
            idate1(4)=idate1(4)+24
            idate1(3)=idate1(3)-1
          endif
C
          if (mod(idate0(1),4).EQ.0) then
            nbjour(2)=29      ! 29 days in february
          endif
C
          if (idate1(3).LE.0) then
            idate1(2)=idate1(2)-1
          endif
C
          if (idate1(2).LE.0) then
            idate1(1)=idate1(1)-1
            idate1(2)=12
          endif
C
          if (idate1(3).LE.0) then
            idate1(3)=idate1(3)+nbjour(idate1(2))
          endif

      ENDIF
c
c
          write(clf1,fmt='(''FM'',A6,''+'',I4.4,I2.2,I2.2,I2.2)')
     $        NAMDOM1,idate1(1),idate1(2),idate1(3),idate1(4)
          write(clf2,fmt='(''FM'',A6,''+'',I4.4,I2.2,I2.2,I2.2)')
     $        NAMDOM2,idate1(1),idate1(2),idate1(3),idate1(4)
          write(clf3,fmt='(''FM'',A6,''+'',I4.4,I2.2,I2.2,I2.2)')
     $        NAMDOM3,idate1(1),idate1(2),idate1(3),idate1(4)
          write(clf4,fmt='(''FM'',A6,''+'',I4.4,I2.2,I2.2,I2.2)')
     $        NAMDOM4,idate1(1),idate1(2),idate1(3),idate1(4)

       return
       end
