      SUBROUTINE ELSOBSGUESS(NTHETA,NEL,val,XELT,
     +                       iTH,iEL,del,dth,
     +                       diff)
C
CCC
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type       : Data assimilation
C   Purpose    : (EL,theta) assimilation
C   Called by  :
C
CCC
C
C Original  : M.-L. Cathala & V.-H. Peuch, CNRM/GMGEC/ERAM, 02/2002
C
C Modified  :
C
CCC
C
	IMPLICIT NONE
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
C
	INTEGER :: NTHETA,NEL,iTH,iEL
	REAL (KIND=8) :: val,dth,del,diff
      REAL (KIND=8) , DIMENSION (NEL,NTHETA) :: XELT
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C
      REAL (KIND=8) :: gh1,gh2,sg
      
C
CCC
C      
      IF (iTH.LT.NTHETA) THEN
        IF (iEL.LT.NEL) THEN
          gh1=   del*XELT(iEL+1,iTH)+
     +       (1.-del)*XELT(iEL,iTH)
          gh2=   del*XELT(iEL+1,iTH+1)+
     +       (1.-del)*XELT(iEL,iTH+1)
          sg=dth*gh2+(1.-dth)*gh1
          diff=val-sg
        ELSE
          sg= dth*XELT(iEL,iTH+1)+
     +       (1.-dth)*XELT(iEL,iTH)
          diff=val-sg 
        ENDIF 
      ELSE
        IF (iEL.LT.NEL) THEN
          sg= del*XELT(iEL+1,iTH)+
     +       (1.-del)*XELT(iEL,iTH)
          diff=val-sg
        ELSE
          diff=val-XELT(iEL,iTH)
        ENDIF
      ENDIF
C
      RETURN
      END
C
CCC
C
