      SUBROUTINE EMIS(LON,LAT,NIV,NIVEMIS,NBNIV,NEMI
     +               ,NTRA,BETA,DT0,XPHFM,EM,QQM,IQMEMI)
C
CCC
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type       : Emissions
C   Purpose    : Inject emission fluxes on 1 to 5 levels
C   Called by  : IOPC3D
C
CCC
C
C  Original : B. Josse & V.-H. Peuch, 04/2000
C
C  Modified :
C
CCC
C                                                            
	USE CSTES_MOD
C
	IMPLICIT NONE	
C
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
C
	INTEGER :: LON,LAT,NIV,NTRA,NIVEMIS,NBNIV,NEMI
	REAL (KIND=8) :: BETA,DT0
	INTEGER , DIMENSION (NTRA) :: IQMEMI
	REAL (KIND=8) , DIMENSION (LON,LAT,NIV)     :: XPHFM
      REAL (KIND=8) , DIMENSION (LON,LAT,NEMI)    :: EM
      REAL (KIND=8) , DIMENSION (LON,LAT,NIV,NTRA):: QQM
C	
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C	
      INTEGER :: LOLA,NIVEMM1,NIVEMM2,NIVEMM3,NIVEMM4,NIVEMM5
      INTEGER :: NIVEMM6,NIVEMM7,NIVEMM8,NIVEMM9
      INTEGER :: ITRA,ILON
      REAL (KIND=8) :: DP0,DP1,DP2,DP3,DP4,DP5,DP6,DP7,DP8
      REAL (KIND=8) :: BETACAR,BETACUB,BETAQUA,BETAPEN
      REAL (KIND=8) :: BETAHEX,BETAHEP,BETAOCT
      REAL (KIND=8) :: EMISNIV
C      
C   
      LOLA=LON*LAT      
      BETACAR=BETA*BETA
      BETACUB=BETA*BETACAR
      BETAQUA=BETA*BETACUB
      BETAPEN=BETA*BETAQUA
      BETAHEX=BETA*BETAPEN
      BETAHEP=BETA*BETAHEX
      BETAOCT=BETA*BETAHEP

      NIVEMM1=NIVEMIS-1
      NIVEMM2=NIVEMIS-2
      NIVEMM3=NIVEMIS-3
      NIVEMM4=NIVEMIS-4
      NIVEMM5=NIVEMIS-5
      NIVEMM6=NIVEMIS-6
      NIVEMM7=NIVEMIS-7
      NIVEMM8=NIVEMIS-8
      NIVEMM9=NIVEMIS-9
C
      IF(NBNIV.EQ.9) THEN
C
       DO itra=1,NTRA
        IF(IQMEMI(itra).GT.0) THEN
         DO ilon=1,LOLA
C
        DP0=XPHFM(ilon,1,NIVEMIS)-XPHFM(ilon,1,NIVEMM1)
        DP1=XPHFM(ilon,1,NIVEMM1)-XPHFM(ilon,1,NIVEMM2)
        DP2=XPHFM(ilon,1,NIVEMM2)-XPHFM(ilon,1,NIVEMM3)
        DP3=XPHFM(ilon,1,NIVEMM3)-XPHFM(ilon,1,NIVEMM4)
        DP4=XPHFM(ilon,1,NIVEMM4)-XPHFM(ilon,1,NIVEMM5)
        DP5=XPHFM(ilon,1,NIVEMM5)-XPHFM(ilon,1,NIVEMM6)
        DP6=XPHFM(ilon,1,NIVEMM6)-XPHFM(ilon,1,NIVEMM7)
        DP7=XPHFM(ilon,1,NIVEMM7)-XPHFM(ilon,1,NIVEMM8)
        DP8=XPHFM(ilon,1,NIVEMM8)-XPHFM(ilon,1,NIVEMM9)
C
        EMISNIV=DT0*(EM(ilon,1,IQMEMI(itra))*MAIR*GG)/
     $    (DP0+BETA*DP1+BETACAR*DP2+BETACUB*DP3+BETAQUA*DP4+
     $         BETAPEN*DP5+BETAHEX*DP6+BETAHEP*DP7+BETAOCT*DP8)
C
        QQM(ilon,1,NIVEMIS,itra)=QQM(ilon,1,NIVEMIS,itra)
     $                          +EMISNIV
        QQM(ilon,1,NIVEMM1,itra)=QQM(ilon,1,NIVEMM1,itra)
     $                          +BETA*EMISNIV
        QQM(ilon,1,NIVEMM2,itra)=QQM(ilon,1,NIVEMM2,itra)
     $                          +BETACAR*EMISNIV
        QQM(ilon,1,NIVEMM3,itra)=QQM(ilon,1,NIVEMM3,itra)
     $                          +BETACUB*EMISNIV
        QQM(ilon,1,NIVEMM4,itra)=QQM(ilon,1,NIVEMM4,itra)
     $                          +BETAQUA*EMISNIV
        QQM(ilon,1,NIVEMM5,itra)=QQM(ilon,1,NIVEMM5,itra)
     $                          +BETAPEN*EMISNIV
        QQM(ilon,1,NIVEMM6,itra)=QQM(ilon,1,NIVEMM6,itra)
     $                          +BETAHEX*EMISNIV
        QQM(ilon,1,NIVEMM7,itra)=QQM(ilon,1,NIVEMM7,itra)
     $                          +BETAHEP*EMISNIV
        QQM(ilon,1,NIVEMM8,itra)=QQM(ilon,1,NIVEMM8,itra)
     $                          +BETAOCT*EMISNIV
C
          ENDDO
         ENDIF
        ENDDO
C
      ELSEIF(NBNIV.EQ.8) THEN
C
       DO itra=1,NTRA
        IF(IQMEMI(itra).GT.0) THEN
         DO ilon=1,LOLA
C
        DP0=XPHFM(ilon,1,NIVEMIS)-XPHFM(ilon,1,NIVEMM1)
        DP1=XPHFM(ilon,1,NIVEMM1)-XPHFM(ilon,1,NIVEMM2)
        DP2=XPHFM(ilon,1,NIVEMM2)-XPHFM(ilon,1,NIVEMM3)
        DP3=XPHFM(ilon,1,NIVEMM3)-XPHFM(ilon,1,NIVEMM4)
        DP4=XPHFM(ilon,1,NIVEMM4)-XPHFM(ilon,1,NIVEMM5)
        DP5=XPHFM(ilon,1,NIVEMM5)-XPHFM(ilon,1,NIVEMM6)
        DP6=XPHFM(ilon,1,NIVEMM6)-XPHFM(ilon,1,NIVEMM7)
        DP7=XPHFM(ilon,1,NIVEMM7)-XPHFM(ilon,1,NIVEMM8)
C
        EMISNIV=DT0*(EM(ilon,1,IQMEMI(itra))*MAIR*GG)/
     $    (DP0+BETA*DP1+BETACAR*DP2+BETACUB*DP3+BETAQUA*DP4+
     $         BETAPEN*DP5+BETAHEX*DP6+BETAHEP*DP7)
C
        QQM(ilon,1,NIVEMIS,itra)=QQM(ilon,1,NIVEMIS,itra)
     $                          +EMISNIV
        QQM(ilon,1,NIVEMM1,itra)=QQM(ilon,1,NIVEMM1,itra)
     $                          +BETA*EMISNIV
        QQM(ilon,1,NIVEMM2,itra)=QQM(ilon,1,NIVEMM2,itra)
     $                          +BETACAR*EMISNIV
        QQM(ilon,1,NIVEMM3,itra)=QQM(ilon,1,NIVEMM3,itra)
     $                          +BETACUB*EMISNIV
        QQM(ilon,1,NIVEMM4,itra)=QQM(ilon,1,NIVEMM4,itra)
     $                          +BETAQUA*EMISNIV
        QQM(ilon,1,NIVEMM5,itra)=QQM(ilon,1,NIVEMM5,itra)
     $                          +BETAPEN*EMISNIV
        QQM(ilon,1,NIVEMM6,itra)=QQM(ilon,1,NIVEMM6,itra)
     $                          +BETAHEX*EMISNIV
        QQM(ilon,1,NIVEMM7,itra)=QQM(ilon,1,NIVEMM7,itra)
     $                          +BETAHEP*EMISNIV
C
          ENDDO
         ENDIF
        ENDDO

        ELSEIF(NBNIV.EQ.5) THEN
C      
        DO itra=1,NTRA
        IF(IQMEMI(itra).GT.0) THEN
        DO ilon=1,LOLA
C        
        DP0=XPHFM(ilon,1,NIVEMIS)-XPHFM(ilon,1,NIVEMM1)
        DP1=XPHFM(ilon,1,NIVEMM1)-XPHFM(ilon,1,NIVEMM2)
        DP2=XPHFM(ilon,1,NIVEMM2)-XPHFM(ilon,1,NIVEMM3)
        DP3=XPHFM(ilon,1,NIVEMM3)-XPHFM(ilon,1,NIVEMM4)
        DP4=XPHFM(ilon,1,NIVEMM4)-XPHFM(ilon,1,NIVEMM5)
C          
        EMISNIV=DT0*(EM(ilon,1,IQMEMI(itra))*MAIR*GG)/
     $    (DP0+BETA*DP1+BETACAR*DP2+BETACUB*DP3+BETAQUA*DP4)
C 
        QQM(ilon,1,NIVEMIS,itra)=QQM(ilon,1,NIVEMIS,itra)
     $                          +EMISNIV
        QQM(ilon,1,NIVEMM1,itra)=QQM(ilon,1,NIVEMM1,itra)
     $                          +BETA*EMISNIV
        QQM(ilon,1,NIVEMM2,itra)=QQM(ilon,1,NIVEMM2,itra)
     $                          +BETACAR*EMISNIV
        QQM(ilon,1,NIVEMM3,itra)=QQM(ilon,1,NIVEMM3,itra)
     $                          +BETACUB*EMISNIV
        QQM(ilon,1,NIVEMM4,itra)=QQM(ilon,1,NIVEMM4,itra)
     $                          +BETAQUA*EMISNIV
C
        ENDDO
        ENDIF
        ENDDO       
C
      ELSEIF(NBNIV.EQ.4) THEN
C      
        DO itra=1,NTRA
        IF(IQMEMI(itra).GT.0) THEN
        DO ilon=1,LOLA
C
        DP0=XPHFM(ilon,1,NIVEMIS)-XPHFM(ilon,1,NIVEMM1)
        DP1=XPHFM(ilon,1,NIVEMM1)-XPHFM(ilon,1,NIVEMM2)
        DP2=XPHFM(ilon,1,NIVEMM2)-XPHFM(ilon,1,NIVEMM3)
        DP3=XPHFM(ilon,1,NIVEMM3)-XPHFM(ilon,1,NIVEMM4)
C          
        EMISNIV=DT0*(EM(ilon,1,IQMEMI(itra))*MAIR*GG)/
     $    (DP0+BETA*DP1+BETACAR*DP2+BETACUB*DP3)
C    
        QQM(ilon,1,NIVEMIS,itra)=QQM(ilon,1,NIVEMIS,itra)
     $                          +EMISNIV
        QQM(ilon,1,NIVEMM1,itra)=QQM(ilon,1,NIVEMM1,itra)
     $                          +BETA*EMISNIV
        QQM(ilon,1,NIVEMM2,itra)=QQM(ilon,1,NIVEMM2,itra)
     $                          +BETACAR*EMISNIV
        QQM(ilon,1,NIVEMM3,itra)=QQM(ilon,1,NIVEMM3,itra)
     $                          +BETACUB*EMISNIV
C
        ENDDO
        ENDIF
        ENDDO
C
      ELSEIF(NBNIV.EQ.3) THEN
C      
        DO itra=1,NTRA
        IF(IQMEMI(itra).GT.0) THEN
        DO ilon=1,LOLA
C
        DP0=XPHFM(ilon,1,NIVEMIS)-XPHFM(ilon,1,NIVEMM1)
        DP1=XPHFM(ilon,1,NIVEMM1)-XPHFM(ilon,1,NIVEMM2)
        DP2=XPHFM(ilon,1,NIVEMM2)-XPHFM(ilon,1,NIVEMM3)
C         
        EMISNIV=DT0*(EM(ilon,1,IQMEMI(itra))*MAIR*GG)/
     $    (DP0+BETA*DP1+BETACAR*DP2)
C    
        QQM(ilon,1,NIVEMIS,itra)=QQM(ilon,1,NIVEMIS,itra)
     $                          +EMISNIV
        QQM(ilon,1,NIVEMM1,itra)=QQM(ilon,1,NIVEMM1,itra)
     $                          +BETA*EMISNIV
        QQM(ilon,1,NIVEMM2,itra)=QQM(ilon,1,NIVEMM2,itra)
     $                          +BETACAR*EMISNIV
C
        ENDDO
        ENDIF
        ENDDO
C
      ENDIF
C       
      END
C
CCC
C
