      SUBROUTINE EMISHR(LONPT,LATPT,LONPTMIN,LATPTMIN,PASPT,ORIG,
     &                  FIC_CADASTRE)                                            
C                                                                               
CCCCC                                                                           
C                                                                               
C   Purpose : Spatialise anthropogenic emission                                 
C             according to AIRPARIF or ESCOMPTE emissions                                   
C             inventories (for localisation, not values)                        
C   __  __   _____   _____   _____   _____   _____                              
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|                             
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|                             
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|                             
C                                                                               
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE                             
C                                                                               
C   Centre National de Recherches Meteorologiques                               
C   Groupe de Modelisation de Grande Echelle et du Climat                       
C   Equipe de Recherches sur l'Atmosphere Moyenne                               
C                                                                               
CCCCC                                                                           
C                                                                               
C  Original : A. Dufour 02/2004                                                                                                                                
C  Modified : Herve Le Berre 06/2006    merge paris and escompte subroutines in a new one             
C                                                                               
C
      USE GRIDS_MOD
      USE PARADI_MOD
C
      IMPLICIT NONE
C
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
C
      INTEGER :: LONPT,LATPT
      REAL (KIND=8) :: LONPTMIN,LATPTMIN,PASPT
      CHARACTER(len=13) :: FIC_CADASTRE
      REAL (KIND=8) , DIMENSION (LONM3,LATM3,0:NHOUR-1) :: ORIG
C
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C     
      INTEGER :: I,J,X,Y,H
      INTEGER :: INDLON,INDLAT
      REAL (KIND=8) :: TOT_PAR
      REAL (KIND=8) , ALLOCATABLE :: CADASTRE(:,:,:)
C
C          
      ALLOCATE (CADASTRE(LONPT,LATPT,0:NHOUR-1))
C
      IF (ABS(PASPT-DRLONF3).GT.1.E-4) THEN                                                  
         WRITE(*,*) ' <><> CONFIGURATION NON PREVUE <><> '
         WRITE(*,*) ' PAS HORIZONTAUX NON COMPATIBLE : grille '
     + ,DRLONF3,' ALORS QUE CADASTRE LOCAL ',PASPT
         WRITE(*,*) ' ARRET '
         CALL MOCAGE_STOP
       ENDIF                                                                    
C
      INDLON= NINT( 1 + (LONPTMIN - RLONF3MIN)/DRLONF3 )
      INDLAT= NINT( 1 + (LATPTMIN - RLATF3MIN)/DRLATF3 )
C
      OPEN (100,FILE=FIC_CADASTRE,FORM='UNFORMATTED')
        READ (100) CADASTRE
      CLOSE (100)
C
      DO H=0,NHOUR-1
        TOT_PAR = 0.
        DO I = INDLON,INDLON+LONPT-1
          DO J = INDLAT, INDLAT+LATPT-1
            TOT_PAR = TOT_PAR + ORIG(I,J,H)
          ENDDO
        ENDDO
        DO I = INDLON, INDLON+LONPT-1
          DO J = INDLAT, INDLAT+LATPT-1
            X = I - INDLON +1
            Y = J - INDLAT +1
            ORIG(i,j,h) = TOT_PAR * CADASTRE(X,Y,H)
         ENDDO
        ENDDO
      ENDDO    
C
      DEALLOCATE (CADASTRE)
C
C
      RETURN
      END       
