	MODULE FORS_MOD
C
C------------------------------------------------------------------------
C 	DAILY SURFACE FLUXES, CLOUDINESS, RAIN AND SNOW (MODEL GRIDS)
C
C	AUTHOR	: HERVE LE BERRE	- CERFACS -
C	DATE		: 03/08/2005
C	VERSION	: 1_0_0
C------------------------------------------------------------------------
C
	IMPLICIT NONE
C
C
	REAL (KIND=8) , ALLOCATABLE , SAVE :: EV1D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: VD1D(:,:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: EM1D(:,:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: XALBSM1D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: CCHI1D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: CCME1D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: CCLO1D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: CCCO1D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PWAL1D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PWAC1D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PSNL1D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PSNC1D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: GZ0M1(:,:)
	
	REAL (KIND=8) , ALLOCATABLE , SAVE :: EV2D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: VD2D(:,:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: EM2D(:,:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: XALBSM2D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: CCHI2D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: CCME2D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: CCLO2D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: CCCO2D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PWAL2D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PWAC2D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PSNL2D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PSNC2D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: GZ0M2(:,:)
	
	REAL (KIND=8) , ALLOCATABLE , SAVE :: EV3D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: VD3D(:,:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: EM3D(:,:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: XALBSM3D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: CCHI3D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: CCME3D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: CCLO3D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: CCCO3D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PWAL3D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PWAC3D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PSNL3D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PSNC3D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: GZ0M3(:,:)
	
	REAL (KIND=8) , ALLOCATABLE , SAVE :: EV4D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: VD4D(:,:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: EM4D(:,:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: XALBSM4D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: CCHI4D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: CCME4D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: CCLO4D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: CCCO4D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PWAL4D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PWAC4D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PSNL4D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PSNC4D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: GZ0M4(:,:)
C
	CONTAINS
C
	SUBROUTINE ALLOC_FORS
C
	USE PARADI_MOD

        ALLOCATE (EV1D(LONM1,LATM1,0:NHOUR))	 ; EV1D(:,:,:) = 0.0
        ALLOCATE (VD1D(LONM1,LATM1,NDEP1,0:NHOUR)) ; VD1D(:,:,:,:) = 0.0
        ALLOCATE (EM1D(LONM1,LATM1,NEMI1,0:NHOUR)) ; EM1D(:,:,:,:) = 0.0
        ALLOCATE (XALBSM1D(LONM1,LATM1,0:NHOUR)) ; XALBSM1D(:,:,:) = 0.0
        ALLOCATE (CCHI1D(LONM1,LATM1,0:NHOUR))	 ; CCHI1D(:,:,:) = 0.0
        ALLOCATE (CCME1D(LONM1,LATM1,0:NHOUR))	 ; CCME1D(:,:,:) = 0.0
        ALLOCATE (CCLO1D(LONM1,LATM1,0:NHOUR))	 ; CCLO1D(:,:,:) = 0.0
        ALLOCATE (CCCO1D(LONM1,LATM1,0:NHOUR))	 ; CCCO1D(:,:,:) = 0.0
        ALLOCATE (PWAL1D(LONM1,LATM1,0:NHOUR))	 ; PWAL1D(:,:,:) = 0.0
        ALLOCATE (PWAC1D(LONM1,LATM1,0:NHOUR))	 ; PWAC1D(:,:,:) = 0.0
        ALLOCATE (PSNL1D(LONM1,LATM1,0:NHOUR))	 ; PSNL1D(:,:,:) = 0.0
        ALLOCATE (PSNC1D(LONM1,LATM1,0:NHOUR))	 ; PSNC1D(:,:,:) = 0.0
        ALLOCATE (GZ0M1(LONM1,LATM1))	 ; GZ0M1(:,:) = 0.0
	
        ALLOCATE (EV2D(LONM2,LATM2,0:NHOUR))	 ; EV2D(:,:,:) = 0.0
        ALLOCATE (VD2D(LONM2,LATM2,NDEP2,0:NHOUR)) ; VD2D(:,:,:,:) = 0.0
        ALLOCATE (EM2D(LONM2,LATM2,NEMI2,0:NHOUR)) ; EM2D(:,:,:,:) = 0.0
        ALLOCATE (XALBSM2D(LONM2,LATM2,0:NHOUR)) ; XALBSM2D(:,:,:) = 0.0
        ALLOCATE (CCHI2D(LONM2,LATM2,0:NHOUR))	 ; CCHI2D(:,:,:) = 0.0
        ALLOCATE (CCME2D(LONM2,LATM2,0:NHOUR))	 ; CCME2D(:,:,:) = 0.0
        ALLOCATE (CCLO2D(LONM2,LATM2,0:NHOUR))	 ; CCLO2D(:,:,:) = 0.0
        ALLOCATE (CCCO2D(LONM2,LATM2,0:NHOUR))	 ; CCCO2D(:,:,:) = 0.0
        ALLOCATE (PWAL2D(LONM2,LATM2,0:NHOUR))	 ; PWAL2D(:,:,:) = 0.0
        ALLOCATE (PWAC2D(LONM2,LATM2,0:NHOUR))	 ; PWAC2D(:,:,:) = 0.0
        ALLOCATE (PSNL2D(LONM2,LATM2,0:NHOUR))	 ; PSNL2D(:,:,:) = 0.0
        ALLOCATE (PSNC2D(LONM2,LATM2,0:NHOUR))	 ; PSNC2D(:,:,:) = 0.0
        ALLOCATE (GZ0M2(LONM2,LATM2))   	 ; GZ0M2(:,:)    = 0.0
	
        ALLOCATE (EV3D(LONM3,LATM3,0:NHOUR))	 ; EV3D(:,:,:) = 0.0
        ALLOCATE (VD3D(LONM3,LATM3,NDEP3,0:NHOUR)) ; VD3D(:,:,:,:) = 0.0
        ALLOCATE (EM3D(LONM3,LATM3,NEMI3,0:NHOUR)) ; EM3D(:,:,:,:) = 0.0
        ALLOCATE (XALBSM3D(LONM3,LATM3,0:NHOUR)) ; XALBSM3D(:,:,:) = 0.0
        ALLOCATE (CCHI3D(LONM3,LATM3,0:NHOUR))	 ; CCHI3D(:,:,:) = 0.0
        ALLOCATE (CCME3D(LONM3,LATM3,0:NHOUR))	 ; CCME3D(:,:,:) = 0.0
        ALLOCATE (CCLO3D(LONM3,LATM3,0:NHOUR))	 ; CCLO3D(:,:,:) = 0.0
        ALLOCATE (CCCO3D(LONM3,LATM3,0:NHOUR))	 ; CCCO3D(:,:,:) = 0.0
        ALLOCATE (PWAL3D(LONM3,LATM3,0:NHOUR))	 ; PWAL3D(:,:,:) = 0.0
        ALLOCATE (PWAC3D(LONM3,LATM3,0:NHOUR))	 ; PWAC3D(:,:,:) = 0.0
        ALLOCATE (PSNL3D(LONM3,LATM3,0:NHOUR))	 ; PSNL3D(:,:,:) = 0.0
        ALLOCATE (PSNC3D(LONM3,LATM3,0:NHOUR))	 ; PSNC3D(:,:,:) = 0.0
        ALLOCATE (GZ0M3(LONM3,LATM3))	 ; GZ0M3(:,:) = 0.0
	
        ALLOCATE (EV4D(LONM4,LATM4,0:NHOUR))	 ; EV4D(:,:,:) = 0.0
        ALLOCATE (VD4D(LONM4,LATM4,NDEP4,0:NHOUR)) ; VD4D(:,:,:,:) = 0.0
        ALLOCATE (EM4D(LONM4,LATM4,NEMI4,0:NHOUR)) ; EM4D(:,:,:,:) = 0.0
        ALLOCATE (XALBSM4D(LONM4,LATM4,0:NHOUR)) ; XALBSM4D(:,:,:) = 0.0
        ALLOCATE (CCHI4D(LONM4,LATM4,0:NHOUR))	 ; CCHI4D(:,:,:) = 0.0
        ALLOCATE (CCME4D(LONM4,LATM4,0:NHOUR))	 ; CCME4D(:,:,:) = 0.0
        ALLOCATE (CCLO4D(LONM4,LATM4,0:NHOUR))	 ; CCLO4D(:,:,:) = 0.0
        ALLOCATE (CCCO4D(LONM4,LATM4,0:NHOUR))	 ; CCCO4D(:,:,:) = 0.0
        ALLOCATE (PWAL4D(LONM4,LATM4,0:NHOUR))	 ; PWAL4D(:,:,:) = 0.0
        ALLOCATE (PWAC4D(LONM4,LATM4,0:NHOUR))	 ; PWAC4D(:,:,:) = 0.0
        ALLOCATE (PSNL4D(LONM4,LATM4,0:NHOUR))	 ; PSNL4D(:,:,:) = 0.0
        ALLOCATE (PSNC4D(LONM4,LATM4,0:NHOUR))	 ; PSNC4D(:,:,:) = 0.0
        ALLOCATE (GZ0M4(LONM4,LATM4))	 ; GZ0M4(:,:) = 0.0

	END SUBROUTINE ALLOC_FORS
C
	SUBROUTINE DEALLOC_FORS
C
	DEALLOCATE (EV1D)
	DEALLOCATE (VD1D)
	DEALLOCATE (EM1D)
	DEALLOCATE (XALBSM1D)
	DEALLOCATE (CCHI1D)
	DEALLOCATE (CCME1D)
	DEALLOCATE (CCLO1D)
	DEALLOCATE (CCCO1D)
	DEALLOCATE (PWAL1D)
	DEALLOCATE (PWAC1D)
	DEALLOCATE (PSNL1D)
	DEALLOCATE (PSNC1D)
	DEALLOCATE (GZ0M1)
C
	DEALLOCATE (EV2D)
	DEALLOCATE (VD2D)
	DEALLOCATE (EM2D)
	DEALLOCATE (XALBSM2D)
	DEALLOCATE (CCHI2D)
	DEALLOCATE (CCME2D)
	DEALLOCATE (CCLO2D)
	DEALLOCATE (CCCO2D)
	DEALLOCATE (PWAL2D)
	DEALLOCATE (PWAC2D)
	DEALLOCATE (PSNL2D)
	DEALLOCATE (PSNC2D)
	DEALLOCATE (GZ0M2)	
C
	DEALLOCATE (EV3D)
	DEALLOCATE (VD3D)
	DEALLOCATE (EM3D)
	DEALLOCATE (XALBSM3D)
	DEALLOCATE (CCHI3D)
	DEALLOCATE (CCME3D)
	DEALLOCATE (CCLO3D)
	DEALLOCATE (CCCO3D)
	DEALLOCATE (PWAL3D)
	DEALLOCATE (PWAC3D)
	DEALLOCATE (PSNL3D)
	DEALLOCATE (PSNC3D)
	DEALLOCATE (GZ0M3)
C
	DEALLOCATE (EV4D)
	DEALLOCATE (VD4D)
	DEALLOCATE (EM4D)
	DEALLOCATE (XALBSM4D)
	DEALLOCATE (CCHI4D)
	DEALLOCATE (CCME4D)
	DEALLOCATE (CCLO4D)
	DEALLOCATE (CCCO4D)
	DEALLOCATE (PWAL4D)
	DEALLOCATE (PWAC4D)
	DEALLOCATE (PSNL4D)
	DEALLOCATE (PSNC4D)
	DEALLOCATE (GZ0M4)
C
	END SUBROUTINE DEALLOC_FORS
C
	END MODULE FORS_MOD	
