      SUBROUTINE IMPGRI(RLON,RLAT,AL,BL,TEXT,LON,LAT,NIV)               
C
CCC
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type      : 3D semi-lagrangian transport scheme
C   Purpose   : Print grid characteristics
C   Called by : INITRANS
C
CCC
C
C  Original : P. Simon, 03/1999
C
C  Modified : V.-H. Peuch (inclusion dans MOCAGE), 04/1999
C
CCC
	USE CSTES_MOD
C
	IMPLICIT NONE
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
C
	INTEGER :: LON,LAT,NIV
	REAL (KIND=8) , DIMENSION(LON)   :: RLON
	REAL (KIND=8) , DIMENSION(LAT)   :: RLAT
	REAL (KIND=8) , DIMENSION(0:NIV) :: AL,BL
      CHARACTER(LEN=32) :: TEXT
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C
	INTEGER :: I,K,L
C
      PRINT 4000,TEXT,LON,LAT,NIV                                       
 4000 FORMAT(/,A32,/,I3,' longitudes'                                   
     +            ,/,I3,' latitudes'                                    
     +            ,/,I3,' niveaux')                                     
C                                                                       
      PRINT *                                                           
      PRINT *,'Longitudes'                                              
      PRINT *                                                           
      DO 1 I=1,LON                                                      
         PRINT 1000,I,RLON(I)*CONV                                    
 1    CONTINUE                                                          
C                                                                       
      PRINT *                                                           
      PRINT *,'Latitudes'                                               
      PRINT *                                                           
      DO 2 K=1,LAT                                                      
         PRINT 2000,K,RLAT(K)*CONV                                      
 2    CONTINUE                                                          
C                                                                       
      PRINT *                                                           
      PRINT *,'Niveaux'                                                 
      PRINT *                                                           
      DO 3 L=0,NIV                                                      
         PRINT 3000,L,AL(L),BL(L),(AL(L)+BL(L)*PREF)/100.               
 3    CONTINUE                                                          
C                                                                       
 1000 FORMAT('I=',I3,' RLON=',F7.2)                                     
 2000 FORMAT('K=',I3,' RLAT=',F6.2)                                     
 3000 FORMAT('L=',I3,' AL=',F10.4,' BL=',F10.4,' PHALF=',F7.2)             
C                                                                       
      RETURN                                                            
      END                                                               
