      subroutine inhisto(idate0)
C
CCC
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type       : I/O
C   Purpose    : Read-in input history files "FM" (LFI format)
C   Called by  :
C
CCC
C     
C  Original : V.-H. Peuch, 04/1999
C
C  Modified :
C
CCC
C
      USE PARADI_MOD
      USE EXPE_MOD
      USE GRIDS_MOD
      USE MOCF_MOD
      USE MRAT_MOD
C
      IMPLICIT NONE
C	
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
C
      INTEGER , DIMENSION (5) ::  idate0
C	
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C		
      INTEGER :: IREP,IBARI,I,NSCHECK,ITRA,INIV,ILON
      INTEGER :: ityptr,itrunc,idgl,idlon,iflev
      INTEGER :: igrib,ibits,istron,ipuila
      REAL (KIND=8) :: zbeta,zclopo,zslopo,zcodil,zvp00,BrLIM
      CHARACTER(len=4) :: cdpref      
      CHARACTER(LEN=19)::  cli1,cli2,cli3,cli4
      LOGICAL :: llgard,LDEXIS,ldcosp
      INTEGER , ALLOCATABLE :: inlopa(:),inzopa(:)
      INTEGER , ALLOCATABLE :: idate(:),idate1(:),nbjour(:)
      REAL (KIND=8) , ALLOCATABLE  :: zf1(:,:),zf2(:,:)
      REAL (KIND=8) , ALLOCATABLE  :: zf3(:,:),zf4(:,:)
      REAL (KIND=8) , ALLOCATABLE  :: zvah(:),zvbh(:)
      REAL (KIND=8) , ALLOCATABLE  :: zgeom(:)  
#ifdef MASSy
      LOGICAL LINITNOy,LINITCly,LINITBry
#endif
C	
      ALLOCATE (IDATE(11)) ; IDATE(:) = 0
      ALLOCATE (IDATE1(5)) ; IDATE1(:) = 0
      ALLOCATE (NBJOUR(12))
      ALLOCATE (zf1(LONF1,LATF1)) ; zf1(:,:) = 0.0
      ALLOCATE (zf2(LONF2,LATF2)) ; zf2(:,:) = 0.0
      ALLOCATE (zf3(LONF3,LATF3)) ; zf3(:,:) = 0.0
      ALLOCATE (zf4(LONF4,LATF4)) ; zf4(:,:) = 0.0
      ALLOCATE (zvah(0:JPMXLEV)) ; zvah(:) = 0.0
      ALLOCATE (zvbh(0:JPMXLEV)) ; zvbh(:) = 0.0
      ALLOCATE (zgeom(JPMXGL)) ; zgeom(:) = 0.0
      ALLOCATE (inlopa(JPMXGL)) ; inlopa(:) = 0
      ALLOCATE (inzopa(JPMXGL)) ; inzopa(:) = 0
C
      nbjour =(/31,28,31,30,31,30,31,31,30,31,30,31/)
C
C 0. DETERMINE FILE NAMES
C
      write(cli1,fmt='(''HM'',A6,''+'',I4.4,I2.2,I2.2,I2.2)')
     +      NAMDOM1,idate0(1),idate0(2),idate0(3),idate0(4)
      write(cli2,fmt='(''HM'',A6,''+'',I4.4,I2.2,I2.2,I2.2)')
     +      NAMDOM2,idate0(1),idate0(2),idate0(3),idate0(4)
      write(cli3,fmt='(''HM'',A6,''+'',I4.4,I2.2,I2.2,I2.2)')
     +      NAMDOM3,idate0(1),idate0(2),idate0(3),idate0(4)
      write(cli4,fmt='(''HM'',A6,''+'',I4.4,I2.2,I2.2,I2.2)')
     +      NAMDOM4,idate0(1),idate0(2),idate0(3),idate0(4)
C
C 1. GLOBAL GRID (M1)
C
      if (IFLAG1) then
C      
        print*,'READING HISTORY FILE :',cli1     
        call faitou(irep,IFRED1,.true.,cli1,'OLD',.true.,
     +             .false.,0,0,ibari,CHEMSCHEME)
C
C CHECK VALID DATE
C      
        call fadies(irep,IFRED1,idate)
C
        do i=1,5
          idate1(i)=idate(i)
        enddo
C
        call TIMESEC(idate0,idate1,nscheck)
C
        if (nscheck.NE.0) then
          print*,' WRONG DATE FOR HISTORY FILE (H1) : ABORT!'
c         CALL MOCAGE_STOP
        endif
C
C CHECK GEOMETRY
C       
        call facies(CHEMSCHEME,ityptr,zbeta,zclopo,zslopo,
     +            zcodil,itrunc,idgl,idlon,inlopa,
     +            inzopa,zgeom,iflev,zvp00,zvah,
     +            zvbh,llgard)
           
        if (     (iflev.NE.NIVM1)
     +       .OR. (idgl.NE.LATM1)
     +       .OR.(idlon.NE.LONM1)    ) then
          print*,' INVALID GLOBAL HISTORY FILE (H1) : ABORT!'
          CALL MOCAGE_STOP
        endif
#ifdef MASSy
C
        LINITNOy=.FALSE.
        LINITCly=.FALSE.
        LINITBry=.FALSE.
#endif
C
C READ-IN DATA
C
        do itra=1,NTRA1
          do iniv=1,NIVM1
            if (iniv.LE.9) then
              write(cdpref,fmt='(''L00'',I1)')iniv
            else
              write(cdpref,fmt='(''L0'',I2)')iniv
            endif
C            
C CHECK AVAILABILITY
C
            call fanion(irep,IFRED1,cdpref,0,TRANAM1(itra),LDEXIS,
     +                  ldcosp,igrib,ibits,istron,ipuila)
C     
            if (LDEXIS) then
              call facile(irep,IFRED1,cdpref,0,TRANAM1(itra),zf1,
     +                   .false.)            
              do ilon=1,LOLAM1
                QQQM1(ilon,1,iniv,itra)=zf1(ilon,1)
              enddo
            else
c              print*,'NO HISTORY FOR ',TRANAM1(itra),' L(',iniv,')'
c              print*,'VALUE IS SET TO ZERO!'
              do ilon=1,LOLAM1
                QQQM1(ilon,1,iniv,itra)=0.
              enddo
#ifdef MASSy
              IF (TRANAM1(itra).EQ.'NO_y') THEN
                LINITNOy=.TRUE.
              ELSEIF (TRANAM1(itra).EQ.'Cl_y') THEN
                LINITCly=.TRUE.
              ELSEIF (TRANAM1(itra).EQ.'Br_y') THEN
                LINITBry=.TRUE.
              ENDIF
#endif
            endif
C
          enddo
        enddo
C
        do itra=1,NSLS1
          do iniv=1,NIVM1
            if (iniv.LE.9) then
              write(cdpref,fmt='(''L00'',I1)')iniv
            else
              write(cdpref,fmt='(''L0'',I2)')iniv
            endif
            call fanion(irep,IFRED1,cdpref,0,SLSNAM1(itra),LDEXIS,
     +                  ldcosp,igrib,ibits,istron,ipuila)
            if (LDEXIS) then
              call facile(irep,IFRED1,cdpref,0,SLSNAM1(itra),zf1,
     +                   .false.)
              do ilon=1,LOLAM1
                HHHM1(ilon,1,iniv,itra)=zf1(ilon,1)
              enddo
            else
c              print*,'NO HISTORY FOR ',SLSNAM1(itra),' L(',iniv,')'
c              print*,'VALUE IS SET TO ZERO!'
              do ilon=1,LOLAM1
                HHHM1(ilon,1,iniv,itra)=0.
              enddo
            endif
          enddo
        enddo
C
        call fairme(irep,IFRED1,'OLD')
C
#ifdef MASSy
#ifdef REPROBUS
        if (LINITNOy) THEN
          print*,'NOy initialised by sum of N species'
          do iniv=1,NIVM1
          do ilon=1,LOLAM1
            QQQM1(ilon,1,iniv,39) =
     +         QQQM1(ilon,1,iniv,4) + 2.0*QQQM1(ilon,1,iniv,5) +
     +         QQQM1(ilon,1,iniv,9) + QQQM1(ilon,1,iniv,13) +
     +         QQQM1(ilon,1,iniv,15) + QQQM1(ilon,1,iniv,16) +
     +         QQQM1(ilon,1,iniv,36)
          enddo
          enddo
        endif
         if (LINITCly) THEN
          print*,'Cly initialised by sum of Cl species'
          do iniv=1,NIVM1
          do ilon=1,LOLAM1
            QQQM1(ilon,1,iniv,40) =
     +         QQQM1(ilon,1,iniv,7) + QQQM1(ilon,1,iniv,8) +
     +         QQQM1(ilon,1,iniv,9) + QQQM1(ilon,1,iniv,10) +
     +     2.0*QQQM1(ilon,1,iniv,11) + QQQM1(ilon,1,iniv,13) +
     +     2.0*QQQM1(ilon,1,iniv,17) + QQQM1(ilon,1,iniv,19) +
     +         QQQM1(ilon,1,iniv,37)
          enddo
          enddo
        endif
        if (LINITBry) THEN
C
          BrLIM=20.9
          print*,'Bry initialised using CFC11 profile'
C
          do iniv=1,NIVM1
          do ilon=1,LOLAM1
C
C Bry is calculated using empirical formula based upon CFC11 profile
C
            QQQM1(ilon,1,iniv,41) =
     +      ( BrLIM - ( 4.36 E-02*QQQM1(ilon,1,iniv,23)*1. E+12 ) -
     +    1.1 E-04*(QQQM1(ilon,1,iniv,23)*1. E+12)**2.0 )*1. E-12
          enddo
          enddo
        endif
#endif
#ifdef RELACS
        if (LINITNOy) THEN
          print*,'NOy initialised by sum of N species'
          do iniv=1,NIVM1
          do ilon=1,LOLAM1
            QQQM1(ilon,1,iniv,62) =
     +         QQQM1(ilon,1,iniv,4) + 2.0*QQQM1(ilon,1,iniv,5) +
     +         QQQM1(ilon,1,iniv,9) + QQQM1(ilon,1,iniv,13) +
     +         QQQM1(ilon,1,iniv,15) + QQQM1(ilon,1,iniv,16) +
     +         QQQM1(ilon,1,iniv,35) + QQQM1(ilon,1,iniv,55) +
     +         QQQM1(ilon,1,iniv,59)
          enddo
          enddo
        endif
         if (LINITCly) THEN
          print*,'Cly initialised by sum of Cl species'
          do iniv=1,NIVM1
          do ilon=1,LOLAM1
            QQQM1(ilon,1,iniv,63) =
     +         QQQM1(ilon,1,iniv,7) + QQQM1(ilon,1,iniv,8) +
     +         QQQM1(ilon,1,iniv,9) + QQQM1(ilon,1,iniv,10) +
     +     2.0*QQQM1(ilon,1,iniv,11) + QQQM1(ilon,1,iniv,13) +
     +     2.0*QQQM1(ilon,1,iniv,17) + QQQM1(ilon,1,iniv,19) +
     +         QQQM1(ilon,1,iniv,60)
          enddo
          enddo
        endif
        if (LINITBry) THEN
C
          BrLIM=20.9
          print*,'Bry initialised using CFC11 profile'
C
          do iniv=1,NIVM1
          do ilon=1,LOLAM1
C
C Bry is calculated using empirical formula based upon CFC11 profile
C
            QQQM1(ilon,1,iniv,64) =
     +      ( BrLIM - ( 4.36 E-02*QQQM1(ilon,1,iniv,23)*1. E+12 ) -
     +    1.1 E-04*(QQQM1(ilon,1,iniv,23)*1. E+12)**2.0 )*1. E-12
          enddo
          enddo
        endif
#endif
#ifdef RACMOBUS
        if (LINITNOy) THEN
          print*,'NOy initialised by sum of N species'
          do iniv=1,NIVM1
          do ilon=1,LOLAM1
            QQQM1(ilon,1,iniv,90) =
     +         QQQM1(ilon,1,iniv,4) + 2.0*QQQM1(ilon,1,iniv,5) +
     +         QQQM1(ilon,1,iniv,9) + QQQM1(ilon,1,iniv,13) +
     +         QQQM1(ilon,1,iniv,15) + QQQM1(ilon,1,iniv,16) +
     +         QQQM1(ilon,1,iniv,35) + QQQM1(ilon,1,iniv,60) +
     +         QQQM1(ilon,1,iniv,61) + QQQM1(ilon,1,iniv,62) +
     +         QQQM1(ilon,1,iniv,82) + QQQM1(ilon,1,iniv,83) +
     +         QQQM1(ilon,1,iniv,87)
          enddo
          enddo
        endif
         if (LINITCly) THEN
          print*,'Cly initialised by sum of Cl species'
          do iniv=1,NIVM1
          do ilon=1,LOLAM1
            QQQM1(ilon,1,iniv,91) =
     +         QQQM1(ilon,1,iniv,7) + QQQM1(ilon,1,iniv,8) +
     +         QQQM1(ilon,1,iniv,9) + QQQM1(ilon,1,iniv,10) +
     +     2.0*QQQM1(ilon,1,iniv,11) + QQQM1(ilon,1,iniv,13) +
     +     2.0*QQQM1(ilon,1,iniv,17) + QQQM1(ilon,1,iniv,19) +
     +         QQQM1(ilon,1,iniv,88)
          enddo
          enddo
        endif
        if (LINITBry) THEN
C
          BrLIM=20.9
          print*,'Bry initialised using CFC11 profile'
C
          do iniv=1,NIVM1
          do ilon=1,LOLAM1
C
C Bry is calculated using empirical formula based upon CFC11 profile
C
            QQQM1(ilon,1,iniv,92) =
     +      ( BrLIM - ( 4.36 E-02*QQQM1(ilon,1,iniv,23)*1. E+12 ) -
     +    1.1 E-04*(QQQM1(ilon,1,iniv,23)*1. E+12)**2.0 )*1. E-12
          enddo
          enddo
        endif
#endif
#endif
      endif
C
C 2. CONTINENTAL GRID (M2)
C
      if (IFLAG2) then
C      
        print*,'READING HISTORY FILE :',cli2     
        call faitou(irep,IFRED2,.true.,cli2,'OLD',.true.,
     +             .false.,0,0,ibari,CHEMSCHEME)
C
C CHECK VALID DATE
C      
        call fadies(irep,IFRED2,idate)
C
        do i=1,5
          idate1(i)=idate(i)
        enddo
C
        call TIMESEC(idate0,idate1,nscheck)
C
        if (nscheck.NE.0) then
          print*,' WRONG DATE FOR HISTORY FILE (H2) : ABORT!'
          CALL MOCAGE_STOP
        endif
C
C CHECK GEOMETRY
C       
        call facies(CHEMSCHEME,ityptr,zbeta,zclopo,zslopo,
     +            zcodil,itrunc,idgl,idlon,inlopa,
     +            inzopa,zgeom,iflev,zvp00,zvah,
     +            zvbh,llgard)
           
        if (     (iflev.NE.NIVM2)
     +       .OR. (idgl.NE.LATM2)
     +       .OR.(idlon.NE.LONM2)    ) then
          print*,' INVALID CONTINENTAL HISTORY FILE (H2) : ABORT!'
          CALL MOCAGE_STOP
        endif
#ifdef MASSy
C
        LINITNOy=.FALSE.
        LINITCly=.FALSE.
        LINITBry=.FALSE.
#endif
C
C READ-IN DATA
C
        do itra=1,NTRA2
          do iniv=1,NIVM2
            if (iniv.LE.9) then
              write(cdpref,fmt='(''L00'',I1)')iniv
            else
              write(cdpref,fmt='(''L0'',I2)')iniv
            endif
C            
C CHECK AVAILABILITY
C
            call fanion(irep,IFRED2,cdpref,0,TRANAM2(itra),LDEXIS,
     +                  ldcosp,igrib,ibits,istron,ipuila)
C     
            if (LDEXIS) then
              call facile(irep,IFRED2,cdpref,0,TRANAM2(itra),zf2,
     +                   .false.)            
              do ilon=1,LOLAM2
                QQQM2(ilon,1,iniv,itra)=zf2(ilon,1)
              enddo
            else
c              print*,'NO HISTORY FOR ',TRANAM2(itra),' L(',iniv,')'
c              print*,'VALUE IS SET TO ZERO!'
              do ilon=1,LOLAM2
                QQQM2(ilon,1,iniv,itra)=0.
              enddo
            endif
#ifdef MASSy
              IF (TRANAM2(itra).EQ.'NO_y') THEN
                LINITNOy=.TRUE.
              ELSEIF (TRANAM2(itra).EQ.'Cl_y') THEN
                LINITCly=.TRUE.
              ELSEIF (TRANAM2(itra).EQ.'Br_y') THEN
                LINITBry=.TRUE.
              ENDIF
#endif
C
          enddo
        enddo
C
        do itra=1,NSLS2
          do iniv=1,NIVM2
            if (iniv.LE.9) then
              write(cdpref,fmt='(''L00'',I1)')iniv
            else
              write(cdpref,fmt='(''L0'',I2)')iniv
            endif
            call fanion(irep,IFRED2,cdpref,0,SLSNAM2(itra),LDEXIS,
     +                  ldcosp,igrib,ibits,istron,ipuila)
            if (LDEXIS) then
              call facile(irep,IFRED2,cdpref,0,SLSNAM2(itra),zf2,
     +                   .false.)
              do ilon=1,LOLAM2
                HHHM2(ilon,1,iniv,itra)=zf2(ilon,1)
              enddo
            else
c              print*,'NO HISTORY FOR ',SLSNAM2(itra),' L(',iniv,')'
c              print*,'VALUE IS SET TO ZERO!'
              do ilon=1,LOLAM2
                HHHM2(ilon,1,iniv,itra)=0.
              enddo
            endif
          enddo
        enddo
C
        call fairme(irep,IFRED2,'OLD')
C
#ifdef MASSy
#ifdef REPROBUS
        if (LINITNOy) THEN
          print*,'NOy initialised by sum of N species'
          do iniv=1,NIVM2
          do ilon=1,LOLAM2
            QQQM2(ilon,1,iniv,39) =
     +         QQQM2(ilon,1,iniv,4) + 2.0*QQQM2(ilon,1,iniv,5) +
     +         QQQM2(ilon,1,iniv,9) + QQQM2(ilon,1,iniv,13) +
     +         QQQM2(ilon,1,iniv,15) + QQQM2(ilon,1,iniv,16) +
     +         QQQM2(ilon,1,iniv,36)
          enddo
          enddo
        endif
         if (LINITCly) THEN
          print*,'Cly initialised by sum of Cl species'
          do iniv=1,NIVM2
          do ilon=1,LOLAM2
            QQQM2(ilon,1,iniv,40) =
     +         QQQM2(ilon,1,iniv,7) + QQQM2(ilon,1,iniv,8) +
     +         QQQM2(ilon,1,iniv,9) + QQQM2(ilon,1,iniv,10) +
     +     2.0*QQQM2(ilon,1,iniv,11) + QQQM2(ilon,1,iniv,13) +
     +     2.0*QQQM2(ilon,1,iniv,17) + QQQM2(ilon,1,iniv,19) +
     +         QQQM2(ilon,1,iniv,37)
          enddo
          enddo
        endif
        if (LINITBry) THEN
C
          BrLIM=20.9
          print*,'Bry initialised using CFC11 profile'
C
          do iniv=1,NIVM2
          do ilon=1,LOLAM2
C
C Bry is calculated using empirical formula based upon CFC11 profile
C
            QQQM2(ilon,1,iniv,41) =
     +      ( BrLIM - ( 4.36 E-02*QQQM2(ilon,1,iniv,23)*1. E+12 ) -
     +    1.1 E-04*(QQQM2(ilon,1,iniv,23)*1. E+12)**2.0 )*1. E-12
          enddo
          enddo
        endif
#endif
#ifdef RELACS
        if (LINITNOy) THEN
          print*,'NOy initialised by sum of N species'
          do iniv=1,NIVM2
          do ilon=1,LOLAM2
            QQQM2(ilon,1,iniv,62) =
     +         QQQM2(ilon,1,iniv,4) + 2.0*QQQM2(ilon,1,iniv,5) +
     +         QQQM2(ilon,1,iniv,9) + QQQM2(ilon,1,iniv,13) +
     +         QQQM2(ilon,1,iniv,15) + QQQM2(ilon,1,iniv,16) +
     +         QQQM2(ilon,1,iniv,35) + QQQM2(ilon,1,iniv,55) +
     +         QQQM2(ilon,1,iniv,59)
          enddo
          enddo
        endif
         if (LINITCly) THEN
          print*,'Cly initialised by sum of Cl species'
          do iniv=1,NIVM2
          do ilon=1,LOLAM2
            QQQM2(ilon,1,iniv,63) =
     +         QQQM2(ilon,1,iniv,7) + QQQM2(ilon,1,iniv,8) +
     +         QQQM2(ilon,1,iniv,9) + QQQM2(ilon,1,iniv,10) +
     +     2.0*QQQM2(ilon,1,iniv,11) + QQQM2(ilon,1,iniv,13) +
     +     2.0*QQQM2(ilon,1,iniv,17) + QQQM2(ilon,1,iniv,19) +
     +         QQQM2(ilon,1,iniv,60)
          enddo
          enddo
        endif
        if (LINITBry) THEN
C
          BrLIM=20.9
          print*,'Bry initialised using CFC11 profile'
C
          do iniv=1,NIVM2
          do ilon=1,LOLAM2
C
C Bry is calculated using empirical formula based upon CFC11 profile
C
            QQQM2(ilon,1,iniv,64) =
     +      ( BrLIM - ( 4.36 E-02*QQQM2(ilon,1,iniv,23)*1. E+12 ) -
     +    1.1 E-04*(QQQM2(ilon,1,iniv,23)*1. E+12)**2.0 )*1. E-12
          enddo
          enddo
        endif
#endif
#ifdef RACMOBUS
        if (LINITNOy) THEN
          print*,'NOy initialised by sum of N species'
          do iniv=1,NIVM2
          do ilon=1,LOLAM2
            QQQM2(ilon,1,iniv,90) =
     +         QQQM2(ilon,1,iniv,4) + 2.0*QQQM2(ilon,1,iniv,5) +
     +         QQQM2(ilon,1,iniv,9) + QQQM2(ilon,1,iniv,13) +
     +         QQQM2(ilon,1,iniv,15) + QQQM2(ilon,1,iniv,16) +
     +         QQQM2(ilon,1,iniv,35) + QQQM2(ilon,1,iniv,60) +
     +         QQQM2(ilon,1,iniv,61) + QQQM2(ilon,1,iniv,62) +
     +         QQQM2(ilon,1,iniv,82) + QQQM2(ilon,1,iniv,83) +
     +         QQQM2(ilon,1,iniv,87)
          enddo
          enddo
        endif
         if (LINITCly) THEN
          print*,'Cly initialised by sum of Cl species'
          do iniv=1,NIVM2
          do ilon=1,LOLAM2
            QQQM2(ilon,1,iniv,91) =
     +         QQQM2(ilon,1,iniv,7) + QQQM2(ilon,1,iniv,8) +
     +         QQQM2(ilon,1,iniv,9) + QQQM2(ilon,1,iniv,10) +
     +     2.0*QQQM2(ilon,1,iniv,11) + QQQM2(ilon,1,iniv,13) +
     +     2.0*QQQM2(ilon,1,iniv,17) + QQQM2(ilon,1,iniv,19) +
     +         QQQM2(ilon,1,iniv,88)
          enddo
          enddo
        endif
        if (LINITBry) THEN
C
          BrLIM=20.9
          print*,'Bry initialised using CFC11 profile'
C
          do iniv=1,NIVM2
          do ilon=1,LOLAM2
C
C Bry is calculated using empirical formula based upon CFC11 profile
C
            QQQM2(ilon,1,iniv,92) =
     +      ( BrLIM - ( 4.36 E-02*QQQM2(ilon,1,iniv,23)*1. E+12 ) -
     +    1.1 E-04*(QQQM2(ilon,1,iniv,23)*1. E+12)**2.0 )*1. E-12
          enddo
          enddo
        endif
#endif
#endif
      endif
C
C 3. REGIONAL GRID (M3)
C
      if (IFLAG3) then
C      
        print*,'READING HISTORY FILE :',cli3     
        call faitou(irep,IFRED3,.true.,cli3,'OLD',.true.,
     +             .false.,0,0,ibari,CHEMSCHEME)
C
C CHECK VALID DATE
C      
        call fadies(irep,IFRED3,idate)
C
        do i=1,5
          idate1(i)=idate(i)
        enddo
C
        call TIMESEC(idate0,idate1,nscheck)
C
        if (nscheck.NE.0) then
          print*,' WRONG DATE FOR HISTORY FILE (H3) : ABORT!'
          CALL MOCAGE_STOP
        endif
C
C CHECK GEOMETRY
C       
        call facies(CHEMSCHEME,ityptr,zbeta,zclopo,zslopo,
     +            zcodil,itrunc,idgl,idlon,inlopa,
     +            inzopa,zgeom,iflev,zvp00,zvah,
     +            zvbh,llgard)
           
        if (     (iflev.NE.NIVM3)
     +       .OR. (idgl.NE.LATM3)
     +       .OR.(idlon.NE.LONM3)    ) then
          print*,' INVALID REGIONAL HISTORY FILE (H3) : ABORT!'
          CALL MOCAGE_STOP
        endif
#ifdef MASSy
C
        LINITNOy=.FALSE.
        LINITCly=.FALSE.
        LINITBry=.FALSE.
#endif
C
C READ-IN DATA
C
        do itra=1,NTRA3
          do iniv=1,NIVM3
            if (iniv.LE.9) then
              write(cdpref,fmt='(''L00'',I1)')iniv
            else
              write(cdpref,fmt='(''L0'',I2)')iniv
            endif
C            
C CHECK AVAILABILITY
C
            call fanion(irep,IFRED3,cdpref,0,TRANAM3(itra),LDEXIS,
     +                  ldcosp,igrib,ibits,istron,ipuila)
C     
            if (LDEXIS) then
              call facile(irep,IFRED3,cdpref,0,TRANAM3(itra),zf3,
     +                   .false.)            
              do ilon=1,LOLAM3
                QQQM3(ilon,1,iniv,itra)=zf3(ilon,1)
              enddo
            else
c             print*,'NO HISTORY FOR ',TRANAM3(itra),' L(',iniv,')'
c             print*,'VALUE IS SET TO ZERO!'
              do ilon=1,LOLAM3
                QQQM3(ilon,1,iniv,itra)=0.
              enddo
            endif
#ifdef MASSy
              IF (TRANAM3(itra).EQ.'NO_y') THEN
                LINITNOy=.TRUE.
              ELSEIF (TRANAM3(itra).EQ.'Cl_y') THEN
                LINITCly=.TRUE.
              ELSEIF (TRANAM3(itra).EQ.'Br_y') THEN
                LINITBry=.TRUE.
              ENDIF
#endif
C
          enddo
        enddo
C
        do itra=1,NSLS3
          do iniv=1,NIVM3
            if (iniv.LE.9) then
              write(cdpref,fmt='(''L00'',I1)')iniv
            else
              write(cdpref,fmt='(''L0'',I2)')iniv
            endif
            call fanion(irep,IFRED3,cdpref,0,SLSNAM3(itra),LDEXIS,
     +                  ldcosp,igrib,ibits,istron,ipuila)
            if (LDEXIS) then
              call facile(irep,IFRED3,cdpref,0,SLSNAM3(itra),zf3,
     +                   .false.)
              do ilon=1,LOLAM3
                HHHM3(ilon,1,iniv,itra)=zf3(ilon,1)
              enddo
            else
c              print*,'NO HISTORY FOR ',SLSNAM3(itra),' L(',iniv,')'
c              print*,'VALUE IS SET TO ZERO!'
              do ilon=1,LOLAM3
                HHHM3(ilon,1,iniv,itra)=0.
              enddo
            endif
          enddo
        enddo
C
        call fairme(irep,IFRED3,'OLD')
#ifdef MASSy
#ifdef REPROBUS
        if (LINITNOy) THEN
          print*,'NOy initialised by sum of N species'
          do iniv=1,NIVM3
          do ilon=1,LOLAM3
            QQQM3(ilon,1,iniv,39) =
     +         QQQM3(ilon,1,iniv,4) + 2.0*QQQM3(ilon,1,iniv,5) +
     +         QQQM3(ilon,1,iniv,9) + QQQM3(ilon,1,iniv,13) +
     +         QQQM3(ilon,1,iniv,15) + QQQM3(ilon,1,iniv,16) +
     +         QQQM3(ilon,1,iniv,36)
          enddo
          enddo
        endif
         if (LINITCly) THEN
          print*,'Cly initialised by sum of Cl species'
          do iniv=1,NIVM3
          do ilon=1,LOLAM3
            QQQM3(ilon,1,iniv,40) =
     +         QQQM3(ilon,1,iniv,7) + QQQM3(ilon,1,iniv,8) +
     +         QQQM3(ilon,1,iniv,9) + QQQM3(ilon,1,iniv,10) +
     +     2.0*QQQM3(ilon,1,iniv,11) + QQQM3(ilon,1,iniv,13) +
     +     2.0*QQQM3(ilon,1,iniv,17) + QQQM3(ilon,1,iniv,19) +
     +         QQQM3(ilon,1,iniv,37)
          enddo
          enddo
        endif
        if (LINITBry) THEN
C
          BrLIM=20.9
          print*,'Bry initialised using CFC11 profile'
C
          do iniv=1,NIVM3
          do ilon=1,LOLAM3
C
C Bry is calculated using empirical formula based upon CFC11 profile
C
            QQQM3(ilon,1,iniv,41) =
     +      ( BrLIM - ( 4.36 E-02*QQQM3(ilon,1,iniv,23)*1. E+12 ) -
     +    1.1 E-04*(QQQM3(ilon,1,iniv,23)*1. E+12)**2.0 )*1. E-12
          enddo
          enddo
        endif
#endif
#ifdef RELACS
        if (LINITNOy) THEN
          print*,'NOy initialised by sum of N species'
          do iniv=1,NIVM3
          do ilon=1,LOLAM3
            QQQM3(ilon,1,iniv,62) =
     +         QQQM3(ilon,1,iniv,4) + 2.0*QQQM3(ilon,1,iniv,5) +
     +         QQQM3(ilon,1,iniv,9) + QQQM3(ilon,1,iniv,13) +
     +         QQQM3(ilon,1,iniv,15) + QQQM3(ilon,1,iniv,16) +
     +         QQQM3(ilon,1,iniv,35) + QQQM3(ilon,1,iniv,55) +
     +         QQQM3(ilon,1,iniv,59)
          enddo
          enddo
        endif
         if (LINITCly) THEN
          print*,'Cly initialised by sum of Cl species'
          do iniv=1,NIVM3
          do ilon=1,LOLAM3
            QQQM3(ilon,1,iniv,63) =
     +         QQQM3(ilon,1,iniv,7) + QQQM3(ilon,1,iniv,8) +
     +         QQQM3(ilon,1,iniv,9) + QQQM3(ilon,1,iniv,10) +
     +     2.0*QQQM3(ilon,1,iniv,11) + QQQM3(ilon,1,iniv,13) +
     +     2.0*QQQM3(ilon,1,iniv,17) + QQQM3(ilon,1,iniv,19) +
     +         QQQM3(ilon,1,iniv,60)
          enddo
          enddo
        endif
        if (LINITBry) THEN
C
          BrLIM=20.9
          print*,'Bry initialised using CFC11 profile'
C
          do iniv=1,NIVM3
          do ilon=1,LOLAM3
C
C Bry is calculated using empirical formula based upon CFC11 profile
C
            QQQM3(ilon,1,iniv,64) =
     +      ( BrLIM - ( 4.36 E-02*QQQM3(ilon,1,iniv,23)*1. E+12 ) -
     +    1.1 E-04*(QQQM3(ilon,1,iniv,23)*1. E+12)**2.0 )*1. E-12
          enddo
          enddo
        endif
#endif
#ifdef RACMOBUS
        if (LINITNOy) THEN
          print*,'NOy initialised by sum of N species'
          do iniv=1,NIVM3
          do ilon=1,LOLAM3
            QQQM3(ilon,1,iniv,90) =
     +         QQQM3(ilon,1,iniv,4) + 2.0*QQQM3(ilon,1,iniv,5) +
     +         QQQM3(ilon,1,iniv,9) + QQQM3(ilon,1,iniv,13) +
     +         QQQM3(ilon,1,iniv,15) + QQQM3(ilon,1,iniv,16) +
     +         QQQM3(ilon,1,iniv,35) + QQQM3(ilon,1,iniv,60) +
     +         QQQM3(ilon,1,iniv,61) + QQQM3(ilon,1,iniv,62) +
     +         QQQM3(ilon,1,iniv,82) + QQQM3(ilon,1,iniv,83) +
     +         QQQM3(ilon,1,iniv,87)
          enddo
          enddo
        endif
         if (LINITCly) THEN
          print*,'Cly initialised by sum of Cl species'
          do iniv=1,NIVM3
          do ilon=1,LOLAM3
            QQQM3(ilon,1,iniv,91) =
     +         QQQM3(ilon,1,iniv,7) + QQQM3(ilon,1,iniv,8) +
     +         QQQM3(ilon,1,iniv,9) + QQQM3(ilon,1,iniv,10) +
     +     2.0*QQQM3(ilon,1,iniv,11) + QQQM3(ilon,1,iniv,13) +
     +     2.0*QQQM3(ilon,1,iniv,17) + QQQM3(ilon,1,iniv,19) +
     +         QQQM3(ilon,1,iniv,88)
          enddo
          enddo
        endif
        if (LINITBry) THEN
C
          BrLIM=20.9
          print*,'Bry initialised using CFC11 profile'
C
          do iniv=1,NIVM3
          do ilon=1,LOLAM3
C
C Bry is calculated using empirical formula based upon CFC11 profile
C
            QQQM3(ilon,1,iniv,92) =
     +      ( BrLIM - ( 4.36 E-02*QQQM3(ilon,1,iniv,23)*1. E+12 ) -
     +    1.1 E-04*(QQQM3(ilon,1,iniv,23)*1. E+12)**2.0 )*1. E-12
          enddo
          enddo
        endif
#endif
#endif
C
      endif
C
C 4. ZOOM GRID (M4)
C
      if (IFLAG4) then
C      
        print*,'READING HISTORY FILE :',cli4     
        call faitou(irep,IFRED4,.true.,cli4,'OLD',.true.,
     +             .false.,0,0,ibari,CHEMSCHEME)
C
C CHECK VALID DATE
C      
        call fadies(irep,IFRED4,idate)
C
        do i=1,5
          idate1(i)=idate(i)
        enddo
C
        call TIMESEC(idate0,idate1,nscheck)
C
        if (nscheck.NE.0) then
          print*,' WRONG DATE FOR HISTORY FILE (H4) : ABORT!'
          CALL MOCAGE_STOP
        endif
C
C CHECK GEOMETRY
C       
        call facies(CHEMSCHEME,ityptr,zbeta,zclopo,zslopo,
     +            zcodil,itrunc,idgl,idlon,inlopa,
     +            inzopa,zgeom,iflev,zvp00,zvah,
     +            zvbh,llgard)
           
        if (     (iflev.NE.NIVM4)
     +       .OR. (idgl.NE.LATM4)
     +       .OR.(idlon.NE.LONM4)    ) then
          print*,' INVALID ZOOM HISTORY FILE (H4) : ABORT!'
          CALL MOCAGE_STOP
        endif
#ifdef MASSy
C
        LINITNOy=.FALSE.
        LINITCly=.FALSE.
        LINITBry=.FALSE.
#endif
C
C READ-IN DATA
C
        do itra=1,NTRA4
          do iniv=1,NIVM4
            if (iniv.LE.9) then
              write(cdpref,fmt='(''L00'',I1)')iniv
            else
              write(cdpref,fmt='(''L0'',I2)')iniv
            endif
C            
C CHECK AVAILABILITY
C
            call fanion(irep,IFRED4,cdpref,0,TRANAM4(itra),LDEXIS,
     +                  ldcosp,igrib,ibits,istron,ipuila)
C     
            if (LDEXIS) then
              call facile(irep,IFRED4,cdpref,0,TRANAM4(itra),zf4,
     +                   .false.)            
              do ilon=1,LOLAM4
                QQQM4(ilon,1,iniv,itra)=zf4(ilon,1)
              enddo
            else
c              print*,'NO HISTORY FOR ',TRANAM4(itra),' L(',iniv,')'
c              print*,'VALUE IS SET TO ZERO!'
              do ilon=1,LOLAM4
                QQQM4(ilon,1,iniv,itra)=0.
              enddo
            endif
#ifdef MASSy
              IF (TRANAM4(itra).EQ.'NO_y') THEN
                LINITNOy=.TRUE.
              ELSEIF (TRANAM4(itra).EQ.'Cl_y') THEN
                LINITCly=.TRUE.
              ELSEIF (TRANAM4(itra).EQ.'Br_y') THEN
                LINITBry=.TRUE.
              ENDIF
#endif
C
          enddo
        enddo
C
        do itra=1,NSLS4
          do iniv=1,NIVM4
            if (iniv.LE.9) then
              write(cdpref,fmt='(''L00'',I1)')iniv
            else
              write(cdpref,fmt='(''L0'',I2)')iniv
            endif
            call fanion(irep,IFRED4,cdpref,0,SLSNAM4(itra),LDEXIS,
     +                  ldcosp,igrib,ibits,istron,ipuila)
            if (LDEXIS) then
              call facile(irep,IFRED4,cdpref,0,SLSNAM4(itra),zf4,
     +                   .false.)
              do ilon=1,LOLAM4
                HHHM4(ilon,1,iniv,itra)=zf4(ilon,1)
              enddo
            else
c              print*,'NO HISTORY FOR ',SLSNAM4(itra),' L(',iniv,')'
c              print*,'VALUE IS SET TO ZERO!'
              do ilon=1,LOLAM4
                HHHM4(ilon,1,iniv,itra)=0.
              enddo
            endif
          enddo
        enddo
C
        call fairme(irep,IFRED4,'OLD')
#ifdef MASSy
#ifdef REPROBUS
        if (LINITNOy) THEN
          print*,'NOy initialised by sum of N species'
          do iniv=1,NIVM4
          do ilon=1,LOLAM4
            QQQM4(ilon,1,iniv,39) =
     +         QQQM4(ilon,1,iniv,4) + 2.0*QQQM4(ilon,1,iniv,5) +
     +         QQQM4(ilon,1,iniv,9) + QQQM4(ilon,1,iniv,13) +
     +         QQQM4(ilon,1,iniv,15) + QQQM4(ilon,1,iniv,16) +
     +         QQQM4(ilon,1,iniv,36)
          enddo
          enddo
        endif
         if (LINITCly) THEN
          print*,'Cly initialised by sum of Cl species'
          do iniv=1,NIVM4
          do ilon=1,LOLAM4
            QQQM4(ilon,1,iniv,40) =
     +         QQQM4(ilon,1,iniv,7) + QQQM4(ilon,1,iniv,8) +
     +         QQQM4(ilon,1,iniv,9) + QQQM4(ilon,1,iniv,10) +
     +     2.0*QQQM4(ilon,1,iniv,11) + QQQM4(ilon,1,iniv,13) +
     +     2.0*QQQM4(ilon,1,iniv,17) + QQQM4(ilon,1,iniv,19) +
     +         QQQM4(ilon,1,iniv,37)
          enddo
          enddo
        endif
        if (LINITBry) THEN
C
          BrLIM=20.9
          print*,'Bry initialised using CFC11 profile'
C
          do iniv=1,NIVM4
          do ilon=1,LOLAM4
C
C Bry is calculated using empirical formula based upon CFC11 profile
C
            QQQM4(ilon,1,iniv,41) =
     +      ( BrLIM - ( 4.36 E-02*QQQM4(ilon,1,iniv,23)*1. E+12 ) -
     +    1.1 E-04*(QQQM4(ilon,1,iniv,23)*1. E+12)**2.0 )*1. E-12
          enddo
          enddo
        endif
#endif
#ifdef RELACS
        if (LINITNOy) THEN
          print*,'NOy initialised by sum of N species'
          do iniv=1,NIVM4
          do ilon=1,LOLAM4
            QQQM4(ilon,1,iniv,62) =
     +         QQQM4(ilon,1,iniv,4) + 2.0*QQQM4(ilon,1,iniv,5) +
     +         QQQM4(ilon,1,iniv,9) + QQQM4(ilon,1,iniv,13) +
     +         QQQM4(ilon,1,iniv,15) + QQQM4(ilon,1,iniv,16) +
     +         QQQM4(ilon,1,iniv,35) + QQQM4(ilon,1,iniv,55) +
     +         QQQM4(ilon,1,iniv,59)
          enddo
          enddo
        endif
         if (LINITCly) THEN
          print*,'Cly initialised by sum of Cl species'
          do iniv=1,NIVM4
          do ilon=1,LOLAM4
            QQQM4(ilon,1,iniv,63) =
     +         QQQM4(ilon,1,iniv,7) + QQQM4(ilon,1,iniv,8) +
     +         QQQM4(ilon,1,iniv,9) + QQQM4(ilon,1,iniv,10) +
     +     2.0*QQQM4(ilon,1,iniv,11) + QQQM4(ilon,1,iniv,13) +
     +     2.0*QQQM4(ilon,1,iniv,17) + QQQM4(ilon,1,iniv,19) +
     +         QQQM4(ilon,1,iniv,60)
          enddo
          enddo
        endif
        if (LINITBry) THEN
C
          BrLIM=20.9
          print*,'Bry initialised using CFC11 profile'
C
          do iniv=1,NIVM4
          do ilon=1,LOLAM4
C
C Bry is calculated using empirical formula based upon CFC11 profile
C
            QQQM4(ilon,1,iniv,64) =
     +      ( BrLIM - ( 4.36 E-02*QQQM4(ilon,1,iniv,23)*1. E+12 ) -
     +    1.1 E-04*(QQQM4(ilon,1,iniv,23)*1. E+12)**2.0 )*1. E-12
          enddo
          enddo
        endif
#endif
#ifdef RACMOBUS
        if (LINITNOy) THEN
          print*,'NOy initialised by sum of N species'
          do iniv=1,NIVM4
          do ilon=1,LOLAM4
            QQQM4(ilon,1,iniv,90) =
     +         QQQM4(ilon,1,iniv,4) + 2.0*QQQM4(ilon,1,iniv,5) +
     +         QQQM4(ilon,1,iniv,9) + QQQM4(ilon,1,iniv,13) +
     +         QQQM4(ilon,1,iniv,15) + QQQM4(ilon,1,iniv,16) +
     +         QQQM4(ilon,1,iniv,35) + QQQM4(ilon,1,iniv,60) +
     +         QQQM4(ilon,1,iniv,61) + QQQM4(ilon,1,iniv,62) +
     +         QQQM4(ilon,1,iniv,82) + QQQM4(ilon,1,iniv,83) +
     +         QQQM4(ilon,1,iniv,87)
          enddo
          enddo
        endif
         if (LINITCly) THEN
          print*,'Cly initialised by sum of Cl species'
          do iniv=1,NIVM4
          do ilon=1,LOLAM4
            QQQM4(ilon,1,iniv,91) =
     +         QQQM4(ilon,1,iniv,7) + QQQM4(ilon,1,iniv,8) +
     +         QQQM4(ilon,1,iniv,9) + QQQM4(ilon,1,iniv,10) +
     +     2.0*QQQM4(ilon,1,iniv,11) + QQQM4(ilon,1,iniv,13) +
     +     2.0*QQQM4(ilon,1,iniv,17) + QQQM4(ilon,1,iniv,19) +
     +         QQQM4(ilon,1,iniv,88)
          enddo
          enddo
        endif
        if (LINITBry) THEN
C
          BrLIM=20.9
          print*,'Bry initialised using CFC11 profile'
C
          do iniv=1,NIVM4
          do ilon=1,LOLAM4
C
C Bry is calculated using empirical formula based upon CFC11 profile
C
            QQQM4(ilon,1,iniv,92) =
     +      ( BrLIM - ( 4.36 E-02*QQQM4(ilon,1,iniv,23)*1. E+12 ) -
     +    1.1 E-04*(QQQM4(ilon,1,iniv,23)*1. E+12)**2.0 )*1. E-12
          enddo
          enddo
        endif
#endif
#endif
C
      endif
C
      DEALLOCATE (IDATE)
      DEALLOCATE (IDATE1)
      DEALLOCATE (NBJOUR)
      DEALLOCATE (zf1)
      DEALLOCATE (zf2)
      DEALLOCATE (zf3)
      DEALLOCATE (zf4)
      DEALLOCATE (zvah)
      DEALLOCATE (zvbh)
      DEALLOCATE (zgeom)
      DEALLOCATE (inlopa)
      DEALLOCATE (inzopa)
C      
      RETURN
      END
