      SUBROUTINE INICSTE                                                
C
CCC
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type       : Initializations 
C   Purpose    : Initialize universal constants
C   Called by  : MAIN
C
CCC
C
C  Original : P. Simon, 03/1999
C
C  Modified : V.-H. Peuch (inclusion dans MOCAGE), 04/1999
C
CCC
C
	USE CSTES_MOD
C
	IMPLICIT NONE	
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
C
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C
C                                                                       
C
C PHYSICS
C                                                                       
      MAIR=0.029
      GG=9.80665                                                        
      RA=287.05                                                         
      CP=1005.46                                                        
      OMEGA=7.292 E-05                                                  
      RTER=6371229.                                                     
      PREF=101325.                                                      
      XLL=2.5 E+06
      TREF=273.15
      XAVOG=6.022 E+23
C
C CLOUD AND CONDENSED WATER
C
      RDT     = 11.82
      RTT     = 273.16
      ZGAUSS  = 1./(2.*RDT**2)
      RD      = 8.314/28.9644e-3
      RV      = 8.314/18.0153e-3
      CPD     = 7./2.*RD
      CPV     = 4.*RV
      ZEPSNEB = 1.e-10
      ZEPSDS  = 1.
      QSNEBS  = 0.7
      QSNEBC  = 26000.
      QSSUSS  = 0.25
      QSSUSC  = 1.
      QSSC    = 0.
      QSUSX   = 3.3e-5
      HUCOE   = 2.3
      NPCL01  = 1
      NPCL02  = 1
      HUTIL   = 0.9
C                                                                       
C MISCELANEOUS
C                                                                       
      RTER2=RTER*RTER                                                   
      DEUOMG=2.*OMEGA                                                   
C                                                                       
C  constantes geometriques                                              
C                                                                       
      XPIH=ASIN(1.)                                                     
      XPI =2.*XPIH                                                      
      XPI2=4.*XPIH                                                      
      CONV=180./XPI                                                     
C                                                                       
C
      RETURN                                                            
      END                                                               
