      SUBROUTINE LOADFORCAGE( 
     $                idate0,daynum,NSCY,
     $                clf,IFORC,
     $                TRANSINV,READA,TBTOA,TATOB,LFLAG1,entered,
     $                LONM,LATM,NIVM,LONF,LATF,NIVF,
     $                LOLANIF,LOLANIM,LOLAF,LOLAM,
     $                RLONFMIN,RLONFMAX,RLATFMIN,RLATFMAX,
     $                RLONMMIN,RLONMMAX,RLATMMIN,RLATMMAX,
     $                CPP_NIVM,CPP_PHUC,
     $                ALF,BLF,zvamh,zvbmh,
     $                ALM,BLM,
     $                TGRIFA,UGRIFA,VGRIFA,WGRIFA,QGRIFA,PVGRIFA,
     $                PSOLFA,
     $                TGRIFB,UGRIFB,VGRIFB,WGRIFB,QGRIFB,PVGRIFB,
     $                PSOLFB,
     $                TGRIMA,UGRIMA,VGRIMA,WGRIMA,QGRIMA,PVGRIMA,
     $                PSOLMA,DIVQMA,DIVUMA,
     $                XPAMA,XPHFMA,
     $                TGRIMB,UGRIMB,VGRIMB,WGRIMB,QGRIMB,PVGRIMB,
     $                PSOLMB,DIVQMB,DIVUMB,
     $                XPAMB,XPHFMB,
     $                PREF,HUCOE,NPCL01,NPCL02,HUTIL,RTER,PHUC
     $                              )

C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type       : I/O
C   Purpose    : Read-in 3D forcing files "FM" (LFI format)
C                for regular grids
C   Called by  : FORCAGE
C
CCC
C
C  Original : P. Moinat, 30/11/2005
C
C  Last Modified : H. Le Berre 10/2006  Integration in CVS
C
CCC
C
#ifdef GAUSS
      USE PARADI_MOD
      USE GRIDS_MOD
#endif      
      IMPLICIT NONE
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
      REAL (KIND=8) :: daynum
      INTEGER :: NSCY,idate0(5)
      CHARACTER (LEN=19) :: clf
      INTEGER :: IFORC
      LOGICAL TRANSINV,READA,TBTOA,TATOB,LFLAG1,entered
C
      INTEGER :: LONM,LATM,NIVM,LONF,LATF,NIVF
      INTEGER :: LOLANIF,LOLANIM,LOLAF,LOLAM
      REAL (KIND=8) :: RLONFMIN,RLONFMAX,RLATFMIN,RLATFMAX
      REAL (KIND=8) :: RLONMMIN,RLONMMAX,RLATMMIN,RLATMMAX
C
      INTEGER :: CPP_NIVM,CPP_PHUC
      REAL (KIND=8), DIMENSION(0:NIVF) :: ALF,BLF
      REAL (KIND=8), DIMENSION(0:NIVM) :: zvamh,zvbmh
      REAL (KIND=8), DIMENSION(0:NIVM) :: ALM,BLM
C
      REAL (KIND=8), DIMENSION(LONF,LATF,NIVF) :: TGRIFA,UGRIFA,
     $                               VGRIFA,WGRIFA,QGRIFA,PVGRIFA
      REAL (KIND=8), DIMENSION(LONF,LATF) :: PSOLFA
      REAL (KIND=8), DIMENSION(LONF,LATF,NIVF) :: TGRIFB,UGRIFB,
     $                               VGRIFB,WGRIFB,QGRIFB,PVGRIFB
      REAL (KIND=8), DIMENSION(LONF,LATF) :: PSOLFB
C
      REAL (KIND=8), DIMENSION(LONM,LATM,NIVM) :: TGRIMA,UGRIMA,
     $                               VGRIMA,WGRIMA,QGRIMA,PVGRIMA,
     $                                            DIVQMA,DIVUMA,
     $                                            XPAMA,XPHFMA
      REAL (KIND=8), DIMENSION(LONM,LATM) :: PSOLMA
      REAL (KIND=8), DIMENSION(LONM,LATM,NIVM) :: TGRIMB,UGRIMB,
     $                               VGRIMB,WGRIMB,QGRIMB,PVGRIMB,
     $                                            DIVQMB,DIVUMB,
     $                                            XPAMB,XPHFMB
      REAL (KIND=8), DIMENSION(LONM,LATM) :: PSOLMB
C
      REAL (KIND=8) :: PREF,HUCOE,HUTIL
      INTEGER  :: NPCL01,NPCL02
      REAL (KIND=8) :: RTER
C
      REAL (KIND=8), DIMENSION(CPP_PHUC) :: PHUC
C
C     Local variables
C     ~~~~~~~~~~~~~~~~~
#ifdef GAUSS
      INTEGER :: ilat
#endif
      INTEGER :: irep,ibari
      INTEGER iniv
      REAL (KIND=8) :: ETA
C
C
         CALL TRANSFERDATE(TBTOA,TATOB,
     &                 LONF,LATF,NIVF,
     &                 LONM,LATM,NIVM,
     $                 LOLANIF,LOLANIM,LOLAF,LOLAM,
     $                 TGRIFA,UGRIFA,VGRIFA,WGRIFA,QGRIFA,PVGRIFA,
     $                 XPAMA,XPHFMA,
     $                 TGRIMA,UGRIMA,VGRIMA,WGRIMA,QGRIMA,PVGRIMA,
     $                 DIVQMA,DIVUMA,
     $                 PSOLFA,PSOLMA,
     $                 TGRIFB,UGRIFB,VGRIFB,WGRIFB,QGRIFB,PVGRIFB,
     $                 XPAMB,XPHFMB,
     $                 TGRIMB,UGRIMB,VGRIMB,WGRIMB,QGRIMB,PVGRIMB,
     $                 DIVQMB,DIVUMB,
     $                 PSOLFB,PSOLMB)
C
C Open forcing file
             print*,'READING FORCING FILE :',clf
             call faitou(irep,IFORC,.true.,clf,'OLD',.true.,
     $                  .false.,0,0,ibari,'CADRE.STANDARD')

C Read and check the date of the 3D forcing files "FM" (LFI format)
             CALL READFORCINGDATE(  idate0,
     $                              TRANSINV,
     $                              daynum,NSCY,
     $                              clf,IFORC)

c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ DO THIS ONLY ONCE
      IF ( .NOT. entered ) THEN
C Read and check the grid of the 3D forcing files "FM" (LFI format)
            CALL READFORCINGGEOM(  NIVF,LATF,LONF,
     $                              RLONFMIN,RLONFMAX,
     $                              RLATFMIN,RLATFMAX,
     $                              ALF,BLF)
          if (LOLAM.NE.LOLAF) then
            print*,' (M) AND (F) GRIDS ARE DIFFERENT : ABORT!'
            CALL MOCAGE_STOP
          endif
c
C Define the model grid
          RLONMMIN=RLONFMIN
          RLONMMAX=RLONFMAX
          RLATMMIN=RLATFMIN
          RLATMMAX=RLATFMAX
#ifdef GAUSS
          DO ILAT=1,LATM1
           RLATM1(ILAT)=RLATF1(ILAT)
          ENDDO
#endif	  
c
          do iniv=0,NIVM
#ifdef MIDATM
            ALM(iniv)=zvamh(iniv)
            BLM(iniv)=zvbmh(iniv)
#else
            ALM(iniv)=zvamh(iniv)
            BLM(iniv)=zvbmh(iniv)
#endif
          enddo

c Initialize minimum critical humidity producing a cloud
          if (LFLAG1) then                 ! for GLOBAL DOMAIN ONLY
            if (NIVM.NE.CPP_NIVM) then
              print*,' WRONG NUMBER OF VERTICAL LEVELS : ABORT!'
              CALL MOCAGE_STOP
            else
              do iniv=1,NIVM
                ETA        = ALM(iniv)/PREF+BLM(iniv)
                PHUC(iniv) = 1.-MAX(HUCOE*ETA**NPCL01*
     +                      (1.-ETA)**NPCL02*
     +                      (1.+SQRT(HUTIL)*(ETA-0.5)),1.e-12)
              enddo
            endif
          endif

      ENDIF
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ END DO THIS ONLY ONCE


C Read the 3D forcing fields in the forcing files "FM" (LFI format)
C and perform interpolations
         IF (READA) THEN
             CALL READFORCINGFIELDS(IFORC,
     $                              LONF,LATF,NIVF,LOLAF,
     $                              TGRIFA,UGRIFA,VGRIFA,WGRIFA,
     $                              QGRIFA,PVGRIFA,PSOLFA)

             CALL INTERPOLFORCING(
     $                LONM,LATM,LONF,LATF,NIVM,NIVF,
     $                LOLAM,LOLAF,
     $                CPP_NIVM,CPP_PHUC,
     $                TGRIFA,UGRIFA,VGRIFA,WGRIFA,QGRIFA,PVGRIFA,
     $                PSOLFA,
     $                ALF,BLF,zvamh,zvbmh,
     $                RLONFMIN,RLONFMAX,RLATFMIN,RLATFMAX,
     $                PREF,HUCOE,NPCL01,NPCL02,HUTIL,
     $                RTER,
     $                TGRIMA,UGRIMA,VGRIMA,WGRIMA,QGRIMA,PVGRIMA,
     $                PSOLMA,DIVQMA,DIVUMA,
     $                XPAMA,XPHFMA,
     $                ALM,BLM,
     $                RLONMMIN,RLONMMAX,RLATMMIN,RLATMMAX,
     $                PHUC)

         ELSE           ! IF (READB) THEN
             CALL READFORCINGFIELDS(IFORC,
     $                              LONF,LATF,NIVF,LOLAF,
     $                              TGRIFB,UGRIFB,VGRIFB,WGRIFB,
     $                              QGRIFB,PVGRIFB,PSOLFB)
             CALL INTERPOLFORCING(
     $                LONM,LATM,LONF,LATF,NIVM,NIVF,
     $                LOLAM,LOLAF,
     $                CPP_NIVM,CPP_PHUC,
     $                TGRIFB,UGRIFB,VGRIFB,WGRIFB,QGRIFB,PVGRIFB,
     $                PSOLFB,
     $                ALF,BLF,zvamh,zvbmh,
     $                RLONFMIN,RLONFMAX,RLATFMIN,RLATFMAX,
     $                PREF,HUCOE,NPCL01,NPCL02,HUTIL,
     $                RTER,
     $                TGRIMB,UGRIMB,VGRIMB,WGRIMB,QGRIMB,PVGRIMB,
     $                PSOLMB,DIVQMB,DIVUMB,
     $                XPAMB,XPHFMB,
     $                ALM,BLM,
     $                RLONMMIN,RLONMMAX,RLATMMIN,RLATMMAX,
     $                PHUC)

         ENDIF

             call fairme(irep,IFORC,'OLD')
C
C
      return
      end
