      SUBROUTINE MASSE (LON,LAT,NIV,NTRA
     +                 ,DRLON,DLAT,CLAT,TRANAM
     +                 ,XPHFM,QQQM,RMAS)
C
CCC
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type      : 3D semi-lagrangian transport scheme
C   Purpose   : Compute total mass
C   Called by :
C
CCC
C
C  Original : B. Josse & V.-H. Peuch, 12/1999
C
C  Modified : 
C
CCC
C
      USE CSTES_MOD
C
      IMPLICIT NONE
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
C
      INTEGER :: LON,LAT,NIV,NTRA
      REAL (KIND=8) :: DRLON
      REAL (KIND=8) , DIMENSION (NTRA) :: RMAS
      REAL (KIND=8) , DIMENSION (LAT) :: CLAT
      REAL (KIND=8) , DIMENSION (LAT+1) :: DLAT
      REAL (KIND=8) , DIMENSION (LON,LAT,NIV) :: XPHFM
      REAL (KIND=8) , DIMENSION (LON,LAT,NIV,NTRA) :: QQQM
      CHARACTER*15  , DIMENSION (NTRA) :: TRANAM
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C
      INTEGER :: JLEV,ILAT,ILON,JC
      REAL (KIND=8) :: CST0,RPLSUP
      REAL (KIND=8) , DIMENSION (LAT) :: CST1
      REAL (KIND=8) , ALLOCATABLE :: RDPS(:,:,:)
C
      ALLOCATE (RDPS(LON,LAT,NIV))
C
      CST0=RTER*RTER/MAIR/GG
C       
      DO JLEV=2,NIV            
      DO ILAT=1,LAT  
      DO ILON=1,LON  
        RDPS(ILON,ILAT,JLEV)=
     &       ( XPHFM(ILON,ILAT,JLEV)
     &        -XPHFM(ILON,ILAT,JLEV-1))*CLAT(ILAT)
      ENDDO
      ENDDO
      ENDDO
C
#ifdef MIDATM
      RPLSUP=0.
#else
      RPLSUP=400.
#endif
      DO ILAT=1,LAT  
      DO ILON=1,LON  
        RDPS(ILON,ILAT,1)=(XPHFM(ILON,ILAT,1)-RPLSUP)*CLAT(ILAT)
      ENDDO
      ENDDO
C      
      DO ILAT=1,LAT
       CST1(ILAT)=CST0*DRLON*ABS((DLAT(ILAT+1)-DLAT(ILAT)))
      ENDDO
C
      DO JC=1,NTRA      
        RMAS(JC)=0.
        IF (TRANAM(JC).EQ.'H_2O')          GOTO 10
        IF (TRANAM(JC).EQ.'H_2SO_4')       GOTO 10
        IF (TRANAM(JC).EQ.'PSC')           GOTO 10
        IF (TRANAM(JC).EQ.'LINO_3')        GOTO 10
        IF (TRANAM(JC).EQ.'TRACEUR_FROID') GOTO 10
        IF (TRANAM(JC).EQ.'NO_y')          GOTO 10
        IF (TRANAM(JC).EQ.'Cl_y')          GOTO 10
        IF (TRANAM(JC).EQ.'Br_y')          GOTO 10
        DO JLEV=1,NIV
        DO ILAT=1,LAT
        DO ILON=1,LON
          RMAS(JC)=RMAS(JC)+
     &           QQQM(ILON,ILAT,JLEV,JC)
     &          *RDPS(ILON,ILAT,JLEV)
     &          *CST1(ILAT)
        ENDDO
        ENDDO
        ENDDO      
 10     CONTINUE
      ENDDO
C
      DEALLOCATE (RDPS)
C	
      RETURN 
      END
C
