      SUBROUTINE OUTHISTO(daynum,idate0)
C
CCC
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type       : I/O
C   Purpose    : Write output history files (LFI format)
C   Called by  : MAIN
C
CCC
C     
C  Original : V.-H. Peuch, 04/1999
C
C  Modified :
C
CCC
C
	USE PARADI_MOD
	USE EXPE_MOD
	USE GRIDS_MOD
	USE MOCF_MOD
	USE MRAT_MOD
	USE FORMT_MOD
	USE PHOTO_MOD
	USE SVPHOT_MOD
        USE CSTES_MOD
C
	IMPLICIT NONE
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
C
	REAL (KIND=8) :: daynum
      INTEGER , DIMENSION(5) :: idate0
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C
	INTEGER :: ityptr,itrunc,idgl,idlon,iflev,idom
	INTEGER :: NBDAY,NBHOUR,IREP,IBARI,I,INIV,ILON,ITRA
      REAL (KIND=8) :: zbeta,zclopo,zslopo,zcodil
      REAL (KIND=8) :: zvp00
	CHARACTER(len=4) :: cdpref
      CHARACTER(len=19) :: clf1,clf2,clf3,clf4
      CHARACTER(len=19) :: clo1,clo2,clo3,clo4
	LOGICAL :: llgard
	INTEGER , ALLOCATABLE :: inlopa(:),inzopa(:) 
	INTEGER , ALLOCATABLE :: idate(:),idate1(:),nbjour(:)
	REAL (KIND=8) , ALLOCATABLE  :: zf1(:,:),zf2(:,:)
	REAL (KIND=8) , ALLOCATABLE  :: zf3(:,:),zf4(:,:)
	REAL (KIND=8) , ALLOCATABLE  :: zvah(:),zvbh(:)
	REAL (KIND=8) , ALLOCATABLE  :: zvamh(:),zvbmh(:)
	REAL (KIND=8) , ALLOCATABLE  :: zgeom(:)
        REAL (KIND=8) , ALLOCATABLE  :: ALM1FA(:),ALM2FA(:)
        REAL (KIND=8) , ALLOCATABLE  :: ALM3FA(:),ALM4FA(:)
C
        ALLOCATE (idate(11))	 ; idate(:) = 0
        ALLOCATE (idate1(5))	 ; idate1(:) = 0
        ALLOCATE (nbjour(12))
        ALLOCATE (zf1(LONM1,LATM1))	 ; zf1(:,:) = 0.0
        ALLOCATE (zf2(LONM2,LATM2))	 ; zf2(:,:) = 0.0
        ALLOCATE (zf3(LONM3,LATM3))	 ; zf3(:,:) = 0.0
        ALLOCATE (zf4(LONM4,LATM4))	 ; zf4(:,:) = 0.0
        ALLOCATE (zvah(0:JPMXLEV))	 ; zvah(:) = 0.0
        ALLOCATE (zvbh(0:JPMXLEV))      	 ; zvbh(:) = 0.0      
        ALLOCATE (zvamh(0:NIVM1))       	 ; zvamh(:) = 0.0       
        ALLOCATE (zvbmh(0:NIVM1))	 ; zvbmh(:) = 0.0
        ALLOCATE (zgeom(JPMXGL))	 ; zgeom(:) = 0.0
        ALLOCATE (inlopa(JPMXGL))	 ; inlopa(:) = 0
        ALLOCATE (inzopa(JPMXGL))	 ; inzopa(:) = 0
        ALLOCATE (ALM1FA(0:NIVM1))	 ; ALM1FA(:) = 0.0
        ALLOCATE (ALM2FA(0:NIVM2))	 ; ALM2FA(:) = 0.0
        ALLOCATE (ALM3FA(0:NIVM3))	 ; ALM3FA(:) = 0.0
        ALLOCATE (ALM4FA(0:NIVM4))	 ; ALM4FA(:) = 0.0

C
	nbjour =(/31,28,31,30,31,30,31,31,30,31,30,31/)
C
C 1. GET GEOMETRY ACCORDING TO INITIAL FILE(S)
C
C
C 1.1 DETERMINE OUTPUT DATE
C
      NBDAY=int(daynum/86400.)
      NBHOUR=int((daynum-real(NBDAY)*86400.)/3600.)
C
      IF (.NOT.TRANSINV) THEN
        idate1(5)=0
        idate1(4)=idate0(4)+NBHOUR
        idate1(3)=idate0(3)+NBDAY
        idate1(2)=idate0(2)
        idate1(1)=idate0(1)
        IF (idate1(4).GE.24) THEN
          idate1(4)=idate1(4)-24
          idate1(3)=idate1(3)+1
        ENDIF
        IF (mod(idate0(1),4).EQ.0) THEN
          nbjour(2)=29
        ENDIF
        IF (idate1(3).GT.nbjour(idate1(2))) THEN
          idate1(3)=idate1(3)-nbjour(idate1(2))
          idate1(2)=idate1(2)+1
        ENDIF
        IF (idate1(2).GT.12) THEN
          idate1(1)=idate1(1)+1
          idate1(2)=1
        ENDIF
      ELSE
        idate1(5)=0
        idate1(4)=idate0(4)-NBHOUR
        idate1(3)=idate0(3)-NBDAY
        idate1(2)=idate0(2)
        idate1(1)=idate0(1)
        IF (idate1(4).LT.0) THEN
          idate1(4)=idate1(4)+24
          idate1(3)=idate1(3)-1
        ENDIF
        IF (idate1(4).GE.24) THEN
          idate1(4)=idate1(4)-24
          idate1(3)=idate1(3)+1
        ENDIF
        IF (mod(idate0(1),4).EQ.0) THEN
          nbjour(2)=29
        ENDIF
        IF (idate1(3).GT.nbjour(idate1(2))) THEN
          idate1(3)=idate1(3)-nbjour(idate1(2))
          idate1(2)=idate1(2)+1
        ENDIF
        IF (idate1(3).LE.0) THEN
          idate1(2)=idate1(2)-1
        ENDIF
        IF (idate1(2).LE.0) THEN
          idate1(1)=idate1(1)-1
          idate1(2)=12
        ENDIF
        IF (idate1(2).GT.12) THEN
          idate1(1)=idate1(1)+1
          idate1(2)=1
        ENDIF
        IF (idate1(3).LE.0) THEN
          idate1(3)=idate1(3)+nbjour(idate1(2))
        ENDIF
      ENDIF
C
C 1.2 Passage des coefficients A au bon format (en Pa/Pa)
C
      IF (IFLAG1) THEN
       DO INIV=0,NIVM1
        ALM1FA(INIV)=ALM1(INIV)/PREF
       ENDDO
      ENDIF
      IF (IFLAG2) THEN
       DO INIV=0,NIVM2
        ALM2FA(INIV)=ALM2(INIV)/PREF
       ENDDO
      ENDIF
      IF (IFLAG3) THEN
       DO INIV=0,NIVM1
        ALM3FA(INIV)=ALM3(INIV)/PREF
       ENDDO
      ENDIF
      IF (IFLAG4) THEN
       DO INIV=0,NIVM4
        ALM4FA(INIV)=ALM4(INIV)/PREF
       ENDDO
      ENDIF
C
C 2. GLOBAL GRID (M1)
C
      if (IFLAG1.and.MYID.eq.0) THEN
C
        write(clo1,fmt='(''HM'',A6,''+'',I4.4,I2.2,I2.2,I2.2)')
     +        NAMDOM1,idate1(1),idate1(2),idate1(3),idate1(4)
C
        write(clf1,fmt='(''FM'',A6,''+'',I4.4,I2.2,I2.2,I2.2)')
     +        NAMDOM1,idate0(1),idate0(2),idate0(3),idate0(4)
C
        call faitou(irep,IFORC1,.true.,clf1,'OLD',.true.,
     +             .false.,0,0,ibari,'CADRE.STANDARD')
C     
        call facies('CADRE.STANDARD',ityptr,zbeta,zclopo,zslopo,
     +            zcodil,itrunc,idgl,idlon,inlopa,
     +            inzopa,zgeom,iflev,zvp00,zvah,
     +            zvbh,llgard)
C
C CLOSE OLD FILE
C
        call fairme(irep,IFORC1,'OLD')
C
C SET NEW FILE FRAME
C
        call facade(CHEMSCHEME,ityptr,zbeta,zclopo,zslopo,
     +            zcodil,itrunc,idgl,idlon,inlopa,
     +            inzopa,zgeom,NIVM1,zvp00,ALM1FA,
     +            BLM1,llgard)

C
C OPEN NEW FILE
C
        call faitou(irep,IFSOR1,.true.,clo1,'NEW',.true.,
     +             .false.,0,0,ibari,CHEMSCHEME)
        PRINT *, '>> Writing history file ',TRIM(clo1)
        PRINT *, '   On processor ',MYID
C
C SET NEW FILE DATE
C
        idate(1) = idate1(1)
        idate(2) = idate1(2)
        idate(3) = idate1(3)
        idate(4) = idate1(4)
        idate(5) = idate1(5)
        do i=6,11
          idate(i) = 0
        enddo
        call fandar(irep,IFSOR1,idate)
C
C WRITE DATA
C
        do iniv=1,NIVM1
          if (iniv.LE.9) then
            write(cdpref,fmt='(''L00'',I1)')iniv
          else
            write(cdpref,fmt='(''L0'',I2)')iniv
          endif
C
          do ilon=1,LOLAM1
            zf1(ilon,1)=TGRIM1(ilon,1,iniv)
          enddo 
          call faienc(irep,IFSOR1,cdpref,0,'TEMPERATURE',zf1,
     $                    .false.)
C
          do ilon=1,LOLAM1
            zf1(ilon,1)=UGRIM1(ilon,1,iniv)
          enddo 
          call faienc(irep,IFSOR1,cdpref,0,'VENT_ZONAL',zf1,
     $                    .false.)
C
          do ilon=1,LOLAM1
            zf1(ilon,1)=VGRIM1(ilon,1,iniv)
          enddo 
          call faienc(irep,IFSOR1,cdpref,0,'VENT_MERIDIE',zf1,
     $                    .false.)
C
          do ilon=1,LOLAM1
            zf1(ilon,1)=WGRIM1(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR1,cdpref,0,'VITESSE_VERT',zf1,
     $                    .false.)
C     
          do ilon=1,LOLAM1
            zf1(ilon,1)=QGRIM1(ilon,1,iniv)
          enddo 
          call faienc(irep,IFSOR1,cdpref,0,'HUMI.SPECIFI',zf1,
     $                    .false.)
C
          do ilon=1,LOLAM1
            zf1(ilon,1)=PVGRIM1(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR1,cdpref,0,'POT_VORTICIT',zf1,
     $                    .false.)
C
          do ilon=1,LOLAM1
            zf1(ilon,1)=XPAM1(ilon,1,iniv)
          enddo 
          call faienc(irep,IFSOR1,cdpref,0,'PRESSION_PA',zf1,
     $                    .false.)
C
          do ilon=1,LOLAM1
            zf1(ilon,1)=FCC1(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR1,cdpref,0,'CLOUDINESS',zf1,
     $                    .false.)
C
          do ilon=1,LOLAM1
            zf1(ilon,1)=FCCV1(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR1,cdpref,0,'CONV.CLOUD',zf1,
     $                    .false.)
C
          do ilon=1,LOLAM1
            zf1(ilon,1)=QLIQ1(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR1,cdpref,0,'LIQUID.WATER',zf1,
     $                    .false.)
C
          do ilon=1,LOLAM1
            zf1(ilon,1)=QICE1(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR1,cdpref,0,'SOLID.WATER',zf1,
     $                    .false.)
C
#ifndef RELACS
          IF (iJNO2.GT.0) THEN
            do ilon=1,LOLAM1
              zf1(ilon,1)=TJM1(ilon,1,iniv,iJNO2)
            enddo
            call faienc(irep,IFSOR1,cdpref,0,'JNO2',zf1,
     $                      .false.)
          ENDIF
C
          IF (iJO1D.GT.0) THEN
            do ilon=1,LOLAM1
              zf1(ilon,1)=TJM1(ilon,1,iniv,iJO1D)
            enddo
            call faienc(irep,IFSOR1,cdpref,0,'JO1D',zf1,
     $                      .false.)
          ENDIF
C
          IF (iINDUV.GT.0) THEN
            do ilon=1,LOLAM1
              zf1(ilon,1)=TJM1(ilon,1,iniv,iINDUV)
            enddo
            call faienc(irep,IFSOR1,cdpref,0,'UV.INDEX',zf1,
     $                      .false.)
          ENDIF
C
          IF (iINDUVCS.GT.0) THEN
            do ilon=1,LOLAM1
              zf1(ilon,1)=TJM1(ilon,1,iniv,iINDUVCS)
            enddo
            call faienc(irep,IFSOR1,cdpref,0,'UVI.CLEARSKY',zf1,
     $                      .false.)
          ENDIF
C
          IF (iUVB.GT.0) THEN
            do ilon=1,LOLAM1
              zf1(ilon,1)=TJM1(ilon,1,iniv,iUVB)
            enddo
            call faienc(irep,IFSOR1,cdpref,0,'UV.B',zf1,
     $                      .false.)
            ENDIF
C
          IF (iUVA.GT.0) THEN
            do ilon=1,LOLAM1
              zf1(ilon,1)=TJM1(ilon,1,iniv,iUVA)
            enddo
            call faienc(irep,IFSOR1,cdpref,0,'UV.A',zf1,
     $                      .false.)
          ENDIF
C
#endif
        enddo
C     
        do itra=1,NTRA1
          do iniv=1,NIVM1
            if (iniv.LE.9) then
              write(cdpref,fmt='(''L00'',I1)')iniv
            else
              write(cdpref,fmt='(''L0'',I2)')iniv
            endif
C            
            do ilon=1,LOLAM1
              zf1(ilon,1)=MAX(QQQM1(ilon,1,iniv,itra),1.e-30)
            enddo
            call faienc(irep,IFSOR1,cdpref,0,TRANAM1(itra),zf1,
     $                 .false.)            
C
          enddo
        enddo
C
        do itra=1,NSLS1
          do iniv=1,NIVM1
            if (iniv.LE.9) then
              write(cdpref,fmt='(''L00'',I1)')iniv
            else
              write(cdpref,fmt='(''L0'',I2)')iniv
            endif
C
            do ilon=1,LOLAM1
              zf1(ilon,1)=MAX(HHHM1(ilon,1,iniv,itra),1.e-30)
            enddo
            call faienc(irep,IFSOR1,cdpref,0,SLSNAM1(itra),zf1,
     $                 .false.)
C
          enddo
        enddo
C
        call fairme(irep,IFSOR1,'UNKNIW')
C
      endif
C
C 3. CONTINENTAL GRID (M2)
C
      if (IFLAG2.and.mod(1,NPROCS).eq.MYID) THEN
C
        write(clo2,fmt='(''HM'',A6,''+'',I4.4,I2.2,I2.2,I2.2)')
     +      NAMDOM2,idate1(1),idate1(2),idate1(3),idate1(4)
C
        write(clf2,fmt='(''FM'',A6,''+'',I4.4,I2.2,I2.2,I2.2)')
     +      NAMDOM2,idate0(1),idate0(2),idate0(3),idate0(4)
C
        call faitou(irep,IFORC2,.true.,clf2,'OLD',.true.,
     +             .false.,0,0,ibari,'CADRE.STANDARD')
C     
        call facies('CADRE.STANDARD',ityptr,zbeta,zclopo,zslopo,
     +            zcodil,itrunc,idgl,idlon,inlopa,
     +            inzopa,zgeom,iflev,zvp00,zvah,
     +            zvbh,llgard)
C
C CLOSE OLD FILE
C
        call fairme(irep,IFORC2,'OLD')
C
C SET NEW FILE FRAME
C
        call facade(CHEMSCHEME,ityptr,zbeta,zclopo,zslopo,
     +            zcodil,itrunc,idgl,idlon,inlopa,
     +            inzopa,zgeom,NIVM2,zvp00,ALM2FA,
     +            BLM2,llgard)
C
C OPEN NEW FILE
C
        call faitou(irep,IFSOR2,.true.,clo2,'NEW',.true.,
     +             .false.,0,0,ibari,CHEMSCHEME)
        PRINT *, '>> Writing history file ',TRIM(clo2)
        PRINT *, '   On processor ',MYID
C
C SET NEW FILE DATE
C
        idate(1) = idate1(1)
        idate(2) = idate1(2)
        idate(3) = idate1(3)
        idate(4) = idate1(4)
        idate(5) = idate1(5)
        do i=6,11
          idate(i) = 0
        enddo
        call fandar(irep,IFSOR2,idate)
C
C WRITE DATA
C
        do iniv=1,NIVM2
          if (iniv.LE.9) then
            write(cdpref,fmt='(''L00'',I1)')iniv
          else
            write(cdpref,fmt='(''L0'',I2)')iniv
          endif
C
          do ilon=1,LOLAM2
            zf2(ilon,1)=TGRIM2(ilon,1,iniv)
          enddo 
          call faienc(irep,IFSOR2,cdpref,0,'TEMPERATURE',zf2,
     $                    .false.)
C
          do ilon=1,LOLAM2
            zf2(ilon,1)=UGRIM2(ilon,1,iniv)
          enddo 
          call faienc(irep,IFSOR2,cdpref,0,'VENT_ZONAL',zf2,
     $                    .false.)
C
          do ilon=1,LOLAM2
            zf2(ilon,1)=VGRIM2(ilon,1,iniv)
          enddo 
          call faienc(irep,IFSOR2,cdpref,0,'VENT_MERIDIE',zf2,
     $                    .false.)
C
          do ilon=1,LOLAM2
            zf2(ilon,1)=WGRIM2(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR2,cdpref,0,'VITESSE_VERT',zf2,
     $                    .false.)
C     
          do ilon=1,LOLAM2
            zf2(ilon,1)=QGRIM2(ilon,1,iniv)
          enddo 
          call faienc(irep,IFSOR2,cdpref,0,'HUMI.SPECIFI',zf2,
     $                    .false.)
C
          do ilon=1,LOLAM2
            zf2(ilon,1)=PVGRIM2(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR2,cdpref,0,'POT_VORTICIT',zf2,
     $                    .false.)
C
          do ilon=1,LOLAM2
            zf2(ilon,1)=XPAM2(ilon,1,iniv)
          enddo 
          call faienc(irep,IFSOR2,cdpref,0,'PRESSION_PA',zf2,
     $                    .false.)
C
          do ilon=1,LOLAM2
            zf2(ilon,1)=FCC2(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR2,cdpref,0,'CLOUDINESS',zf2,
     $                    .false.)
C
          do ilon=1,LOLAM2
            zf2(ilon,1)=FCCV2(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR2,cdpref,0,'CONV.CLOUD',zf2,
     $                    .false.)
C
          do ilon=1,LOLAM2
            zf2(ilon,1)=QLIQ2(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR2,cdpref,0,'LIQUID.WATER',zf2,
     $                    .false.)
C
          do ilon=1,LOLAM2
            zf2(ilon,1)=QICE2(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR2,cdpref,0,'SOLID.WATER',zf2,
     $                    .false.)
C
          do ilon=1,LOLAM2
            zf2(ilon,1)=TJM2(ilon,1,iniv,1)
          enddo
          call faienc(irep,IFSOR2,cdpref,0,'JNO2',zf2,
     $                    .false.)
C
          do ilon=1,LOLAM2
            zf2(ilon,1)=TJM2(ilon,1,iniv,2)
          enddo
          call faienc(irep,IFSOR2,cdpref,0,'JO1D',zf2,
     $                    .false.)
C
          IF (iINDUV.GT.0) THEN 
            do ilon=1,LOLAM2
              zf2(ilon,1)=TJM2(ilon,1,iniv,iINDUV)
            enddo
            call faienc(irep,IFSOR2,cdpref,0,'UV.INDEX',zf2,
     $                      .false.)
          ENDIF
C          
          IF (iINDUVCS.GT.0) THEN
            do ilon=1,LOLAM2
              zf2(ilon,1)=TJM2(ilon,1,iniv,iINDUVCS)
            enddo
            call faienc(irep,IFSOR2,cdpref,0,'UVI.CLEARSKY',zf2,
     $                      .false.)
          ENDIF
C
          IF (iUVB.GT.0) THEN
            do ilon=1,LOLAM2
              zf2(ilon,1)=TJM2(ilon,1,iniv,iUVB)
            enddo
            call faienc(irep,IFSOR2,cdpref,0,'UV.B',zf2,
     $                      .false.)
          ENDIF
C
          IF (iUVA.GT.0) THEN
            do ilon=1,LOLAM2
              zf2(ilon,1)=TJM2(ilon,1,iniv,iUVA)
            enddo
            call faienc(irep,IFSOR2,cdpref,0,'UV.A',zf2,
     $                      .false.)
          ENDIF
C
        enddo
C     
        do itra=1,NTRA2
          do iniv=1,NIVM2
            if (iniv.LE.9) then
              write(cdpref,fmt='(''L00'',I1)')iniv
            else
              write(cdpref,fmt='(''L0'',I2)')iniv
            endif
C            
            do ilon=1,LOLAM2
              zf2(ilon,1)=MAX(QQQM2(ilon,1,iniv,itra),1.e-30)
            enddo
            call faienc(irep,IFSOR2,cdpref,0,TRANAM2(itra),zf2,
     $                 .false.)            
C
          enddo
        enddo
C
        do itra=1,NSLS2
          do iniv=1,NIVM2
            if (iniv.LE.9) then
              write(cdpref,fmt='(''L00'',I1)')iniv
            else
              write(cdpref,fmt='(''L0'',I2)')iniv
            endif
C
            do ilon=1,LOLAM2
              zf2(ilon,1)=MAX(HHHM2(ilon,1,iniv,itra),1.e-30)
            enddo
            call faienc(irep,IFSOR2,cdpref,0,SLSNAM2(itra),zf2,
     $                 .false.)
C
          enddo
        enddo
C
C
        call fairme(irep,IFSOR2,'UNKNIW')
C
      endif
C
C 4. REGIONAL GRID (M3)
C
      if (IFLAG3.and.mod(2,NPROCS).eq.MYID) THEN
C
        write(clo3,fmt='(''HM'',A6,''+'',I4.4,I2.2,I2.2,I2.2)')
     +      NAMDOM3,idate1(1),idate1(2),idate1(3),idate1(4)
C
        write(clf3,fmt='(''FM'',A6,''+'',I4.4,I2.2,I2.2,I2.2)')
     +      NAMDOM3,idate0(1),idate0(2),idate0(3),idate0(4)
C
        call faitou(irep,IFORC3,.true.,clf3,'OLD',.true.,
     +             .false.,0,0,ibari,'CADRE.STANDARD')
C     
        call facies('CADRE.STANDARD',ityptr,zbeta,zclopo,zslopo,
     +            zcodil,itrunc,idgl,idlon,inlopa,
     +            inzopa,zgeom,iflev,zvp00,zvah,
     +            zvbh,llgard)
C
C CLOSE OLD FILE
C
        call fairme(irep,IFORC3,'OLD')
C
C SET NEW FILE FRAME
C
        call facade(CHEMSCHEME,ityptr,zbeta,zclopo,zslopo,
     +            zcodil,itrunc,idgl,idlon,inlopa,
     +            inzopa,zgeom,NIVM3,zvp00,ALM3FA,
     +            BLM3,llgard)
C
C OPEN NEW FILE
C
        call faitou(irep,IFSOR3,.true.,clo3,'NEW',.true.,
     +             .false.,0,0,ibari,CHEMSCHEME)
        PRINT *, '>> Writing history file ',TRIM(clo3)
        PRINT *, '   On processor ',MYID
C
C SET NEW FILE DATE
C
        idate(1) = idate1(1)
        idate(2) = idate1(2)
        idate(3) = idate1(3)
        idate(4) = idate1(4)
        idate(5) = idate1(5)
        do i=6,11
          idate(i) = 0
        enddo
        call fandar(irep,IFSOR3,idate)
C
C WRITE DATA
C
        do iniv=1,NIVM3
          if (iniv.LE.9) then
            write(cdpref,fmt='(''L00'',I1)')iniv
          else
            write(cdpref,fmt='(''L0'',I2)')iniv
          endif
C
          do ilon=1,LOLAM3
            zf3(ilon,1)=TGRIM3(ilon,1,iniv)
          enddo 
          call faienc(irep,IFSOR3,cdpref,0,'TEMPERATURE',zf3,
     $                    .false.)
C
          do ilon=1,LOLAM3
            zf3(ilon,1)=UGRIM3(ilon,1,iniv)
          enddo 
          call faienc(irep,IFSOR3,cdpref,0,'VENT_ZONAL',zf3,
     $                    .false.)
C
          do ilon=1,LOLAM3
            zf3(ilon,1)=VGRIM3(ilon,1,iniv)
          enddo 
          call faienc(irep,IFSOR3,cdpref,0,'VENT_MERIDIE',zf3,
     $                    .false.)
C
          do ilon=1,LOLAM3
            zf3(ilon,1)=WGRIM3(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR3,cdpref,0,'VITESSE_VERT',zf3,
     $                    .false.)
C     
          do ilon=1,LOLAM3
            zf3(ilon,1)=QGRIM3(ilon,1,iniv)
          enddo 
          call faienc(irep,IFSOR3,cdpref,0,'HUMI.SPECIFI',zf3,
     $                    .false.)
C
          do ilon=1,LOLAM3
            zf3(ilon,1)=PVGRIM3(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR3,cdpref,0,'POT_VORTICIT',zf3,
     $                    .false.)
C
          do ilon=1,LOLAM3
            zf3(ilon,1)=XPAM3(ilon,1,iniv)
          enddo 
          call faienc(irep,IFSOR3,cdpref,0,'PRESSION_PA',zf3,
     $                    .false.)
C
          do ilon=1,LOLAM3
            zf3(ilon,1)=FCC3(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR3,cdpref,0,'CLOUDINESS',zf3,
     $                    .false.)
C
          do ilon=1,LOLAM3
            zf3(ilon,1)=FCCV3(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR3,cdpref,0,'CONV.CLOUD',zf3,
     $                    .false.)
C
          do ilon=1,LOLAM3
            zf3(ilon,1)=QLIQ3(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR3,cdpref,0,'LIQUID.WATER',zf3,
     $                    .false.)
C
          do ilon=1,LOLAM3
            zf3(ilon,1)=QICE3(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR3,cdpref,0,'SOLID.WATER',zf3,
     $                    .false.)
C
          do ilon=1,LOLAM3
            zf3(ilon,1)=TJM3(ilon,1,iniv,1)
          enddo
          call faienc(irep,IFSOR3,cdpref,0,'JNO2',zf3,
     $                    .false.)
C
          do ilon=1,LOLAM3
            zf3(ilon,1)=TJM3(ilon,1,iniv,2)
          enddo
          call faienc(irep,IFSOR3,cdpref,0,'JO1D',zf3,
     $                    .false.)
C
          IF (iINDUV.GT.0) THEN
            do ilon=1,LOLAM3
              zf3(ilon,1)=TJM3(ilon,1,iniv,iINDUV)
            enddo
            call faienc(irep,IFSOR3,cdpref,0,'UV.INDEX',zf3,
     $                      .false.)
          ENDIF
C
          IF (iINDUVCS.GT.0) THEN
            do ilon=1,LOLAM3
              zf3(ilon,1)=TJM3(ilon,1,iniv,iINDUVCS)
            enddo
            call faienc(irep,IFSOR3,cdpref,0,'UVI.CLEARSKY',zf3,
     $                      .false.)
          ENDIF
C
          IF (iUVB.GT.0) THEN
            do ilon=1,LOLAM3
              zf3(ilon,1)=TJM3(ilon,1,iniv,iUVB)
            enddo
            call faienc(irep,IFSOR3,cdpref,0,'UV.B',zf3,
     $                      .false.)
          ENDIF
C
          IF (iUVA.GT.0) THEN
            do ilon=1,LOLAM3
              zf3(ilon,1)=TJM3(ilon,1,iniv,iUVA)
            enddo
            call faienc(irep,IFSOR3,cdpref,0,'UV.A',zf3,
     $                      .false.)
          ENDIF
C
        enddo
C     
        do itra=1,NTRA3
          do iniv=1,NIVM3
            if (iniv.LE.9) then
              write(cdpref,fmt='(''L00'',I1)')iniv
            else
              write(cdpref,fmt='(''L0'',I2)')iniv
            endif
C            
            do ilon=1,LOLAM3
              zf3(ilon,1)=MAX(QQQM3(ilon,1,iniv,itra),1.e-30)
            enddo
            call faienc(irep,IFSOR3,cdpref,0,TRANAM3(itra),zf3,
     $                 .false.)            
C
          enddo
        enddo
C
        do itra=1,NSLS3
          do iniv=1,NIVM3
            if (iniv.LE.9) then
              write(cdpref,fmt='(''L00'',I1)')iniv
            else
              write(cdpref,fmt='(''L0'',I2)')iniv
            endif
C
            do ilon=1,LOLAM3
              zf3(ilon,1)=MAX(HHHM3(ilon,1,iniv,itra),1.e-30)
            enddo
            call faienc(irep,IFSOR3,cdpref,0,SLSNAM3(itra),zf3,
     $                 .false.)
C
          enddo
        enddo
C
        call fairme(irep,IFSOR3,'UNKNIW')
C
      endif
C
C 5. ZOOM GRID (M4)
C
      if (IFLAG4.and.mod(3,NPROCS).eq.MYID) THEN
C
        write(clo4,fmt='(''HM'',A6,''+'',I4.4,I2.2,I2.2,I2.2)')
     +      NAMDOM4,idate1(1),idate1(2),idate1(3),idate1(4)
C
        write(clf4,fmt='(''FM'',A6,''+'',I4.4,I2.2,I2.2,I2.2)')
     +      NAMDOM4,idate0(1),idate0(2),idate0(3),idate0(4)
C
        call faitou(irep,IFORC4,.true.,clf4,'OLD',.true.,
     +             .false.,0,0,ibari,'CADRE.STANDARD')
C
        call facies('CADRE.STANDARD',ityptr,zbeta,zclopo,zslopo,
     +            zcodil,itrunc,idgl,idlon,inlopa,
     +            inzopa,zgeom,iflev,zvp00,zvah,
     +            zvbh,llgard)
C
C CLOSE OLD FILE
C
        call fairme(irep,IFORC4,'OLD')
C
C SET NEW FILE FRAME
C
        call facade(CHEMSCHEME,ityptr,zbeta,zclopo,zslopo,
     +            zcodil,itrunc,idgl,idlon,inlopa,
     +            inzopa,zgeom,NIVM4,zvp00,ALM4FA,
     +            BLM4,llgard)
C
C OPEN NEW FILE
C
        call faitou(irep,IFSOR4,.true.,clo4,'NEW',.true.,
     +             .false.,0,0,ibari,CHEMSCHEME)
        PRINT *, '>> Writing history file ',TRIM(clo4)
        PRINT *, '   On processor ',MYID
C
C SET NEW FILE DATE
C
        idate(1) = idate1(1)
        idate(2) = idate1(2)
        idate(3) = idate1(3)
        idate(4) = idate1(4)
        idate(5) = idate1(5)
        do i=6,11
          idate(i) = 0
        enddo
        call fandar(irep,IFSOR4,idate)
C
C WRITE DATA
C
        do iniv=1,NIVM4
          if (iniv.LE.9) then
            write(cdpref,fmt='(''L00'',I1)')iniv
          else
            write(cdpref,fmt='(''L0'',I2)')iniv
          endif
C
          do ilon=1,LOLAM4
            zf4(ilon,1)=TGRIM4(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR4,cdpref,0,'TEMPERATURE',zf4,
     $                    .false.)
C
          do ilon=1,LOLAM4
            zf4(ilon,1)=UGRIM4(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR4,cdpref,0,'VENT_ZONAL',zf4,
     $                    .false.)
C
          do ilon=1,LOLAM4
            zf4(ilon,1)=VGRIM4(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR4,cdpref,0,'VENT_MERIDIE',zf4,
     $                    .false.)
C
          do ilon=1,LOLAM4
            zf4(ilon,1)=WGRIM4(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR4,cdpref,0,'VITESSE_VERT',zf4,
     $                    .false.)
C
          do ilon=1,LOLAM4
            zf4(ilon,1)=QGRIM4(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR4,cdpref,0,'HUMI.SPECIFI',zf4,
     $                    .false.)
C
          do ilon=1,LOLAM4
            zf4(ilon,1)=PVGRIM4(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR4,cdpref,0,'POT_VORTICIT',zf4,
     $                    .false.)
C
          do ilon=1,LOLAM4
            zf4(ilon,1)=XPAM4(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR4,cdpref,0,'PRESSION_PA',zf4,
     $                    .false.)
C
          do ilon=1,LOLAM4
            zf4(ilon,1)=FCC4(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR4,cdpref,0,'CLOUDINESS',zf4,
     $                    .false.)
C
          do ilon=1,LOLAM4
            zf4(ilon,1)=FCCV4(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR4,cdpref,0,'CONV.CLOUD',zf4,
     $                    .false.)
C
          do ilon=1,LOLAM4
            zf4(ilon,1)=QLIQ4(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR4,cdpref,0,'LIQUID.WATER',zf4,
     $                    .false.)
C
          do ilon=1,LOLAM4
            zf4(ilon,1)=QICE4(ilon,1,iniv)
          enddo
          call faienc(irep,IFSOR4,cdpref,0,'SOLID.WATER',zf4,
     $                    .false.)
C
          do ilon=1,LOLAM4
            zf4(ilon,1)=TJM4(ilon,1,iniv,1)
          enddo
          call faienc(irep,IFSOR4,cdpref,0,'JNO2',zf4,
     $                    .false.)
C
          do ilon=1,LOLAM4
            zf4(ilon,1)=TJM4(ilon,1,iniv,2)
          enddo
          call faienc(irep,IFSOR4,cdpref,0,'JO1D',zf4,
     $                    .false.)
C
          IF (iINDUV.GT.0) THEN
            do ilon=1,LOLAM4
              zf4(ilon,1)=TJM4(ilon,1,iniv,iINDUV)
            enddo
            call faienc(irep,IFSOR4,cdpref,0,'UV.INDEX',zf4,
     $                      .false.)
          ENDIF
C
          IF (iINDUVCS.GT.0) THEN
            do ilon=1,LOLAM4
              zf4(ilon,1)=TJM4(ilon,1,iniv,iINDUVCS)
            enddo
            call faienc(irep,IFSOR4,cdpref,0,'UVI.CLEARSKY',zf4,
     $                      .false.)
          ENDIF
C
          IF (iUVB.GT.0) THEN
            do ilon=1,LOLAM4
              zf4(ilon,1)=TJM4(ilon,1,iniv,iUVB)
            enddo
            call faienc(irep,IFSOR4,cdpref,0,'UV.B',zf4,
     $                      .false.)
          ENDIF
C
          IF (iUVA.GT.0) THEN
            do ilon=1,LOLAM4
              zf4(ilon,1)=TJM4(ilon,1,iniv,iUVA)
            enddo
            call faienc(irep,IFSOR4,cdpref,0,'UV.A',zf4,
     $                      .false.)
          ENDIF
C
        enddo
C
        do itra=1,NTRA4
          do iniv=1,NIVM4
            if (iniv.LE.9) then
              write(cdpref,fmt='(''L00'',I1)')iniv
            else
              write(cdpref,fmt='(''L0'',I2)')iniv
            endif
C
            do ilon=1,LOLAM4
              zf4(ilon,1)=MAX(QQQM4(ilon,1,iniv,itra),1.e-30)
            enddo
            call faienc(irep,IFSOR4,cdpref,0,TRANAM4(itra),zf4,
     $                 .false.)
C
          enddo
        enddo
C
        do itra=1,NSLS4
          do iniv=1,NIVM4
            if (iniv.LE.9) then
              write(cdpref,fmt='(''L00'',I1)')iniv
            else
              write(cdpref,fmt='(''L0'',I2)')iniv
            endif
C
            do ilon=1,LOLAM4
              zf4(ilon,1)=MAX(HHHM4(ilon,1,iniv,itra),1.e-30)
            enddo
            call faienc(irep,IFSOR4,cdpref,0,SLSNAM4(itra),zf4,
     $                 .false.)
C
          enddo
        enddo
C
        call fairme(irep,IFSOR4,'UNKNIW')
C
      endif

C
C WRITE FORECAST PROGRESS LOOK-UP FILE
C
      PRINT*,">> HM OUTPUT FOR : ",NBDAY*24+NBHOUR
#ifdef MPI
      IF (MYID.EQ.MASTER) THEN
#endif
      OPEN(777,FILE="ECHHM",FORM="FORMATTED")
      WRITE(777,778) NBDAY*24+NBHOUR
      CLOSE(777)
#ifdef MPI
      endif
#endif
  778 FORMAT(I2.2)
C      
C
	DEALLOCATE (idate)
	DEALLOCATE (idate1)
	DEALLOCATE (nbjour)
	DEALLOCATE (zf1)
	DEALLOCATE (zf2)
	DEALLOCATE (zf3)
	DEALLOCATE (zf4)
	DEALLOCATE (zvah)
	DEALLOCATE (zvbh)
	DEALLOCATE (zvamh)
	DEALLOCATE (zvbmh)
	DEALLOCATE (zgeom)
	DEALLOCATE (inlopa)
	DEALLOCATE (inzopa)
        DEALLOCATE (ALM1FA)
        DEALLOCATE (ALM2FA)
        DEALLOCATE (ALM3FA)
        DEALLOCATE (ALM4FA)
C	
C
      RETURN
      END
