      subroutine outnetcdf( daynum, idate0 ,idate00, id_iter)
C
CCCCC
C
C
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 09/06/2005
C
C   Type      : Service
C   Purpose   : Write NetCDF output files
C   Called by : 
C
CCC
C
C  Original : A. Piacentini, 04/2005
C
C  Modified :
C
CCCCC
C
	USE PARADI_MOD
	USE EXPE_MOD
	USE GRIDS_MOD
	USE MOCF_MOD
	USE MRAT_MOD
	USE FORMT_MOD
	USE PHOTO_MOD
	USE OUTNETCDF_MOD
	USE SVPHOT_MOD
        USE CSTES_MOD
C
	IMPLICIT NONE
C
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~

	INTEGER, intent(in) :: id_iter
	REAL (KIND=8) :: daynum
	INTEGER , DIMENSION(5) :: idate0,idate00
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C		
C
#ifdef MIDATM
#define CPP_ESP 'O_3'
#else
#define CPP_ESP 'O_x'
#endif
C
      INCLUDE 'netcdf.inc'
C
      INTEGER :: IL_FD,IL_NBNIV,IL_NC_AHYB,IL_NC_BHYB
      INTEGER :: IL_NC_TEMP,IL_NC_XWIND,IL_NC_YWIND,IL_NC_WWIND
      INTEGER :: NBDAY,NBHOUR
      INTEGER :: ityptr,itrunc,idgl,idlon,iflev
      INTEGER :: ib_i, ib_j, ib_k, ib, ib_dom
      INTEGER :: il_dom, il_lat, il_lon
      LOGICAL :: llgard
      CHARACTER(len=4) :: cdpref
      CHARACTER(len=26) :: cln1
      CHARACTER(len=6) :: cl_name
      INTEGER , ALLOCATABLE :: IDATE(:),idate1(:),nbjour(:)
C
C  NETCDF DECLARATION
C    
      INTEGER :: il_ncfile, il_dlon, il_dlat, il_dniv, il_diter
      INTEGER :: il_flon, il_flat, il_fniv, il_fiter
      INTEGER :: il_done, il_fone, il_fdob
      INTEGER :: ila_ncdim(1)
      INTEGER :: ila_ncdims(4), ila_ncstart(4), ila_nccount(4)
      INTEGER :: il_nc_psol
      INTEGER, DIMENSION(:), ALLOCATABLE :: ila_nc_field
      INTEGER, DIMENSION(:), ALLOCATABLE :: ila_nc_ctot
      INTEGER, DIMENSION(:), ALLOCATABLE :: ila_field_pos
      INTEGER, DIMENSION(:), ALLOCATABLE :: ila_field_kd
      INTEGER :: il_outsp
      INTEGER :: il_err
      REAL (KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: rla_coltot
      REAL (KIND=4), DIMENSION(:,:), ALLOCATABLE ::rla_coltot2d
      REAL (KIND=4), DIMENSION(:), ALLOCATABLE :: rla_dim_lo
      REAL (KIND=4), DIMENSION(:), ALLOCATABLE :: rla_dim_la
      REAL (KIND=4), DIMENSION(nivm1) :: rla_dim_ni
      REAL (KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: rla_field
      REAL (KIND=4), DIMENSION(:,:), ALLOCATABLE :: rla_psolml
      REAL (KIND=4), DIMENSION(0:nivm1) :: rla_alm1,rla_blm1
      REAL (KIND=4) :: rl_daynum
      CHARACTER(LEN=26), DIMENSION(:), ALLOCATABLE :: cla_fieldname
      CHARACTER(LEN=48) :: cl_fld_stdname
      CHARACTER(LEN=26) :: cl_fieldunit
      CHARACTER(LEN=48) :: cldat, cltori, cl_source
C
      REAL (KIND=8) , POINTER :: rla_PSOLM (:,:)
      REAL (KIND=8) , POINTER :: rla_XPAM (:,:,:)
      REAL (KIND=8) , POINTER :: rla_XPHFM(:,:,:)
      REAL (KIND=8) , POINTER :: rla_TGRIM(:,:,:)
      REAL (KIND=8) , POINTER :: rla_UGRIM(:,:,:)
      REAL (KIND=8) , POINTER :: rla_VGRIM(:,:,:)
      REAL (KIND=8) , POINTER :: rla_WGRIM(:,:,:)
      REAL (KIND=8) , POINTER :: rla_QQQM (:,:,:,:)
      REAL (KIND=8) , POINTER :: rla_HHHM (:,:,:,:)
      
C
	ALLOCATE (idate(5)) ; idate(:) = 0
	ALLOCATE (idate1(5)) ; idate1(:) = 0
	ALLOCATE (NBJOUR(12))
C
	nbjour =(/31,28,31,30,31,30,31,31,30,31,30,31/)

C
C 1. CHOOSE TIME UNIT ACCORDING TO INITIAL FILE(S)
C
      if (knshort .le. 0) THEN
          knshort = 1
          species(1) = CPP_ESP
      end if
C
      ALLOCATE (ila_field_pos(knshort)) ; ila_field_pos(:) = 0
      ALLOCATE (ila_field_kd(knshort)) ; ila_field_kd(:) = 0
      ALLOCATE (cla_fieldname(knshort))
      cla_fieldname(:) = "123456789 123456789 123456"
C
      il_outsp = 0
      DO ib = 1,knshort
        il_fd = 0
        DO ib_i = 1, ntra1
          IF (species(ib) .eq. TRANAM1(ib_i)) THEN
              il_outsp = il_outsp+1
              ila_field_kd(il_outsp) = 1
              ila_field_pos(il_outsp) = ib_i
              cla_fieldname(il_outsp) = species(ib)
              il_fd = 1
              go to 181
          END IF
        END DO
        DO ib_i = 1, nsls1
          IF (species(ib) .eq. SLSNAM1(ib_i)) THEN
              il_outsp = il_outsp+1
              ila_field_kd(il_outsp) = 2
              ila_field_pos(il_outsp) = ib_i
              cla_fieldname(il_outsp) = species(ib)
              il_fd = 1
              go to 181
          END IF
        END DO
 181    CONTINUE
        IF (il_fd .eq. 0) THEN
            WRITE(6,*) 'Component ',trim(species(ib)),
     $          ' not existent in this scheme'
        END IF
      END DO
C
      write(cldat,fmt=
     $    '(''seconds since '',
     $    I4.4,"-",I2.2,"-",I2.2," ",I2.2,":",I2.2,":00")')
     $      idate00(1),idate00(2),idate00(3),idate00(4),idate00(5)
      write(cltori,fmt=
     $    '(I4.4,"-",I2.2,"-",I2.2," ",I2.2,":",I2.2,":00")')
     $      idate00(1),idate00(2),idate00(3),idate00(4),idate00(5)
C
C 1.1 DETERMINE OUTPUT DATE
C
      NBDAY=int(daynum/86400.)
      NBHOUR=int((daynum-real(NBDAY)*86400.)/3600.)
C
      IF (.NOT.TRANSINV) THEN
        idate1(5)=0
        idate1(4)=idate0(4)+NBHOUR
        idate1(3)=idate0(3)+NBDAY
        idate1(2)=idate0(2)
        idate1(1)=idate0(1)
        IF (idate1(4).GE.24) THEN
          idate1(4)=idate1(4)-24
          idate1(3)=idate1(3)+1
        ENDIF
        IF (mod(idate0(1),4).EQ.0) THEN
          nbjour(2)=29
        ENDIF
        IF (idate1(3).GT.nbjour(idate1(2))) THEN
          idate1(3)=idate1(3)-nbjour(idate1(2))
          idate1(2)=idate1(2)+1
        ENDIF
        IF (idate1(2).GT.12) THEN
          idate1(1)=idate1(1)+1
          idate1(2)=1
        ENDIF
        IF (id_iter.gt.0 .and. idate1(4).eq.0
     $      .and. int(daynum).gt.0) THEN
            idate1(3)=idate1(3)-1
            idate1(4)=24
            IF (idate1(3).eq.0) THEN
                idate1(2) = idate1(2)-1
                IF (idate1(2) .eq. 0) THEN
                    idate1(2) = 12
                    idate1(1) = idate1(1)-1
                ENDIF
                idate1(3)=nbjour(idate1(2))
            ENDIF
        ENDIF
      ELSE
        idate1(5)=0
        idate1(4)=idate0(4)-NBHOUR
        idate1(3)=idate0(3)-NBDAY
        idate1(2)=idate0(2)
        idate1(1)=idate0(1)
        IF (idate1(4).LT.0) THEN
          idate1(4)=idate1(4)+24
          idate1(3)=idate1(3)-1
        ENDIF
        IF (idate1(4).GE.24) THEN
          idate1(4)=idate1(4)-24
          idate1(3)=idate1(3)+1
        ENDIF
        IF (mod(idate0(1),4).EQ.0) THEN
          nbjour(2)=29
        ENDIF
        IF (idate1(3).GT.nbjour(idate1(2))) THEN
          idate1(3)=idate1(3)-nbjour(idate1(2))
          idate1(2)=idate1(2)+1
        ENDIF
        IF (idate1(3).LE.0) THEN
          idate1(2)=idate1(2)-1
        ENDIF
        IF (idate1(2).LE.0) THEN
          idate1(1)=idate1(1)-1
          idate1(2)=12
        ENDIF
        IF (idate1(2).GT.12) THEN
          idate1(1)=idate1(1)+1
          idate1(2)=1
        ENDIF
        IF (idate1(3).LE.0) THEN
          idate1(3)=idate1(3)+nbjour(idate1(2))
        ENDIF
      ENDIF

C
C SPAN THE DOMAINS
C
      il_dom = 1
      IF (iflag2) il_dom = 2
      IF (iflag3) il_dom = 3
      IF (iflag4) il_dom = 4

C
      DO ib_dom = 1, il_dom
        IF ((NPROCS-MOD((ib_dom-1),NPROCS)-1).eq.MYID) THEN
C
      IF (ib_dom .eq. 1) THEN
C
          il_lon = lonm1
          ALLOCATE (rla_dim_lo(lonm1))
          DO ib_i = 1, lonm1
            rla_dim_lo(ib_i) = REAL(rlonm1(ib_i)*180./3.141592653589793)
          END DO
C
          il_lat = latm1
          ALLOCATE (rla_dim_la(latm1))
          DO ib_j = 1, latm1
            rla_dim_la(ib_j) = REAL(rlatm1(ib_j)*180./3.141592653589793)
          END DO
C
          cl_name = NAMDOM1
C
          rla_PSOLM => PSOLM1
          rla_XPAM  => XPAM1 
          rla_XPHFM => XPHFM1
          rla_TGRIM => TGRIM1
          rla_UGRIM => UGRIM1
          rla_VGRIM => VGRIM1
          rla_WGRIM => WGRIM1
          rla_QQQM  => QQQM1
          rla_HHHM  => HHHM1 
C
      ENDIF

      IF (ib_dom .eq. 2) THEN
C
          il_lon = lonm2
          ALLOCATE (rla_dim_lo(lonm2))
          DO ib_i = 1, lonm2
            rla_dim_lo(ib_i) = REAL(rlonm2(ib_i)*180./3.141592653589793)
          END DO
C
          il_lat = latm2
          ALLOCATE (rla_dim_la(latm2))
          DO ib_j = 1, latm2
            rla_dim_la(ib_j) = REAL(rlatm2(ib_j)*180./3.141592653589793)
          END DO
C
          cl_name = NAMDOM2
C
          rla_PSOLM => PSOLM2
          rla_XPAM  => XPAM2
          rla_XPHFM => XPHFM2
          rla_TGRIM => TGRIM2
          rla_UGRIM => UGRIM2
          rla_VGRIM => VGRIM2
          rla_WGRIM => WGRIM2
          rla_QQQM  => QQQM2 
          rla_HHHM  => HHHM2 
C
      ENDIF

      IF (ib_dom .eq. 3) THEN
C
          il_lon = lonm3
          ALLOCATE (rla_dim_lo(lonm3))
          DO ib_i = 1, lonm3
            rla_dim_lo(ib_i) = REAL(rlonm3(ib_i)*180./3.141592653589793)
          END DO
C
          il_lat = latm3
          ALLOCATE (rla_dim_la(latm3))
          DO ib_j = 1, latm3
            rla_dim_la(ib_j) = REAL(rlatm3(ib_j)*180./3.141592653589793)
          END DO
C
          cl_name = NAMDOM3
C
          rla_PSOLM => PSOLM3
          rla_XPAM  => XPAM3 
          rla_XPHFM => XPHFM3
          rla_TGRIM => TGRIM3
          rla_UGRIM => UGRIM3
          rla_VGRIM => VGRIM3
          rla_WGRIM => WGRIM3
          rla_QQQM  => QQQM3
          rla_HHHM  => HHHM3 
C
      ENDIF

      IF (ib_dom .eq. 4) THEN
C
          il_lon = lonm4
          ALLOCATE (rla_dim_lo(lonm4))
          DO ib_i = 1, lonm4
            rla_dim_lo(ib_i) = REAL(rlonm4(ib_i)*180./3.141592653589793)
          END DO
C
          il_lat = latm4
          ALLOCATE (rla_dim_la(latm4))
          DO ib_j = 1, latm4
            rla_dim_la(ib_j) = REAL(rlatm4(ib_j)*180./3.141592653589793)
          END DO
C
          cl_name = NAMDOM4
C
          rla_PSOLM => PSOLM4
          rla_XPAM  => XPAM4 
          rla_XPHFM => XPHFM4
          rla_TGRIM => TGRIM4
          rla_UGRIM => UGRIM4
          rla_VGRIM => VGRIM4
          rla_WGRIM => WGRIM4
          rla_QQQM  => QQQM4
          rla_HHHM  => HHHM4 
C
      ENDIF
C
      ALLOCATE (rla_field(il_lon,il_lat,nivm1)) ; rla_field(:,:,:) = 0.0
      ALLOCATE (rla_psolml(il_lon,il_lat)) ; rla_psolml(:,:) = 0.0
C
      DO ib_k = 1,KNLEVELS
        rla_dim_ni(ib_k) = REAL(iga_level(ib_k))
      END DO
C
CCC WRITE HISTORY IN NETCDF FILE
C
      IF (id_iter .ge. 0) THEN
       WRITE(cln1,
     + fmt='(''HM'',A6,''+'',I4.4,I2.2,I2.2,I2.2,''+I'',I2.2,''.nc'')')
     + cl_name,idate1(1),idate1(2),idate1(3),idate1(4),id_iter
      ELSE
       WRITE(cln1,
     + fmt='(''HM'',A6,''+'',I4.4,I2.2,I2.2,I2.2,''.nc'')')
     + cl_name,idate1(1),idate1(2),idate1(3),idate1(4)
      END IF
C
C** OPEN NETCDF FILE
C
      il_err = NF_CREATE(cln1, NF_CLOBBER, il_ncfile)
      PRINT *, '>> Writing NetCDF output file ',TRIM(cln1)
      PRINT *, '   On processor ',MYID
C
C** DEFINE DIMENSIONS
C
      il_nbniv = KNLEVELS
      il_err = NF_DEF_DIM(il_ncfile, 'time', NF_UNLIMITED, il_diter)
      il_err = NF_DEF_DIM(il_ncfile, 'lev', il_nbniv, il_dniv)
      il_err = NF_DEF_DIM(il_ncfile, 'lat', il_lat, il_dlat)
      il_err = NF_DEF_DIM(il_ncfile, 'lon', il_lon, il_dlon)
      IF (KTOTC .ne. 0) THEN
          il_err = NF_DEF_DIM(il_ncfile, 'one', 1, il_done)
      END IF
C
C** DEFINE DIMENSION VARIABLES
C
      ila_ncdim(1) = il_diter
      il_err = NF_DEF_VAR(il_ncfile, 'time', NF_REAL, 1, ila_ncdim,
     $    il_fiter)
C
      ila_ncdim(1) = il_dniv
      il_err = NF_DEF_VAR(il_ncfile, 'lev', NF_REAL, 1, ila_ncdim,
     $    il_fniv)
C
      ila_ncdim(1) = il_dlat
      il_err = NF_DEF_VAR(il_ncfile, 'lat', NF_REAL, 1, ila_ncdim,
     $    il_flat)
C
      ila_ncdim(1) = il_dlon
      il_err = NF_DEF_VAR(il_ncfile, 'lon', NF_REAL, 1, ila_ncdim,
     $    il_flon)
C
      IF (KTOTC .ne. 0) THEN
          ila_ncdim(1) = il_done
          il_err = NF_DEF_VAR(il_ncfile, 'one', NF_REAL, 1, 
     $        ila_ncdim, il_fone)
          il_err = NF_DEF_VAR(il_ncfile, 'Dobson', NF_REAL, 1, 
     $         ila_ncdim, il_fdob) 
          il_err = NF_PUT_ATT_TEXT(il_ncfile, il_fdob,
     $        'long_name', 49,
     $        'Dobson constant for total column units conversion')
      END IF
C
C**  DEFINE ATTRIBUTES
C
      il_ERR = NF_PUT_ATT_TEXT(il_ncfile, NF_GLOBAL, 'Conventions',
     $    6, 'CF-1.0')
      cl_source='MOCAGE with chemical scheme '//trim(CHEMSCHEME) 
      il_ERR = NF_PUT_ATT_TEXT(il_ncfile, NF_GLOBAL, 'source',
     $   len_trim(cl_source), trim(cl_source))
      il_ERR = NF_PUT_ATT_TEXT(il_ncfile, NF_GLOBAL, 'domain',
     $   len_trim(cl_name),cl_name)
      il_ERR = NF_PUT_ATT_INT(il_ncfile, NF_GLOBAL, 'levels',
     $   NF_INT,1,nivm1)
      il_ERR = NF_PUT_ATT_TEXT(il_ncfile, NF_GLOBAL, 'institution',
     $   16, 'CNRM and CERFACS')
      il_err = NF_PUT_ATT_TEXT(il_ncfile, il_flon,  'standard_name',
     $    9, 'longitude')
      il_err = NF_PUT_ATT_TEXT(il_ncfile, il_flat,  'standard_name',
     $    8, 'latitude')
      il_err = NF_PUT_ATT_TEXT(il_ncfile, il_fniv,  'standard_name',
     $    43, 'atmosphere_hybrid_sigma_pressure_coordinate')
      il_err = NF_PUT_ATT_TEXT(il_ncfile, il_fniv,  'positive',
     $    4, 'down')
      il_err = NF_PUT_ATT_TEXT(il_ncfile, il_fniv,  'formula_terms'
     $   , 60,
     $   'ap: a_hybr_coord b: b_hybr_coord ps: air_pressure_at_surface')

      il_err = NF_PUT_ATT_TEXT(il_ncfile, il_fiter, 'standard_name', 9,
     $    'Time axis')
C
      il_err = NF_PUT_ATT_TEXT(il_ncfile, il_flon, 'units', 12,
     $    'degrees_east')
      il_err = NF_PUT_ATT_TEXT(il_ncfile, il_flat, 'units',13,
     $    'degrees_north')
      il_err = NF_PUT_ATT_TEXT(il_ncfile, il_fniv, 'units', 3, 'lev')
      il_err = NF_PUT_ATT_TEXT(il_ncfile, il_fiter,'axis',  1, 't')
      il_err = NF_PUT_ATT_TEXT(il_ncfile, il_fiter,'units',
     $    LEN_TRIM(cldat), cldat)
      il_err = NF_PUT_ATT_TEXT(il_ncfile, il_fiter,'time_origin',
     $    LEN_TRIM(cltori), cltori)
      il_err = NF_PUT_ATT_TEXT(il_ncfile, il_fiter,'calendar', 6,
     $    'noleap')
C
C
C** DEFINE PRESSURE COORDINATE VARIABLES AND ATTRIBUTES
C
C   SURFACE PRESSURE (2D)
C
      ila_ncdims(1) = il_dlon
      ila_ncdims(2) = il_dlat
      ila_ncdims(3) = il_diter
C
      il_err = NF_DEF_VAR(il_ncfile, 'air_pressure_at_surface', 
     $    NF_REAL,3, ila_ncdims, il_nc_psol)
      il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_psol, 'standard_name',
     $    23, 'air_pressure_at_surface')
      il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_psol, 'units',
     $    2, 'Pa')
C
C  HYBRID COORDINATE COEFFICIENTS (2*1D)
C
      ila_ncdims(1) = il_dniv
C
      il_err = NF_DEF_VAR(il_ncfile, 'a_hybr_coord', 
     $    NF_REAL,1, ila_ncdims, il_nc_ahyb)
      il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_ahyb, 'long_name',
     $    34, 'a coefficient of hybrid coordinate')
C
      il_err = NF_DEF_VAR(il_ncfile, 'b_hybr_coord', 
     $    NF_REAL,1, ila_ncdims, il_nc_bhyb)
      il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_bhyb, 'long_name',
     $    34, 'b coefficient of hybrid coordinate')
C
C** TEMPERATURE (3D)
C
      ila_ncdims(1) = il_dlon
      ila_ncdims(2) = il_dlat
      ila_ncdims(3) = il_dniv
      ila_ncdims(4) = il_diter

      il_err = NF_DEF_VAR(il_ncfile, 'air_temperature', NF_REAL,4,
     $    ila_ncdims, il_nc_temp)
      il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_temp, 'units',
     $    1, 'K')

C
C** WIND (3*3D)
C
      il_err = NF_DEF_VAR(il_ncfile, 'x_wind', NF_REAL,4,
     $    ila_ncdims, il_nc_xwind)
      il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_xwind, 'units',
     $    5, 'm s-1')

      il_err = NF_DEF_VAR(il_ncfile, 'y_wind', NF_REAL,4,
     $    ila_ncdims, il_nc_ywind)
      il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_ywind, 'units',
     $    5, 'm s-1')

      il_err = NF_DEF_VAR(il_ncfile, 'w_wind', NF_REAL,4,
     $    ila_ncdims, il_nc_wwind)
      il_err = NF_PUT_ATT_TEXT(il_ncfile, il_nc_ywind, 'units',
     $    5, 'm s-1')


C
C** DEFINE FIELD VARIABLES AND ATTRIBUTES
C
      ALLOCATE (ila_nc_field(il_outsp)) ; ila_nc_field(:) = 0
      IF (KTOTC .ne. 0) THEN
          ALLOCATE (ila_nc_ctot(il_outsp)) ; ila_nc_field(:) = 0
          ALLOCATE (rla_coltot(il_lon,il_lat,nivm1))
                    rla_coltot(:,:,:) = 0.0
          ALLOCATE (rla_coltot2d(il_lon,il_lat)) ; rla_coltot2d(:,:) = 0.0
      ENDIF
C
      do ib = 1, il_outsp
        ila_ncdims(1) = il_dlon
        ila_ncdims(2) = il_dlat
        ila_ncdims(3) = il_dniv
        ila_ncdims(4) = il_diter
C
        il_err = NF_DEF_VAR(il_ncfile, cla_fieldname(ib), NF_REAL,4,
     $      ila_ncdims, ila_nc_field(ib))
C
        cl_fld_stdname="mole_fraction_of_"//cla_fieldname(ib)
        il_err = NF_PUT_ATT_TEXT(il_ncfile, ila_nc_field(ib), 
     $      'standard_name' ,LEN_TRIM(cl_fld_stdname),
     $      TRIM(cl_fld_stdname))
C
        cl_fieldunit = 'ppv'
        il_err = NF_PUT_ATT_TEXT(il_ncfile, ila_nc_field(ib), 'units',
     $      LEN_TRIM(cl_fieldunit), cl_fieldunit)
C
        IF (KTOTC .ne. 0) THEN
            ila_ncdims(1) = il_dlon
            ila_ncdims(2) = il_dlat
            ila_ncdims(3) = il_diter
            cl_fld_stdname=TRIM(cla_fieldname(ib))//"_tc"
            il_err = NF_DEF_VAR(il_ncfile, TRIM(cl_fld_stdname),
     $          NF_REAL,3,ila_ncdims, ila_nc_ctot(ib))
            cl_fld_stdname="Total column of "//cla_fieldname(ib)
            il_err = NF_PUT_ATT_TEXT(il_ncfile, ila_nc_ctot(ib),
     $          'long_name', LEN_TRIM(cl_fld_stdname),
     $          TRIM(cl_fld_stdname))
            cl_fieldunit = 'molec m-2' 
            il_err = NF_PUT_ATT_TEXT(il_ncfile, ila_nc_ctot(ib),
     $          'units', LEN_TRIM(cl_fieldunit), cl_fieldunit)
        END IF
C
      END DO

C
C** END OF DEFINE MODE
C
      il_err= NF_ENDDEF(il_ncfile)
C
C** WRITE DATA TO FILE
C
      il_err = NF_PUT_VAR_REAL(il_ncfile,il_flon,rla_dim_lo)
C
      il_err = NF_PUT_VAR_REAL(il_ncfile,il_flat,rla_dim_la)
C
      il_err = NF_PUT_VAR_REAL(il_ncfile,il_fniv,
     $    rla_dim_ni(1:il_nbniv))
C  
      ila_ncstart(1) = 1
      ila_nccount(1) = 1
      rl_daynum=REAL(daynum)
      il_err = NF_PUT_VARA_REAL(il_ncfile,il_fiter,ila_ncstart,
     $    ila_nccount,rl_daynum)
C
      IF (KTOTC .ne. 0) THEN
          ila_ncstart(1) = 1
          ila_nccount(1) = 1
          rl_daynum=1.
          il_err = NF_PUT_VARA_REAL(il_ncfile,il_fone,ila_ncstart,
     $        ila_nccount,rl_daynum)
          rl_daynum=2.685e20
          il_err = NF_PUT_VARA_REAL(il_ncfile,il_fdob,ila_ncstart,
     $        ila_nccount,rl_daynum)
      END IF          
C
C output of the surface pressure      
C
      ila_ncstart(1) = 1
      ila_ncstart(2) = 1
      ila_ncstart(3) = 1
      ila_nccount(1) = il_lon
      ila_nccount(2) = il_lat
      ila_nccount(3) = 1
	rla_psolml=REAL(rla_psolm)	
      il_err = NF_PUT_VARA_REAL(il_ncfile,il_nc_psol, ila_ncstart,
     $    ila_nccount,rla_psolml)
C
C output of the pressure coordinate coefficients    
C
      ila_ncstart(1) = 1
      ila_nccount(1) = il_nbniv
      DO ib_k = 1, KNLEVELS
	rla_alm1(ib_k)=REAL(alm1(iga_level(ib_k)))
        rla_blm1(ib_k)=REAL(blm1(iga_level(ib_k)))
      END DO
C
      il_err = NF_PUT_VARA_REAL(il_ncfile,il_nc_ahyb, ila_ncstart,
     $    ila_nccount,rla_alm1(1:KNLEVELS))
C
      il_err = NF_PUT_VARA_REAL(il_ncfile,il_nc_bhyb, ila_ncstart,
     $    ila_nccount,rla_blm1(1:KNLEVELS))
C
C output of the temperature   
C
      ila_ncstart(1) = 1
      ila_ncstart(2) = 1
      ila_ncstart(3) = 1
      ila_ncstart(4) = 1
      ila_nccount(1) = il_lon
      ila_nccount(2) = il_lat
      ila_nccount(3) = il_nbniv
      ila_nccount(4) = 1
C      
      DO ib_k = 1, il_nbniv
        rla_field(:,:,ib_k)=
     $      REAL(rla_TGRIM(:,:,iga_level(ib_k)))
      END DO

      il_err = NF_PUT_VARA_REAL(il_ncfile,il_nc_temp,
     $    ila_ncstart, ila_nccount,rla_field)

C
C output of the wind components    
C
C      
      DO ib_k = 1, il_nbniv
        rla_field(:,:,ib_k)=
     $      REAL(rla_UGRIM(:,:,iga_level(ib_k)))
      END DO

      il_err = NF_PUT_VARA_REAL(il_ncfile,il_nc_xwind,
     $    ila_ncstart, ila_nccount,rla_field)

      DO ib_k = 1, il_nbniv
        rla_field(:,:,ib_k)=
     $      REAL(rla_VGRIM(:,:,iga_level(ib_k)))
      END DO

      il_err = NF_PUT_VARA_REAL(il_ncfile,il_nc_ywind,
     $    ila_ncstart, ila_nccount,rla_field)

      DO ib_k = 1, il_nbniv
        rla_field(:,:,ib_k)=
     $      REAL(rla_WGRIM(:,:,iga_level(ib_k)))
      END DO

      il_err = NF_PUT_VARA_REAL(il_ncfile,il_nc_wwind,
     $    ila_ncstart, ila_nccount,rla_field)


C
C output of the species
C
      DO ib =1, il_outsp
        ila_ncstart(1) = 1
        ila_ncstart(2) = 1
        ila_ncstart(3) = 1
        ila_ncstart(4) = 1
        ila_nccount(1) = il_lon
        ila_nccount(2) = il_lat
        ila_nccount(3) = il_nbniv
        ila_nccount(4) = 1
        IF (ila_field_kd(ib) .eq. 1) THEN
            DO ib_k = 1, il_nbniv
              rla_field(:,:,ib_k)=
     $            REAL(rla_QQQM(:,:,iga_level(ib_k),
     $            ila_field_pos(ib)))
            END DO
        ELSE
            DO ib_k = 1, il_nbniv
              rla_field(:,:,ib_k)=
     $            REAL(rla_HHHM(:,:,iga_level(ib_k),
     $            ila_field_pos(ib)))
            END DO
        ENDIF

        il_err = NF_PUT_VARA_REAL(il_ncfile,ila_nc_field(ib),
     $      ila_ncstart, ila_nccount,rla_field)
        IF (KTOTC .ne. 0) THEN
            IF (ila_field_kd(ib) .eq. 1) THEN
                CALL sumvert (il_lon,il_lat,NIVM1, rla_XPAM,
     $              rla_XPHFM,rla_QQQM(:,:,:,ila_field_pos(ib)),
     $              rla_coltot)
            ELSE
                CALL sumvert (il_lon,il_lat,NIVM1, rla_XPAM,
     $              rla_XPHFM,rla_HHHM(:,:,:,ila_field_pos(ib)),
     $              rla_coltot)
            ENDIF
            rla_coltot2d=REAL(rla_coltot(:,:,NIVM1))
            ila_ncstart(1) = 1
            ila_ncstart(2) = 1
            ila_ncstart(3) = 1
            ila_nccount(1) = il_lon
            ila_nccount(2) = il_lat
            ila_nccount(3) = 1
            il_err = NF_PUT_VARA_REAL(il_ncfile,ila_nc_ctot(ib),
     $          ila_ncstart, ila_nccount,rla_coltot2d)
        END IF           
      END DO
C
C** CLOSE THE NETCDF FILE
C
      il_err = NF_CLOSE(il_ncfile)
C
      DEALLOCATE(rla_dim_lo)
      DEALLOCATE(rla_dim_la)
      DEALLOCATE(rla_field)
      DEALLOCATE(rla_psolml)
      DEALLOCATE(ila_nc_field)
      IF (KTOTC .ne. 0) THEN
          DEALLOCATE (ila_nc_ctot)
          DEALLOCATE (rla_coltot)
          DEALLOCATE (rla_coltot2d)
      ENDIF
      
      ENDIF
C
      ENDDO
C
      DEALLOCATE(ila_field_kd)
      DEALLOCATE(ila_field_pos)
      DEALLOCATE(cla_fieldname)
C
	DEALLOCATE (idate)
	DEALLOCATE (idate1)
	DEALLOCATE (nbjour)
C
C
      RETURN
      END
