      SUBROUTINE OUTSOURCE(TIME)
C
CCC
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 23/02/2006
C
C   Type       : Point source release model version
C   Purpose    : Write specific output file for point 
C                source release
C   Called by  : MAIN
C
CCC
C
C  Original : V.-H. Peuch, D. Lacroix (02/2006)
C
C  Last Modified :
C
CCC
C
      USE PARADI_MOD
      USE MOCF_MOD
      USE SRC_MOD
      USE SRCFLX_MOD
      USE MRAT_MOD
      USE CSTES_MOD
      USE FORMT_MOD

C
C INPUT
C
      REAL TIME
C
C LOCAL VARIABLES
C
      INTEGER i,j,k,isrc
      LOGICAL LDIAG
      REAL T2DOUT1(LONM1,LATM1)
      REAL T2DOUT2(LONM2,LATM2)
      REAL T2DOUT3(LONM3,LATM3)
      REAL T2DOUT4(LONM4,LATM4)
      REAL T3DOUT1(LONM1,LATM1,NIVM1)
      REAL T3DOUT2(LONM2,LATM2,NIVM2)
      REAL T3DOUT3(LONM3,LATM3,NIVM3)
      REAL T3DOUT4(LONM4,LATM4,NIVM4)
      REAL VOLMOL      
C
C FLAG FOR OUTPUT MODE
C
C LDIAG = .FALSE. : SUM-UP ALL 10 TRACERS, FLUXES
C LDIAG = .TRUE.  : DETAILED OUTPUT 
C
      LDIAG=.FALSE.
C
C 1. WRITE CURRENT DATE IN FILE
C
      IF (IFLAG1) WRITE(IFSORACC1) TIME
      IF (IFLAG2) WRITE(IFSORACC2) TIME
      IF (IFLAG3) WRITE(IFSORACC3) TIME
      IF (IFLAG4) WRITE(IFSORACC4) TIME
C
C 2. WRITE IN FILES DEPENDING UPON OUTPUT MODE
C
      IF (LDIAG) THEN
C
C VHP : NOUVEAUX OUTPUTS COMPLETS -> ADAPTER LES OUTILS AVAL
C
C DOMAIN 1 : GLOBE
C
        IF (IFLAG1) THEN
C
C a. ATMOSPHERIC MIXING RATIOS (3D)
C
           DO isrc=1,NSRC
             DO k=1,NIVM1
             DO j=1,LATM1
             DO i=1,LONM1
               T3DOUT1(i,j,k)=QQQM1(i,j,k,isrc)
             ENDDO
             ENDDO
             ENDDO
             WRITE(IFSORACC1) T3DOUT1
           ENDDO
C
C b. DRY DEPOSITION (2D)
C
           DO isrc=1,NSRC
             DO j=1,LATM1
             DO i=1,LONM1
               T2DOUT1(i,j)=DFDRYCUMUL1(i,j,isrc)
             ENDDO
             ENDDO
             WRITE(IFSORACC1) T2DOUT1
           ENDDO
C
C c. WET SCAVENGING, BELOW CV CLOUDS (2D)
C
           DO isrc=1,NSRC
             DO j=1,LATM1
             DO i=1,LONM1
               T2DOUT1(i,j)=DFBCVCUMUL1(i,j,isrc)
             ENDDO
             ENDDO
             WRITE(IFSORACC1) T2DOUT1
           ENDDO
C
C d. WET SCAVENGING, IN CV CLOUDS (2D)
C
           DO isrc=1,NSRC
             DO j=1,LATM1
             DO i=1,LONM1
               T2DOUT1(i,j)=DFICVCUMUL1(i,j,isrc)
             ENDDO
             ENDDO
             WRITE(IFSORACC1) T2DOUT1
           ENDDO
C
C e. WET SCAVENGING, STRATIFORM (2D)
C
           DO isrc=1,NSRC
             DO j=1,LATM1
             DO i=1,LONM1
               T2DOUT1(i,j)=DFSTRCUMUL1(i,j,isrc)
             ENDDO
             ENDDO
             WRITE(IFSORACC1) T2DOUT1
           ENDDO
C
C f. CONVECTIVE RAIN FLUXES (3D)
C
           WRITE(IFSORACC1) PCVRCUMUL1
C
C g. CONVECTIVE SNOW FLUXES (3D)
C
           WRITE(IFSORACC1) PCVSCUMUL1
C
C h. STRATIFORM RAIN+SNOW FLUXES (3D)
C
           WRITE(IFSORACC1) PSTRCUMUL1
C
C i. TEMPERATURE FOR LATER CONVERSIONS (3D)
C 
           WRITE(IFSORACC1) TGRIM1
C
C j. PRESSURE ON MODEL LEVELS FOR LATER CONVERSIONS (3D)
C
           WRITE(IFSORACC1) XPAM1
        ENDIF
C
C DOMAIN 2
C
        IF (IFLAG2) THEN
C
C a. ATMOSPHERIC MIXING RATIOS (3D)
C
           DO isrc=1,NSRC
             DO k=1,NIVM2
             DO j=1,LATM2
             DO i=1,LONM2
               T3DOUT2(i,j,k)=QQQM2(i,j,k,isrc)
             ENDDO
             ENDDO
             ENDDO
             WRITE(IFSORACC2) T3DOUT2
           ENDDO
C
C b. DRY DEPOSITION (2D)
C
           DO isrc=1,NSRC
             DO j=1,LATM2
             DO i=1,LONM2
               T2DOUT2(i,j)=DFDRYCUMUL2(i,j,isrc)
             ENDDO
             ENDDO
             WRITE(IFSORACC2) T2DOUT2
           ENDDO
C
C c. WET SCAVENGING, BELOW CV CLOUDS (2D)
C
           DO isrc=1,NSRC
             DO j=1,LATM2
             DO i=1,LONM2
               T2DOUT2(i,j)=DFBCVCUMUL2(i,j,isrc)
             ENDDO
             ENDDO
             WRITE(IFSORACC2) T2DOUT2
           ENDDO
C
C d. WET SCAVENGING, IN CV CLOUDS (2D)
C
           DO isrc=1,NSRC
             DO j=1,LATM2
             DO i=1,LONM2
               T2DOUT2(i,j)=DFICVCUMUL2(i,j,isrc)
             ENDDO
             ENDDO
             WRITE(IFSORACC2) T2DOUT2
           ENDDO
C
C e. WET SCAVENGING, STRATIFORM (2D)
C
           DO isrc=1,NSRC
             DO j=1,LATM2
             DO i=1,LONM2
               T2DOUT2(i,j)=DFSTRCUMUL2(i,j,isrc)
             ENDDO
             ENDDO
             WRITE(IFSORACC2) T2DOUT2
           ENDDO
C
C f. CONVECTIVE RAIN FLUXES (3D)
C
           WRITE(IFSORACC2) PCVRCUMUL2
C
C g. CONVECTIVE SNOW FLUXES (3D)
C
           WRITE(IFSORACC2) PCVSCUMUL2
C
C h. STRATIFORM RAIN+SNOW FLUXES (3D)
C
           WRITE(IFSORACC2) PSTRCUMUL2
C
C i. TEMPERATURE FOR LATER CONVERSIONS (3D)
C 
           WRITE(IFSORACC2) TGRIM2
C
C j. PRESSURE ON MODEL LEVELS FOR LATER CONVERSIONS (3D)
C
           WRITE(IFSORACC2) XPAM2
        ENDIF
C
C DOMAIN 3
C
        IF (IFLAG3) THEN
C
C a. ATMOSPHERIC MIXING RATIOS (3D)
C
           DO isrc=1,NSRC
             DO k=1,NIVM3
             DO j=1,LATM3
             DO i=1,LONM3
               T3DOUT3(i,j,k)=QQQM3(i,j,k,isrc)
             ENDDO
             ENDDO
             ENDDO
             WRITE(IFSORACC3) T3DOUT3
           ENDDO
C
C b. DRY DEPOSITION (2D)
C
           DO isrc=1,NSRC
             DO j=1,LATM3
             DO i=1,LONM3
               T2DOUT3(i,j)=DFDRYCUMUL3(i,j,isrc)
             ENDDO
             ENDDO
             WRITE(IFSORACC3) T2DOUT3
           ENDDO
C
C c. WET SCAVENGING, BELOW CV CLOUDS (2D)
C
           DO isrc=1,NSRC
             DO j=1,LATM3
             DO i=1,LONM3
               T2DOUT3(i,j)=DFBCVCUMUL3(i,j,isrc)
             ENDDO
             ENDDO
             WRITE(IFSORACC3) T2DOUT3
           ENDDO
C
C d. WET SCAVENGING, IN CV CLOUDS (2D)
C
           DO isrc=1,NSRC
             DO j=1,LATM3
             DO i=1,LONM3
               T2DOUT3(i,j)=DFICVCUMUL3(i,j,isrc)
             ENDDO
             ENDDO
             WRITE(IFSORACC3) T2DOUT3
           ENDDO
C
C e. WET SCAVENGING, STRATIFORM (2D)
C
           DO isrc=1,NSRC
             DO j=1,LATM3
             DO i=1,LONM3
               T2DOUT3(i,j)=DFSTRCUMUL3(i,j,isrc)
             ENDDO
             ENDDO
             WRITE(IFSORACC3) T2DOUT3
           ENDDO
C
C f. CONVECTIVE RAIN FLUXES (3D)
C
           WRITE(IFSORACC3) PCVRCUMUL3
C
C g. CONVECTIVE SNOW FLUXES (3D)
C
           WRITE(IFSORACC3) PCVSCUMUL3
C
C h. STRATIFORM RAIN+SNOW FLUXES (3D)
C
           WRITE(IFSORACC3) PSTRCUMUL3
C
C i. TEMPERATURE FOR LATER CONVERSIONS (3D)
C 
           WRITE(IFSORACC3) TGRIM3
C
C j. PRESSURE ON MODEL LEVELS FOR LATER CONVERSIONS (3D)
C
           WRITE(IFSORACC3) XPAM3
        ENDIF
C
C DOMAIN 4
C
        IF (IFLAG4) THEN
C
C a. ATMOSPHERIC MIXING RATIOS (3D)
C
           DO isrc=1,NSRC
             DO k=1,NIVM4
             DO j=1,LATM4
             DO i=1,LONM4
               T3DOUT4(i,j,k)=QQQM4(i,j,k,isrc)
             ENDDO
             ENDDO
             ENDDO
             WRITE(IFSORACC4) T3DOUT4
           ENDDO
C
C b. DRY DEPOSITION (2D)
C
           DO isrc=1,NSRC
             DO j=1,LATM4
             DO i=1,LONM4
               T2DOUT4(i,j)=DFDRYCUMUL4(i,j,isrc)
             ENDDO
             ENDDO
             WRITE(IFSORACC4) T2DOUT4
           ENDDO
C
C c. WET SCAVENGING, BELOW CV CLOUDS (2D)
C
           DO isrc=1,NSRC
             DO j=1,LATM4
             DO i=1,LONM4
               T2DOUT4(i,j)=DFBCVCUMUL4(i,j,isrc)
             ENDDO
             ENDDO
             WRITE(IFSORACC4) T2DOUT4
           ENDDO
C
C d. WET SCAVENGING, IN CV CLOUDS (2D)
C
           DO isrc=1,NSRC
             DO j=1,LATM4
             DO i=1,LONM4
               T2DOUT4(i,j)=DFICVCUMUL4(i,j,isrc)
             ENDDO
             ENDDO
             WRITE(IFSORACC4) T2DOUT4
           ENDDO
C
C e. WET SCAVENGING, STRATIFORM (2D)
C
           DO isrc=1,NSRC
             DO j=1,LATM4
             DO i=1,LONM4
               T2DOUT4(i,j)=DFSTRCUMUL4(i,j,isrc)
             ENDDO
             ENDDO
             WRITE(IFSORACC4) T2DOUT4
           ENDDO
C
C f. CONVECTIVE RAIN FLUXES (3D)
C
           WRITE(IFSORACC4) PCVRCUMUL4
C
C g. CONVECTIVE SNOW FLUXES (3D)
C
           WRITE(IFSORACC4) PCVSCUMUL4
C
C h. STRATIFORM RAIN+SNOW FLUXES (3D)
C
           WRITE(IFSORACC4) PSTRCUMUL4
C
C i. TEMPERATURE FOR LATER CONVERSIONS (3D)
C 
           WRITE(IFSORACC4) TGRIM4
C
C j. PRESSURE ON MODEL LEVELS FOR LATER CONVERSIONS (3D)
C
           WRITE(IFSORACC4) XPAM4
        ENDIF       
C
      ELSE
C
C VHP : ANCIENS DIAGNOSTICS
C
        IF (EMIUNIT(1).EQ.'BQPERH') THEN
C
C DOMAIN 1 : GLOBE
C
          IF (IFLAG1) THEN 
C
C ATMOSPHERIC MIXING RATIOS
C
            DO k=NIVM1,1,-1
              WRITE(IFSORACC1)
     +          ((QQQM1(i,j,k,1)+QQQM1(i,j,k,2)+QQQM1(i,j,k,3)
     +           +QQQM1(i,j,k,4)+QQQM1(i,j,k,5)+QQQM1(i,j,k,6)
     +           +QQQM1(i,j,k,7)+QQQM1(i,j,k,8)+QQQM1(i,j,k,9)
     +           +QQQM1(i,j,k,10),i=1,LONM1),j=LATM1,1,-1)
            ENDDO
C
C DRY DEPOSITION
C
            WRITE(IFSORACC1)
     +        ((DFDRYCUMUL1(i,j,1)+DFDRYCUMUL1(i,j,2)+DFDRYCUMUL1(i,j,3)
     +         +DFDRYCUMUL1(i,j,4)+DFDRYCUMUL1(i,j,5)+DFDRYCUMUL1(i,j,6)
     +         +DFDRYCUMUL1(i,j,7)+DFDRYCUMUL1(i,j,8)+DFDRYCUMUL1(i,j,9)
     +         +DFDRYCUMUL1(i,j,10),i=1,LONM1),j=LATM1,1,-1)
C
C TOTAL WET DEPOSITION
C
            WRITE(IFSORACC1)
     +        ((DFBCVCUMUL1(i,j,1)+DFBCVCUMUL1(i,j,2)+DFBCVCUMUL1(i,j,3)
     +         +DFBCVCUMUL1(i,j,4)+DFBCVCUMUL1(i,j,5)+DFBCVCUMUL1(i,j,6)
     +         +DFBCVCUMUL1(i,j,7)+DFBCVCUMUL1(i,j,8)+DFBCVCUMUL1(i,j,9)
     +         +DFBCVCUMUL1(i,j,10)
     +         +DFICVCUMUL1(i,j,1)+DFICVCUMUL1(i,j,2)+DFICVCUMUL1(i,j,3)
     +         +DFICVCUMUL1(i,j,4)+DFICVCUMUL1(i,j,5)+DFICVCUMUL1(i,j,6)
     +         +DFICVCUMUL1(i,j,7)+DFICVCUMUL1(i,j,8)+DFICVCUMUL1(i,j,9)
     +         +DFICVCUMUL1(i,j,10)
     +         +DFSTRCUMUL1(i,j,1)+DFSTRCUMUL1(i,j,2)+DFSTRCUMUL1(i,j,3)
     +         +DFSTRCUMUL1(i,j,4)+DFSTRCUMUL1(i,j,5)+DFSTRCUMUL1(i,j,6)
     +         +DFSTRCUMUL1(i,j,7)+DFSTRCUMUL1(i,j,8)+DFSTRCUMUL1(i,j,9)
     +         +DFSTRCUMUL1(i,j,10),i=1,LONM1),j=LATM1,1,-1)
C
C TOTAL PRECIPITATION FLUXES
C
              DO j=1,LATM1
                DO i=1,LONM1
                  T2DOUT1(i,j) = 0.
                  DO k=1,NIVM1
                    T2DOUT1(i,j)= T2DOUT1(i,j)+PCVRCUMUL1(i,j,k)
     +                         + PCVSCUMUL1(i,j,k)+PSTRCUMUL1(i,j,k)
                  ENDDO
                ENDDO
              ENDDO
              WRITE(IFSORACC1)
     +          ((T2DOUT1(i,j),i=1,LONM1),j=LATM1,1,-1)   
          ENDIF
C
C DOMAIN 2
C          
          IF (IFLAG2) THEN 
C
C ATMOSPHERIC MIXING RATIOS
C
            DO k=NIVM2,1,-1
              WRITE(IFSORACC2)
     +          ((QQQM2(i,j,k,1)+QQQM2(i,j,k,2)+QQQM2(i,j,k,3)
     +           +QQQM2(i,j,k,4)+QQQM2(i,j,k,5)+QQQM2(i,j,k,6)
     +           +QQQM2(i,j,k,7)+QQQM2(i,j,k,8)+QQQM2(i,j,k,9)
     +           +QQQM2(i,j,k,10),i=1,LONM2),j=LATM2,1,-1)
            ENDDO
C
C DRY DEPOSITION
C
            WRITE(IFSORACC2)
     +        ((DFDRYCUMUL2(i,j,1)+DFDRYCUMUL2(i,j,2)+DFDRYCUMUL2(i,j,3)
     +         +DFDRYCUMUL2(i,j,4)+DFDRYCUMUL2(i,j,5)+DFDRYCUMUL2(i,j,6)
     +         +DFDRYCUMUL2(i,j,7)+DFDRYCUMUL2(i,j,8)+DFDRYCUMUL2(i,j,9)
     +         +DFDRYCUMUL2(i,j,10),i=1,LONM2),j=LATM2,1,-1)
C
C TOTAL WET DEPOSITION
C
            WRITE(IFSORACC2)
     +        ((DFBCVCUMUL2(i,j,1)+DFBCVCUMUL2(i,j,2)+DFBCVCUMUL2(i,j,3)
     +         +DFBCVCUMUL2(i,j,4)+DFBCVCUMUL2(i,j,5)+DFBCVCUMUL2(i,j,6)
     +         +DFBCVCUMUL2(i,j,7)+DFBCVCUMUL2(i,j,8)+DFBCVCUMUL2(i,j,9)
     +         +DFBCVCUMUL2(i,j,10)
     +         +DFICVCUMUL2(i,j,1)+DFICVCUMUL2(i,j,2)+DFICVCUMUL2(i,j,3)
     +         +DFICVCUMUL2(i,j,4)+DFICVCUMUL2(i,j,5)+DFICVCUMUL2(i,j,6)
     +         +DFICVCUMUL2(i,j,7)+DFICVCUMUL2(i,j,8)+DFICVCUMUL2(i,j,9)
     +         +DFICVCUMUL2(i,j,10)
     +         +DFSTRCUMUL2(i,j,1)+DFSTRCUMUL2(i,j,2)+DFSTRCUMUL2(i,j,3)
     +         +DFSTRCUMUL2(i,j,4)+DFSTRCUMUL2(i,j,5)+DFSTRCUMUL2(i,j,6)
     +         +DFSTRCUMUL2(i,j,7)+DFSTRCUMUL2(i,j,8)+DFSTRCUMUL2(i,j,9)
     +         +DFSTRCUMUL2(i,j,10),i=1,LONM2),j=LATM2,1,-1)
C
C TOTAL PRECIPITATION FLUXES
C
              DO j=1,LATM2
                DO i=1,LONM2
                  T2DOUT2(i,j) = 0.
                  DO k=1,NIVM2
                    T2DOUT2(i,j)= T2DOUT2(i,j)+PCVRCUMUL2(i,j,k)
     +                         + PCVSCUMUL2(i,j,k)+PSTRCUMUL2(i,j,k)
                  ENDDO
                ENDDO
              ENDDO
              WRITE(IFSORACC2)
     +          ((T2DOUT2(i,j),i=1,LONM2),j=LATM2,1,-1)   
          ENDIF
C
C DOMAIN 3
C
          IF (IFLAG3) THEN 
C
C ATMOSPHERIC MIXING RATIOS
C
            DO k=NIVM3,1,-1
              WRITE(IFSORACC3)
     +          ((QQQM3(i,j,k,1)+QQQM3(i,j,k,2)+QQQM3(i,j,k,3)
     +           +QQQM3(i,j,k,4)+QQQM3(i,j,k,5)+QQQM3(i,j,k,6)
     +           +QQQM3(i,j,k,7)+QQQM3(i,j,k,8)+QQQM3(i,j,k,9)
     +           +QQQM3(i,j,k,10),i=1,LONM3),j=LATM3,1,-1)
            ENDDO
C
C DRY DEPOSITION
C
            WRITE(IFSORACC3)
     +        ((DFDRYCUMUL3(i,j,1)+DFDRYCUMUL3(i,j,2)+DFDRYCUMUL3(i,j,3)
     +         +DFDRYCUMUL3(i,j,4)+DFDRYCUMUL3(i,j,5)+DFDRYCUMUL3(i,j,6)
     +         +DFDRYCUMUL3(i,j,7)+DFDRYCUMUL3(i,j,8)+DFDRYCUMUL3(i,j,9)
     +         +DFDRYCUMUL3(i,j,10),i=1,LONM3),j=LATM3,1,-1)
C
C TOTAL WET DEPOSITION
C
            WRITE(IFSORACC3)
     +        ((DFBCVCUMUL3(i,j,1)+DFBCVCUMUL3(i,j,2)+DFBCVCUMUL3(i,j,3)
     +         +DFBCVCUMUL3(i,j,4)+DFBCVCUMUL3(i,j,5)+DFBCVCUMUL3(i,j,6)
     +         +DFBCVCUMUL3(i,j,7)+DFBCVCUMUL3(i,j,8)+DFBCVCUMUL3(i,j,9)
     +         +DFBCVCUMUL3(i,j,10)
     +         +DFICVCUMUL3(i,j,1)+DFICVCUMUL3(i,j,2)+DFICVCUMUL3(i,j,3)
     +         +DFICVCUMUL3(i,j,4)+DFICVCUMUL3(i,j,5)+DFICVCUMUL3(i,j,6)
     +         +DFICVCUMUL3(i,j,7)+DFICVCUMUL3(i,j,8)+DFICVCUMUL3(i,j,9)
     +         +DFICVCUMUL3(i,j,10)
     +         +DFSTRCUMUL3(i,j,1)+DFSTRCUMUL3(i,j,2)+DFSTRCUMUL3(i,j,3)
     +         +DFSTRCUMUL3(i,j,4)+DFSTRCUMUL3(i,j,5)+DFSTRCUMUL3(i,j,6)
     +         +DFSTRCUMUL3(i,j,7)+DFSTRCUMUL3(i,j,8)+DFSTRCUMUL3(i,j,9)
     +         +DFSTRCUMUL3(i,j,10),i=1,LONM3),j=LATM3,1,-1)
C
C TOTAL PRECIPITATION FLUXES
C
              DO j=1,LATM3
                DO i=1,LONM3
                  T2DOUT3(i,j) = 0.
                  DO k=1,NIVM3
                    T2DOUT3(i,j)= T2DOUT3(i,j)+PCVRCUMUL3(i,j,k)
     +                         + PCVSCUMUL3(i,j,k)+PSTRCUMUL3(i,j,k)
                  ENDDO
                ENDDO
              ENDDO
              WRITE(IFSORACC3)
     +          ((T2DOUT3(i,j),i=1,LONM3),j=LATM3,1,-1)   
          ENDIF
C
C DOMAIN 4
C
          IF (IFLAG4) THEN 
C
C ATMOSPHERIC MIXING RATIOS
C
            DO k=NIVM4,1,-1
              WRITE(IFSORACC4)
     +          ((QQQM4(i,j,k,1)+QQQM4(i,j,k,2)+QQQM4(i,j,k,3)
     +           +QQQM4(i,j,k,4)+QQQM4(i,j,k,5)+QQQM4(i,j,k,6)
     +           +QQQM4(i,j,k,7)+QQQM4(i,j,k,8)+QQQM4(i,j,k,9)
     +           +QQQM4(i,j,k,10),i=1,LONM4),j=LATM4,1,-1)
            ENDDO
C
C DRY DEPOSITION
C
            WRITE(IFSORACC4)
     +        ((DFDRYCUMUL4(i,j,1)+DFDRYCUMUL4(i,j,2)+DFDRYCUMUL4(i,j,3)
     +         +DFDRYCUMUL4(i,j,4)+DFDRYCUMUL4(i,j,5)+DFDRYCUMUL4(i,j,6)
     +         +DFDRYCUMUL4(i,j,7)+DFDRYCUMUL4(i,j,8)+DFDRYCUMUL4(i,j,9)
     +         +DFDRYCUMUL4(i,j,10),i=1,LONM4),j=LATM4,1,-1)
C
C TOTAL WET DEPOSITION
C
            WRITE(IFSORACC4)
     +        ((DFBCVCUMUL4(i,j,1)+DFBCVCUMUL4(i,j,2)+DFBCVCUMUL4(i,j,3)
     +         +DFBCVCUMUL4(i,j,4)+DFBCVCUMUL4(i,j,5)+DFBCVCUMUL4(i,j,6)
     +         +DFBCVCUMUL4(i,j,7)+DFBCVCUMUL4(i,j,8)+DFBCVCUMUL4(i,j,9)
     +         +DFBCVCUMUL4(i,j,10)
     +         +DFICVCUMUL4(i,j,1)+DFICVCUMUL4(i,j,2)+DFICVCUMUL4(i,j,3)
     +         +DFICVCUMUL4(i,j,4)+DFICVCUMUL4(i,j,5)+DFICVCUMUL4(i,j,6)
     +         +DFICVCUMUL4(i,j,7)+DFICVCUMUL4(i,j,8)+DFICVCUMUL4(i,j,9)
     +         +DFICVCUMUL4(i,j,10)
     +         +DFSTRCUMUL4(i,j,1)+DFSTRCUMUL4(i,j,2)+DFSTRCUMUL4(i,j,3)
     +         +DFSTRCUMUL4(i,j,4)+DFSTRCUMUL4(i,j,5)+DFSTRCUMUL4(i,j,6)
     +         +DFSTRCUMUL4(i,j,7)+DFSTRCUMUL4(i,j,8)+DFSTRCUMUL4(i,j,9)
     +         +DFSTRCUMUL4(i,j,10),i=1,LONM4),j=LATM4,1,-1)
C
C TOTAL PRECIPITATION FLUXES
C
              DO j=1,LATM4
                DO i=1,LONM4
                  T2DOUT4(i,j) = 0.
                  DO k=1,NIVM4
                    T2DOUT4(i,j)= T2DOUT4(i,j)+PCVRCUMUL4(i,j,k)
     +                         + PCVSCUMUL4(i,j,k)+PSTRCUMUL4(i,j,k)
                  ENDDO
                ENDDO
              ENDDO
              WRITE(IFSORACC4)
     +          ((T2DOUT4(i,j),i=1,LONM4),j=LATM4,1,-1)   
          ENDIF
C
CCCCCC          
C
        ELSEIF (EMIUNIT(1).EQ.'GRPERS') THEN
C
C VHP : DIAGNOSTICS SPECIFIQUES POUR ETEX?
C
C DOMAIN 1 : GLOBE
C
          IF (IFLAG1) THEN 
C
C SUM AND CONVERT MIXING RATIOS TO DENSITIES (kg.m-3) ; WRITE
C
            DO k=1,NIVM1
            DO j=1,LATM1
            DO i=1,LONM1
              T3DOUT1(i,j,k) = 
     +            QQQM1(i,j,k,1)+QQQM1(i,j,k,2)+QQQM1(i,j,k,3)
     +           +QQQM1(i,j,k,4)+QQQM1(i,j,k,5)+QQQM1(i,j,k,6)
     +           +QQQM1(i,j,k,7)+QQQM1(i,j,k,8)+QQQM1(i,j,k,9)
     +           +QQQM1(i,j,k,10)
              VOLMOL = 22.414
     +                *(TGRIM1(i,j,k)/TREF)*(PREF/XPAM1(i,j,k))
              T3DOUT1(i,j,k) = T3DOUT1(i,j,k)*MOLWEIGHT(1)/VOLMOL
            ENDDO
            ENDDO
            ENDDO
            DO k=NIVM1,1,-1
              WRITE(IFSORACC1)
     +          ((T3DOUT1(i,j,k),i=1,LONM1),j=LATM1,1,-1)
            ENDDO
C
C SUM AND CONVERT DRY DEPOSITION FLUXES TO DENSITIES (kg.m-3) ; WRITE
C
            DO j=1,LATM1
            DO i=1,LONM1
              T2DOUT1(i,j) = 
     +            DFDRYCUMUL1(i,j,1)+DFDRYCUMUL1(i,j,2)
     +           +DFDRYCUMUL1(i,j,3)+DFDRYCUMUL1(i,j,4)
     +           +DFDRYCUMUL1(i,j,5)+DFDRYCUMUL1(i,j,6)
     +           +DFDRYCUMUL1(i,j,7)+DFDRYCUMUL1(i,j,8)
     +           +DFDRYCUMUL1(i,j,9)+DFDRYCUMUL1(i,j,10)
C VHP : EST-CE QUE CELA A UN SENS?
              VOLMOL = 22.414
     +                *(TGRIM1(i,j,47)/TREF)*(PREF/XPAM1(i,j,47))
              T2DOUT1(i,j) = T2DOUT1(i,j)*MOLWEIGHT(1)/VOLMOL
            ENDDO
            ENDDO
            WRITE(IFSORACC1) ((T2DOUT1(i,j),i=1,LONM1),j=LATM1,1,-1)
C
C TOTAL WET DEPOSITION, SUM, CONVERT ; WRITE
C
            DO j=1,LATM1
            DO i=1,LONM1
              T2DOUT1(i,j) = 
     +            DFBCVCUMUL1(i,j,1)+DFBCVCUMUL1(i,j,2)
     +           +DFBCVCUMUL1(i,j,3)+DFBCVCUMUL1(i,j,4)
     +           +DFBCVCUMUL1(i,j,5)+DFBCVCUMUL1(i,j,6)
     +           +DFBCVCUMUL1(i,j,7)+DFBCVCUMUL1(i,j,8)
     +           +DFBCVCUMUL1(i,j,9)+DFBCVCUMUL1(i,j,10)
     +           +DFICVCUMUL1(i,j,1)+DFICVCUMUL1(i,j,2)
     +           +DFICVCUMUL1(i,j,3)+DFICVCUMUL1(i,j,4)
     +           +DFICVCUMUL1(i,j,5)+DFICVCUMUL1(i,j,6)
     +           +DFICVCUMUL1(i,j,7)+DFICVCUMUL1(i,j,8)
     +           +DFICVCUMUL1(i,j,9)+DFICVCUMUL1(i,j,10)
     +           +DFSTRCUMUL1(i,j,1)+DFSTRCUMUL1(i,j,2)
     +           +DFSTRCUMUL1(i,j,3)+DFSTRCUMUL1(i,j,4)
     +           +DFSTRCUMUL1(i,j,5)+DFSTRCUMUL1(i,j,6)
     +           +DFSTRCUMUL1(i,j,7)+DFSTRCUMUL1(i,j,8)
     +           +DFSTRCUMUL1(i,j,9)+DFSTRCUMUL1(i,j,10)
C VHP : EST-CE QUE CELA A UN SENS?
              VOLMOL = 22.414
     +                *(TGRIM1(i,j,47)/TREF)*(PREF/XPAM1(i,j,47))
              T2DOUT1(i,j) = T2DOUT1(i,j)*MOLWEIGHT(1)/VOLMOL
            ENDDO
            ENDDO
            WRITE(IFSORACC1) ((T2DOUT1(i,j),i=1,LONM1),j=LATM1,1,-1)
C
C TOTAL PRECIPITATION FLUXES
C
            DO j=1,LATM1
              DO i=1,LONM1
                T2DOUT1(i,j) = 0.
                DO k=1,NIVM1
                  T2DOUT1(i,j)= T2DOUT1(i,j)+PCVRCUMUL1(i,j,k)
     +                       + PCVSCUMUL1(i,j,k)+PSTRCUMUL1(i,j,k)
                ENDDO
              ENDDO
            ENDDO
            WRITE(IFSORACC1) ((T2DOUT1(i,j),i=1,LONM1),j=LATM1,1,-1)   
          ENDIF              
C
C DOMAIN 2
C
          IF (IFLAG2) THEN 
C
C SUM AND CONVERT MIXING RATIOS TO DENSITIES (kg.m-3) ; WRITE
C
            DO k=1,NIVM2
            DO j=1,LATM2
            DO i=1,LONM2
              T3DOUT2(i,j,k) = 
     +            QQQM2(i,j,k,1)+QQQM2(i,j,k,2)+QQQM2(i,j,k,3)
     +           +QQQM2(i,j,k,4)+QQQM2(i,j,k,5)+QQQM2(i,j,k,6)
     +           +QQQM2(i,j,k,7)+QQQM2(i,j,k,8)+QQQM2(i,j,k,9)
     +           +QQQM2(i,j,k,10)
              VOLMOL = 22.414
     +                *(TGRIM2(i,j,k)/TREF)*(PREF/XPAM2(i,j,k))
              T3DOUT2(i,j,k) = T3DOUT2(i,j,k)*MOLWEIGHT(1)/VOLMOL
            ENDDO
            ENDDO
            ENDDO
            DO k=NIVM2,1,-1
              WRITE(IFSORACC2)
     +          ((T3DOUT2(i,j,k),i=1,LONM2),j=LATM2,1,-1)
            ENDDO
C
C SUM AND CONVERT DRY DEPOSITION FLUXES TO DENSITIES (kg.m-3) ; WRITE
C
            DO j=1,LATM2
            DO i=1,LONM2
              T2DOUT2(i,j) = 
     +            DFDRYCUMUL2(i,j,1)+DFDRYCUMUL2(i,j,2)
     +           +DFDRYCUMUL2(i,j,3)+DFDRYCUMUL2(i,j,4)
     +           +DFDRYCUMUL2(i,j,5)+DFDRYCUMUL2(i,j,6)
     +           +DFDRYCUMUL2(i,j,7)+DFDRYCUMUL2(i,j,8)
     +           +DFDRYCUMUL2(i,j,9)+DFDRYCUMUL2(i,j,10)
C VHP : EST-CE QUE CELA A UN SENS?
              VOLMOL = 22.414
     +                *(TGRIM2(i,j,47)/TREF)*(PREF/XPAM2(i,j,47))
              T2DOUT2(i,j) = T2DOUT2(i,j)*MOLWEIGHT(1)/VOLMOL
            ENDDO
            ENDDO
            WRITE(IFSORACC2) ((T2DOUT2(i,j),i=1,LONM2),j=LATM2,1,-1)
C
C TOTAL WET DEPOSITION, SUM, CONVERT ; WRITE
C
            DO j=1,LATM2
            DO i=1,LONM2
              T2DOUT2(i,j) = 
     +            DFBCVCUMUL2(i,j,1)+DFBCVCUMUL2(i,j,2)
     +           +DFBCVCUMUL2(i,j,3)+DFBCVCUMUL2(i,j,4)
     +           +DFBCVCUMUL2(i,j,5)+DFBCVCUMUL2(i,j,6)
     +           +DFBCVCUMUL2(i,j,7)+DFBCVCUMUL2(i,j,8)
     +           +DFBCVCUMUL2(i,j,9)+DFBCVCUMUL2(i,j,10)
     +           +DFICVCUMUL2(i,j,1)+DFICVCUMUL2(i,j,2)
     +           +DFICVCUMUL2(i,j,3)+DFICVCUMUL2(i,j,4)
     +           +DFICVCUMUL2(i,j,5)+DFICVCUMUL2(i,j,6)
     +           +DFICVCUMUL2(i,j,7)+DFICVCUMUL2(i,j,8)
     +           +DFICVCUMUL2(i,j,9)+DFICVCUMUL2(i,j,10)
     +           +DFSTRCUMUL2(i,j,1)+DFSTRCUMUL2(i,j,2)
     +           +DFSTRCUMUL2(i,j,3)+DFSTRCUMUL2(i,j,4)
     +           +DFSTRCUMUL2(i,j,5)+DFSTRCUMUL2(i,j,6)
     +           +DFSTRCUMUL2(i,j,7)+DFSTRCUMUL2(i,j,8)
     +           +DFSTRCUMUL2(i,j,9)+DFSTRCUMUL2(i,j,10)
C VHP : EST-CE QUE CELA A UN SENS?
              VOLMOL = 22.414
     +                *(TGRIM2(i,j,47)/TREF)*(PREF/XPAM2(i,j,47))
              T2DOUT2(i,j) = T2DOUT2(i,j)*MOLWEIGHT(1)/VOLMOL
            ENDDO
            ENDDO
            WRITE(IFSORACC2) ((T2DOUT2(i,j),i=1,LONM2),j=LATM2,1,-1)
C
C TOTAL PRECIPITATION FLUXES
C
            DO j=1,LATM2
              DO i=1,LONM2
                T2DOUT2(i,j) = 0.
                DO k=1,NIVM2
                  T2DOUT2(i,j)= T2DOUT2(i,j)+PCVRCUMUL2(i,j,k)
     +                       + PCVSCUMUL2(i,j,k)+PSTRCUMUL2(i,j,k)
                ENDDO
              ENDDO
            ENDDO
            WRITE(IFSORACC2) ((T2DOUT2(i,j),i=1,LONM2),j=LATM2,1,-1)   
          ENDIF              
C
C DOMAIN 3
C
          IF (IFLAG3) THEN 
C
C SUM AND CONVERT MIXING RATIOS TO DENSITIES (kg.m-3) ; WRITE
C
            DO k=1,NIVM3
            DO j=1,LATM3
            DO i=1,LONM3
              T3DOUT3(i,j,k) = 
     +            QQQM3(i,j,k,1)+QQQM3(i,j,k,2)+QQQM3(i,j,k,3)
     +           +QQQM3(i,j,k,4)+QQQM3(i,j,k,5)+QQQM3(i,j,k,6)
     +           +QQQM3(i,j,k,7)+QQQM3(i,j,k,8)+QQQM3(i,j,k,9)
     +           +QQQM3(i,j,k,10)
              VOLMOL = 22.414
     +                *(TGRIM3(i,j,k)/TREF)*(PREF/XPAM3(i,j,k))
              T3DOUT3(i,j,k) = T3DOUT3(i,j,k)*MOLWEIGHT(1)/VOLMOL
            ENDDO
            ENDDO
            ENDDO
            DO k=NIVM3,1,-1
              WRITE(IFSORACC3)
     +          ((T3DOUT3(i,j,k),i=1,LONM3),j=LATM3,1,-1)
            ENDDO
C
C SUM AND CONVERT DRY DEPOSITION FLUXES TO DENSITIES (kg.m-3) ; WRITE
C
            DO j=1,LATM3
            DO i=1,LONM3
              T2DOUT3(i,j) = 
     +            DFDRYCUMUL3(i,j,1)+DFDRYCUMUL3(i,j,2)
     +           +DFDRYCUMUL3(i,j,3)+DFDRYCUMUL3(i,j,4)
     +           +DFDRYCUMUL3(i,j,5)+DFDRYCUMUL3(i,j,6)
     +           +DFDRYCUMUL3(i,j,7)+DFDRYCUMUL3(i,j,8)
     +           +DFDRYCUMUL3(i,j,9)+DFDRYCUMUL3(i,j,10)
C VHP : EST-CE QUE CELA A UN SENS?
              VOLMOL = 22.414
     +                *(TGRIM3(i,j,47)/TREF)*(PREF/XPAM3(i,j,47))
              T2DOUT3(i,j) = T2DOUT3(i,j)*MOLWEIGHT(1)/VOLMOL
            ENDDO
            ENDDO
            WRITE(IFSORACC3) ((T2DOUT3(i,j),i=1,LONM3),j=LATM3,1,-1)
C
C TOTAL WET DEPOSITION, SUM, CONVERT ; WRITE
C
            DO j=1,LATM3
            DO i=1,LONM3
              T2DOUT3(i,j) = 
     +            DFBCVCUMUL3(i,j,1)+DFBCVCUMUL3(i,j,2)
     +           +DFBCVCUMUL3(i,j,3)+DFBCVCUMUL3(i,j,4)
     +           +DFBCVCUMUL3(i,j,5)+DFBCVCUMUL3(i,j,6)
     +           +DFBCVCUMUL3(i,j,7)+DFBCVCUMUL3(i,j,8)
     +           +DFBCVCUMUL3(i,j,9)+DFBCVCUMUL3(i,j,10)
     +           +DFICVCUMUL3(i,j,1)+DFICVCUMUL3(i,j,2)
     +           +DFICVCUMUL3(i,j,3)+DFICVCUMUL3(i,j,4)
     +           +DFICVCUMUL3(i,j,5)+DFICVCUMUL3(i,j,6)
     +           +DFICVCUMUL3(i,j,7)+DFICVCUMUL3(i,j,8)
     +           +DFICVCUMUL3(i,j,9)+DFICVCUMUL3(i,j,10)
     +           +DFSTRCUMUL3(i,j,1)+DFSTRCUMUL3(i,j,2)
     +           +DFSTRCUMUL3(i,j,3)+DFSTRCUMUL3(i,j,4)
     +           +DFSTRCUMUL3(i,j,5)+DFSTRCUMUL3(i,j,6)
     +           +DFSTRCUMUL3(i,j,7)+DFSTRCUMUL3(i,j,8)
     +           +DFSTRCUMUL3(i,j,9)+DFSTRCUMUL3(i,j,10)
C VHP : EST-CE QUE CELA A UN SENS?
              VOLMOL = 22.414
     +                *(TGRIM3(i,j,47)/TREF)*(PREF/XPAM3(i,j,47))
              T2DOUT3(i,j) = T2DOUT3(i,j)*MOLWEIGHT(1)/VOLMOL
            ENDDO
            ENDDO
            WRITE(IFSORACC3) ((T2DOUT3(i,j),i=1,LONM3),j=LATM3,1,-1)
C
C TOTAL PRECIPITATION FLUXES
C
            DO j=1,LATM3
              DO i=1,LONM3
                T2DOUT3(i,j) = 0.
                DO k=1,NIVM3
                  T2DOUT3(i,j)= T2DOUT3(i,j)+PCVRCUMUL3(i,j,k)
     +                       + PCVSCUMUL3(i,j,k)+PSTRCUMUL3(i,j,k)
                ENDDO
              ENDDO
            ENDDO
            WRITE(IFSORACC3) ((T2DOUT3(i,j),i=1,LONM3),j=LATM3,1,-1)   
          ENDIF              
C
C DOMAIN 4
C
          IF (IFLAG4) THEN 
C
C SUM AND CONVERT MIXING RATIOS TO DENSITIES (kg.m-3) ; WRITE
C
            DO k=1,NIVM4
            DO j=1,LATM4
            DO i=1,LONM4
              T3DOUT4(i,j,k) = 
     +            QQQM4(i,j,k,1)+QQQM4(i,j,k,2)+QQQM4(i,j,k,3)
     +           +QQQM4(i,j,k,4)+QQQM4(i,j,k,5)+QQQM4(i,j,k,6)
     +           +QQQM4(i,j,k,7)+QQQM4(i,j,k,8)+QQQM4(i,j,k,9)
     +           +QQQM4(i,j,k,10)
              VOLMOL = 22.414
     +                *(TGRIM4(i,j,k)/TREF)*(PREF/XPAM4(i,j,k))
              T3DOUT4(i,j,k) = T3DOUT4(i,j,k)*MOLWEIGHT(1)/VOLMOL
            ENDDO
            ENDDO
            ENDDO
            DO k=NIVM4,1,-1
              WRITE(IFSORACC4)
     +          ((T3DOUT4(i,j,k),i=1,LONM4),j=LATM4,1,-1)
            ENDDO
C
C SUM AND CONVERT DRY DEPOSITION FLUXES TO DENSITIES (kg.m-3) ; WRITE
C
            DO j=1,LATM4
            DO i=1,LONM4
              T2DOUT4(i,j) = 
     +            DFDRYCUMUL4(i,j,1)+DFDRYCUMUL4(i,j,2)
     +           +DFDRYCUMUL4(i,j,3)+DFDRYCUMUL4(i,j,4)
     +           +DFDRYCUMUL4(i,j,5)+DFDRYCUMUL4(i,j,6)
     +           +DFDRYCUMUL4(i,j,7)+DFDRYCUMUL4(i,j,8)
     +           +DFDRYCUMUL4(i,j,9)+DFDRYCUMUL4(i,j,10)
C VHP : EST-CE QUE CELA A UN SENS?
              VOLMOL = 22.414
     +                *(TGRIM4(i,j,47)/TREF)*(PREF/XPAM4(i,j,47))
              T2DOUT4(i,j) = T2DOUT4(i,j)*MOLWEIGHT(1)/VOLMOL
            ENDDO
            ENDDO
            WRITE(IFSORACC4) ((T2DOUT4(i,j),i=1,LONM4),j=LATM4,1,-1)
C
C TOTAL WET DEPOSITION, SUM, CONVERT ; WRITE
C
            DO j=1,LATM4
            DO i=1,LONM4
              T2DOUT4(i,j) = 
     +            DFBCVCUMUL4(i,j,1)+DFBCVCUMUL4(i,j,2)
     +           +DFBCVCUMUL4(i,j,3)+DFBCVCUMUL4(i,j,4)
     +           +DFBCVCUMUL4(i,j,5)+DFBCVCUMUL4(i,j,6)
     +           +DFBCVCUMUL4(i,j,7)+DFBCVCUMUL4(i,j,8)
     +           +DFBCVCUMUL4(i,j,9)+DFBCVCUMUL4(i,j,10)
     +           +DFICVCUMUL4(i,j,1)+DFICVCUMUL4(i,j,2)
     +           +DFICVCUMUL4(i,j,3)+DFICVCUMUL4(i,j,4)
     +           +DFICVCUMUL4(i,j,5)+DFICVCUMUL4(i,j,6)
     +           +DFICVCUMUL4(i,j,7)+DFICVCUMUL4(i,j,8)
     +           +DFICVCUMUL4(i,j,9)+DFICVCUMUL4(i,j,10)
     +           +DFSTRCUMUL4(i,j,1)+DFSTRCUMUL4(i,j,2)
     +           +DFSTRCUMUL4(i,j,3)+DFSTRCUMUL4(i,j,4)
     +           +DFSTRCUMUL4(i,j,5)+DFSTRCUMUL4(i,j,6)
     +           +DFSTRCUMUL4(i,j,7)+DFSTRCUMUL4(i,j,8)
     +           +DFSTRCUMUL4(i,j,9)+DFSTRCUMUL4(i,j,10)
C VHP : EST-CE QUE CELA A UN SENS?
              VOLMOL = 22.414
     +                *(TGRIM4(i,j,47)/TREF)*(PREF/XPAM4(i,j,47))
              T2DOUT4(i,j) = T2DOUT4(i,j)*MOLWEIGHT(1)/VOLMOL
            ENDDO
            ENDDO
            WRITE(IFSORACC4) ((T2DOUT4(i,j),i=1,LONM4),j=LATM4,1,-1)
C
C TOTAL PRECIPITATION FLUXES
C
            DO j=1,LATM4
              DO i=1,LONM4
                T2DOUT4(i,j) = 0.
                DO k=1,NIVM4
                  T2DOUT4(i,j)= T2DOUT4(i,j)+PCVRCUMUL4(i,j,k)
     +                       + PCVSCUMUL4(i,j,k)+PSTRCUMUL4(i,j,k)
                ENDDO
              ENDDO
            ENDDO
            WRITE(IFSORACC4) ((T2DOUT4(i,j),i=1,LONM4),j=LATM4,1,-1)   
          ENDIF  
        ENDIF              
      ENDIF
C
CCC      
C
      RETURN
      END
C
CCC
C
