	MODULE PARADI_MOD
C
C------------------------------------------------------------------------
C 	MODEL MAIN PARAMETERS
C
C	AUTHOR	: HERVE LE BERRE	- CERFACS -
C	DATE		: 03/08/2005
C	VERSION	: 1_0_0
C------------------------------------------------------------------------
C
C
#ifdef PALM_RESEARCH
	USE palm_user_param
#endif
	IMPLICIT NONE
C
C
 
CCC MODEL MAIN PARAMETERS
C
C     LONM* = NUMBER OF LONGITUDES
C     LATM* = NUMBER OF LATITUDES
C     NIVM* = NUMBER OF VERTICAL LEVELS
C     NTRA* = NUMBER OF TRANSPORTED SPECIES
C     NSLS* = NUMBER OF SHORT-LIVED SPECIES
C     NEMI* = NUMBER OF EMITTED SPECIES
C     NDEP* = NUMBER OF DEPOSITED SPECIES 
C
C  0. CPP Dependent quantities 
C
#ifdef MIDATM
#ifdef NIV_91
#define CPP_NIVM 91
#define CPP_NIVF 91
#endif
#ifdef NIV_60
#define CPP_NIVM 60
#define CPP_NIVF 60
#endif
#else
#define CPP_NIVM 47
#define CPP_NIVF 41
#endif
C
	INTEGER , SAVE :: NTRA1,NSLS1,NEMI1,NDEP1
	INTEGER , SAVE :: LONM1,LATM1,NIVM1
	INTEGER , SAVE :: NTRA2,NSLS2,NEMI2,NDEP2
	INTEGER , SAVE :: LONM2,LATM2,NIVM2
	INTEGER , SAVE :: NTRA3,NSLS3,NEMI3,NDEP3
	INTEGER , SAVE :: LONM3,LATM3,NIVM3
	INTEGER , SAVE :: NTRA4,NSLS4,NEMI4,NDEP4
	INTEGER , SAVE :: LONM4,LATM4,NIVM4
C
	INTEGER, SAVE :: NASSIM1
C
	INTEGER , SAVE :: LOLAM1,LANIM1,LOLANIM1
	INTEGER , SAVE :: LOLAM2,LANIM2,LOLANIM2
	INTEGER , SAVE :: LOLAM3,LANIM3,LOLANIM3
	INTEGER , SAVE :: LOLAM4,LANIM4,LOLANIM4
C
	INTEGER , SAVE :: LONF1,LATF1,NIVF1
	INTEGER , SAVE :: LONF2,LATF2,NIVF2
	INTEGER , SAVE :: LONF3,LATF3,NIVF3
	INTEGER , SAVE :: LONF4,LATF4,NIVF4
C	
	INTEGER , SAVE :: LOLAF1,LANIF1,LOLANIF1
	INTEGER , SAVE :: LOLAF2,LANIF2,LOLANIF2
	INTEGER , SAVE :: LOLAF3,LANIF3,LOLANIF3
	INTEGER , SAVE :: LOLAF4,LANIF4,LOLANIF4
C
	INTEGER , SAVE :: NPTS1	
	INTEGER , SAVE :: NPTS2
	INTEGER , SAVE :: NPTS3
	INTEGER , SAVE :: NPTS4
C
	INTEGER , SAVE :: NPTS
C
	INTEGER , SAVE :: NCOL,NIV1D,NTRA1D,NSLS1D,NEMI1D,NDEP1D
	INTEGER , SAVE :: NHOUR
C
	INTEGER , SAVE :: nobsmax,nobstspmax,ninstmax,nbnivpresmax
	INTEGER , SAVE :: nbconstmax
	INTEGER , SAVE :: NBOX
	REAL (KIND=8)  , SAVE :: THETAMIN,DELTATH
	INTEGER :: LADEMI
        INTEGER , SAVE :: NCARIO3,NCARIOCO,NCARIOHNO3
C
	INTEGER , SAVE :: JPMXLEV,JPMXGL
	INTEGER :: ig_run_mode
	INTEGER, PARAMETER :: DRY_RUN=0
	INTEGER, PARAMETER :: DIR_MODEL=1
	INTEGER, PARAMETER :: OBS_OPERATOR=2
	INTEGER, PARAMETER :: TL_MODEL=3
	INTEGER, PARAMETER :: ADJ_MODEL=4
C
	CONTAINS
C
	SUBROUTINE LOAD_PARADI(id_err)
C
C       Load the actual values of the paradi parameters from 
C       a namelist or from a palm module
C
	IMPLICIT NONE
C
	INTEGER :: id_err
	INTEGER :: il_err
C
C	READ GRID AND FORCING PARAMETERS IN NAMELIST

	NAMELIST/PARAM_G1/NTRA1,NSLS1,NEMI1,NDEP1
     +		     ,LONM1,LATM1,LONF1,LATF1	
	NAMELIST/PARAM_G2/NTRA2,NSLS2,NEMI2,NDEP2
     +		     ,LONM2,LATM2,LONF2,LATF2
	NAMELIST/PARAM_G3/NTRA3,NSLS3,NEMI3,NDEP3
     +		     ,LONM3,LATM3,LONF3,LATF3
	NAMELIST/PARAM_G4/NTRA4,NSLS4,NEMI4,NDEP4
     +		     ,LONM4,LATM4,LONF4,LATF4	
	NAMELIST/PARAM_MODEL1D/NCOL,NIV1D,NTRA1D,NSLS1D,NEMI1D,NDEP1D
	NAMELIST/PARAM_OTHER/NHOUR,nobsmax,nobstspmax,ninstmax
     +			  ,nbnivpresmax,nbconstmax,THETAMIN,DELTATH
     +			  ,LADEMI,NBOX,NCARIO3,NCARIOCO,NCARIOHNO3
	NAMELIST/PARAM_XRD/JPMXLEV,JPMXGL
C
#ifdef MIDATM
#ifdef NIV_91
#define CPP_NIVM 91
#define CPP_NIVF 91
#endif
#ifdef NIV_60
#define CPP_NIVM 60
#define CPP_NIVF 60
#endif
#else
#define CPP_NIVM 47
#define CPP_NIVF 41
#endif
C
#ifdef MIDATM
#ifdef NIV_91
#define CPP_PHUC 91
#endif
#ifdef NIV_60
#define CPP_PHUC 60
#endif
#else
#define CPP_PHUC 47
#endif
C
#ifdef CARIOLLE
#define CPP_NPHOT 1
#endif
#ifdef REPROBUS
#define CPP_NPHOT 39
#endif
#ifdef RELACS
#define CPP_NPHOT 45
#endif
#ifdef RACMOBUS
#define CPP_NPHOT 55
#endif
#ifdef ACCIDENT
#define CPP_NPHOT 1
#endif


C	
	NIVM1=CPP_NIVM
	NIVF1=CPP_NIVF
	NIVM2=CPP_NIVM
	NIVF2=CPP_NIVF
	NIVM3=CPP_NIVM
	NIVF3=CPP_NIVF
	NIVM4=CPP_NIVM
	NIVF4=CPP_NIVF
C
	id_err = 0
C	
	OPEN(88,FILE="namelist_param",FORM="formatted",IOSTAT=id_err)
	READ(88,PARAM_G1,IOSTAT=il_err)
	id_err = id_err + il_err
	READ(88,PARAM_G2,IOSTAT=il_err)
	id_err = id_err + il_err
	READ(88,PARAM_G3,IOSTAT=il_err)
	id_err = id_err + il_err
	READ(88,PARAM_G4,IOSTAT=il_err)
	id_err = id_err + il_err
	READ(88,PARAM_MODEL1D,IOSTAT=il_err)
	id_err = id_err + il_err
	READ(88,PARAM_OTHER,IOSTAT=il_err)
	id_err = id_err + il_err
	READ(88,PARAM_XRD,IOSTAT=il_err)
	id_err = id_err + il_err
	CLOSE(88)
#ifdef MASSy
        NTRA1=NTRA1+3
        NTRA2=NTRA2+3
        NTRA3=NTRA3+3
        NTRA4=NTRA4+3
#endif
#ifdef CARIOLLE
        NTRA1=0
        NTRA2=0
        NTRA3=0
        NTRA4=0
	NEMI1=0
	NDEP1=0
	NEMI2=0
	NDEP2=0
	NEMI3=0
	NDEP3=0
	NEMI4=0
	NDEP4=0
#ifdef LINO_3
        NTRA1=NTRA1+1
        NTRA2=NTRA2+1
        NTRA3=NTRA3+1
        NTRA4=NTRA4+1
	NCARIO3=8
#endif
#ifdef TFROID
        NTRA1=NTRA1+1
        NTRA2=NTRA2+1
        NTRA3=NTRA3+1
        NTRA4=NTRA4+1
	NCARIO3=9
#endif
#ifdef LINCO
        NTRA1=NTRA1+1
        NTRA2=NTRA2+1
        NTRA3=NTRA3+1
        NTRA4=NTRA4+1
C
	NEMI1=NEMI1+1
	NDEP1=NDEP1+1
	NEMI2=NEMI2+1
	NDEP2=NDEP2+1
	NEMI3=NEMI3+1
	NDEP3=NDEP3+1
	NEMI4=NEMI4+1
	NDEP4=NDEP4+1
#endif
#ifdef LINHNO_3
        NTRA1=NTRA1+1
        NTRA2=NTRA2+1
        NTRA3=NTRA3+1
        NTRA4=NTRA4+1
#endif
#endif
C
#ifdef PALM_RESEARCH
	IF ((LONM1.ne.ip_lonm1).or.(LATM1.ne.ip_latm1).or.
     +      (NIVM1 .ne. ip_nivm1)) THEN
	  WRITE(*,*) '!!! Error: dimensions and palm_constants',
     + ' are not conforming'
          WRITE(*,*) 'Check LONM1 = ',LONM1,' and ip_lonm1 = ',
     +      ip_lonm1
          WRITE(*,*) 'Check LATM1 = ',LATM1,' and ip_latm1 = ',
     +      ip_latm1
          WRITE(*,*) 'Check NIVM1 = ',NIVM1,' and ip_nivm1 = ',
     +      ip_nivm1
	  id_err = 1
	ENDIF
	NASSIM1=ip_nassim
	IF (ig_run_mode .eq. DIR_MODEL) THEN
	    IF ((NTRA1.ne.ip_ntra1).or.(NSLS1.ne.ip_nsls1)) THEN
	      WRITE(*,*) '!!! Error: number of species and',
     + ' PALM constants are not conforming'
	      WRITE(*,*) 'Check NTRA1 = ',NTRA1,' and ip_ntra1 = ',
     +          ip_ntra1
              WRITE(*,*) 'Check NSLS1 = ',NSLS1,' and ip_nsls1 = ',
     +          ip_nsls1
	      id_err = 1
            ENDIF
	ENDIF
#endif
C
	LOLAM1=LONM1*LATM1
	LANIM1=LATM1*NIVM1
	LOLANIM1=LONM1*LATM1*NIVM1
	LOLAM2=LONM2*LATM2
	LANIM2=LATM2*NIVM2
	LOLANIM2=LONM2*LATM2*NIVM2
	LOLAM3=LONM3*LATM3
	LANIM3=LATM3*NIVM3
	LOLANIM3=LONM3*LATM3*NIVM3
	LOLAM4=LONM4*LATM4
	LANIM4=LATM4*NIVM4
	LOLANIM4=LONM4*LATM4*NIVM4	
C
	LOLAF1=LONF1*LATF1
	LANIF1=LATF1*NIVF1
	LOLANIF1=LONF1*LATF1*NIVF1
	LOLAF2=LONF2*LATF2
	LANIF2=LATF2*NIVF2
	LOLANIF2=LONF2*LATF2*NIVF2
	LOLAF3=LONF3*LATF3
	LANIF3=LATF3*NIVF3
	LOLANIF3=LONF3*LATF3*NIVF3
	LOLAF4=LONF4*LATF4
	LANIF4=LATF4*NIVF4
	LOLANIF4=LONF4*LATF4*NIVF4
C	
	NPTS1=LOLANIM1
	NPTS2=LOLANIM2
	NPTS3=LOLANIM3
	NPTS4=LOLANIM4
C	
	NPTS=MAX(NPTS1,NPTS2,NPTS3,NPTS4)
C
	END SUBROUTINE LOAD_PARADI
C
	END MODULE PARADI_MOD
