      SUBROUTINE POIDREG(X,XMIN,DXREG
     +                  ,IND,ALF1,ALF2,ALF3,ALF4,NDIM)
C
CCC
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type      : 3D semi-lagrangian transport scheme
C   Purpose   : Compute weights for cubic interpolation
C               on a regular grid
C   Called by : 
C
CCC
C
C  Original : P. Simon, 03/1999
C
C  Modified : V.-H. Peuch (inclusion dans MOCAGE), 04/1999
C             P. Simon    (suppression des tests), 08/1999
C
CCC
C
	IMPLICIT NONE
C
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
C
	INTEGER :: NDIM	
	REAL (KIND=8) :: XMIN,DXREG
	INTEGER , DIMENSION (NDIM) :: IND
	REAL (KIND=8) , DIMENSION (NDIM) :: X
	REAL (KIND=8) , DIMENSION (NDIM) :: ALF1,ALF2,ALF3,ALF4
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C
	INTEGER :: N,IX
	REAL (KIND=8) :: COEFX,DX1,DX2,DX3,DX4
	REAL (KIND=8) :: DX
	REAL (KIND=8) :: COEF1, COEF2, COEF3,COEF4
C
C
C  coefficients pour le calcul des poids des interpolations cubiques
C
      COEFX=1./(DXREG*DXREG*DXREG)
      COEF1=-COEFX/6.
      COEF2= COEFX/2.
      COEF3=-COEFX/2.
      COEF4= COEFX/6.
C
C  positionnement
C
      DO N=1,NDIM
         IX=INT((X(N)-XMIN)/DXREG)
         IND(N)=IX
         DX=X(N)-XMIN-REAL(IX)*DXREG
C
C  calcul des poids proprement dit
C
         DX1=DX+DXREG
         DX2=DX
         DX3=DX-DXREG
         DX4=DX-DXREG*2.
         ALF1(N)=COEF1*DX2*DX3*DX4
         ALF2(N)=COEF2*DX1*DX3*DX4
         ALF3(N)=COEF3*DX1*DX2*DX4
         ALF4(N)=COEF4*DX1*DX2*DX3
      ENDDO
C
      RETURN
      END
