      SUBROUTINE POSIREG(X,Y,IDOM
     +                  ,XMIN2,XMAX2,YMIN2,YMAX2
     +                  ,XMIN3,XMAX3,YMIN3,YMAX3
     +                  ,XMIN4,XMAX4,YMIN4,YMAX4
     +                  ,IGR,NDIM)
C
CCC
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type       : 3D semi-lagrangion transport scheme
C   Purpose    : Locate (X,Y) points relative to grids
C   Called by  :
C
CCC
C
C  Original : P. Simon, 03/1999
C
C  Modified : V.-H. Peuch (inclusion dans MOCAGE), 04/1999
C
CCC
C
	IMPLICIT NONE
C
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
C
	INTEGER :: NDIM,IDOM	
      REAL (KIND=8) :: XMIN2,XMAX2,YMIN2,YMAX2                                      
      REAL (KIND=8) :: XMIN3,XMAX3,YMIN3,YMAX3                                      
      REAL (KIND=8) :: XMIN4,XMAX4,YMIN4,YMAX4 
	INTEGER , DIMENSION(NDIM) :: IGR
	REAL (KIND=8) , DIMENSION(NDIM) :: X,Y      
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C
	INTEGER :: N
C         
C                                                              
      IF(IDOM.EQ.1) THEN
C
        DO 1 N=1,NDIM
           IGR(N)=1
 1      CONTINUE
C
      ELSEIF(IDOM.EQ.2) THEN
C
        DO 2 N=1,NDIM
           IF(X(N).LT.XMIN2.OR.X(N).GT.XMAX2) THEN
             IGR(N)=1
           ELSEIF(Y(N).LT.YMIN2.OR.Y(N).GT.YMAX2) THEN
             IGR(N)=1
           ELSE
             IGR(N)=2
           ENDIF
 2      CONTINUE
C
      ELSEIF(IDOM.EQ.3) THEN
C
        DO 3 N=1,NDIM
           IF(X(N).LT.XMIN2.OR.X(N).GT.XMAX2) THEN
             IGR(N)=1
           ELSEIF(Y(N).LT.YMIN2.OR.Y(N).GT.YMAX2) THEN
             IGR(N)=1
           ELSEIF(X(N).LT.XMIN3.OR.X(N).GT.XMAX3) THEN
             IGR(N)=2
           ELSEIF(Y(N).LT.YMIN3.OR.Y(N).GT.YMAX3) THEN
             IGR(N)=2
           ELSE
             IGR(N)=3
           ENDIF
 3      CONTINUE
C
      ELSEIF(IDOM.EQ.4) THEN
C
        DO 4 N=1,NDIM
           IF(X(N).LT.XMIN2.OR.X(N).GT.XMAX2) THEN
             IGR(N)=1
           ELSEIF(Y(N).LT.YMIN2.OR.Y(N).GT.YMAX2) THEN
             IGR(N)=1
           ELSEIF(X(N).LT.XMIN3.OR.X(N).GT.XMAX3) THEN
             IGR(N)=2
           ELSEIF(Y(N).LT.YMIN3.OR.Y(N).GT.YMAX3) THEN
             IGR(N)=2
           ELSEIF(X(N).LT.XMIN4.OR.X(N).GT.XMAX4) THEN
             IGR(N)=3
           ELSEIF(Y(N).LT.YMIN4.OR.Y(N).GT.YMAX4) THEN
             IGR(N)=3
           ELSE
             IGR(N)=4
           ENDIF
 4      CONTINUE
C
      ENDIF
C                                                                       
      RETURN                                                            
      END                                                               
