      SUBROUTINE READFORCINGDATE( idate0,
     $                            TRANSINV,
     $                            daynum,NSCY,
     $                            clf,IFORC)

C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type       : I/O
C   Purpose    : Read and check the date of the 3D forcing files "FM" (LFI format)
C   Called by  : FORCAGE
C
CCC
C
C  Original : P. Moinat, 21/10/2005
C
C  Last Modified : H. Le Berre 10/2006  Integration in CVS


      IMPLICIT NONE
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
      INTEGER , DIMENSION(5) :: idate0
      LOGICAL :: TRANSINV
      REAL (KIND=8) :: daynum
      INTEGER :: NSCY
      CHARACTER (LEN=19) :: clf
      INTEGER :: IFORC
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C
      INTEGER , DIMENSION(11) :: idate
      INTEGER , DIMENSION(5)  :: idate1
      INTEGER :: irep,nscheck
C
c
c Valid date verification
c
            call fadies(irep,IFORC,idate)
c
            idate1(1)=idate(1)
            idate1(2)=idate(2)
            idate1(3)=idate(3)
            idate1(4)=idate(4)+idate(7)
            idate1(5)=idate(5)
c
            IF (.NOT.TRANSINV) THEN
                CALL TIMESEC(idate0,idate1,nscheck)
            ELSE
                CALL TIMESEC(idate1,idate0,nscheck)
            ENDIF
c
            if (REAL(nscheck).NE.(daynum+REAL(NSCY))) then
              print*,' WRONG DATE FOR FILE  : ',clf
              print*,'         ABORT!'
              CALL MOCAGE_STOP
            endif
C
C
          return
          end
