      SUBROUTINE READFORCINGFIELDS( 
     $                            IFORC,
     $                            LONF,LATF,NIVF,LOLAF,
     $                            TGRIF,UGRIF,VGRIF,WGRIF,
     $                            QGRIF,PVGRIF,PSOLF)

C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type       : I/O
C   Purpose    : Read the 3D forcing fields in the forcing files "FM" (LFI format)
C   Called by  : FORCAGE
C
CCC
C
C  Original : P. Moinat, 21/10/2005
C
C  Last Modified : H. Le Berre 10/2006  Integration in CVS 


      IMPLICIT NONE
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
      INTEGER :: IFORC
      INTEGER :: LONF,LATF,NIVF,LOLAF
      REAL (KIND=8), DIMENSION(LONF,LATF,NIVF) :: TGRIF,UGRIF,VGRIF,
     $                                            WGRIF,QGRIF,PVGRIF   
      REAL (KIND=8), DIMENSION(LONF,LATF) :: PSOLF
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
      REAL (KIND=8), DIMENSION(LONF,LATF) :: zf
      INTEGER :: iniv,ilon,irep
      CHARACTER (LEN=4) :: cdpref
C
C
            do iniv=1,NIVF
              if (iniv.LE.9) then
                write(cdpref,fmt='(''S00'',I1)')iniv
              else
                write(cdpref,fmt='(''S0'',I2)')iniv
              endif
              call facile(irep,IFORC,cdpref,0,'TEMPERATURE',zf,
     $                    .false.)
              do ilon=1,LOLAF
                TGRIF(ilon,1,iniv)=zf(ilon,1)
              enddo
              call facile(irep,IFORC,cdpref,0,'VENT_ZONAL',zf,
     $                    .false.)
              do ilon=1,LOLAF
                UGRIF(ilon,1,iniv)=zf(ilon,1)
              enddo
              call facile(irep,IFORC,cdpref,0,'VENT_MERIDIE',zf,
     $                    .false.)
              do ilon=1,LOLAF
                VGRIF(ilon,1,iniv)=zf(ilon,1)
              enddo
              call facile(irep,IFORC,cdpref,0,'VITESSE_VERT',zf,
     $                    .false.)
              do ilon=1,LOLAF
                WGRIF(ilon,1,iniv)=zf(ilon,1)
              enddo
              call facile(irep,IFORC,cdpref,0,'HUMI.SPECIFI',zf,
     $                    .false.)
              do ilon=1,LOLAF
                QGRIF(ilon,1,iniv)=zf(ilon,1)
              enddo
c             call facile(irep,IFORC,cdpref,0,'POT_VORTICIT',zf,
c    $                    .false.)
              do ilon=1,LOLAF
c               PVGRIF(ilon,1,iniv)=zf(ilon,1)
                PVGRIF(ilon,1,iniv)=0.
              enddo
            enddo
            call facile(irep,IFORC,'SURF',0,'PRESSION',zf,
     $                  .false.)
            do ilon=1,LOLAF
              PSOLF(ilon,1)=zf(ilon,1)
            enddo
C
C
          return
          end
