      SUBROUTINE READFORCINGGEOM(
     $                            NIVF,LATF,LONF,
     $                            RLONFMIN,RLONFMAX,RLATFMIN,RLATFMAX,
     $                            ALF,BLF)

C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type       : I/O
C   Purpose    : Read and check the grid of the 3D forcing files "FM" (LFI format)
C   Called by  : FORCAGE
C
CCC
C
C  Original : P. Moinat, 21/10/2005
C
C  Last Modified : H. Le Berre 10/2006  Integration in CVS
C
C
#ifdef GAUSS
      USE GRIDS_MOD
      USE CSTES_MOD
#endif
      IMPLICIT NONE
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
      INTEGER NIVF,LATF,LONF
      REAL (KIND=8) :: RLONFMIN,RLONFMAX,RLATFMIN,RLATFMAX
      REAL (KIND=8), DIMENSION(0:NIVF) :: ALF,BLF
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
#ifdef GAUSS
      INTEGER :: k
#endif
      REAL (KIND=8) :: zbeta,zclopo,zslopo,zcodil,zvp00
      REAL (KIND=8), DIMENSION(322) :: zgeom
      REAL (KIND=8), DIMENSION (0:100) :: zvah,zvbh
      INTEGER :: ityptr,itrunc,idgl,idlon,iflev
      INTEGER , DIMENSION(322) :: inlopa,inzopa
      LOGICAL :: llgard
      INTEGER :: iniv
C
C
            call facies('CADRE.STANDARD',ityptr,zbeta,zclopo,zslopo,
     $            zcodil,itrunc,idgl,idlon,inlopa,
     $            inzopa,zgeom,iflev,zvp00,zvah,
     $            zvbh,llgard)
c
            if (    (iflev.NE.NIVF)
     $          .OR.(idgl.NE.LATF)
     $          .OR.(idlon.NE.LONF)    ) then
            print*,' INVALID GEOMETRY FOR GRID : ABORT!'
            CALL MOCAGE_STOP
            endif
c
#ifndef GAUSS
            RLONFMIN=zgeom(4)-0.5*(zgeom(6)-zgeom(4))/real(idlon-1)
            RLONFMAX=zgeom(6)+0.5*(zgeom(6)-zgeom(4))/real(idlon-1)
            RLATFMIN=zgeom(5)-0.5*(zgeom(7)-zgeom(5))/real(idgl-1)
            RLATFMAX=zgeom(7)+0.5*(zgeom(7)-zgeom(5))/real(idgl-1)
#else
            RLONF1MIN=0.
            RLONF1MAX=XPI2
            RLATF1MIN=-XPIH
            RLATF1MAX=+XPIH
	    DO K=1,idgl/2
             RLATF1(K       )=-ASIN(zgeom(k))
             RLATF1(idgl-K+1)= ASIN(zgeom(k))
            ENDDO
#endif	    	    
c
            do iniv=0,NIVF
              ALF(iniv)=zvah(iniv)*zvp00
              BLF(iniv)=zvbh(iniv)
            enddo
C
C
          return
          end
