      SUBROUTINE REORCHA(X,IGR,IDOM
     +                  ,NDIM,NDIM1,NDIM2,NDIM3,NDIM4)
C
CCC
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type       : 3D semi-lagrangian transport scheme
C   Purpose    : Re-organize tracers arrays
C   Called by  : 
C
CCC
C
C  Original : P. Simon, 08/1999
C
CCC
C
	IMPLICIT NONE
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
C	
	INTEGER :: IDOM,NDIM,NDIM1,NDIM2,NDIM3,NDIM4
	REAL (KIND=8) , DIMENSION (NDIM) :: X
      INTEGER , DIMENSION (NDIM) :: IGR
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C	
      INTEGER :: N,N1,N2,N3,N4
	REAL (KIND=8) , ALLOCATABLE :: XAUX(:)
C
C
	ALLOCATE (XAUX(NDIM))
C	
      N1=0
      N2=NDIM1
      N3=NDIM1+NDIM2
      N4=NDIM1+NDIM2+NDIM3
C
      IF(IDOM.EQ.1) THEN
C
        DO 1 N=1,NDIM
           XAUX(N)=X(N)
 1      CONTINUE
C
      ELSEIF(IDOM.EQ.2) THEN
C
        DO 2 N=1,NDIM
           IF(IGR(N).EQ.1) THEN
             N1=N1+1
             XAUX(N)=X(N1)
           ELSEIF(IGR(N).EQ.2) THEN
             N2=N2+1
             XAUX(N)=X(N2)
           ENDIF
 2      CONTINUE
C
      ELSEIF(IDOM.EQ.3) THEN
C
        DO 3 N=1,NDIM
           IF(IGR(N).EQ.1) THEN
             N1=N1+1
             XAUX(N)=X(N1)
           ELSEIF(IGR(N).EQ.2) THEN
             N2=N2+1
             XAUX(N)=X(N2)
           ELSEIF(IGR(N).EQ.3) THEN
             N3=N3+1
             XAUX(N)=X(N3)
           ENDIF
 3      CONTINUE
C
      ELSEIF(IDOM.EQ.4) THEN
C
        DO 4 N=1,NDIM
           IF(IGR(N).EQ.1) THEN
             N1=N1+1
             XAUX(N)=X(N1)
           ELSEIF(IGR(N).EQ.2) THEN
             N2=N2+1
             XAUX(N)=X(N2)
           ELSEIF(IGR(N).EQ.3) THEN
             N3=N3+1
             XAUX(N)=X(N3)
           ELSEIF(IGR(N).EQ.4) THEN
             N4=N4+1
             XAUX(N)=X(N4)
           ENDIF
 4      CONTINUE
C
      ENDIF
C
      DO 5 N=1,NDIM
         X(N)=XAUX(N)
 5    CONTINUE
C
	DEALLOCATE (XAUX)
C
C
      RETURN
      END
