      SUBROUTINE REORPOS(X,Y,Z,P,IGR,IDOM
     +                  ,NDIM,NDIM1,NDIM2,NDIM3,NDIM4)
C
CCC
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type       : 3D semi-lagrangian transport scheme
C   Purpose    : Reorganize localizations arrays
C   Called by  :
C
C
CCC
C
C  Original : P. Simon, 08/1999
C
CCC
C
	IMPLICIT NONE
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
C
	INTEGER :: NDIM,NDIM1,NDIM2,NDIM3,NDIM4
	REAL (KIND=8) , DIMENSION (NDIM) :: X,Y,Z,P
	INTEGER , DIMENSION (NDIM) :: IGR
	INTEGER :: IDOM
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C
      INTEGER :: N,N1,N2,N3,N4
C	
	REAL (KIND=8), ALLOCATABLE :: X1(:),Y1(:),Z1(:),P1(:)
	REAL (KIND=8), ALLOCATABLE :: X2(:),Y2(:),Z2(:),P2(:)
	REAL (KIND=8), ALLOCATABLE :: X3(:),Y3(:),Z3(:),P3(:)
	REAL (KIND=8), ALLOCATABLE :: X4(:),Y4(:),Z4(:),P4(:)
C
C
C
        NDIM1=0
      NDIM2=0
      NDIM3=0
      NDIM4=0
C
      IF(IDOM.EQ.1) THEN
C
	ALLOCATE (X1(NDIM))
	ALLOCATE (Y1(NDIM))
	ALLOCATE (Z1(NDIM))
	ALLOCATE (P1(NDIM))
        NDIM1=NDIM
        NDIM2=0
        NDIM3=0
        NDIM4=0
        DO 11 N=1,NDIM
           X1(N)=X(N)
           Y1(N)=Y(N)
           Z1(N)=Z(N)
           P1(N)=P(N)
 11     CONTINUE
C
      ELSEIF(IDOM.EQ.2) THEN
C
	ALLOCATE (X1(NDIM))
	ALLOCATE (Y1(NDIM))
	ALLOCATE (Z1(NDIM))
	ALLOCATE (P1(NDIM))
	ALLOCATE (X2(NDIM))
	ALLOCATE (Y2(NDIM))
	ALLOCATE (Z2(NDIM))
	ALLOCATE (P2(NDIM))
        NDIM3=0
        NDIM4=0
        DO 12 N=1,NDIM
           IF(IGR(N).EQ.1) THEN
             NDIM1=NDIM1+1
             X1(NDIM1)=X(N)
             Y1(NDIM1)=Y(N)
             Z1(NDIM1)=Z(N)
             P1(NDIM1)=P(N)
           ELSEIF(IGR(N).EQ.2) THEN
             NDIM2=NDIM2+1
             X2(NDIM2)=X(N)
             Y2(NDIM2)=Y(N)
             Z2(NDIM2)=Z(N)
             P2(NDIM2)=P(N)
           ENDIF
 12     CONTINUE
C
      ELSEIF(IDOM.EQ.3) THEN
C
	ALLOCATE (X1(NDIM))
	ALLOCATE (Y1(NDIM))
	ALLOCATE (Z1(NDIM))
	ALLOCATE (P1(NDIM))
	ALLOCATE (X2(NDIM))
	ALLOCATE (Y2(NDIM))
	ALLOCATE (Z2(NDIM))
	ALLOCATE (P2(NDIM))
	ALLOCATE (X3(NDIM))
	ALLOCATE (Y3(NDIM))
	ALLOCATE (Z3(NDIM))
	ALLOCATE (P3(NDIM))
        NDIM4=0
        DO 13 N=1,NDIM
           IF(IGR(N).EQ.1) THEN
             NDIM1=NDIM1+1
             X1(NDIM1)=X(N)
             Y1(NDIM1)=Y(N)
             Z1(NDIM1)=Z(N)
             P1(NDIM1)=P(N)
           ELSEIF(IGR(N).EQ.2) THEN
             NDIM2=NDIM2+1
             X2(NDIM2)=X(N)
             Y2(NDIM2)=Y(N)
             Z2(NDIM2)=Z(N)
             P2(NDIM2)=P(N)
           ELSEIF(IGR(N).EQ.3) THEN
             NDIM3=NDIM3+1
             X3(NDIM3)=X(N)
             Y3(NDIM3)=Y(N)
             Z3(NDIM3)=Z(N)
             P3(NDIM3)=P(N)
           ENDIF
 13     CONTINUE
C
      ELSEIF(IDOM.EQ.4) THEN
C
	ALLOCATE (X1(NDIM))
	ALLOCATE (Y1(NDIM))
	ALLOCATE (Z1(NDIM))
	ALLOCATE (P1(NDIM))
	ALLOCATE (X2(NDIM))
	ALLOCATE (Y2(NDIM))
	ALLOCATE (Z2(NDIM))
	ALLOCATE (P2(NDIM))
	ALLOCATE (X3(NDIM))
	ALLOCATE (Y3(NDIM))
	ALLOCATE (Z3(NDIM))
	ALLOCATE (P3(NDIM))
	ALLOCATE (X4(NDIM))
	ALLOCATE (Y4(NDIM))
	ALLOCATE (Z4(NDIM))
	ALLOCATE (P4(NDIM))
        DO 14 N=1,NDIM
           IF(IGR(N).EQ.1) THEN
             NDIM1=NDIM1+1
             X1(NDIM1)=X(N)
             Y1(NDIM1)=Y(N)
             Z1(NDIM1)=Z(N)
             P1(NDIM1)=P(N)
           ELSEIF(IGR(N).EQ.2) THEN
             NDIM2=NDIM2+1
             X2(NDIM2)=X(N)
             Y2(NDIM2)=Y(N)
             Z2(NDIM2)=Z(N)
             P2(NDIM2)=P(N)
           ELSEIF(IGR(N).EQ.3) THEN
             NDIM3=NDIM3+1
             X3(NDIM3)=X(N)
             Y3(NDIM3)=Y(N)
             Z3(NDIM3)=Z(N)
             P3(NDIM3)=P(N)
           ELSEIF(IGR(N).EQ.4) THEN
             NDIM4=NDIM4+1
             X4(NDIM4)=X(N)
             Y4(NDIM4)=Y(N)
             Z4(NDIM4)=Z(N)
             P4(NDIM4)=P(N)
           ENDIF
 14     CONTINUE
C
      ENDIF
C
      DO 21 N=1,NDIM1
         N1=N
         X(N1)=X1(N)
         Y(N1)=Y1(N)
         Z(N1)=Z1(N)
         P(N1)=P1(N)
 21   CONTINUE
	DEALLOCATE (X1)
	DEALLOCATE (Y1)
	DEALLOCATE (Z1)
	DEALLOCATE (P1)
C
      IF (IDOM .GE. 2) THEN
          DO 22 N=1,NDIM2
            N2=N+NDIM1
            X(N2)=X2(N)
            Y(N2)=Y2(N)
            Z(N2)=Z2(N)
            P(N2)=P2(N)
 22       CONTINUE
	DEALLOCATE (X2)
	DEALLOCATE (Y2)
	DEALLOCATE (Z2)
	DEALLOCATE (P2)
      ENDIF
C
      IF (IDOM .GE. 3) THEN
          DO 23 N=1,NDIM3
            N3=N+NDIM1+NDIM2
            X(N3)=X3(N)
            Y(N3)=Y3(N)
            Z(N3)=Z3(N)
            P(N3)=P3(N)
 23       CONTINUE
	DEALLOCATE (X3)
	DEALLOCATE (Y3)
	DEALLOCATE (Z3)
	DEALLOCATE (P3)
      ENDIF
C
      IF (IDOM .EQ. 4) THEN
          DO 24 N=1,NDIM4
            N4=N+NDIM1+NDIM2+NDIM3
            X(N4)=X4(N)
            Y(N4)=Y4(N)
            Z(N4)=Z4(N)
            P(N4)=P4(N)
 24       CONTINUE
	DEALLOCATE (X4)
	DEALLOCATE (Y4)
	DEALLOCATE (Z4)
	DEALLOCATE (P4)
      ENDIF	
C
      RETURN
      END
