      SUBROUTINE SPATIAL_ANTHROP
C
CCCCC                                                                           
C                                                                               
C   Purpose : Spatialise anthropogenic emission                                 
C             according to the ARPEGE field PROP.URB                            
C             and to ESCOMPTE and AIRPARIF emissions                            
C             inventories (for localisation, not values)                        
C   __  __   _____   _____   _____   _____   _____                              
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|                             
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|                             
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|                             
C                                                                               
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE                             
C                                                                               
C   Centre National de Recherches Meteorologiques                               
C   Groupe de Modelisation de Grande Echelle et du Climat                       
C   Equipe de Recherches sur l'Atmosphere Moyenne                               
C                                                                               
CCCCC                                                                           
C                                                                               
C  Original : A. Dufour 02/2004                                                                                                                                
C  Modified : Herve Le Berre 06/2006                                                                  
C                                                                                    
      USE GRIDS_MOD
      USE MRAT_MOD
      USE FORS_MOD
      USE PARADI_MOD
      USE CSTES_MOD
C       	
      IMPLICIT NONE
C
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C                                                        
      INTEGER :: NLON,NLAT
      INTEGER :: INDXMIN,INDXMAX,INDYMIN,INDYMAX
      INTEGER :: ii,jj,hh,i,j,x,y,xx,yy,iesp,itrait,itra 
      REAL (KIND=8) :: LONMIN,LATMIN,PAS
      REAL (KIND=8) :: DIFFUS
      REAL (KIND=8) :: RESPATIAL
      CHARACTER(len=3)  :: source 
      CHARACTER(len=4)  :: esp 
      CHARACTER(len=4)  :: type
      CHARACTER(len=13) :: FIC_CADASTRE                                                                               
      REAL (KIND=8) , ALLOCATABLE :: EMEP(:,:,:) 
      REAL (KIND=8) , ALLOCATABLE :: FRA(:,:,:) 
      REAL (KIND=8) , ALLOCATABLE :: URB(:,:) 
      REAL (KIND=8) , ALLOCATABLE :: PROP(:,:) 
C                                                                               
C
      ALLOCATE (EMEP(LONM2,LATM2,0:NHOUR-1))
      ALLOCATE (FRA (LONM3,LATM3,0:NHOUR-1)) ; FRA(:,:,:) = 0.0
      ALLOCATE (PROP(LONM2,LATM2))
      ALLOCATE (URB(LONM3,LATM3))
C      
C     Calculs des indices de la grille EMEP05 correspondant
C     aux 4 coins de la grille FRAN01 (grille de calcul)
C
      INDXMIN=NINT( 1+(RLONF3(1)-RLONF2(1))/DRLONF2 )
      INDXMAX=NINT( 1+(RLONF3(LONM3)-RLONF2(1))/DRLONF2 )
      INDYMIN=NINT( 1+(RLATF3(1)-RLATF2(1))/DRLATF2 )
      INDYMAX=NINT( 1+(RLATF3(LATM3)-RLATF2(1))/DRLATF2 )
C      
      source='S00'
      esp='E005'
      type='WEEK'
C      
      DIFFUS=0.2
C                                                 
      RESPATIAL = 1. - DIFFUS
C                                                                               
      OPEN(UNIT=100,file='PROP.URBANIS_FRAN01',form='unformatted')
        READ(100) URB
      CLOSE(100)
C                                                                               
      DO iesp=1,NEMI2
C                                                                               
      IF ( (EMINAM2(iesp).NE.'ISO').AND.
     +(EMINAM2(iesp).NE.'API').AND.
     +(EMINAM3(iesp).NE.'LIM') ) THEN
C                                                                               
      itrait=0
      DO itra=1,NEMI3
        IF (EMINAM3(itra).EQ.EMINAM2(iesp)) itrait=itra
      ENDDO
C
      DO hh=0,NHOUR-1
C
      prop(:,:)=0.
C                                                                               
      DO i=1,LONM2
        DO j=1,LATM2
          EMEP(i,j,hh)=EM2D(i,j,iesp,hh)
        ENDDO
      ENDDO
C                                                                               
      DO i=INDXMIN,INDXMAX
      ii = i - INDXMIN + 1
        DO j=INDYMIN,INDYMAX
          jj = j - INDYMIN + 1
          DO x=1,5
            xx= (ii-1)*5 + x
            DO y=1,5
              yy= (jj-1)*5 + y
              prop(i,j)=prop(i,j)+URB(xx,yy)
              FRA(xx,yy,hh)=25*EMEP(i,j,hh)*URB(xx,yy)
            ENDDO
          ENDDO
          IF (prop(i,j).NE.0.) THEN
           DO x=1,5
            xx= (ii-1)*5 + x
            DO y=1,5
              yy= (jj-1)*5 + y
              FRA(xx,yy,hh)=DIFFUS*EMEP(i,j,hh) +
     + RESPATIAL*FRA(xx,yy,hh)/prop(i,j)
            ENDDO
           ENDDO
          ELSE
           DO x=1,5
            xx= (ii-1)*5 + x
            DO y=1,5
              yy= (jj-1)*5 + y
              FRA(xx,yy,hh)=EMEP(i,j,hh)
            ENDDO
           ENDDO
          ENDIF
        ENDDO
      ENDDO
C                                                                               
      ENDDO
C     enddo du hh=0,NHOUR
C
C                                                                               
C     definition du domaine PARIS
C
      FIC_CADASTRE=esp//source//type
      NLON=38
      NLAT=25
      LONMIN=0.6
      LATMIN=47.3
      PAS=0.1
C  
      CALL EMISHR(NLON,NLAT,LONMIN/CONV,LATMIN/CONV,PAS/CONV,
     &            FRA,FIC_CADASTRE)
C
C     definition du domaine ESCOMPTE
C
      FIC_CADASTRE='ES'//esp//source//type
      NLON=17
      NLAT=13
      LONMIN=4.5
      LATMIN=42.7
      PAS=0.1
C  
      CALL EMISHR(NLON,NLAT,LONMIN/CONV,LATMIN/CONV,PAS/CONV,
     &            FRA,FIC_CADASTRE)
C                                                                               
      DO hh=0,NHOUR-1
       DO i=1,LONM3
        DO j=1,LATM3
          EM3D(i,j,itrait,hh)=FRA(i,j,hh)
        ENDDO
       ENDDO
      ENDDO
C     enddo du hh=0,NHOUR                                                       
C                                                                               
      ENDIF
C     endif du iesp non biogenique                                              
C                                                                               
      ENDDO
C     enddo du iesp=1,NEMIEMEP
C                                                                                     
      DEALLOCATE (EMEP)
      DEALLOCATE (FRA)
      DEALLOCATE (PROP)
      DEALLOCATE (URB)
C
C
      RETURN
      END
