        MODULE SRC_MOD
C
C------------------------------------------------------------------------
C 	POINT SOURCES DEFINITION
C
C	AUTHOR	: B.Josse	- CNRM -
C	DATE		: 11/04/2006
C	VERSION	: 2_0_0
C------------------------------------------------------------------------
C
	IMPLICIT NONE



C POINT SOURCES DEFINITION : "ACCIDENT" VERSION
C
C NSRC      : NUMBER OF POINT SOURCES CONSIDERED (CURRENT MAX.:10)
C POLNAME   : POLLUTANTS NAME (CHARACTER*15) 
C HALFLIFE  : POLLUTANTS HALF-LIFE (s)
C VDEPOSIT  : POLLUTANTS FIXED DEPOSITION VELOCITY (m.s-1)
C MOLWEIGHT : POLLUTANTS MOLECULAR WEIGHT (g)
C PSOURCE   : (*,1) POINT SOURCE LONGITUDE
C             (*,2) POINT SOURCE LATITUDE
C             (*,3) POINT SOURCE RELEASE
C             (*,4) POINT SOURCE EXTENSION (TOP : > in Pa ; <0 in meters)
C             (*,5) POINT SOURCE EXTENSION (BOTTOM : > in Pa ; <0 in meters)
C EMIUNIT   : UNITY FOR RELEASE ('BQPERH','GRPERS' CHARACTER*6)
C IDATEMI1  : RELEASE START DATE (1 : Y ; 2 : M ; 3 : D ; 4 : H ; 5 : MIN)
C IDATEMI2  : RELEASE END DATE (1 : Y ; 2 : M ; 3 : D ; 4 : H ; 5 : MIN)
C IFSORACC* : LOGICAL UNITS FOR OUTPUTS ON DOMAINS 1, 2, 3 AND 4  
C IFINACC   : LOGICAL UNIT FOR POINT SOURCES NAMELIST
C
      INTEGER , SAVE :: NSRC
      INTEGER , SAVE :: IFINACC,IFSORACC1,IFSORACC2,IFSORACC3,IFSORACC4
      INTEGER , SAVE :: IFSORACCP1,IFSORACCP2,IFSORACCP3,IFSORACCP4
      INTEGER , SAVE :: IFSORACCZ1,IFSORACCZ2,IFSORACCZ3,IFSORACCZ4


      CHARACTER(LEN=6)  , ALLOCATABLE , SAVE :: EMIUNIT(:)
      CHARACTER(LEN=15) , ALLOCATABLE , SAVE :: POLNAME(:)
      INTEGER , ALLOCATABLE , SAVE :: IDATEMI1(:,:),IDATEMI2(:,:)
      REAL (KIND=8) , ALLOCATABLE , SAVE :: PSOURCE(:,:)
      REAL (KIND=8) , ALLOCATABLE , SAVE :: HALFLIFE(:)
      REAL (KIND=8) , ALLOCATABLE , SAVE :: VDEPOSIT(:)
      REAL (KIND=8) , ALLOCATABLE , SAVE :: MOLWEIGHT(:)
      LOGICAL , SAVE :: SRC
      CHARACTER(LEN=15) , ALLOCATABLE , SAVE :: IDENTSTAT(:)



      
	CONTAINS
C
	SUBROUTINE ALLOC_SRC

        USE PARADI_MOD
C
	ALLOCATE (EMIUNIT(NTRA1)) ; EMIUNIT(:) = "123456"
	ALLOCATE (POLNAME(NTRA1)) ; POLNAME(:) = "123456789 12345"
        ALLOCATE (IDENTSTAT(NTRA1)) ; IDENTSTAT(:) = "123456789 12345"
	ALLOCATE (IDATEMI1(NTRA1,5)) ; IDATEMI1(:,:) = 0
	ALLOCATE (IDATEMI2(NTRA1,5)) ; IDATEMI2(:,:) = 0
	ALLOCATE (PSOURCE(NTRA1,5)) ; PSOURCE(:,:) = 0.0
        ALLOCATE (HALFLIFE(NTRA1)) ; HALFLIFE(:) = 0.0
        ALLOCATE (VDEPOSIT(NTRA1)) ; VDEPOSIT(:) = 0.0
        ALLOCATE (MOLWEIGHT(NTRA1)) ; MOLWEIGHT(:) = 0




C
	END SUBROUTINE ALLOC_SRC
C
	SUBROUTINE DEALLOC_SRC
C
	DEALLOCATE (EMIUNIT)
	DEALLOCATE (POLNAME)
        DEALLOCATE (IDENTSTAT)
	DEALLOCATE (IDATEMI1)
	DEALLOCATE (IDATEMI2)
	DEALLOCATE (PSOURCE)
        DEALLOCATE (HALFLIFE)
        DEALLOCATE (VDEPOSIT)
        DEALLOCATE (MOLWEIGHT)


C
	END SUBROUTINE DEALLOC_SRC
C
	END MODULE SRC_MOD
