       MODULE SRCFLX_MOD
C
C TABLES FOR CUMULATED FLUXES (ACCIDENT VERSION)
C
C------------------------------------------------------------------------
C
C TABLES FOR CUMULATED FLUXES (ACCIDENT VERSION)
C	AUTHOR	: B.Josse	- CNRM -
C	DATE		: 11/04/2006
C	VERSION	: 2_0_0
C------------------------------------------------------------------------
C
      IMPLICIT NONE


C CONVECTIVE RAIN FLUXES (3D)
C
      REAL (KIND=8) , ALLOCATABLE , SAVE :: PCVRCUMUL1(:,:,:)
      REAL (KIND=8) , ALLOCATABLE , SAVE :: PCVRCUMUL2(:,:,:)
      REAL (KIND=8) , ALLOCATABLE , SAVE :: PCVRCUMUL3(:,:,:)
      REAL (KIND=8) , ALLOCATABLE , SAVE :: PCVRCUMUL4(:,:,:)
C
C CONVECTIVE SNOW FLUXES (3D)
C
      REAL(KIND=8) , ALLOCATABLE , SAVE ::  PCVSCUMUL1(:,:,:)
      REAL(KIND=8) , ALLOCATABLE , SAVE ::  PCVSCUMUL2(:,:,:)
      REAL(KIND=8) , ALLOCATABLE , SAVE ::  PCVSCUMUL3(:,:,:)
      REAL(KIND=8) , ALLOCATABLE , SAVE ::  PCVSCUMUL4(:,:,:)
C
C STRATIFORM RAIN+SNOW FLUXES (3D)
C
      REAL(KIND=8) , ALLOCATABLE , SAVE ::  PSTRCUMUL1(:,:,:)
      REAL(KIND=8) , ALLOCATABLE , SAVE ::  PSTRCUMUL2(:,:,:)
      REAL(KIND=8) , ALLOCATABLE , SAVE ::  PSTRCUMUL3(:,:,:)
      REAL(KIND=8) , ALLOCATABLE , SAVE ::  PSTRCUMUL4(:,:,:)
C
C WET SCAVENGING DEPOSITION FLUXES (BELOW CONVECTIVE CLOUDS)
C
      REAL(KIND=8) , ALLOCATABLE , SAVE ::  DFBCVCUMUL1(:,:,:)
      REAL(KIND=8) , ALLOCATABLE , SAVE ::  DFBCVCUMUL2(:,:,:)
      REAL(KIND=8) , ALLOCATABLE , SAVE ::  DFBCVCUMUL3(:,:,:)
      REAL(KIND=8) , ALLOCATABLE , SAVE ::  DFBCVCUMUL4(:,:,:)
C
C WET SCAVENGING DEPOSITION FLUXES (IN CONVECTIVE CLOUDS)
C
      REAL(KIND=8) , ALLOCATABLE , SAVE ::  DFICVCUMUL1(:,:,:)
      REAL(KIND=8) , ALLOCATABLE , SAVE ::  DFICVCUMUL2(:,:,:)
      REAL(KIND=8) , ALLOCATABLE , SAVE ::  DFICVCUMUL3(:,:,:)
      REAL(KIND=8) , ALLOCATABLE , SAVE ::  DFICVCUMUL4(:,:,:)
C
C WET DEPOSITION FLUXES (LARGE SCALE)
C
      REAL(KIND=8) , ALLOCATABLE , SAVE ::  DFSTRCUMUL1(:,:,:)
      REAL(KIND=8) , ALLOCATABLE , SAVE ::  DFSTRCUMUL2(:,:,:)
      REAL(KIND=8) , ALLOCATABLE , SAVE ::  DFSTRCUMUL3(:,:,:)
      REAL(KIND=8) , ALLOCATABLE , SAVE ::  DFSTRCUMUL4(:,:,:)
C
C DRY DEPOSITION FLUXES
C
      REAL(KIND=8) , ALLOCATABLE , SAVE ::  DFDRYCUMUL1(:,:,:)
      REAL(KIND=8) , ALLOCATABLE , SAVE ::  DFDRYCUMUL2(:,:,:)
      REAL(KIND=8) , ALLOCATABLE , SAVE ::  DFDRYCUMUL3(:,:,:)
      REAL(KIND=8) , ALLOCATABLE , SAVE ::  DFDRYCUMUL4(:,:,:)
C

      CONTAINS

      SUBROUTINE ALLOC_SRCFLX

       USE PARADI_MOD
C
      ALLOCATE( PCVRCUMUL1(LONM1,LATM1,NIVM1))
      ALLOCATE( PCVRCUMUL2(LONM2,LATM2,NIVM2))
      ALLOCATE( PCVRCUMUL3(LONM3,LATM3,NIVM3))
      ALLOCATE( PCVRCUMUL4(LONM4,LATM4,NIVM4))
C
      ALLOCATE( PCVSCUMUL1(LONM1,LATM1,NIVM1))
      ALLOCATE( PCVSCUMUL2(LONM2,LATM2,NIVM2))
      ALLOCATE( PCVSCUMUL3(LONM3,LATM3,NIVM3))
      ALLOCATE( PCVSCUMUL4(LONM4,LATM4,NIVM4))
C
      ALLOCATE( PSTRCUMUL1(LONM1,LATM1,NIVM1))
      ALLOCATE( PSTRCUMUL2(LONM2,LATM2,NIVM2))
      ALLOCATE( PSTRCUMUL3(LONM3,LATM3,NIVM3))
      ALLOCATE( PSTRCUMUL4(LONM4,LATM4,NIVM4))
C
      ALLOCATE( DFBCVCUMUL1(LONM1,LATM1,NTRA1))
      ALLOCATE( DFBCVCUMUL2(LONM2,LATM2,NTRA2))
      ALLOCATE( DFBCVCUMUL3(LONM3,LATM3,NTRA3))
      ALLOCATE( DFBCVCUMUL4(LONM4,LATM4,NTRA4))
C
      ALLOCATE( DFICVCUMUL1(LONM1,LATM1,NTRA1))
      ALLOCATE( DFICVCUMUL2(LONM2,LATM2,NTRA2))
      ALLOCATE( DFICVCUMUL3(LONM3,LATM3,NTRA3))
      ALLOCATE( DFICVCUMUL4(LONM4,LATM4,NTRA4))
C
      ALLOCATE( DFSTRCUMUL1(LONM1,LATM1,NTRA1))
      ALLOCATE( DFSTRCUMUL2(LONM2,LATM2,NTRA2))
      ALLOCATE( DFSTRCUMUL3(LONM3,LATM3,NTRA3))
      ALLOCATE( DFSTRCUMUL4(LONM4,LATM4,NTRA4))
C
      ALLOCATE( DFDRYCUMUL1(LONM1,LATM1,NTRA1))
      ALLOCATE( DFDRYCUMUL2(LONM2,LATM2,NTRA2))
      ALLOCATE( DFDRYCUMUL3(LONM3,LATM3,NTRA3))
      ALLOCATE( DFDRYCUMUL4(LONM4,LATM4,NTRA4))

	END SUBROUTINE ALLOC_SRCFLX
C
	SUBROUTINE DEALLOC_SRCFLX

      DEALLOCATE( PCVRCUMUL1)
      DEALLOCATE( PCVRCUMUL2)
      DEALLOCATE( PCVRCUMUL3)
      DEALLOCATE( PCVRCUMUL4)
C
      DEALLOCATE( PCVSCUMUL1)
      DEALLOCATE( PCVSCUMUL2)
      DEALLOCATE( PCVSCUMUL3)
      DEALLOCATE( PCVSCUMUL4)
C
      DEALLOCATE( PSTRCUMUL1)
      DEALLOCATE( PSTRCUMUL2)
      DEALLOCATE( PSTRCUMUL3)
      DEALLOCATE( PSTRCUMUL4)
C
      DEALLOCATE( DFBCVCUMUL1)
      DEALLOCATE( DFBCVCUMUL2)
      DEALLOCATE( DFBCVCUMUL3)
      DEALLOCATE( DFBCVCUMUL4)
C
      DEALLOCATE( DFICVCUMUL1)
      DEALLOCATE( DFICVCUMUL2)
      DEALLOCATE( DFICVCUMUL3)
      DEALLOCATE( DFICVCUMUL4)
C
      DEALLOCATE( DFSTRCUMUL1)
      DEALLOCATE( DFSTRCUMUL2)
      DEALLOCATE( DFSTRCUMUL3)
      DEALLOCATE( DFSTRCUMUL4)
C
      DEALLOCATE( DFDRYCUMUL1)
      DEALLOCATE( DFDRYCUMUL2)
      DEALLOCATE( DFDRYCUMUL3)
      DEALLOCATE( DFDRYCUMUL4)

      END SUBROUTINE DEALLOC_SRCFLX
C
	END MODULE SRCFLX_MOD


        

C
