      SUBROUTINE SURFLUX( daynum, idate0 )
C
CCC
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type       : I/O
C   Purpose    : Read-in surface forcings files "SM" (LFI format)
C                for regular grids. 
C   Called by  : MAIN
C
CCC
C
C  Original : V.-H. Peuch, 04/1999
C
C  Modified : V.-H. Peuch, 07/2002
C
CCC
C
	USE PARADI_MOD
	USE CSTES_MOD
	USE EXPE_MOD
	USE FORS_MOD
	USE MOCF_MOD
	USE MRAT_MOD
	USE UNDCOLMT_MOD
        USE GRIDS_MOD
C
	IMPLICIT NONE
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
C
	REAL (KIND=8) :: daynum
	INTEGER , DIMENSION(5) :: idate0		
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C
	INTEGER :: ITEST,ITRA,NBDAY,NBHOUR,IREP,IBARI,I,IHOUR,ILON
	INTEGER :: ityptr,itrunc,idgl,idlon,iflev
      INTEGER :: igrib,ibits,istron,ipuila
	REAL (KIND=8) , ALLOCATABLE  :: zf1(:,:),zf2(:,:)
	REAL (KIND=8) , ALLOCATABLE  :: zf3(:,:),zf4(:,:)
	REAL (KIND=8) , ALLOCATABLE  :: zvah(:),zvbh(:)
	REAL (KIND=8) , ALLOCATABLE  :: zgeom(:)
	INTEGER , ALLOCATABLE :: inlopa(:),inzopa(:)
	INTEGER , ALLOCATABLE :: idate(:),idate1(:),nbjour(:)
      REAL (KIND=8) :: zbeta,zclopo,zslopo,zcodil
      REAL (KIND=8) :: zvp00
      LOGICAL :: llgard,LDEXIS,ldcosp,SPAT_ANT
      CHARACTER(len=4) :: cdpref
      CHARACTER(len=6) :: cdpref2
      CHARACTER(len=19) :: clf1,clf2,clf3,clf4
C
C
	ALLOCATE (idate(11)) ; idate(:) = 0
	ALLOCATE (idate1(5)) ; idate1(:) = 0
	ALLOCATE (nbjour(12))
	ALLOCATE (zf1(LONM1,LATM1)) ; zf1(:,:) = 0.0
      ALLOCATE (zf2(LONM2,LATM2)) ; zf2(:,:) = 0.0
      ALLOCATE (zf3(LONM3,LATM3)) ; zf3(:,:) = 0.0
      ALLOCATE (zf4(LONM4,LATM4)) ; zf4(:,:) = 0.0
	ALLOCATE (zvah(0:JPMXLEV)) ; zvah(:) = 0.0
	ALLOCATE (zvbh(0:JPMXLEV)) ; zvbh(:) = 0.0
	ALLOCATE (zgeom(JPMXGL)) ; zgeom(:) = 0.0
	ALLOCATE (inlopa(JPMXGL)) ; inlopa(:) = 0
	ALLOCATE (inzopa(JPMXGL)) ; inzopa(:) = 0
C
      nbjour =(/31,28,31,30,31,30,31,31,30,31,30,31/)
C
      SPAT_ANT=.TRUE.
      IF (.NOT.TRANSINV) THEN
        itest=int(daynum)+idate0(4)*3600
      ELSE 
        itest=int(daynum)-idate0(4)*3600
      ENDIF 
      IF ((int(daynum).EQ.0).OR.
     $    (mod(itest, 86400).EQ.0)) THEN
C
CCC
C
      if (L1D) then
C
C 1D-version : TRANAM1,2,3,4 DO NOT EXIST
C
        if (IFLAG1) then
          DO itra=1,NTRA1
            TRANAM1(itra)=TRANAM1D(itra)
          ENDDO
          DO itra=1,NSLS1
            SLSNAM1(itra)=SLSNAM1D(itra)
          ENDDO
        endif
C
        if (IFLAG2) then
          DO itra=1,NTRA2
            TRANAM2(itra)=TRANAM1D(itra)
          ENDDO
          DO itra=1,NSLS2
            SLSNAM2(itra)=SLSNAM1D(itra)
          ENDDO
        endif
C
        if (IFLAG3) then
          DO itra=1,NTRA3
            TRANAM3(itra)=TRANAM1D(itra)
          ENDDO
          DO itra=1,NSLS3
            SLSNAM3(itra)=SLSNAM1D(itra)
          ENDDO
        endif
C
        if (IFLAG4) then
          DO itra=1,NTRA4
            TRANAM4(itra)=TRANAM1D(itra)
          ENDDO
          DO itra=1,NSLS4
            SLSNAM4(itra)=SLSNAM1D(itra)
          ENDDO
        endif
      endif
C
CCC
C
      NBDAY=int(daynum/86400.)
      NBHOUR=int((daynum-real(NBDAY)*86400.)/3600.)
C
      IF (.NOT.TRANSINV) THEN
        idate1(5)=0
        idate1(4)=idate0(4)+NBHOUR
        idate1(3)=idate0(3)+NBDAY
        idate1(2)=idate0(2)
        idate1(1)=idate0(1)
        IF (idate1(4).GE.24) THEN
          idate1(4)=idate1(4)-24
          idate1(3)=idate1(3)+1
        ENDIF
        IF (mod(idate0(1),4).EQ.0) THEN
          nbjour(2)=29
        ENDIF
        IF (idate1(3).GT.nbjour(idate1(2))) THEN
          idate1(3)=idate1(3)-nbjour(idate1(2))
          idate1(2)=idate1(2)+1
        ENDIF
        IF (idate1(2).GT.12) THEN
          idate1(1)=idate1(1)+1
          idate1(2)=1
        ENDIF
      ELSE
        idate1(5)=0
        idate1(4)=idate0(4)-NBHOUR
        idate1(3)=idate0(3)-NBDAY
        idate1(2)=idate0(2)
        idate1(1)=idate0(1)
        IF (idate1(4).LE.0) THEN
          idate1(4)=idate1(4)+24
          idate1(3)=idate1(3)-1
        ENDIF 
        IF (mod(idate0(1),4).EQ.0) THEN
          nbjour(2)=29
        ENDIF 
        IF (idate1(3).GT.nbjour(idate1(2))) THEN
          idate1(3)=idate1(3)-nbjour(idate1(2))
          idate1(2)=idate1(2)+1
        ENDIF 
        IF (idate1(3).LE.0) THEN
          idate1(2)=idate1(2)-1
        ENDIF 
        IF (idate1(2).LE.0) THEN
          idate1(1)=idate1(1)-1
          idate1(2)=12
        ENDIF 
        IF (idate1(2).GT.12) THEN
          idate1(1)=idate1(1)+1
          idate1(2)=1
        ENDIF 
        IF (idate1(3).LE.0) THEN
          idate1(3)=idate1(3)+nbjour(idate1(2))
        ENDIF
      ENDIF
C
C 1. DETERMINE FILE NAMES
C
      write(clf1,fmt='(''SM'',A6,''+'',I4.4,I2.2,I2.2)')
     +      NAMDOM1,idate1(1),idate1(2),idate1(3)
      write(clf2,fmt='(''SM'',A6,''+'',I4.4,I2.2,I2.2)')
     +      NAMDOM2,idate1(1),idate1(2),idate1(3)
      write(clf3,fmt='(''SM'',A6,''+'',I4.4,I2.2,I2.2)')
     +      NAMDOM3,idate1(1),idate1(2),idate1(3)
      write(clf4,fmt='(''SM'',A6,''+'',I4.4,I2.2,I2.2)')
     +      NAMDOM4,idate1(1),idate1(2),idate1(3)
C
C 1. GLOBAL GRID (M1)
C
      if (IFLAG1) then
C
        print*,'READING SURFACE FORCING FILE :',clf1
        call faitou(irep,IFSFX1,.true.,clf1,'OLD',.true.,
     +             .false.,0,0,ibari,CHEMSCHEME)
C
C CHECK VALID DATE
C
        call fadies(irep,IFSFX1,idate)
C
        do i=1,3
          if(idate(i).NE.idate1(i)) then
            print*,' WRONG DATE FOR SURFACE FILE (SM1) : ABORT!'
            CALL MOCAGE_STOP
          endif
        enddo
C
C CHECK GEOMETRY
C
        call facies(CHEMSCHEME,ityptr,zbeta,zclopo,zslopo,
     +            zcodil,itrunc,idgl,idlon,inlopa,
     +            inzopa,zgeom,iflev,zvp00,zvah,
     +            zvbh,llgard)

        if (     (idgl.NE.LATM1)
     +       .OR.(idlon.NE.LONM1)    ) then
          print*,' INVALID SURFACE FORCING FILE (SM1) : ABORT!'
          CALL MOCAGE_STOP
        endif
C
C READ-IN DATA
C
C MODEL OROGRAPHY
C
      call facile(irep,IFSFX1,"SURF",1,
     &              "GEOPOTENTIEL",GZ0M1,.FALSE.)
C
      do ihour=0,NHOUR-1
        if (ihour.LE.9) then
          write(cdpref2,fmt='(''SF0'',I1)')ihour
        else
          write(cdpref2,fmt='(''SF'',I2)')ihour
        endif
C
C SURFACE INSTANTANEOUS EVAPORATION (kg/s)
C
        call facile(irep,IFSFX1,cdpref2,1,
     &              "EVAP",zf1,.FALSE.)
        do ilon=1,LOLAM1
          EV1D(ilon,1,ihour)=zf1(ilon,1)
        enddo
C
C SURFACE ALBEDO
C
        call facile(irep,IFSFX1,cdpref2,1,
     &              "ALBE",zf1,.FALSE.)
        do ilon=1,LOLAM1
          XALBSM1D(ilon,1,ihour)=zf1(ilon,1)
        enddo
C
C CLOUDINESS - HIGH LEVEL
C
        call facile(irep,IFSFX1,cdpref2,1,
     &              "CCHI",zf1,.FALSE.)
        do ilon=1,LOLAM1
          CCHI1D(ilon,1,ihour)=zf1(ilon,1)
        enddo
C
C CLOUDINESS - MEDIUM LEVEL
C
        call facile(irep,IFSFX1,cdpref2,1,
     &              "CCME",zf1,.FALSE.)
        do ilon=1,LOLAM1
          CCME1D(ilon,1,ihour)=zf1(ilon,1)
        enddo
C
C CLOUDINESS - LOW LEVEL
C
        call facile(irep,IFSFX1,cdpref2,1,
     &              "CCLO",zf1,.FALSE.)
        do ilon=1,LOLAM1
          CCLO1D(ilon,1,ihour)=zf1(ilon,1)
        enddo
C
C CLOUDINESS - CONVECTIVE
C
        call facile(irep,IFSFX1,cdpref2,1,
     &              "CCCO",zf1,.FALSE.)
        do ilon=1,LOLAM1
          CCCO1D(ilon,1,ihour)=zf1(ilon,1)
        enddo
C
C RAIN - LARGE-SCALE
C
        call facile(irep,IFSFX1,cdpref2,1,
     &              "PWAL",zf1,.FALSE.)
        do ilon=1,LOLAM1
          PWAL1D(ilon,1,ihour)=zf1(ilon,1)
        enddo
C
C RAIN - CONVECTIVE
C
        call facile(irep,IFSFX1,cdpref2,1,
     &              "PWAC",zf1,.FALSE.)
        do ilon=1,LOLAM1
          PWAC1D(ilon,1,ihour)=zf1(ilon,1)
        enddo
C
C SNOW - LARGE-SCALE
C
        call facile(irep,IFSFX1,cdpref2,1,
     &              "PSNL",zf1,.FALSE.)
        do ilon=1,LOLAM1
          PSNL1D(ilon,1,ihour)=zf1(ilon,1)
        enddo
C
C SNOW - CONVECTIVE
C
        call facile(irep,IFSFX1,cdpref2,1,
     &              "PSNC",zf1,.FALSE.)
        do ilon=1,LOLAM1
          PSNC1D(ilon,1,ihour)=zf1(ilon,1)
        enddo
      enddo
      do ilon=1,LOLAM1
        EV1D(ilon,1,NHOUR)=EV1D(ilon,1,NHOUR-1)
      enddo
      
#ifndef ACCIDENT
C
C SURFACE EMISSIONS (molec/cell/s)
C
      do ihour=0,NHOUR-1
        if (ihour.LE.9) then
          write(cdpref,fmt='(''EM0'',I1)')ihour
        else
          write(cdpref,fmt='(''EM'',I2)')ihour
        endif
        do itra=1,NEMI1
          call facile(irep,IFSFX1,cdpref,0,
     &                EMINAM1(itra),zf1,.FALSE.)
          do ilon=1,LOLAM1
            EM1D(ilon,1,itra,ihour)=zf1(ilon,1)
          enddo
        enddo
      enddo
      do ilon=1,LOLAM1*NEMI1
        EM1D(ilon,1,1,NHOUR)=EM1D(ilon,1,1,NHOUR-1)
      enddo 
C
C DEPOSITION VELOCITIES (m/s)
C
      do ihour=0,NHOUR-1
        if (ihour.LE.9) then
          write(cdpref,fmt='(''DV0'',I1)')ihour
        else
          write(cdpref,fmt='(''DV'',I2)')ihour
        endif
        do itra=1,NDEP1
          call facile(irep,IFSFX1,cdpref,0,
     &                DEPNAM1(itra),zf1,.FALSE.)
          do ilon=1,LOLAM1
            VD1D(ilon,1,itra,ihour)=zf1(ilon,1)
          enddo
        enddo
      enddo 
      do ilon=1,LOLAM1*NDEP1
        VD1D(ilon,1,1,NHOUR)=VD1D(ilon,1,1,NHOUR-1)
      enddo
C
#endif
      call fairme(irep,IFSFX1,'OLD')
C
      endif
C
C 2. CONTINENTAL GRID (M2)
C
      if (IFLAG2) then
C
        print*,'READING SURFACE FORCING FILE :',clf2
        call faitou(irep,IFSFX2,.true.,clf2,'OLD',.true.,
     +             .false.,0,0,ibari,CHEMSCHEME)
C
C CHECK VALID DATE
C
        call fadies(irep,IFSFX2,idate)
C
C
        do i=1,3
          if(idate(i).NE.idate1(i)) then
            print*,' WRONG DATE FOR SURFACE FILE (SM2) : ABORT!'
            CALL MOCAGE_STOP
          endif
        enddo
C
C CHECK GEOMETRY
C
        call facies(CHEMSCHEME,ityptr,zbeta,zclopo,zslopo,
     +            zcodil,itrunc,idgl,idlon,inlopa,
     +            inzopa,zgeom,iflev,zvp00,zvah,
     +            zvbh,llgard)

        if (     (idgl.NE.LATM2)
     +       .OR.(idlon.NE.LONM2)    ) then
          print*,' INVALID SURFACE FORCING FILE (SM2) : ABORT!'
          CALL MOCAGE_STOP
        endif
C
C READ-IN DATA
C
C MODEL OROGRAPHY
C
      call facile(irep,IFSFX2,"SURF",1,
     &              "GEOPOTENTIEL",GZ0M2,.FALSE.)
C
      do ihour=0,NHOUR-1
        if (ihour.LE.9) then
          write(cdpref2,fmt='(''SF0'',I1)')ihour
        else
          write(cdpref2,fmt='(''SF'',I2)')ihour
        endif
C
C SURFACE INSTANTANEOUS EVAPORATION (kg/s)
C
        call facile(irep,IFSFX2,cdpref2,1,
     &              "EVAP",zf2,.FALSE.)
        do ilon=1,LOLAM2
            EV2D(ilon,1,ihour)=zf2(ilon,1)
        enddo
C
C SURFACE ALBEDO
C
        call facile(irep,IFSFX2,cdpref2,1,
     &              "ALBE",zf2,.FALSE.)
        do ilon=1,LOLAM2
          XALBSM2D(ilon,1,ihour)=zf2(ilon,1)
        enddo
C
C CLOUDINESS - HIGH LEVEL
C
        call facile(irep,IFSFX2,cdpref2,1,
     &              "CCHI",zf2,.FALSE.)
        do ilon=1,LOLAM2
          CCHI2D(ilon,1,ihour)=zf2(ilon,1)
        enddo
C
C CLOUDINESS - MEDIUM LEVEL
C
        call facile(irep,IFSFX2,cdpref2,1,
     &              "CCME",zf2,.FALSE.)
        do ilon=1,LOLAM2
          CCME2D(ilon,1,ihour)=zf2(ilon,1)
        enddo
C
C CLOUDINESS - LOW LEVEL
C
        call facile(irep,IFSFX2,cdpref2,1,
     &              "CCLO",zf2,.FALSE.)
        do ilon=1,LOLAM2
          CCLO2D(ilon,1,ihour)=zf2(ilon,1)
        enddo
C
C CLOUDINESS - CONVECTIVE
C
        call facile(irep,IFSFX2,cdpref2,1,
     &              "CCCO",zf2,.FALSE.)
        do ilon=1,LOLAM2
          CCCO2D(ilon,1,ihour)=zf2(ilon,1)
        enddo
C
C RAIN - LARGE-SCALE
C
        call facile(irep,IFSFX2,cdpref2,1,
     &              "PWAL",zf2,.FALSE.)
        do ilon=1,LOLAM2
          PWAL2D(ilon,1,ihour)=zf2(ilon,1)
        enddo
C
C RAIN - CONVECTIVE
C
        call facile(irep,IFSFX2,cdpref2,1,
     &              "PWAC",zf2,.FALSE.)
        do ilon=1,LOLAM2
          PWAC2D(ilon,1,ihour)=zf2(ilon,1)
        enddo
C
C SNOW - LARGE-SCALE
C
        call facile(irep,IFSFX2,cdpref2,1,
     &              "PSNL",zf2,.FALSE.)
        do ilon=1,LOLAM2
          PSNL2D(ilon,1,ihour)=zf2(ilon,1)
        enddo
C
C SNOW - CONVECTIVE
C
        call facile(irep,IFSFX2,cdpref2,1,
     &              "PSNC",zf2,.FALSE.)
        do ilon=1,LOLAM2
          PSNC2D(ilon,1,ihour)=zf2(ilon,1)
        enddo
      enddo
      do ilon=1,LOLAM2
        EV2D(ilon,1,NHOUR)=EV2D(ilon,1,NHOUR-1)
      enddo
      
#ifndef ACCIDENT
C
C SURFACE EMISSIONS (molec/cell/s)
C
      do ihour=0,NHOUR-1
        if (ihour.LE.9) then
          write(cdpref,fmt='(''EM0'',I1)')ihour
        else
          write(cdpref,fmt='(''EM'',I2)')ihour
        endif
        do itra=1,NEMI2
          call facile(irep,IFSFX2,cdpref,0,
     &                EMINAM2(itra),zf2,.FALSE.)
          do ilon=1,LOLAM2
            EM2D(ilon,1,itra,ihour)=zf2(ilon,1)
          enddo
        enddo
      enddo

      IF (NAMDOM2.EQ.'EMEP05') THEN 

       CALL DECALPIC(LONM2,LATM2,NEMI2,NHOUR,RLONM2,RLATM2,
     +               EMINAM2,EM2D)
       CALL MINIMPARIS(LONM2,LATM2,NEMI2,NHOUR,RLONM2,RLATM2,
     +                 EMINAM2,EM2D)
      ENDIF



      do ilon=1,LOLAM2*NEMI2
        EM2D(ilon,1,1,NHOUR)=EM2D(ilon,1,1,NHOUR-1)
      enddo
C
C DEPOSITION VELOCITIES (m/s)
C
      do ihour=0,NHOUR-1
        if (ihour.LE.9) then
          write(cdpref,fmt='(''DV0'',I1)')ihour
        else
          write(cdpref,fmt='(''DV'',I2)')ihour
        endif
        do itra=1,NDEP2
          call facile(irep,IFSFX2,cdpref,0,
     &                DEPNAM2(itra),zf2,.FALSE.)
          do ilon=1,LOLAM2
            VD2D(ilon,1,itra,ihour)=zf2(ilon,1)
          enddo
        enddo
      enddo
      do ilon=1,LOLAM2*NDEP2
        VD2D(ilon,1,1,NHOUR)=VD2D(ilon,1,1,NHOUR-1)
      enddo
C
      call fairme(irep,IFSFX2,'OLD')
C
#endif
      endif
C
C 3. REGIONAL GRID (M3)
C
      if (IFLAG3) then
C
        print*,'READING SURFACE FORCING FILE :',clf3
        call faitou(irep,IFSFX3,.true.,clf3,'OLD',.true.,
     +             .false.,0,0,ibari,CHEMSCHEME)
C
C CHECK VALID DATE
C
        call fadies(irep,IFSFX3,idate)
C
        do i=1,3
          if(idate(i).NE.idate1(i)) then
            print*,' WRONG DATE FOR SURFACE FILE (SM3) : ABORT!'
            CALL MOCAGE_STOP
          endif
        enddo
C
C CHECK GEOMETRY
C
        call facies(CHEMSCHEME,ityptr,zbeta,zclopo,zslopo,
     +            zcodil,itrunc,idgl,idlon,inlopa,
     +            inzopa,zgeom,iflev,zvp00,zvah,
     +            zvbh,llgard)

        if (     (idgl.NE.LATM3)
     +       .OR.(idlon.NE.LONM3)    ) then
          print*,' INVALID SURFACE FORCING FILE (SM3) : ABORT!'
          CALL MOCAGE_STOP
        endif
C
C READ-IN DATA
C
C MODEL OROGRAPHY
C
      call facile(irep,IFSFX3,"SURF",1,
     &              "GEOPOTENTIEL",GZ0M3,.FALSE.)
C
      do ihour=0,NHOUR-1
        if (ihour.LE.9) then
          write(cdpref2,fmt='(''SF0'',I1)')ihour
        else
          write(cdpref2,fmt='(''SF'',I2)')ihour
        endif
C
C SURFACE INSTANTANEOUS EVAPORATION (kg/s)
C
        call facile(irep,IFSFX3,cdpref2,1,
     &              "EVAP",zf3,.FALSE.)
        do ilon=1,LOLAM3
            EV3D(ilon,1,ihour)=zf3(ilon,1)
        enddo
C
C SURFACE ALBEDO
C
        call facile(irep,IFSFX3,cdpref2,1,
     &              "ALBE",zf3,.FALSE.)
        do ilon=1,LOLAM3
          XALBSM3D(ilon,1,ihour)=zf3(ilon,1)
        enddo
C
C CLOUDINESS - HIGH LEVEL
C
        call facile(irep,IFSFX3,cdpref2,1,
     &              "CCHI",zf3,.FALSE.)
        do ilon=1,LOLAM3
          CCHI3D(ilon,1,ihour)=zf3(ilon,1)
        enddo
C
C CLOUDINESS - MEDIUM LEVEL
C
        call facile(irep,IFSFX3,cdpref2,1,
     &              "CCME",zf3,.FALSE.)
        do ilon=1,LOLAM3
          CCME3D(ilon,1,ihour)=zf3(ilon,1)
        enddo
C
C CLOUDINESS - LOW LEVEL
C
        call facile(irep,IFSFX3,cdpref2,1,
     &              "CCLO",zf3,.FALSE.)
        do ilon=1,LOLAM3
          CCLO3D(ilon,1,ihour)=zf3(ilon,1)
        enddo
C
C CLOUDINESS - CONVECTIVE
C
        call facile(irep,IFSFX3,cdpref2,1,
     &              "CCCO",zf3,.FALSE.)
        do ilon=1,LOLAM3
          CCCO3D(ilon,1,ihour)=zf3(ilon,1)
        enddo
C
C RAIN - LARGE-SCALE
C
        call facile(irep,IFSFX3,cdpref2,1,
     &              "PWAL",zf3,.FALSE.)
        do ilon=1,LOLAM3
          PWAL3D(ilon,1,ihour)=zf3(ilon,1)
        enddo
C
C RAIN - CONVECTIVE
C
        call facile(irep,IFSFX3,cdpref2,1,
     &              "PWAC",zf3,.FALSE.)
        do ilon=1,LOLAM3
          PWAC3D(ilon,1,ihour)=zf3(ilon,1)
        enddo
C
C SNOW - LARGE-SCALE
C
        call facile(irep,IFSFX3,cdpref2,1,
     &              "PSNL",zf3,.FALSE.)
        do ilon=1,LOLAM3
          PSNL3D(ilon,1,ihour)=zf3(ilon,1)
        enddo
C
C SNOW - CONVECTIVE
C
        call facile(irep,IFSFX3,cdpref2,1,
     &              "PSNC",zf3,.FALSE.)
        do ilon=1,LOLAM3
          PSNC3D(ilon,1,ihour)=zf3(ilon,1)
        enddo
      enddo
      do ilon=1,LOLAM3
        EV3D(ilon,1,NHOUR)=EV3D(ilon,1,NHOUR-1)
      enddo
#ifndef ACCIDENT
C
C SURFACE EMISSIONS (molec/cell/s)
C
      do ihour=0,NHOUR-1
        if (ihour.LE.9) then
          write(cdpref,fmt='(''EM0'',I1)')ihour
        else
          write(cdpref,fmt='(''EM'',I2)')ihour
        endif
        do itra=1,NEMI3
          call facile(irep,IFSFX3,cdpref,0,
     &                EMINAM3(itra),zf3,.FALSE.)
          do ilon=1,LOLAM3
            EM3D(ilon,1,itra,ihour)=zf3(ilon,1)
          enddo
        enddo
      enddo
C                                                                               
C TAKE HIGH RESOLUTION SPATIAL DISTRIBUTIONS INTO ACCOUNT                       
C                                                                               
      if (SPAT_ANT) then        
       if (NAMDOM3.EQ.'FRAN01') THEN              
           CALL SPATIAL_ANTHROP     
       endif           
      endif               
C
      do ilon=1,LOLAM3*NEMI3
        EM3D(ilon,1,1,NHOUR)=EM3D(ilon,1,1,NHOUR-1)
      enddo
C
C DEPOSITION VELOCITIES (m/s)
C
      do ihour=0,NHOUR-1
        if (ihour.LE.9) then
          write(cdpref,fmt='(''DV0'',I1)')ihour
        else
          write(cdpref,fmt='(''DV'',I2)')ihour
        endif
        do itra=1,NDEP3
          call facile(irep,IFSFX3,cdpref,0,
     &                DEPNAM3(itra),zf3,.FALSE.)
          do ilon=1,LOLAM3
            VD3D(ilon,1,itra,ihour)=zf3(ilon,1)
          enddo
        enddo
      enddo
      do ilon=1,LOLAM3*NDEP3
        VD3D(ilon,1,1,NHOUR)=VD3D(ilon,1,1,NHOUR-1)
      enddo
C
#endif
      call fairme(irep,IFSFX3,'OLD')
C
      endif
C
C 4. ZOOM GRID (M4)
C
      if (IFLAG4) then
C
        print*,'READING SURFACE FORCING FILE :',clf4
        call faitou(irep,IFSFX4,.true.,clf4,'OLD',.true.,
     +             .false.,0,0,ibari,CHEMSCHEME)
C
C CHECK VALID DATE
C
        call fadies(irep,IFSFX4,idate)
C
        do i=1,3
          if(idate(i).NE.idate1(i)) then
            print*,' WRONG DATE FOR SURFACE FILE (SM4) : ABORT!'
            CALL MOCAGE_STOP
          endif
        enddo
C
C CHECK GEOMETRY
C
        call facies(CHEMSCHEME,ityptr,zbeta,zclopo,zslopo,
     +            zcodil,itrunc,idgl,idlon,inlopa,
     +            inzopa,zgeom,iflev,zvp00,zvah,
     +            zvbh,llgard)

        if (     (idgl.NE.LATM4)
     +       .OR.(idlon.NE.LONM4)    ) then
          print*,' INVALID SURFACE FORCING FILE (SM4) : ABORT!'
          CALL MOCAGE_STOP
        endif
C
C READ-IN DATA
C
C MODEL OROGRAPHY
C
      call facile(irep,IFSFX4,"SURF",1,
     &              "GEOPOTENTIEL",GZ0M4,.FALSE.)
C
      do ihour=0,NHOUR-1
        if (ihour.LE.9) then
          write(cdpref2,fmt='(''SF0'',I1)')ihour
        else
          write(cdpref2,fmt='(''SF'',I2)')ihour
        endif
C
C SURFACE INSTANTANEOUS EVAPORATION (kg/s)
C
        call facile(irep,IFSFX4,cdpref2,1,
     &              "EVAP",zf4,.FALSE.)
        do ilon=1,LOLAM4
            EV4D(ilon,1,ihour)=zf4(ilon,1)
        enddo
C
C SURFACE ALBEDO
C
        call facile(irep,IFSFX4,cdpref2,1,
     &              "ALBE",zf4,.FALSE.)
        do ilon=1,LOLAM4
          XALBSM4D(ilon,1,ihour)=zf4(ilon,1)
        enddo
C
C CLOUDINESS - HIGH LEVEL
C
        call facile(irep,IFSFX4,cdpref2,1,
     &              "CCHI",zf4,.FALSE.)
        do ilon=1,LOLAM4
          CCHI4D(ilon,1,ihour)=zf4(ilon,1)
        enddo
C
C CLOUDINESS - MEDIUM LEVEL
C
        call facile(irep,IFSFX4,cdpref2,1,
     &              "CCME",zf4,.FALSE.)
        do ilon=1,LOLAM4
          CCME4D(ilon,1,ihour)=zf4(ilon,1)
        enddo
C
C CLOUDINESS - LOW LEVEL
C
        call facile(irep,IFSFX4,cdpref2,1,
     &              "CCLO",zf4,.FALSE.)
        do ilon=1,LOLAM4
          CCLO4D(ilon,1,ihour)=zf4(ilon,1)
        enddo
C
C CLOUDINESS - CONVECTIVE
C
        call facile(irep,IFSFX4,cdpref2,1,
     &              "CCCO",zf4,.FALSE.)
        do ilon=1,LOLAM4
          CCCO4D(ilon,1,ihour)=zf4(ilon,1)
        enddo
C
C RAIN - LARGE-SCALE
C
        call facile(irep,IFSFX4,cdpref2,1,
     &              "PWAL",zf4,.FALSE.)
        do ilon=1,LOLAM4
          PWAL4D(ilon,1,ihour)=zf4(ilon,1)
        enddo
C
C RAIN - CONVECTIVE
C
        call facile(irep,IFSFX4,cdpref2,1,
     &              "PWAC",zf4,.FALSE.)
        do ilon=1,LOLAM4
          PWAC4D(ilon,1,ihour)=zf4(ilon,1)
        enddo
C
C SNOW - LARGE-SCALE
C
        call facile(irep,IFSFX4,cdpref2,1,
     &              "PSNL",zf4,.FALSE.)
        do ilon=1,LOLAM4
          PSNL4D(ilon,1,ihour)=zf4(ilon,1)
        enddo
C
C SNOW - CONVECTIVE
C
        call facile(irep,IFSFX4,cdpref2,1,
     &              "PSNC",zf4,.FALSE.)
        do ilon=1,LOLAM4
          PSNC4D(ilon,1,ihour)=zf4(ilon,1)
        enddo
      enddo
      do ilon=1,LOLAM4
        EV4D(ilon,1,NHOUR)=EV4D(ilon,1,NHOUR-1)
      enddo
      
#ifndef ACCIDENT
C
C SURFACE EMISSIONS (molec/cell/s)
C
      do ihour=0,NHOUR-1
        if (ihour.LE.9) then
          write(cdpref,fmt='(''EM0'',I1)')ihour
        else
          write(cdpref,fmt='(''EM'',I2)')ihour
        endif
        do itra=1,NEMI4
          call facile(irep,IFSFX4,cdpref,0,
     &                EMINAM4(itra),zf4,.FALSE.)
          do ilon=1,LOLAM4
            EM4D(ilon,1,itra,ihour)=zf4(ilon,1)
          enddo
        enddo
      enddo
      do ilon=1,LOLAM4*NEMI4
        EM4D(ilon,1,1,NHOUR)=EM4D(ilon,1,1,NHOUR-1)
      enddo
C
C DEPOSITION VELOCITIES (m/s)
C
      do ihour=0,NHOUR-1
        if (ihour.LE.9) then
          write(cdpref,fmt='(''DV0'',I1)')ihour
        else
          write(cdpref,fmt='(''DV'',I2)')ihour
        endif
        do itra=1,NDEP4
          call facile(irep,IFSFX4,cdpref,0,
     &                DEPNAM4(itra),zf4,.FALSE.)
          do ilon=1,LOLAM4
            VD4D(ilon,1,itra,ihour)=zf4(ilon,1)
          enddo
        enddo
      enddo
      do ilon=1,LOLAM4*NDEP4
        VD4D(ilon,1,1,NHOUR)=VD4D(ilon,1,1,NHOUR-1)
      enddo
C
#endif
      call fairme(irep,IFSFX4,'OLD')
C
      endif
C
CCC
C
      ENDIF
C	
	DEALLOCATE (idate)
	DEALLOCATE (idate1)
	DEALLOCATE (nbjour)
	DEALLOCATE (zf1)
	DEALLOCATE (zf2)
	DEALLOCATE (zf3)
	DEALLOCATE (zf4)
	DEALLOCATE (zvah)
	DEALLOCATE (zvbh)
	DEALLOCATE (zgeom)
	DEALLOCATE (inlopa)
	DEALLOCATE (inzopa)
      RETURN
      END
