      SUBROUTINE TCVCONV(LON,LAT,NIV,NTRA,
     +                 SURFM,
     +                 PL,PLT2,PSOL,EJ1,
     +                 U3D,V3D,T3D,Q3D,DIVQ3D,DIVU3D,
     +                 QQQM,LPFLX,SPFLX,
     +                 ICALCONV,BIGG,IBIGIP)
C
CCC
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type      : Convection and Diffusion (Tiedtke/Louis) 
C   Purpose   : Interface
C   Called by : 
C
CCC
C
C  Original : B.Josse, P.Simon, 05/1999
C
C  Modified : B.Josse, V.-H.Peuch (inclusion dans MOCAGE), 05/1999
C
CCC
C
	USE EXPE_MOD
	USE CSTES_MOD
C
	IMPLICIT NONE
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
C
      INTEGER :: LON,LAT,NIV,NTRA
	REAL (KIND=8) , DIMENSION (LON,LAT) :: SURFM,PSOL,EJ1
	REAL (KIND=8) , DIMENSION (LON,LAT,NIV) :: PL,PLT2,U3D,V3D
	REAL (KIND=8) , DIMENSION (LON,LAT,NIV) :: T3D,Q3D
	REAL (KIND=8) , DIMENSION (LON,LAT,NIV) :: SPFLX,LPFLX,IBIGIP	
      REAL (KIND=8) , DIMENSION (LON,LAT,NIV) :: DIVQ3D,DIVU3D
      REAL (KIND=8) , DIMENSION (LON,LAT,NIV,NTRA) :: QQQM
      REAL (KIND=8) , DIMENSION (LON,LAT,NIV,NIV) :: BIGG
      LOGICAL :: ICALCONV
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C		
      INTEGER :: J,IDEB,IFIN,JDEB,JFIN,LDEB,LFIN,ILON,ILAT
	REAL (KIND=8) , ALLOCATABLE :: PLT(:,:,:)
C     switches for model
      LOGICAL :: LCONV,LVDIF
      PARAMETER (LCONV=.TRUE.,LVDIF=.TRUE.)       
C
C
	ALLOCATE (PLT(LON,LAT,0:NIV))
C	
      IF (ICALCONV) THEN
      DO ilon=1,LON*LAT*NIV*NIV
        BIGG(ilon,1,1,1)=0.
      ENDDO
      DO ilon=1,LON*LAT*NIV
        IBIGIP(ilon,1,1)=0
      ENDDO
      ENDIF
C
      DO ilon=1,LON*LAT*NIV
        SPFLX(ilon,1,1)=0.
        LPFLX(ilon,1,1)=0.
      ENDDO
C
      DO ilon=1,LON
      DO ilat=1,LAT
      PLT(ilon,ilat,0)=200.00
      ENDDO
      ENDDO
C
      DO ilon=1,LON*LAT*NIV
        PLT(ilon,1,1)=PLT2(ilon,1,1)
      ENDDO
C
C CHOIX DES INDICES DE BOUCLE
C      
      IDEB=1
      IFIN=LON
      JDEB=1
      JFIN=LAT
      LDEB=17
      LFIN=NIV
C    
       DO 1 J=JDEB,JFIN
C          
         CALL TCVCALSUB(J,LON,LAT,NIV,NTRA,
     +                 SURFM,
     +                 PL,PLT,PSOL,EJ1,
     +                 U3D,V3D,T3D,Q3D,
     +                 DIVQ3D,DIVU3D,
     +                 QQQM,LPFLX,
     +                 IDEB,IFIN,LDEB,LFIN,ICALCONV,
     +                 BIGG,IBIGIP)     
C  
 1      CONTINUE 
C
	DEALLOCATE (PLT)
C
C
	 RETURN	 
       END
