      SUBROUTINE TCVCONZOM(LON,LAT,NIV,LDEB,NTRA,I,J,G,QQQM,SM,IP)
C
CCC
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type      : Convection and Diffusion (Tiedtke/Louis)
C   Purpose   : Mixing of tracers by convection with zero order moments
C   Called by : 
C
C     The matrix CONVC is applied to S0. 
C 
CCC
	IMPLICIT NONE 
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
C
      INTEGER :: I,J,LON,LAT,NIV,LDEB,NTRA
      INTEGER , DIMENSION (LDEB:NIV) :: IP
	REAL (KIND=8) , DIMENSION (LON,LAT,NIV,NTRA) :: QQQM
      REAL (KIND=8) , DIMENSION (LON,LAT,NIV) :: SM
      REAL (KIND=8) , DIMENSION (LDEB:NIV,LDEB:NIV) :: G      
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C
      INTEGER :: LH,ISW,JV,L,ICON
	REAL (KIND=8) , ALLOCATABLE :: ZRM(:)
C
C
	ALLOCATE (ZRM(LDEB:NIV))
C
      LH=NIV-LDEB+1
      ISW=1
C
      DO 1 JV=1,NTRA
C
        DO 10 L=LDEB,NIV
          ZRM (L)=QQQM(I,J,L,JV)*SM(I,J,L)
   10   CONTINUE
C
        CALL DLUX(ZRM,G,LH,LH,ISW,IP,ICON)
C
C Copy new tracer masses from temporary storage to main arrays
C
        DO 12 L=LDEB,NIV
          QQQM(I,J,L,JV)=ZRM(L)/SM(I,J,L)
  12    CONTINUE
C      
   1  CONTINUE
C
	DEALLOCATE (ZRM)
C	
C	
	RETURN
      END
