      FUNCTION TCVDQSATDT(T,P)
C
CCC
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type      : Convection and Diffusion (Tiedtke/Louis)
C   Purpose   : Compute derivative of saturation specific
C               humidity with respect to temperature
C   Called by :
C
CCC
C
C INPUT :
C
C     T:   TEMPERATURE (K)
C     P:   PRESSURE (Pa)
C
CCC
C
	USE CSTES_MOD
C
	IMPLICIT NONE
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
C
	REAL (KIND=8) :: P,T
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C
	REAL (KIND=8) :: C1,C3A,C3B,C4A,C4B,ES,QSAT
	REAL (KIND=8) :: TCVDQSATDT
      PARAMETER ( C1=610.78,
     +		 C3A=17.269,
     +		 C3B=21.875,
     +		 C4A=35.86,
     +		 C4B= 7.66)
C
C
      IF(P.LT.0.) THEN
        TCVDQSATDT=0.
        RETURN
      ENDIF
C

      IF(T.GE.TREF) THEN
        ES=C1*EXP(C3A*(T-TREF)/(T-C4A))
        QSAT=RA/RV/((P/ES)-(1-RA/RV))
        TCVDQSATDT=C3A*(TREF-C4A)*QSAT/
     +          ((T-C4A)*(T-C4A)*(1.-(1.-RA/RV)*ES/P))
      ELSE
        ES=C1*EXP(C3B*(T-TREF)/(T-C4B))
        QSAT=RA/RV/((P/ES)-(1-RA/RV))
        TCVDQSATDT=C3A*(TREF-C4A)*QSAT/
     +          ((T-C4A)*(T-C4A)*(1.-(1.-RA/RV)*ES/P))
      ENDIF
C
      RETURN
      END

