      FUNCTION TCVQSAT(T,P)


!   __  __   _____   _____   _____   _____   _____
!  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
!  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
!  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
!
!   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
!   VERSION_RELEASE_BUGFIX : 0_1_1 
!
!CC DATE : 15/05/2005
!
!   Type      : Convection and Diffusion (Tiedtke/Louis)
!   Purpose   : Compute saturation specific humidity
!   Called by :
!
!
! INPUT :
!
!     T:   TEMPERATURE (K)
!     P:   PRESSURE (Pa)

        USE CSTES_MOD

        IMPLICIT NONE

!     Subroutine arguments.
!     ~~~~~~~~~~~~~~~~~~~~

        REAL (KIND=8) :: P,T

!     Variables locales.
!     ~~~~~~~~~~~~~~~~~

      REAL (KIND=8) :: TCVQSAT,ES
      REAL (KIND=8) , PARAMETER :: C1=610.78
      REAL (KIND=8) , PARAMETER :: C3A=17.269
      REAL (KIND=8) , PARAMETER :: C3B=21.875
      REAL (KIND=8) , PARAMETER :: C4A=35.86
      REAL (KIND=8) , PARAMETER :: C4B= 7.66

      IF(P <= 0.) THEN
        TCVQSAT=0.
        RETURN
      ENDIF
  
      IF(T >= TREF) THEN
        ES=C1*EXP(C3A*(T-TREF)/(T-C4A))
      ELSE
        ES=C1*EXP(C3B*(T-TREF)/(T-C4B))
      ENDIF
    
      TCVQSAT=RA/RV/((P/ES)-(1-RA/RV))
  
      RETURN
      END
