      SUBROUTINE TOPWAT(DT,QQQM,LON,LAT,NIV,NTRA,iH2O,iCO)
C
CCCCC
C
C   Relax mesospheric water vapour towards climatological
C   value (for climatic version)
C
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C
C   Centre National de Recherches Meteorologiques
C   Groupe de Modelisation de Grande Echelle et du Climat
C   Equipe de Recherches sur l'Atmosphere Moyenne
C
CCCCC
C
C  Original : H. Teyssedre, 04/2003
C  Modified : H. Le Berre   06/2006  Fortran 90 compliant
C             H. Teyssedre, 12/2007  inclusion de CO pour le schema lineaire
C
CCCCC
C
      IMPLICIT NONE
C
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
C
      INTEGER :: LON,LAT,NIV,NTRA,iH2O,iCO
      REAL (KIND=8) :: DT
      REAL (KIND=8) , DIMENSION (LON,LAT,NIV,NTRA) :: QQQM
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C     
      INTEGER ::ILON,ILAT
      REAL (KIND=8) :: XTOPH2O,XTOPCO, TAU
C
C
      XTOPH2O = 6.E-06
#ifdef NIV_91
      XTOPCO  = 1.E-06
#endif
#ifdef NIV_60
      XTOPCO  = 6.E-07
#endif
      TAU  = 7.
C
C RELAXATION TIME (DAY)
C
      IF (iH2O.NE.0) THEN
        DO ILAT=1,LAT
        DO ILON=1,LON
          QQQM(ILON,ILAT,1,iH2O)=XTOPH2O+
     +   (QQQM(ILON,ILAT,1,iH2O)-XTOPH2O)*EXP(-DT/(TAU*86400.))
        ENDDO
        ENDDO
      ENDIF
#ifdef CARIOLLE
#ifdef LINCO
      IF (iCO.NE.0) THEN
        DO ILAT=1,LAT
        DO ILON=1,LON
          QQQM(ILON,ILAT,1,iCO )=XTOPCO +
     +   (QQQM(ILON,ILAT,1,iCO )-XTOPCO )*EXP(-DT/(TAU*86400.))
        ENDDO
        ENDDO
      ENDIF
#endif
#endif
C
C
      RETURN
      END
