      SUBROUTINE TOTAL( HHHM, hnm, XPAM, o3t, SLSNAM,
     +                  nlon, nlat, niv, nsls)
C
CCC
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type      : Chemistry 
C   Purpose   : Compute total ozone column (cm-2)
C   Called by : 
C
CCC
C
C  Original : F. Lefevre (REPROBUS, LIB37)
C
C  Modified : V.-H.Peuch (inclusion dans MOCAGE), 08/1999
C
	IMPLICIT NONE
C
C     ~~~~~~~~~~~~~~~~~~~~
C
      INTEGER :: nlon, nlat, niv, nsls
      REAL (KIND=8), DIMENSION (nlon,nlat,niv,nsls) :: HHHM
      REAL (KIND=8), DIMENSION (nlon,nlat,niv) :: hnm,XPAM
      REAL (KIND=8), DIMENSION (nlon,nlat,niv) :: o3t
      CHARACTER(LEN=15), DIMENSION (nsls) :: SLSNAM
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C
      INTEGER :: LOLA,LOLANI,ISLS,ILON,INIV,iozo
      REAL (KIND=8) :: ZCMT,DP
      CHARACTER(LEN=15) :: OZONE
      LOGICAL :: lozok
C
C     zcmt : Gas constant/(Boltzmann Cst.*g)
C
      zcmt   = 2.120e20
      lola   = nlon*nlat
      lolani = nlon*nlat*niv
      OZONE  = 'O_3'
      lozok  = .FALSE.
C
      DO isls = 1, nsls
        IF (SLSNAM(isls).EQ.OZONE) THEN
          iozo=isls
          lozok=.TRUE.
        ENDIF
      ENDDO
C
      IF (lozok) THEN
C
        DO ilon = 1,lola
          o3t(ilon,1,1) = HHHM(ilon,1,1,iozo)*hnm(ilon,1,1)*6.8e5
#ifdef MIDATM
C Ozone column limited to 1 DU at maximum for first layer
          o3t(ilon,1,1) = min(o3t(ilon,1,1),2.685e+16)
#else
C Ozone column limited to 60 DU at maximum for first layer
          o3t(ilon,1,1) = min(o3t(ilon,1,1),1.611e+18)
#endif
        ENDDO
        DO iniv = 2,niv
        DO ilon = 1,lola
          dp = XPAM(ilon,1,iniv) - XPAM(ilon,1,iniv-1)
          o3t(ilon,1,iniv) = o3t(ilon,1,iniv-1)
     +               + zcmt*( HHHM(ilon,1,iniv  ,iozo)
     +                       +HHHM(ilon,1,iniv-1,iozo))*.5*dp
        ENDDO
        ENDDO
C
      else
        WRITE(*,*) '>> OZONE IS NOT IN CHEMICAL SCHEME : ABORT!'
        CALL MOCAGE_STOP
      endif
C
      RETURN
      END
C
CCC
C
