      SUBROUTINE TRANSFERDATE(TBTOA,TATOB, 
     &                 LONF,LATF,NIVF,
     &                 LONM,LATM,NIVM,
     $                 LOLANIF,LOLANIM,LOLAF,LOLAM,
     $                 TGRIFA,UGRIFA,VGRIFA,WGRIFA,QGRIFA,PVGRIFA,
     $                 XPAMA,XPHFMA,
     $                 TGRIMA,UGRIMA,VGRIMA,WGRIMA,QGRIMA,PVGRIMA,
     $                 DIVQMA,DIVUMA,
     $                 PSOLFA,PSOLMA,
     $                 TGRIFB,UGRIFB,VGRIFB,WGRIFB,QGRIFB,PVGRIFB,
     $                 XPAMB,XPHFMB,
     $                 TGRIMB,UGRIMB,VGRIMB,WGRIMB,QGRIMB,PVGRIMB,
     $                 DIVQMB,DIVUMB,
     $                 PSOLFB,PSOLMB)

C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type       : I/O
C   Purpose    : Substitute date B arrays in date A arrays
C   Called by  : FORCAGE
C
CCC
C
C  Original : P. Moinat, 21/10/2005
C
C  Last Modified :  H. Le Berre 10/2006  Integration in CVS
C
C
      IMPLICIT NONE
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
      LOGICAL TBTOA,TATOB
      INTEGER LONF,LATF,NIVF
      INTEGER LONM,LATM,NIVM
      INTEGER LOLANIF,LOLANIM,LOLAF,LOLAM
c time A
      REAL (KIND=8), DIMENSION(LONF,LATF,NIVF) :: TGRIFA,UGRIFA,
     $                                         VGRIFA,WGRIFA,
     $                                        QGRIFA,PVGRIFA
      REAL (KIND=8), DIMENSION(LONM,LATM,NIVM) :: XPAMA,XPHFMA,
     $                          TGRIMA,UGRIMA,VGRIMA,WGRIMA,
     $                                       QGRIMA,PVGRIMA,
     $                                        DIVQMA,DIVUMA
      REAL (KIND=8), DIMENSION(LONF,LATF) :: PSOLFA
      REAL (KIND=8), DIMENSION(LONM,LATM) :: PSOLMA
c time B
      REAL (KIND=8), DIMENSION(LONF,LATF,NIVF) :: TGRIFB,UGRIFB,
     $                                         VGRIFB,WGRIFB,
     $                                        QGRIFB,PVGRIFB
      REAL (KIND=8), DIMENSION(LONM,LATM,NIVM) :: XPAMB,XPHFMB,
     $                          TGRIMB,UGRIMB,VGRIMB,WGRIMB,
     $                                       QGRIMB,PVGRIMB,
     $                                        DIVQMB,DIVUMB
      REAL (KIND=8), DIMENSION(LONF,LATF) :: PSOLFB
      REAL (KIND=8), DIMENSION(LONM,LATM) :: PSOLMB
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
      INTEGER :: ilon
C
C
      IF (TBTOA) THEN
            do ilon = 1,LOLANIF
              TGRIFA(ilon,1,1) = TGRIFB(ilon,1,1)
              UGRIFA(ilon,1,1) = UGRIFB(ilon,1,1)
              VGRIFA(ilon,1,1) = VGRIFB(ilon,1,1)
              WGRIFA(ilon,1,1) = WGRIFB(ilon,1,1)
              QGRIFA(ilon,1,1) = QGRIFB(ilon,1,1)
              PVGRIFA(ilon,1,1) = PVGRIFB(ilon,1,1)
            enddo
            do ilon = 1,LOLANIM
               XPAMA(ilon,1,1) =  XPAMB(ilon,1,1)
              XPHFMA(ilon,1,1) = XPHFMB(ilon,1,1)
              TGRIMA(ilon,1,1) = TGRIMB(ilon,1,1)
              UGRIMA(ilon,1,1) = UGRIMB(ilon,1,1)
              VGRIMA(ilon,1,1) = VGRIMB(ilon,1,1)
              WGRIMA(ilon,1,1) = WGRIMB(ilon,1,1)
              QGRIMA(ilon,1,1) = QGRIMB(ilon,1,1)
              PVGRIMA(ilon,1,1) = PVGRIMB(ilon,1,1)
              DIVQMA(ilon,1,1) = DIVQMB(ilon,1,1)
              DIVUMA(ilon,1,1) = DIVUMB(ilon,1,1)
            enddo
            do ilon = 1,LOLAF
              PSOLFA(ilon,1) = PSOLFB(ilon,1)
            enddo
            do ilon = 1,LOLAM
              PSOLMA(ilon,1) = PSOLMB(ilon,1)
            enddo
      ENDIF
      IF (TATOB) THEN
            do ilon = 1,LOLANIF
              TGRIFB(ilon,1,1)  = TGRIFA(ilon,1,1)
              UGRIFB(ilon,1,1)  = UGRIFA(ilon,1,1)
              VGRIFB(ilon,1,1)  = VGRIFA(ilon,1,1)
              WGRIFB(ilon,1,1)  = WGRIFA(ilon,1,1)
              QGRIFB(ilon,1,1)  = QGRIFA(ilon,1,1)
              PVGRIFB(ilon,1,1) = PVGRIFA(ilon,1,1)
            enddo
            do ilon = 1,LOLANIM
              XPAMB(ilon,1,1)  = XPAMA(ilon,1,1)
              XPHFMB(ilon,1,1) = XPHFMA(ilon,1,1)
              TGRIMB(ilon,1,1) = TGRIMA(ilon,1,1)
              UGRIMB(ilon,1,1) = UGRIMA(ilon,1,1)
              VGRIMB(ilon,1,1) = VGRIMA(ilon,1,1)
              WGRIMB(ilon,1,1) = WGRIMA(ilon,1,1)
              QGRIMB(ilon,1,1) = QGRIMA(ilon,1,1)
              PVGRIMB(ilon,1,1)= PVGRIMA(ilon,1,1)
              DIVQMB(ilon,1,1) = DIVQMA(ilon,1,1)
              DIVUMB(ilon,1,1) = DIVUMA(ilon,1,1)
            enddo
            do ilon = 1,LOLAF
              PSOLFB(ilon,1) = PSOLFA(ilon,1)
            enddo
            do ilon = 1,LOLAM
              PSOLMB(ilon,1) = PSOLMA(ilon,1)
            enddo
      ENDIF
C
C
          return
          end
