	MODULE UNDCOLMT_MOD
C
C------------------------------------------------------------------------
C 	DATA FOR 1D-MODEL (VALID FOR CURRENT TIMESTEP)
C
C	AUTHOR	: HERVE LE BERRE	- CERFACS -
C	DATE		: 03/08/2005
C	VERSION	: 1_0_0
C------------------------------------------------------------------------
C
	IMPLICIT NONE
C
C
	LOGICAL , SAVE :: L1D
	CHARACTER(LEN=15) , ALLOCATABLE , SAVE :: TRANAM1D(:)
	CHARACTER(LEN=15) , ALLOCATABLE , SAVE :: SLSNAM1D(:)
	CHARACTER(LEN=15) , ALLOCATABLE , SAVE :: EMINAM1D(:)
	CHARACTER(LEN=15) , ALLOCATABLE , SAVE :: DEPNAM1D(:)
	INTEGER , ALLOCATABLE , SAVE :: IQMEMI1D(:),IQMDEP1D(:)
	INTEGER , ALLOCATABLE , SAVE :: IHMDEP1D(:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PSOLM1D(:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PVGRIM1D(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: X1D(:),Y1D(:),SURF1D(:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: XPHFM1D(:,:),XPAM1D(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: UGRIM1D(:,:),VGRIM1D(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: WGRIM1D(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: TGRIM1D(:,:),QGRIM1D(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: DIVQM1D(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: DIVUM1D(:,:),FCC1D(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: FCCV1D(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: QLIQ1D(:,:),QICE1D(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: QQQM1D(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: HHHM1D(:,:,:),EVD(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: EMD(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: VDD(:,:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: XALBSMD(:,:),PWALD(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PWACD(:,:)
	REAL (KIND=8) , ALLOCATABLE , SAVE :: PSNLD(:,:),PSNCD(:,:)
C
	CONTAINS
C
	SUBROUTINE ALLOC_UNDCOLMT
C
	USE PARADI_MOD
C
        ALLOCATE (TRANAM1D(NTRA1D))	  ; TRANAM1D(:) = '123456789 12345'
        ALLOCATE (SLSNAM1D(NSLS1D))	  ; SLSNAM1D(:) = '123456789 12345'
        ALLOCATE (EMINAM1D(NEMI1D))	  ; EMINAM1D(:) = '123456789 12345'
        ALLOCATE (DEPNAM1D(NDEP1D))	  ; DEPNAM1D(:) = '123456789 12345'
        ALLOCATE (IQMEMI1D(NTRA1D))	  ; IQMEMI1D(:) = 0.0
        ALLOCATE (IQMDEP1D(NTRA1D))	  ; IQMDEP1D(:) = 0.0
        ALLOCATE (IHMDEP1D(NSLS1D))	  ; IHMDEP1D(:) = 0.0
        ALLOCATE (X1D(NCOL))	  ; X1D(:) = 0.0
        ALLOCATE (Y1D(NCOL))	  ; Y1D(:) = 0.0
        ALLOCATE (SURF1D(NCOL))	  ; SURF1D(:) = 0.0
        ALLOCATE (PSOLM1D(NCOL))	  ; PSOLM1D(:) = 0.0
        ALLOCATE (XPHFM1D(NCOL,NIV1D))	  ; XPHFM1D(:,:) = 0.0
        ALLOCATE (XPAM1D(NCOL,NIV1D))	  ; XPAM1D(:,:) = 0.0
        ALLOCATE (UGRIM1D(NCOL,NIV1D))	  ; UGRIM1D(:,:) = 0.0
        ALLOCATE (VGRIM1D(NCOL,NIV1D))	  ; VGRIM1D(:,:) = 0.0
        ALLOCATE (WGRIM1D(NCOL,NIV1D))	  ; WGRIM1D(:,:) = 0.0
        ALLOCATE (TGRIM1D(NCOL,NIV1D))	  ; TGRIM1D(:,:) = 0.0
        ALLOCATE (QGRIM1D(NCOL,NIV1D))	  ; QGRIM1D(:,:) = 0.0
        ALLOCATE (PVGRIM1D(NCOL,NIV1D))	  ; PVGRIM1D(:,:) = 0.0
        ALLOCATE (DIVQM1D(NCOL,NIV1D))	  ; DIVQM1D(:,:) = 0.0
        ALLOCATE (DIVUM1D(NCOL,NIV1D))	  ; DIVUM1D(:,:) = 0.0
        ALLOCATE (FCC1D(NCOL,NIV1D))	  ; FCC1D(:,:) = 0.0
        ALLOCATE (FCCV1D(NCOL,NIV1D))	  ; FCCV1D(:,:) = 0.0
        ALLOCATE (QLIQ1D(NCOL,NIV1D))	  ; QLIQ1D(:,:) = 0.0
        ALLOCATE (QICE1D(NCOL,NIV1D))	  ; QICE1D(:,:) = 0.0
        ALLOCATE (QQQM1D(NCOL,NIV1D,NTRA1D))	  ; QQQM1D(:,:,:) = 0.0
        ALLOCATE (HHHM1D(NCOL,NIV1D,NSLS1D))	  ; HHHM1D(:,:,:) = 0.0
        ALLOCATE (EVD(NCOL,0:NHOUR))	  ; EVD(:,:) = 0.0
        ALLOCATE (XALBSMD(NCOL,0:NHOUR))	  ; XALBSMD(:,:) = 0.0
        ALLOCATE (PWALD(NCOL,0:NHOUR))	  ; PWALD(:,:) = 0.0
        ALLOCATE (PWACD(NCOL,0:NHOUR))	  ; PWACD(:,:) = 0.0
        ALLOCATE (PSNLD(NCOL,0:NHOUR))	  ; PSNLD(:,:) = 0.0
        ALLOCATE (PSNCD(NCOL,0:NHOUR))	  ; PSNCD(:,:) = 0.0
        ALLOCATE (EMD(NCOL,NEMI1D,0:NHOUR))	  ; EMD(:,:,:) = 0.0
        ALLOCATE (VDD(NCOL,NDEP1D+3,0:NHOUR))	  ; VDD(:,:,:) = 0.0
C
	END SUBROUTINE ALLOC_UNDCOLMT
C
	SUBROUTINE DEALLOC_UNDCOLMT
C
	DEALLOCATE (TRANAM1D)
	DEALLOCATE (SLSNAM1D)
	DEALLOCATE (EMINAM1D)
	DEALLOCATE (DEPNAM1D)
	DEALLOCATE (IQMEMI1D)
	DEALLOCATE (IQMDEP1D)
	DEALLOCATE (IHMDEP1D)
	DEALLOCATE (X1D)
	DEALLOCATE (Y1D)
	DEALLOCATE (SURF1D)
	DEALLOCATE (PSOLM1D)
	DEALLOCATE (XPHFM1D)
	DEALLOCATE (XPAM1D)
	DEALLOCATE (UGRIM1D)
	DEALLOCATE (VGRIM1D)
	DEALLOCATE (WGRIM1D)
	DEALLOCATE (TGRIM1D)
	DEALLOCATE (QGRIM1D)
	DEALLOCATE (PVGRIM1D)
	DEALLOCATE (DIVQM1D)
	DEALLOCATE (DIVUM1D)
	DEALLOCATE (FCC1D)
	DEALLOCATE (FCCV1D)
	DEALLOCATE (QLIQ1D)
	DEALLOCATE (QICE1D)
	DEALLOCATE (QQQM1D)
	DEALLOCATE (HHHM1D)
	DEALLOCATE (EVD)
	DEALLOCATE (XALBSMD)
	DEALLOCATE (PWALD)
	DEALLOCATE (PWACD)
	DEALLOCATE (PSNLD)
	DEALLOCATE (PSNCD)
	DEALLOCATE (EMD)
	DEALLOCATE (VDD)
C
	END SUBROUTINE DEALLOC_UNDCOLMT
C
	END  MODULE UNDCOLMT_MOD 
