#ifdef PALM_RESEARCH
C
      SUBROUTINE WRTOBS(daynum,idate0,flag,LEND)
#else
C
      SUBROUTINE WRTOBS(daynum,idate0,LEND)
#endif
C
CCC
C   __  __   _____   _____   _____   _____   _____
C  |  \/  | /     \ /     \ /  _  \ /  ___\ |  ___|
C  |      | |  |  | |  <--< |  _  | |  \_ \ |  ___|
C  |_|\/|_| \_____/ \_____/ \_/ \_/ \_____/ |_____|
C
C   MODELE DE CHIMIE ATMOSPHERIQUE A GRANDE ECHELLE
C   VERSION_RELEASE_BUGFIX : 0_1_1 
C
CCC DATE : 15/05/2005
C
C   Type       : Observations
C   Purpose    : Write output diagnostic data file on observations locations
C   Called by  : MADONA
C
CCC
C
C Original  : M.-L. Cathala & V.-H. Peuch, CNRM/GMGEC/ERAM, 03/1999
C
C Modified  : V.-H. Peuch, CNRM/GMGEC/ERAM, 01/2001
C
CCC
C
	USE PARADI_MOD
	USE EXPE_MOD
	USE MOCF_MOD
	USE DATOBS_MOD
        USE CSTES_MOD
C
	IMPLICIT NONE
C
C     Subroutine arguments.
C     ~~~~~~~~~~~~~~~~~~~~
C
      REAL (KIND=8) :: daynum
      INTEGER , DIMENSION (5) :: idate0
      LOGICAL :: LEND
C
C     Variables locales.
C     ~~~~~~~~~~~~~~~~~
C
      INTEGER :: flag
      INTEGER :: I,IOBS,J,K,NBDAY,NBHOUR
      INTEGER ,ALLOCATABLE :: idate1(:),nbjour(:)
#ifdef PALM_RESEARCH
#define PALM_DIAG
#endif
#ifdef PALM_DIAG
      CHARACTER(LEN=24) :: clf1,clf2,clf3,clf4
#else
      CHARACTER(LEN=20) :: clf1,clf2,clf3,clf4
#endif
C
#ifndef PALM_RESEARCH
      flag = 0
#endif
C
      ALLOCATE (idate1(5))
      ALLOCATE (nbjour(12))
C	
	nbjour =(/31,28,31,30,31,30,31,31,30,31,30,31/)
C
C
CCC 0. WRITE DIAGNOSTIC FILES EVERY DAY
C
      IF  ((MOD(INT(daynum)+idate0(4)*3600,
     +     86400).EQ.0).OR.
     +     (LEND.AND.(MOD(INT(daynum)+idate0(4)*3600,
     +     86400).NE.0))) THEN
C
CCC 1. DETERMINE FILE NAMES AND OPEN FILES
C
        NBDAY=int((daynum-DT0)/86400.)
        NBHOUR=int((daynum-DT0-real(NBDAY)*86400.)/3600.)
C
        idate1(5)=0
        idate1(4)=idate0(4)+NBHOUR
        idate1(3)=idate0(3)+NBDAY
        idate1(2)=idate0(2)
        idate1(1)=idate0(1)
C
        IF (idate1(4).GE.24) THEN
          idate1(4)=idate1(4)-24
          idate1(3)=idate1(3)+1
        ENDIF
C
        IF (mod(idate0(1),4).EQ.0) THEN
          nbjour(2)=nbjour(2)+1
        ENDIF 
C
        IF (idate1(3).GT.nbjour(idate1(2))) THEN
          idate1(3)=idate1(3)-nbjour(idate1(2))
          idate1(2)=idate1(2)+1
        ENDIF
C
        IF (idate1(2).GT.12) THEN
          idate1(1)=idate1(1)+1
          idate1(2)=1
        ENDIF
C
CCC 2. WRITE DIAGNOSTICS FOR ALL DOMAINS
C
        IF (IFLAG1.and.MYID.eq.0) THEN
C
#ifdef PALM_DIAG
                WRITE(clf1,
     +            fmt='(''HDIAG'',A6,''+'',I4.4,I2.2,I2.2,''+W'',I2.2)')
     +            NAMDOM1,idate1(1),idate1(2),idate1(3),flag
#else
                WRITE(clf1,fmt='(''HDIAG'',A6,''+'',I4.4,I2.2,I2.2)')
     +            NAMDOM1,idate1(1),idate1(2),idate1(3)
#endif
            WRITE(*,*) '> WRITING DIAG. FILE : ',clf1
CAP
            CALL FLUSH(6)
C
          OPEN(unit=IFDIAG1,file=clf1,form='formatted')
          WRITE(IFDIAG1,*) nobs,nos
          CALL FLUSH(IFDIAG1)
          DO i=1,nos
            WRITE(IFDIAG1,101) defos(i)
          CALL FLUSH(IFDIAG1)
          ENDDO
          DO iobs=1,nobs
#ifdef GAUSS
            if (xobslon(iobs).gt.180.) then
              xobslon(iobs)=xobslon(iobs)-360.
            endif
#endif
            WRITE(IFDIAG1,102)
     +        idatobs(iobs,1),idatobs(iobs,2),
     +        idatobs(iobs,3),idatobs(iobs,4),idatobs(iobs,5),
     +        typemesure(iobs),ninst(iobs),
     +        xobslat(iobs),xobslon(iobs),
     +        nbnivpres(iobs)
          CALL FLUSH(IFDIAG1)
            DO j=1,nbnivpres(iobs)
              WRITE(IFDIAG1,103)
     +          nivpres(iobs,j),nbconst(iobs,j)
          CALL FLUSH(IFDIAG1)
              DO k=1,nbconst(iobs,j)
#ifdef PALM_DIAG
                WRITE(IFDIAG1,105)
     +          constname(iobs,j,k),
     +          GUESS1(iobs,j,k),
     +          VAL(iobs,j,k),
     +          VAL(iobs,j,k) - GUESS1(iobs,j,k)
          CALL FLUSH(IFDIAG1)
#else
                WRITE(IFDIAG1,104)
     +          constname(iobs,j,k),GUESS1(iobs,j,k)
#endif
              ENDDO
            ENDDO
          ENDDO
          CLOSE(IFDIAG1)
        ENDIF
C
        IF (IFLAG2.and.MOD(1,NPROCS).eq.MYID) THEN
C
#ifdef PALM_DIAG
                WRITE(clf2,
     +            fmt='(''HDIAG'',A6,''+'',I4.4,I2.2,I2.2,''+W'',I2.2)')
     +            NAMDOM2,idate1(1),idate1(2),idate1(3),flag
#else
                WRITE(clf2,fmt='(''HDIAG'',A6,''+'',I4.4,I2.2,I2.2)')
     +            NAMDOM2,idate1(1),idate1(2),idate1(3)
#endif
            WRITE(*,*) '> WRITING DIAG. FILE : ',clf2
C
          OPEN(unit=IFDIAG2,file=clf2,form='formatted')
          WRITE(IFDIAG2,*) nobs,nos
          DO i=1,nos
            WRITE(IFDIAG2,101) defos(i)
          ENDDO
          DO iobs=1,nobs
            WRITE(IFDIAG2,102)
     +        idatobs(iobs,1),idatobs(iobs,2),
     +        idatobs(iobs,3),idatobs(iobs,4),idatobs(iobs,5),
     +        typemesure(iobs),ninst(iobs),
     +        xobslat(iobs),xobslon(iobs),
     +        nbnivpres(iobs)
            DO j=1,nbnivpres(iobs)
              WRITE(IFDIAG2,103)
     +          nivpres(iobs,j),nbconst(iobs,j)
              DO k=1,nbconst(iobs,j)
#ifdef PALM_DIAG
                WRITE(IFDIAG2,105)
     +          constname(iobs,j,k),
     +          GUESS2(iobs,j,k),
     +          VAL(iobs,j,k),
     +          VAL(iobs,j,k) - GUESS2(iobs,j,k)
#else
                WRITE(IFDIAG2,104)
     +          constname(iobs,j,k),GUESS2(iobs,j,k)
#endif
              ENDDO
            ENDDO
          ENDDO
          CLOSE(IFDIAG2)
        ENDIF
C
        IF (IFLAG3.and.MOD(2,NPROCS).eq.MYID) THEN
C
#ifdef PALM_DIAG
            WRITE(clf3,
     +          fmt='(''HDIAG'',A6,''+'',I4.4,I2.2,I2.2,''+W'',I2.2)')
     +          NAMDOM3,idate1(1),idate1(2),idate1(3),flag
#else
            WRITE(clf3,fmt='(''HDIAG'',A6,''+'',I4.4,I2.2,I2.2)')
     +          NAMDOM3,idate1(1),idate1(2),idate1(3)
#endif
            WRITE(*,*) '> WRITING DIAG. FILE : ',clf3
C
          OPEN(unit=IFDIAG3,file=clf3,form='formatted')
          WRITE(IFDIAG3,*) nobs,nos
          DO i=1,nos
            WRITE(IFDIAG3,101) defos(i)
          ENDDO
          DO iobs=1,nobs
            WRITE(IFDIAG3,102)
     +        idatobs(iobs,1),idatobs(iobs,2),
     +        idatobs(iobs,3),idatobs(iobs,4),idatobs(iobs,5),
     +        typemesure(iobs),ninst(iobs),
     +        xobslat(iobs),xobslon(iobs),
     +        nbnivpres(iobs)
            DO j=1,nbnivpres(iobs)
              WRITE(IFDIAG3,103)
     +          nivpres(iobs,j),nbconst(iobs,j)
              DO k=1,nbconst(iobs,j)
#ifdef PALM_DIAG
                WRITE(IFDIAG3,105)
     +          constname(iobs,j,k),
     +          GUESS3(iobs,j,k),
     +          VAL(iobs,j,k),
     +          VAL(iobs,j,k) - GUESS3(iobs,j,k)
#else
                WRITE(IFDIAG3,104)
     +          constname(iobs,j,k),GUESS3(iobs,j,k)
#endif
              ENDDO
            ENDDO
          ENDDO
          CLOSE(IFDIAG3)
        ENDIF
C
        IF (IFLAG4.and.MOD(3,NPROCS).eq.MYID) THEN
C
#ifdef PALM_DIAG
            WRITE(clf4,
     +          fmt='(''HDIAG'',A6,''+'',I4.4,I2.2,I2.2,''+W'',I2.2)')
     +          NAMDOM4,idate1(1),idate1(2),idate1(3),flag
#else
            WRITE(clf4,fmt='(''HDIAG'',A6,''+'',I4.4,I2.2,I2.2)')
     +          NAMDOM4,idate1(1),idate1(2),idate1(3)
#endif
            WRITE(*,*) '> WRITING DIAG. FILE : ',clf4
C
          OPEN(unit=IFDIAG4,file=clf4,form='formatted')
          WRITE(IFDIAG4,*) nobs,nos
          DO i=1,nos
            WRITE(IFDIAG4,101) defos(i)
          ENDDO
          DO iobs=1,nobs
            WRITE(IFDIAG4,102)
     +        idatobs(iobs,1),idatobs(iobs,2),
     +        idatobs(iobs,3),idatobs(iobs,4),idatobs(iobs,5),
     +        typemesure(iobs),ninst(iobs),
     +        xobslat(iobs),xobslon(iobs),
     +        nbnivpres(iobs)
            DO j=1,nbnivpres(iobs)
              WRITE(IFDIAG4,103)
     +          nivpres(iobs,j),nbconst(iobs,j)
              DO k=1,nbconst(iobs,j)
#ifdef PALM_DIAG
                WRITE(IFDIAG4,105)
     +          constname(iobs,j,k),
     +          GUESS4(iobs,j,k),
     +          VAL(iobs,j,k),
     +          VAL(iobs,j,k) - GUESS4(iobs,j,k)
#else
                WRITE(IFDIAG4,104)
     +          constname(iobs,j,k),GUESS4(iobs,j,k)
#endif
              ENDDO
            ENDDO
          ENDDO
          CLOSE(IFDIAG4)
      ENDIF
C
CCC 3. FORMATS
C
 101    FORMAT(A68)
 102    FORMAT(I4,I2.2,I2.2,I2.2,I2.2,1X,A6,1X,I5.5,1X,
     +         F6.2,1X,F7.2,1X,I2)
 103    FORMAT(F7.0,1X,I2)
 104    FORMAT(A5,1X,E12.5)
 105    FORMAT(A5,1X,E12.5,1X,E12.5,1X,E12.5)
C
CCC
C
      ENDIF
C
	DEALLOCATE (idate1)
	DEALLOCATE (nbjour)
C
C      
	RETURN
      END
